This is the Fi data directory.

The subdirectory 'input' contains data files available by default, like:
uvpol* : files containing precalculated uv kernels
*.cool: electron impact cooling functions 
*.Hcool: H impact cooling functions
*.starprop: stellar synthesis models
*.halo: halo files

The subdirectory 'output' is initially empty, and is used to store temporary data files, and other output such as log files.

subroutine mech_feedback
 include 'globals.h'
 integer i
 real :: dt
 
 dt=tnow-tsnfeedback
  
 if(dt.lt.0) call terror(' feedback time error')
 
 select case (feedback)
  case('fuv ')
  case('pres')
   call pp_feedback(dt,tnow)
  case('kine')
   call randomvelfeedback(dt,tnow)
  case('solo')
   call terror('currently dangerous')
   call terror('solo not isotherm ')
   call energyfeedback(dt,tnow)
  case('solh')
   call heatingfeedback(dt,tnow)
  case default
   call terror(' feedback error 2')
 end select 
 
 tsnfeedback=tnow
 
 end subroutine mech_feedback
 
subroutine pp_feedback(dt,tnu)
 include 'globals.h'
 
   integer i,p,npp, niter
   integer mythread,totalthread,low,up
!$ integer omp_get_thread_num,omp_get_num_threads 
   real tnu,dt
   real starpos(1:3),searchrad,sn_energy,starent
   real sn_activity,lsnheat,mc2fac,ts
   real, allocatable :: p_acc(:,:)
   real time1,time2,mintime,maxtime,tottime
   npp=0
   mc2fac=(lightspeed/velscale)**2
! test  
   ts=salpetertime*bh_rad_eff*year*1.e6/timescale
! stars
   do p=nbodies-nstar+1,nbodies   
    if(tnu-tform(p)-dt.le.tbubble.OR.snentropy(p).GT.0) then
     npp=npp+1
     templist(npp)=p
    endif
   enddo
! bh (tform=time of last mdot(=tfeedb) !=0 )
     
   if(verbosity.GT.0)print*,'<pressureparticle> particles:', npp  
   mintime=1.e10; maxtime=0.; tottime=0
   lsnheat=0.
!$omp  parallel &
!$omp private(niter, p,i,sn_energy,starpos,searchrad, &
!$omp  mythread,totalthread,starent,low,up,time1,time2,p_acc) &
!$omp shared( npp,tnu,dt,lsnheat,ts) if(npp.gt.50) &
!$omp reduction( max : maxtime) &
!$omp reduction(+ : tottime) &
!$omp reduction( min : mintime)
        mythread=0
        totalthread=1
!$      mythread=omp_get_thread_num()
!$      totalthread=omp_get_num_threads()
  allocate(p_acc(nsph,3))
  call wall_time(time1)
  p_acc(1:nsph,1:3)=0.
!$omp do reduction(+ : lsnheat)
 do i=1,npp   
  p=templist(i)
  if(p.LE.nbodies-nbh) then
   sn_energy=sne_eff*mass(p)*(sn_activity(tnu-tform(p))-sn_activity(tnu-tform(p)-dt))  
  else
! test  
   sn_energy=bh_rad_eff*bh_fdbk_eff*(tfeedb(p)-0.25*mass(p)/ts)*mc2fac*MIN(dt,tbubble)
  endif 
  lsnheat=lsnheat+sn_energy
  if(sn_energy.GT.0.OR.snentropy(p).GT.0) then
   starpos=pos(p,1:3)
   searchrad=hsmooth(p)
   starent=snentropy(p)
   if(searchrad.LT.0.OR.searchrad.GT.hboxsize) then
    print*,searchrad
    call terror('pres. searchrad')
   endif 
   call pressureparticle(starpos,starent,sn_energy,searchrad,p_acc)
   hsmooth(p)=searchrad
   snentropy(p)=starent
   if(snentropy(p).lt.0) snentropy(p)=0.
   if(tnu-tform(p).GT.tbubble) then
    snentropy(p)=0. 
    hsmooth(p)=0.
   endif 
  endif
 enddo
!$omp enddo nowait
 call wall_time(time2)

if(nsphact.GT.0) then
  p_acc(1:pactive(1)-1,1:3)=0.
  do i=2,nsphact
   if(pactive(i-1).GE.pactive(i)) then
!$omp critical   
    call terror(' serious feedback error')
!$omp end critical
   endif
   p_acc(pactive(i-1)+1:pactive(i)-1,1:3)=0.
  enddo
 p_acc(pactive(nsphact)+1:nsph,1:3)=0.

 niter=0
 do i=0,totalthread-1
  low=int(float(mod(i+mythread,totalthread))/totalthread*nsph)+1
  up= int(float(mod(i+mythread,totalthread)+1)/totalthread*nsph)
  do p=low,up
   niter=niter+1
   acc(p,1)=acc(p,1)+p_acc(p,1)
   acc(p,2)=acc(p,2)+p_acc(p,2)
   acc(p,3)=acc(p,3)+p_acc(p,3)
  enddo
!$omp barrier
 enddo
 if(niter.NE.nsph) then
!$omp critical   
    call terror(' pp_feedback inconsistent iter count')
!$omp end critical
 endif
endif 
 mintime=MIN(mintime,time2-time1)
 maxtime=MAX(maxtime,time2-time1)
 tottime=tottime+time2-time1
 deallocate(p_acc)
!$omp end parallel
 snheat=snheat+lsnheat
 if(verbosity.GT.0) then
   write(*,'(" <pressureparticle> time:", 3f8.2)') maxtime,mintime,tottime
 endif
 
end subroutine pp_feedback


subroutine pressureparticle(spos,starent,dstarent,hsearch,p_acc)
 include 'globals.h'
 real,intent(in) :: spos(3),dstarent
 real, intent(inout) :: hsearch,starent,p_acc(nsph,3)
 real :: dens,ddens
 integer :: i,p,nneigh
  searchreuse=0
  nneigh=0
  call hsmdenspos2(spos,hsearch,dens,ddens,nneigh)
  if(nneigh.EQ.0.OR.dens.eq.0) return
  starent=starent+dstarent*gamma1/dens**gamma1
  if(starent.GT.0) call scatterfeedbackco(spos,hsearch,nneigh,dens,ddens,starent,p_acc)     
end

subroutine scatterfeedbackco(spos,hsearch,n,dens,ddens,starent,p_acc)
 include 'globals.h' 
 integer,intent(in) :: n
 real,intent(in) :: spos(3),dens,ddens,hsearch,starent
 real,intent(inout) :: p_acc(nsph,3)
 real :: rhog2,fj,dptot(3)
 real hsminv,dwnorm,distnorm,dx,dy,dz,dr2,dr2p,drw,dwsm,dwmass &
      , aij,drdp,mindrdp,wnorm,wsm
 integer i,p,iwsm,nearsph
 real mindist2
 integer, parameter :: mcorrect=1 ! 0=no, 1=smooth,2=closest,3=inproduct

 if(n.EQ.0.or.dens.le.0) then
!$omp critical
  call terror(' impossible feedback dens error')
!$omp end critical 
 endif

 rhog2=dens**(gamma-2)
 fj=1/(1+ddens*hsearch/3/(dens+rhomin))
 hsminv=1./hsearch
 wnorm=piinv*hsminv*hsminv*hsminv
 dwnorm=piinv*hsminv*hsminv*hsminv*hsminv*hsminv
 distnorm=hsminv**2*deldr2i
 dptot=0.
 
 mindist2=4*hsearch**2
 nearsph=0 
  
 do i=1,n
  p=srlist(i)
  tempvect(i)=0.
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  dr2p=dr2*distnorm
  if(ninterp.GT.dr2p) then
  if(dr2.LE.mindist2.and.mass(p).GT.0) then
   nearsph=p
   mindist2=dr2
  endif 
  iwsm=INT(dr2p)
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  tempvect(i)=wnorm*wsm

  dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
  dwmass=dwnorm*dwsm
  
  aij=fj*starent*rhog2*dwmass
  p_acc(p,1)=p_acc(p,1)+aij*dx
  p_acc(p,2)=p_acc(p,2)+aij*dy
  p_acc(p,3)=p_acc(p,3)+aij*dz

  dptot(1)=dptot(1)+aij*mass(p)*dx
  dptot(2)=dptot(2)+aij*mass(p)*dy
  dptot(3)=dptot(3)+aij*mass(p)*dz
  
  endif
 enddo   
 
 if(mcorrect.EQ.3) then
  nearsph=0
  mindrdp=2*hsearch*sqrt(dptot(1)**2+dptot(2)**2+dptot(3)**2)
  do i=1,n
   p=srlist(i)
   dx=pos(p,1)-spos(1)
   dy=pos(p,2)-spos(2)
   dz=pos(p,3)-spos(3)
   if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
   if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
   if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
   if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
   if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
   if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
   drdp=dx*dptot(1)+dy*dptot(2)+dz*dptot(3)  
   if(drdp.LE.mindrdp.AND.tempvect(i).GT.0.AND.mass(p).GT.0) then
    nearsph=p
    mindrdp=drdp
   endif 
  enddo
 endif
 
 if(mcorrect.GT.1) then
  if(nearsph.eq.0) then 
!$omp critical
  call terror(' feedback oeps')
!$omp end critical  
  endif
  p_acc(nearsph,1)=p_acc(nearsph,1)-dptot(1)/mass(nearsph) 
  p_acc(nearsph,2)=p_acc(nearsph,2)-dptot(2)/mass(nearsph) 
  p_acc(nearsph,3)=p_acc(nearsph,3)-dptot(3)/mass(nearsph) 
 endif
 
 if(mcorrect.EQ.1) then
  do i=1,n
   p=srlist(i)
   p_acc(p,1)=p_acc(p,1)-dptot(1)*tempvect(i)/dens
   p_acc(p,2)=p_acc(p,2)-dptot(2)*tempvect(i)/dens
   p_acc(p,3)=p_acc(p,3)-dptot(3)*tempvect(i)/dens
  enddo
 endif
 
end subroutine
 
! ******** sn_activity ************************************************
! ***** returns cumulative sn energy/ unit mass as function of age ****
! (timestep independence)

function sn_activity(age)
 include 'globals.h'
 real, intent(in) :: age
 real :: sn_activity
 
 if(age.lt.tsnbeg) then
  sn_activity=0.
  return  
 endif 
 if(age.gt.tbubble) then
  sn_activity=snenergy
  return
 endif
 sn_activity=snenergy*(age-tsnbeg)/(tbubble-tsnbeg)
 
end function sn_activity

subroutine randomvelfeedback(dt,tnu)
 include 'globals.h'
 
   integer i,p,npp,niter
   integer mythread,totalthread,low,up
!$ integer omp_get_thread_num,omp_get_num_threads 
   real tnu,dt
   real starpos(ndim), searchrad,sn_energy
   real sn_activity,lsnheat,mc2fac
   real, allocatable :: p_vel(:,:)
   
   if(nsphact.EQ.0.OR.dt.eq.0)return
   npp=0   
   mc2fac=(lightspeed/velscale)**2

   do p=nbodies-nstar+1,nbodies
    if(tnu-tform(p)-dt.LE.tbubble) then
      npp=npp+1
      templist(npp)=p
    endif
   enddo
   if(verbosity.GT.0) print*,'<randomvelfeedback> sn particles:', npp   
   
   lsnheat=0.
!$omp parallel &
!$omp private(niter, p,i,sn_energy,starpos,searchrad,mythread,totalthread,low,up,p_vel) &
!$omp shared( npp,tnu,dt,lsnheat) if(npp.gt.50)
        mythread=0
        totalthread=1
!$      mythread=omp_get_thread_num()
!$      totalthread=omp_get_num_threads()
  allocate(p_vel(1:nsph,3))
  p_vel(1:nsph,1:3)=0.

!$omp do reduction(+ : lsnheat)
 do i=1,npp   
  p=templist(i)
! note: sn_energy is really a rate here !!
! (to be able to take account of individual timesteps)  
  if(p.LE.nbodies-nbh) then
   sn_energy=sne_eff*mass(p)*(sn_activity(tnu-tform(p))-sn_activity(tnu-tform(p)-dt))/dt  
  else
   sn_energy=bh_rad_eff*bh_fdbk_eff*tfeedb(p)*mc2fac
  endif 

  lsnheat=lsnheat+sn_energy*dt
  if(sn_energy.GT.0) then
   starpos=pos(p,1:3)
   searchrad=hsmooth(p)
   if(searchrad.LT.0.OR.searchrad.GT.hboxsize) then
    print*,searchrad
    call terror('kine searchrad')
   endif    
   call randomvelo(starpos,sn_energy,searchrad,p_vel,p)
   hsmooth(p)=searchrad
  endif
 enddo
!$omp enddo nowait

! p_vel is calculated with sn_energy rate, scales with sqrt(t)
! (maintain independence of timestep)
 if(nsphact.GT.0) then
  p_vel(1:pactive(1)-1,1:3)=0.
  p_vel(pactive(1),1:3)=p_vel(pactive(1),1:3)*SQRT(dtime/2**(itimestp(pactive(1))-1))
  do i=2,nsphact
   do p=pactive(i-1)+1,pactive(i)-1
    p_vel(p,1:3)=0.
   enddo
  p_vel(pactive(i),1:3)=p_vel(pactive(i),1:3)*SQRT(dtime/2**(itimestp(pactive(i))-1))
  enddo
  p_vel(pactive(nsphact)+1:nsph,1:3)=0.

 niter=0
 do i=0,totalthread-1
  low=int(float(mod(i+mythread,totalthread))/totalthread*nsph)+1
  up= int(float(mod(i+mythread,totalthread)+1)/totalthread*nsph)
  do p=low,up
   niter=niter+1
   vel(p,1)=vel(p,1)+p_vel(p,1)
   vel(p,2)=vel(p,2)+p_vel(p,2)
   vel(p,3)=vel(p,3)+p_vel(p,3)
  enddo
!$omp barrier
 enddo
 if(niter.NE.nsph) then
!$omp critical   
    call terror(' randomvelfeedback inconsistent iter count')
!$omp end critical
 endif
 endif
 deallocate(p_vel)
!$omp end parallel
 snheat=snheat+lsnheat

end subroutine

subroutine randomvelo(spos,energy,hsearch,p_vel,pid)
 include 'globals.h'
 real,intent(in) :: spos(3),energy
 real,intent(inout) :: hsearch,p_vel(nsph,3)
 real :: dens,ddens
 integer :: nneigh,i,p,pid,j
 real :: dx,dy,dz,dvx,dvy,px,py,pz,pRND
 real :: hsminv,wnorm,distnorm, dr2p,wsm,dr2,drw
 integer :: iwsm 
 
  searchreuse=0
  nneigh=0
  call hsmdenspos2(spos,hsearch,dens,ddens,nneigh)
  if(dens.EQ.0.OR.nneigh.EQ.0) return
  px=0;py=0;pz=0
  j=0
 hsminv=1./hsearch
 wnorm=piinv*hsminv*hsminv*hsminv
 distnorm=hsminv**2*deldr2i  
 do i=1,nneigh
  p=srlist(i)
  tempvect(i)=0.
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  dr2p=dr2*distnorm
  if(ninterp.GT.dr2p) then
  iwsm=INT(dr2p)
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  tempvect(i)=wnorm*wsm
  endif
 enddo   
  do i=1,nneigh
   p=srlist(i)   
100     continue
         dx=2*pRND(p+3*(pid+j))-1.
         dy=2*pRND(p+3*(pid+j)+1)-1.
         dz=2*pRND(p+3*(pid+j)+2)-1.
         dvx=dx**2+dy**2+dz**2
         j=j+1
	 if(dvx.GE.1.) goto 100 
    dvy=4./3.*SQRT(2*energy*tempvect(i)/dens*sne_eff)
    p_vel(p,1)=p_vel(p,1)+dx*dvy
    p_vel(p,2)=p_vel(p,2)+dy*dvy
    p_vel(p,3)=p_vel(p,3)+dz*dvy
    px=px+dx*dvy*mass(p)
    py=py+dy*dvy*mass(p)
    pz=pz+dz*dvy*mass(p)
  enddo

  do i=1,nneigh
   p=srlist(i)
    p_vel(p,1)=p_vel(p,1)-px*tempvect(i)/dens ! tempvect already divided by mass
    p_vel(p,2)=p_vel(p,2)-py*tempvect(i)/dens
    p_vel(p,3)=p_vel(p,3)-pz*tempvect(i)/dens
  enddo
end

subroutine energyfeedback(dt,tnu)
 include 'globals.h'
 
   integer i,p,npp,niter
   integer mythread,totalthread,low,up
!$ integer omp_get_thread_num,omp_get_num_threads 
   real tnu,dt
   real starpos(ndim), searchrad,sn_energy
   real sn_activity,ethtoent,lsnheat,mc2fac
   real, allocatable :: p_eth(:)
   
   npp=0
   mc2fac=(lightspeed/velscale)**2

   do p=nbodies-nstar+1,nbodies
    if(tnu-tform(p)-dt.LE.tbubble) then
     npp=npp+1
     templist(npp)=p
    endif
   enddo
   lsnheat=0.
!$omp parallel &
!$omp private(niter,p,i,sn_energy,starpos,searchrad,mythread,totalthread,low,up,p_eth) &
!$omp shared( npp,tnu,dt,lsnheat) if(npp.gt.50)
        mythread=0
        totalthread=1
!$      mythread=omp_get_thread_num()
!$      totalthread=omp_get_num_threads()
  allocate(p_eth(nsph))
  p_eth(1:nsph)=0.

!$omp do reduction(+ : lsnheat)
 do i=1,npp   
  p=templist(i)
  if(p.LE.nbodies-nbh) then
   sn_energy=sne_eff*mass(p)*(sn_activity(tnu-tform(p))-sn_activity(tnu-tform(p)-dt))  
  else
   sn_energy=bh_rad_eff*bh_fdbk_eff*tfeedb(p)*mc2fac*MIN(dt,tbubble)
  endif 
  
  lsnheat=lsnheat+sn_energy
  if(sn_energy.GT.0) then
   starpos=pos(p,1:3)
   searchrad=epsgrav(p)
   call energyreturn(starpos,sn_energy,searchrad,p_eth)
  endif
 enddo
!$omp enddo nowait

 if(nsphact.GT.0) then
  p_eth(1:pactive(1)-1)=0.
  do i=2,nsphact
   do p=pactive(i-1)+1,pactive(i)-1
    p_eth(p)=0.
   enddo
  enddo
  p_eth(pactive(nsphact)+1:nsph)=0.

  niter=0
  do i=0,totalthread-1
  low=int(float(mod(i+mythread,totalthread))/totalthread*nsph)+1
  up= int(float(mod(i+mythread,totalthread)+1)/totalthread*nsph)
  do p=low,up
   niter=niter+1
   ethermal(p)=ethermal(p)+p_eth(p)
   ethold(p)=ethold(p)+p_eth(p)
  enddo
!$omp barrier
  enddo
 if(niter.NE.nsph) then
!$omp critical   
    call terror(' energyfeedback inconsistent iter count')
!$omp end critical
 endif
 endif
 deallocate(p_eth)
!$omp end parallel
 snheat=snheat+lsnheat

 if(uentropy) then
  do i=1,nsphact
   p=pactive(i)
   ethtoent=gamma1/rho(p)**gamma1
   csound(p)=SQRT(gamma*gamma1*ethermal(p)/ethtoent)
  enddo
 else
  do i=1,nsphact
   p=pactive(i)
   ethtoent=1
   csound(p)=SQRT(gamma*gamma1*ethermal(p)/ethtoent)
  enddo
 endif
 
end subroutine

subroutine energyreturn(spos,energy,hsearch,p_eth)
 include 'globals.h'
 real,intent(in) :: spos(3),energy
 real,intent(inout) :: hsearch,p_eth(nsph)
 integer :: nneigh,i,p,nearsph
 real :: dist2,dist2a
 
 nneigh=0
 do while(nneigh.eq.0)
 hsearch=2*hsearch
 call search_d2(root,hsearch,spos,nneigh,srlist,tempvect)
 enddo
 if(nneigh.gt.0) then
  dist2=hsearch**2
  nearsph=0
  do i=1,nneigh
      dist2=tempvect(i)
      p=srlist(i)
      if(dist2.gt.dist2a.and.mass(p).GT.0) then
        dist2=dist2a
        nearsph=p
      endif 
  enddo
  if(nearsph.eq.0) call terror(' weird solo error')
  if(uentropy) then
   p_eth(nearsph)=p_eth(nearsph)+energy/mass(nearsph)*gamma1/rho(nearsph)**gamma1
  else
   p_eth(nearsph)=p_eth(nearsph)+energy/mass(nearsph)  
  endif
 else
  print*,'*** feedback does not find particle ??'
 endif 
end

subroutine heatingfeedback(dt,tnu)
 include 'globals.h'
 
   integer i,p,npp,niter
   integer mythread,totalthread,low,up
!$ integer omp_get_thread_num,omp_get_num_threads 
   real tnu,dt
   real starpos(ndim), searchrad,sn_energy
   real sn_activity,ethtoent,lsnheat,mc2fac
   real, allocatable :: pesn(:)
   
   npp=0
   mc2fac=(lightspeed/velscale)**2
   if(nsphact.GT.0.OR.dt.eq.0)return

! be careful: 
   do i=1,nsphact
    esnthdt(pactive(i))=0.
   enddo
   
   do p=nbodies-nstar+1,nbodies
    if(tnu-tform(p)-dt.LE.tbubble) then
     npp=npp+1
     templist(npp)=p
    endif
   enddo
   lsnheat=0.
!$omp parallel &
!$omp private(niter,p,i,sn_energy,starpos,searchrad,mythread,totalthread,low,up,pesn) &
!$omp shared( npp,tnu,dt,lsnheat) if(npp.gt.50)
        mythread=0
        totalthread=1
!$      mythread=omp_get_thread_num()
!$      totalthread=omp_get_num_threads()
  allocate(pesn(nsph))
  pesn(1:nsph)=0.

!$omp do reduction(+ : lsnheat)
 do i=1,npp   
  p=templist(i)
  if(p.LE.nbodies-nbh) then
   sn_energy=sne_eff*mass(p)*(sn_activity(tnu-tform(p))-sn_activity(tnu-tform(p)-dt))  
  else
   sn_energy=bh_rad_eff*bh_fdbk_eff*tfeedb(p)*mc2fac*MIN(dt,tbubble)
  endif 
  lsnheat=lsnheat+sn_energy*dt
  sn_energy=sn_energy/dt
  if(sn_energy.GT.0) then
   starpos=pos(p,1:3)
   searchrad=epsgrav(p)
   call singlepheating(starpos,sn_energy,searchrad,pesn)
  endif
 enddo
!$omp enddo nowait

 if(nsphact.GT.0) then
  pesn(1:pactive(1)-1)=0.
  do i=2,nsphact
   do p=pactive(i-1)+1,pactive(i)-1
    pesn(p)=0.
   enddo
  enddo
  pesn(pactive(nsphact)+1:nsph)=0.

  niter=0
  do i=0,totalthread-1
  low=int(float(mod(i+mythread,totalthread))/totalthread*nsph)+1
  up= int(float(mod(i+mythread,totalthread)+1)/totalthread*nsph)
  do p=low,up
   niter=niter+1
   esnthdt(p)=esnthdt(p)+pesn(p)
  enddo
!$omp barrier
  enddo
 if(niter.NE.nsph) then
!$omp critical   
    call terror(' heatingfeedback inconsistent iter count')
!$omp end critical
 endif
 endif
 deallocate(pesn)
!$omp end parallel
! snheat=snheat+lsnheat
 
end subroutine

subroutine singlepheating(spos,energy,hsearch,pesn)
 include 'globals.h'
 real,intent(in) :: spos(3),energy
 real,intent(inout) :: hsearch,pesn(nsph)
 integer :: nneigh,i,p,nearsph
 real :: dist2,dist2a
 
 nneigh=0
 do while(nneigh.eq.0)
 hsearch=2*hsearch
 call search_d2(root,hsearch,spos,nneigh,srlist,tempvect)
 enddo
 if(nneigh.gt.0) then
  dist2=hsearch**2
  nearsph=0
  do i=1,nneigh
      dist2=tempvect(i)
      p=srlist(i)
      if(dist2.gt.dist2a.and.mass(p).GT.0) then
        dist2=dist2a
        nearsph=p
      endif 
  enddo
  if(nearsph.eq.0) call terror(' weird solh error')
  pesn(nearsph)=pesn(nearsph)+energy/mass(nearsph)  
 else
  print*,'*** feedback does not find particle ??'
 endif 
end

 subroutine writefits(filename,naxis,naxes,pic)
      integer status,unit,blocksize,bitpix,naxis,naxes(3)
      integer i,j,k,group,fpixel,nelements
      real pic(:,:)
      character filename*80
      logical simple,extend

      status=0

!      filename='HImap.fits'
      
      call deletefile(filename,status)
      call ftgiou(unit,status)

      blocksize=1
      call ftinit(unit,filename,blocksize,status)

      simple=.true.
      bitpix=-64
!      naxis=2
!      naxes(1)=nx
!      naxes(2)=ny
      extend=.true.

      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)

      group=1
      fpixel=1
      nelements=1
      do i=1,naxis
       nelements=naxes(i)*nelements
      enddo
      call ftpprd(unit,group,fpixel,nelements,pic,status)

      call ftclos(unit, status)
      call ftfiou(unit, status)
      
      if (status .gt. 0)call printerror(status)
      end subroutine
          
      subroutine printerror(status)


      integer status
      character errtext*30,errmessage*80

      if (status .le. 0)return
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      enddo
      end subroutine
      
      
      subroutine deletefile(filename,status)
      integer status,unit,blocksize
      character*(*) filename

      if (status .gt. 0)return

      call ftgiou(unit,status)

      call ftopen(unit,filename,1,blocksize,status)

      if (status .eq. 0)then
          call ftdelt(unit,status)
      else if (status .eq. 103)then
          status=0
          call ftcmsg
      else
          status=0
          call ftcmsg
          call ftdelt(unit,status)
      end if

      call ftfiou(unit, status)
      end subroutine


subroutine WriteMap(filename,tauname)
  use MakeMapMod
  implicit none
  character, optional :: filename*80,tauname*80
  character :: file*80
  integer :: naxes(3)
 
  interface 
   subroutine writefits(fname,naxis,naxes,pic)
      integer status,unit,naxis,naxes(3)
      real pic(:,:)
      character fname*80
    end subroutine
  end interface
  
  if(present(filename)) then
   file=filename
  else
   print*,' uit filenaam?'
   read*, file
  endif
 
  naxes(1)=nx
  naxes(2)=ny
  if(file(1:5).NE.'XXXXX') call writefits(file,2,naxes,pic)
 
  if(extinction.eq.1) then
   
  if(present(tauname)) then
   file=tauname
  else
   print*,' tau filenaam?'
   read*, file
  endif
 
  naxes(1)=nx
  naxes(2)=ny
  if(file(1:5).NE.'XXXXX') call writefits(file,2,naxes,opdepth)

  endif  
 
 end subroutine

! fromgabe
  function Hui_HII_recombB(T)
    real :: T
    real :: Hui_HII_recombB, lambda
    real, parameter :: T_HI=1.57807d5

    lambda = 2.d0 * T_HI / T
    Hui_HII_recombB = 2.753d-14 * lambda**1.500d0 / &
         ( 1.d0 + (lambda/2.740d0)**0.407d0 )**2.242d0

  end function Hui_HII_recombB


 subroutine projectparticles(mapmode)
 use MakeMapMod
 use StarsMod
 use ElementsMod
 use CoolingMod
 use fccoMod
  include 'globals.h'
  character(len=5) :: mapmode
  integer :: np,test,inear,i,p,bandnr,C
  real :: band(20),taufactor,clustersize,clustertime,rhoconst
  real :: hsearch,getlocalscale
  real :: pe,qc,fcoc,g0,zmetal,ethtoent
  real, external :: pRND
  real :: fha=0.3
  real, allocatable :: himass(:),gpos(:,:),hsm(:),opacs(:)
  integer, allocatable :: pindex(:)
  real, external :: Hui_HII_recombB

! set some constants 
 clustersize=0.04/unitl_in_kpc
 clustertime=10**7*year
 taufactor=6.25e-8*unitm_in_msun/unitl_in_kpc**2*fhydrogn*zQ()/solarzQ()
 rhoconst=6.7678e-32*unitm_in_msun/unitl_in_kpc**3
 zmetal=zQ()/solarzQ()
 C=elementnrQ("C   ")

 select case(mapmode)
 
 case('XXXXX')
  print*,'you have found the projectparticle debug mode!'
  print*,'N?'
  read*,np
 case('gas')
  np=nsph   
 case('dark')
  np=nbodies-nstar-nsph
 case('all')
  np=nbodies 
 case('HI')
  np=nsph
 case('H2')
  np=nsph
 case('Ha')
  np=nstar+nsph
 case('Ha2')
  np=nstar+nsph
 case('FUV')
  np=nstar+nsph
 case('stars')
  np=nstar
 case('new')
  np=nstar
 case('unst')
  np=nsph
 case('C')
  np=nsph
  call fccoInit
 case('CO')
  np=nsph   
  call fccoInit
 case('LC')
  np=nsph
  call fccoInit
 case('LCO')
  np=nsph   
  call fccoInit
 case('Ccool')
  np=nsph
 case default
  call startree
  bandnr=IACHAR(mapmode(1:1))-IACHAR('0')
  if(bandnr.LT.1.OR.bandnr.GT.nbandsQ()) &
    call terror('mapmode error')
  np=nsph+nstar
 end select

 allocate(gpos(np,1:3),hsm(np),himass(np),opacs(np),pindex(np),stat=test)
 if(test.NE.0) call terror('project mem. alloc. fails')

 select case(mapmode)
 
 case('XXXXX')
  print*,'give particle info: x,y,z,size,mass,opac'
  do i=1,np
   read*,gpos(i,1),gpos(i,2),gpos(i,3),hsm(i),himass(i),opacs(i) 
   pindex(i)=i
  enddo
 case('gas')
  np=nsph   
  do i=1,nsph
   himass(i)=unitm_in_msun*mass(i)
   gpos(i,1:3)=pos(i,1:3)
   hsm(i)=epsgrav(i)
   opacs(i)=0.
   pindex(i)=nbexist(i)
  enddo
 case('dark')
  np=nbodies-nstar-nsph
  do i=1,np
   p=nsph+i
   himass(i)=unitm_in_msun*mass(p)
   gpos(i,1:3)=pos(p,1:3)
   hsm(i)=epsgrav(p)
   opacs(i)=0.
   pindex(i)=nbexist(p)
  enddo
 case('all')
  np=nbodies 
  do i=1,nbodies
   himass(i)=unitm_in_msun*mass(i)
   gpos(i,1:3)=pos(i,1:3)
   hsm(i)=epsgrav(i)
   opacs(i)=0.
   pindex(i)=nbexist(i)
  enddo
 case('stars')
  np=nstar
  do i=1,nstar
   p=nbodies-nstar+i
   himass(i)=unitm_in_msun*mass(p)
   gpos(i,1:3)=pos(p,1:3)
   hsm(i)=epsgrav(p)
   pindex(i)=nbexist(p)
  enddo
 case('new')
  np=0
  do i=1,nstar-nbh
   p=nbodies-nstar+i
   if((tnow-tform(p))*timescale.LE.5.e6*year) then
    np=np+1
    himass(np)=unitm_in_msun*mass(p)
    gpos(np,1:3)=pos(p,1:3)
    hsm(np)=epsgrav(p)
    pindex(np)=nbexist(p)
   endif
  enddo
 case('HI')
  np=nsph
  do i=1,nsph
   himass(i)=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))*max(0.,1-h2frac(i))
   gpos(i,1:3)=pos(i,1:3)
   hsm(i)=hsmooth(i)
   opacs(i)=0.
   pindex(i)=nbexist(i)
  enddo
 case('H2')
   np=nsph
   do i=1,nsph
    himass(i)=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))*max(0.,h2frac(i))
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)
    opacs(i)=0.
    pindex(i)=nbexist(i)
   enddo

  case('Ha')
   np=nstar+nsph
   do i=1,nsph
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)
    himass(i)=0
    opacs(i)=0.75*taufactor* &
      mass(i)*max(0.,1-elecfrac(i)) !   *max(0.,1-h2frac(i))
    pindex(i)=nbexist(i)
   enddo
   do i=1,nstar
    p=nbodies-nstar+i
    himass(i+nsph)=unitm_in_msun*mass(p)*ha((tnow-tform(p))*timescale/year)
    hsm(i+nsph)=epsgrav(p)
    gpos(i+nsph,1:3)=pos(p,1:3)
    opacs(i+nsph)=0.
    pindex(i+nsph)=nbexist(p)
   enddo  

  case('Ha2')
   np=nstar+nsph
   do i=1,nsph
    temperat(i)=10000
!    print*,mass(i),elecfrac(i),rho(i),temperat(i),fha
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)
    himass(i)=unitm_in_msun*mass(i)*min(elecfrac(i),1.)* &
  &    elecfrac(i)*densconst*rho(i)*fha*Hui_HII_recombB(temperat(i))
    opacs(i)=0.75*taufactor* &
      mass(i)*max(0.,1-elecfrac(i)) ! *max(0.,1-h2frac(i))
    pindex(i)=nbexist(i)
   enddo
   do i=1,nstar
    p=nbodies-nstar+i
    himass(i+nsph)=0
!    himass(i+nsph)=unitm_in_msun*mass(p)*ha((tnow-tform(p))*timescale/year)
    hsm(i+nsph)=epsgrav(p)
    gpos(i+nsph,1:3)=pos(p,1:3)
    opacs(i+nsph)=0.
    pindex(i+nsph)=nbexist(p)
   enddo  

  case('FUV')
   np=nstar+nsph
   do i=1,nsph
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)
    himass(i)=0
    opacs(i)=3.*taufactor*mass(i)*max(0.,1-elecfrac(i)) ! *max(0.,1-h2frac(i))
    pindex(i)=nbexist(i)
   enddo
   do i=1,nstar
    p=nbodies-nstar+i
    himass(i+nsph)=unitm_in_msun*mass(p)*dFUV((tnow-tform(p))*timescale/year)
    gpos(i+nsph,1:3)=pos(p,1:3)
    hsm(i+nsph)=epsgrav(p)
    opacs(i+nsph)=0.
    pindex(i+nsph)=nbexist(p)
  enddo

  case('unst')
  np=0
  do i=1,nsph
   if(rho(i)*pi/6.*(csound(i)**2*pi/rho(i))**1.5.GT.masscrit) then
    np=np+1
    gpos(np,1:3)=pos(i,1:3)
    hsm(np)=hsmooth(i)
    himass(np)=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))*max(0.,1-h2frac(i))
    pindex(np)=nbexist(i)
   endif
  enddo
  
  case('C')
   np=nsph
   do i=1,nsph
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)
    if(uentropy) then 
      ethtoent=gamma1/rho(p)**gamma1
    else 
      ethtoent=1
    endif
    pe=(gamma1*ethermal(i)/ethtoent+vdisp(i)**2/3.)*velscale**2*rho(i)*rhoconst/kboltz
    g0=fuvheat(i)/heatconst/2/1.71  ! /2: half is blocked, /1.71: Habing -> Draine
    fcoc=fcco(rho(i)*densconst,G0,Pe,zmetal)
    qc=q1c(temperat(i))
    himass(i)=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))* & 
      min(fcoc,h2frac(i))
    pindex(i)=nbexist(i)
   enddo

  case('CO')
   np=nsph
   do i=1,nsph
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)    
    if(uentropy) then 
      ethtoent=gamma1/rho(p)**gamma1
    else 
      ethtoent=1
    endif
    pe=(gamma1*ethermal(i)/ethtoent+vdisp(i)**2/3.)*velscale**2*rho(i)*rhoconst/kboltz
    g0=fuvheat(i)/heatconst/2/1.71  ! /2: half is blocked, /1.71: Habing -> Draine
    fcoc=fcco(rho(i)*densconst,G0,Pe,zmetal)
    qc= q1co(temperat(i))
    himass(i)=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))* &
      min(fcoc,h2frac(i))
    pindex(i)=nbexist(i)
   enddo
   
  case('LC')
   np=nsph
   do i=1,nsph
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)
    if(uentropy) then 
      ethtoent=gamma1/rho(p)**gamma1
    else 
      ethtoent=1
    endif
    pe=(gamma1*ethermal(i)/ethtoent+vdisp(i)**2/3.)*velscale**2*rho(i)*rhoconst/kboltz
    g0=fuvheat(i)/heatconst/2/1.71  ! /2: half is blocked, /1.71: Habing -> Draine
    fcoc=fcco(rho(i)*densconst,G0,Pe,zmetal)
    qc=q1c(temperat(i))
    himass(i)=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))* & 
      min(fcoc,h2frac(i))*qc*zmetal
    pindex(i)=nbexist(i)
   enddo

  case('LCO')
   np=nsph
   do i=1,nsph
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)    
    if(uentropy) then 
      ethtoent=gamma1/rho(p)**gamma1
    else 
      ethtoent=1
    endif
    pe=(gamma1*ethermal(i)/ethtoent+vdisp(i)**2/3.)*velscale**2*rho(i)*rhoconst/kboltz
    g0=fuvheat(i)/heatconst/2/1.71  ! /2: half is blocked, /1.71: Habing -> Draine
    fcoc=fcco(rho(i)*densconst,G0,Pe,zmetal)
    qc= q1co(temperat(i))
    himass(i)=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))* &
      min(fcoc,h2frac(i))*qc*zmetal
    pindex(i)=nbexist(i)
   enddo
   
  case('Ccool')
   np=nsph
   do i=1,nsph
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)    
    himass(i)=unitm_in_msun*mass(i)*cool_par*rho(i)* &
      ElementCoolFunc(elecfrac(i),temperat(i),C)
    pindex(i)=nbexist(i)   
   enddo
   print*,'lum:',sum(himass(1:nsph))
    
  case default
   np=nsph+nstar
   do i=1,nsph
    gpos(i,1:3)=pos(i,1:3)
    hsm(i)=hsmooth(i)
    himass(i)=0
    opacs(i)=axavQ(bandnr)*taufactor* &
      mass(i)*max(0.,1-elecfrac(i)) ! *max(0.,1-h2frac(i))   
    pindex(i)=nbexist(i)   
   enddo
   do i=1,nstar
    p=nbodies-nstar+i
    band=mbands((tnow-tform(p))*timescale/year)
    gpos(i+nsph,1:3)=pos(p,1:3)
    himass(i+nsph)=unitm_in_msun*mass(p)*band(bandnr)
    hsearch=getlocalscale(pos(p,1:3))
    call nnscalefix(pos(p,1:3),hsearch,inear,targetnn,nn_tol,root)
!    hsearch=0.05
!    inear=0
!    call search(root,2*hsearch,pos(p,1:3),inear,bodlist)
!    print*,p,hsearch,inear
!    hsm(nsph+i)= &
!      MIN(hsearch,clustersize*(1+((tnow-tform(p))*timescale/clustertime)))   
!    hsearch=eps
!    hsm(nsph+i)=0.05-hsearch*log( MAX(pRND(nbexist(p)+4),0.00001) )
    hsm(nsph+i)=-hsearch*log( MAX(pRND(nbexist(p)+4),0.00001) )/2. &
                -hsearch*log( MAX(pRND(3*nbexist(p)+4),0.00001) )/2.
!    hsm(nsph+i)=hsearch*2*pRND(nbexist(p)+4)
    pindex(nsph+i)=nbexist(p)
    opacs(nsph+i)=0.
   enddo  
  end select

  if(np.GT.0) call project(np,gpos,hsm,himass,opacs,pindex)

  deallocate(gpos,hsm,himass,opacs,pindex)

 end subroutine



subroutine maphimap(nmap)
 use MakeMapMod
 use StarsMod
 use ElementsMod
 include 'globals.h'
 integer nmap
 integer,parameter :: ndigits=6,maxmap=100
 character(len=ndigits) :: nstring
 character(len=80) :: filenaam,opnaam
 character(len=8) :: identify(maxmap)
 character(len=5) :: mapmode(maxmap)
 integer :: imsize(maxmap,2),proj(maxmap),ext(maxmap)
 integer, save :: maps=0 
 real  :: focus(maxmap,3), pointing(maxmap,3), &
           upvector(maxmap,3),width(maxmap),zmin(maxmap)
 integer :: ioerror,i,j,skipfactor,oldseed
 
 interface
   subroutine WriteMap(filename,tauname)
     character, optional :: filename*80,tauname*80
   end subroutine
 end interface
! reset rndtable to fixed seed (to get consistency for random stars) 
 oldseed=rnseed
 rnseed=initialseed
 call setRND
 rnseed=oldseed

 skipfactor=1  
 call itos(nmap,ndigits,nstring)
  
! read image info (if present)
 open(unit=upars, file='image', status='OLD', iostat=ioerror)
 if(ioerror.NE.0) RETURN

 read(upars,*,iostat=ioerror) maps, skipfactor
   if(skipfactor.LE.0) skipfactor=1
   if(maps.GT.maxmap) maps=maxmap
   if(maps.GT.0) then
    do i=1,maps
    read(upars,*,iostat=ioerror) mapmode(i)
    read(upars,*,iostat=ioerror) identify(i)
    read(upars,*,iostat=ioerror) imsize(i,1:2)
    read(upars,*,iostat=ioerror) focus(i,1:3)
    read(upars,*,iostat=ioerror) pointing(i,1:3)
    read(upars,*,iostat=ioerror) upvector(i,1:3)
    read(upars,*,iostat=ioerror) width(i)
    read(upars,*,iostat=ioerror) proj(i)
    read(upars,*,iostat=ioerror) ext(i)
    read(upars,*,iostat=ioerror) zmin(i)
    if(width(i).eq.0.and.proj(i).eq.0) width(i)=rsize
    if(width(i).eq.0.and.proj(i).eq.1) width(i)=45.
    enddo
   endif
   if(ioerror.NE.0) then
    print*,' stop -- error reading image info'
    stop
   endif
  close(upars)
  
 if(mod(nmap,skipfactor).NE.0) return 

 do j=1,maps
  call Initmap(imsize(j,1:2),width(j),focus(j,1:3),pointing(j,1:3),upvector(j,1:3),proj(j),ext(j),zmin(j))

  if(verbosity.GT.0) print*,'<map> ',identify(j),imsize(j,1:2)

  call projectparticles(mapmode(j))

  filenaam=trim(outputfile)//'-'//nstring//'_'//trim(identify(j))//'.fits'
  opnaam='XXXXX'
  if(ext(j).EQ.1.AND.j.EQ.maps) opnaam='opacity'
  call WriteMap(filenaam,opnaam)
  call EndMap
 enddo
end subroutine

module HICubeMod
 implicit none
 private
 public:: InitHICube, projectparticle,EndCube

 real,save :: xsize,ysize,vsize
 integer,save :: nx,ny,nv
 real,save :: dx,dy,dv
 real,save :: centerv
 real,save,dimension(3) :: lookat,xax,yax,direction

 real, allocatable,save :: cube(:,:,:),scratch(:,:,:)
 
 real,parameter :: maxx=2,maxy=2,maxv=3
 real,parameter :: Pi=3.141592654

 contains

 subroutine InitHICube
  real :: up(3)
  integer :: test
  
  print*,' image pixel size (WxH), velocity channels?'
  read*,nx,ny,nv
  print*,' image width, velocity range?'
  read*,xsize,vsize
  print*,' look at?'
  read*, lookat
  print*,' direction?'
  read*,direction
  print*,' upvector'
  read*,up
  print*,' system velocity?'
  read*,centerv

  allocate(cube(nx,ny,nv),scratch(nx,ny,nv),STAT=test)  
  if(test.NE.0) call cubeError(1)
   cube=0.

  
  dx=(xsize)/(nx-1)
  dy=dx
  ysize=dx*(ny-1)
  dv=(vsize)/(nv-1)
  
  print*,dx,dy,dv
  call normalize(direction)
  call outer(xax,direction,up)
  call normalize(xax)
  call outer(yax,xax,direction)
  call normalize(yax)
  print*,xax,yax

 end subroutine

 subroutine endCube

 call writefits

 deallocate(cube,scratch)
 
 end subroutine

 subroutine cubeError(i)
  integer i
  
  print*,i
  stop
 end subroutine

 subroutine projectparticle(pos,hsmooth,vel,dopplerwidth,mass)
  real :: pos(3),hsmooth,vel(3),dopplerwidth,mass,offset(3)
  integer i,j,k,isize,jsize,ksize
!  real, allocatable :: pimage(:,:,:)
  
  isize=2*maxx*hsmooth/dx+1
  jsize=2*maxy*hsmooth/dy+1
  ksize=2*maxv*dopplerwidth/dv+1
  if(isize.le.nx.and.jsize.le.ny.and.ksize.le.nv) then
  
  call positionp(i,j,k,offset,pos,hsmooth,vel,dopplerwidth)

!  allocate(pimage(isize,jsize,ksize))

  call makepimage(scratch,offset,isize,jsize,ksize,hsmooth,dopplerwidth)
  
  call addpimage(i,j,k,isize,jsize,ksize,scratch,mass)

  endif

!  deallocate(pimage)

 end subroutine


 subroutine addpimage(i,j,k,isize,jsize,ksize,pimage,mass)
  integer i,j,k,isize,jsize,ksize,n,m,l
  real mass,pimage(isize,jsize,ksize)
  
!  do n=1,isize
!   do m=1,jsize
!    do l=1,ksize
  do l=1,ksize
   do m=1,jsize
    do n=1,isize
    if((n+i.GE.1.AND.n+i.LE.nx).AND. &
       (m+j.GE.1.AND.m+j.LE.ny).AND. &
       (k+l.GE.1.AND.k+l.LE.nv)) then
       cube(n+i,m+j,l+k)=cube(n+i,m+j,l+k)+pimage(n,m,l)*mass
    endif    
    enddo
   enddo
  enddo  
  
 end subroutine

 subroutine makepimage(pimage,offset,isize,jsize,ksize,hsmooth,dw)
  integer :: isize,jsize,ksize
  real :: offset(3),hsmooth,dw,pimage(isize,jsize,ksize)
  real :: r,di,dj,dk,dens,norm,hinv,dwinv
  integer :: i,j,k
  
  hinv=1/hsmooth
  dwinv=1/dw
  norm=0.
  if(isize.eq.1.or.jsize.eq.1) then
   pimage(1:isize,1:jsize,1:ksize)=0.
   do k=1,ksize
    dk=-maxv*dw-offset(3)+(k-1)*dv
    dens=exp(-(dk*dwinv)**2/2)
    norm=norm+dens
    pimage((isize+1)/2,(jsize+1)/2,k)=dens
   enddo  
  else 
!  do i=1,isize
!   do j=1,jsize
!    do k=1,ksize
 do k=1,ksize
  do j=1,jsize
    do i=1,isize
      di=-maxx*hsmooth-offset(1)+(i-1)*dx    
      dj=-maxy*hsmooth-offset(2)+(j-1)*dy
      dk=-maxv*dw-offset(3)+(k-1)*dv
      r=SQRT(di**2+dj**2)*hinv
      dens=spline(r)*exp(-(dk*dwinv)**2/2)
      norm=norm+dens
      pimage(i,j,k)=dens
    enddo
   enddo
  enddo  
  endif
  
  if(norm.ne.0) then 
!  do i=1,isize
!   do j=1,jsize
!    do k=1,ksize
    do k=1,ksize
   do j=1,jsize
  do i=1,isize
      pimage(i,j,k)=pimage(i,j,k)/norm
    enddo
   enddo
  enddo  
  endif
 
 end subroutine

 subroutine positionp(i,j,k,offset,pos,hsmooth,vel,dw)
  integer :: i,j,k
  real :: offset(3),pos(3),hsmooth,vel(3),dw
  real x,y,v
  
  x=dot_product(xax,pos-lookat)
  y=dot_product(yax,pos-lookat)
  v=dot_product(direction,vel)-centerv
  
  i=(x-maxx*hsmooth+xsize/2)/dx
  j=(y-maxy*hsmooth+ysize/2)/dy
  k=(v-maxv*dw+vsize/2)/dv
  
  offset(1)=(x-maxx*hsmooth+xsize/2)-i*dx
  offset(2)=(y-maxy*hsmooth+ysize/2)-j*dy
  offset(3)=(v-maxv*dw+vsize/2)-k*dv

 end subroutine

 function spline(r) result(w)
  real :: r,w
  w=0
  if(r.GT.2) return
  if(r.LT.1) then
   w=1-3/2.*r**2+3/4.*r**3
  else
   w=1/4.*(2-r)**3
  endif
   w=w*10/(7*Pi)
 end function
 
 subroutine normalize(n)
  real n(3),v
   v=SQRT(n(1)**2+n(2)**2+n(3)**2)
   n(1)=n(1)/v
   n(2)=n(2)/v
   n(3)=n(3)/v
 end subroutine
	
 subroutine outer(o,v,w)
  real v(3),w(3),o(3)
  o(1)=v(2)*w(3)-w(2)*v(3)
  o(2)=v(3)*w(1)-w(3)*v(1)
  o(3)=v(1)*w(2)-w(1)*v(2)
 end subroutine
 
 subroutine writefits
      integer status,unit,blocksize,bitpix,naxis,naxes(3)
      integer i,j,k,group,fpixel,nelements
      character filename*80
      logical simple,extend

      status=0

      filename='HICube.fits'
      
      call deletefile(filename,status)
      call ftgiou(unit,status)

      blocksize=1
      call ftinit(unit,filename,blocksize,status)

      simple=.true.
      bitpix=-64
      naxis=3
      naxes(1)=nx
      naxes(2)=ny
      naxes(3)=nv
      extend=.true.

      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)

      group=1
      fpixel=1
      nelements=naxes(1)*naxes(2)*naxes(3)
      call ftpprd(unit,group,fpixel,nelements,cube,status)

!      call ftpkyj(unit,'EXPOSURE',1500,'Total Exposure Time',status)

      call ftclos(unit, status)
      call ftfiou(unit, status)
      
      if (status .gt. 0)call printerror(status)
      end subroutine
          
      subroutine printerror(status)


      integer status
      character errtext*30,errmessage*80

      if (status .le. 0)return
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      enddo
      end subroutine
      
      
      subroutine deletefile(filename,status)


      integer status,unit,blocksize
      character*(*) filename

      if (status .gt. 0)return

      call ftgiou(unit,status)

      call ftopen(unit,filename,1,blocksize,status)

      if (status .eq. 0)then
          call ftdelt(unit,status)
      else if (status .eq. 103)then
          status=0
          call ftcmsg
      else
          status=0
          call ftcmsg
          call ftdelt(unit,status)
      end if

      call ftfiou(unit, status)
      end subroutine
      
end module


program makecube
 use HICubeMod
 include 'globals.h'
 real gpos(3),hsm,gvel(3),dw,himass
 integer i,mode
 character*24 filenaam
 call initmem(nbodsmax,nsphmax,ncells) 
 
 CALL set_parameters(0)

 print*,'filenaam?'
 read*,filenaam
 CALL readbods(filenaam)

 call heattabel        
 CALL initpars

 IF(periodic) CALL initbc

 CALL initnewstar

 CALL postprocessread
 
 call InitHICube

 print*,' map mode( 0=HI,1=H2)?'
 read*, mode

if(mode.eq.0) then
 do i=1,nsph
  gpos=pos(i,1:3)
  gvel=vel(i,1:3)*velscale/1.e5
  hsm=hsmooth(i)
  dw=SQRT(kboltz/amu*temperat(i))/1.e5
  himass=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))*max(0.,1.-h2frac(i))
  if( himass.gt.0) call projectparticle(gpos,hsm,gvel,dw,himass)
 enddo
else
 do i=1,nsph
  gpos=pos(i,1:3)
  gvel=vel(i,1:3)*velscale/1.e5
  hsm=hsmooth(i)
  dw=SQRT(kboltz/amu/2*temperat(i))/1.e5
  himass=unitm_in_msun*mass(i)*max(0.,1-elecfrac(i))*h2frac(i)
  if( himass.gt.0) call projectparticle(gpos,hsm,gvel,dw,himass)
 enddo
endif

 
 call EndCube
 
end program

program sfrinfo
 real  :: tmin,tmax,dt,rmax,dr
 integer :: ntime,nr
 integer :: ig,is,i,j
 real :: pos(3),vel(3),rho,temp,xe,fuv,h2,smass,gmass,time
 character :: filename*80
 real, allocatable :: sfh(:,:),taxis(:),raxis(:)
 real,parameter :: pi=3.141592654
 integer :: naxes(3)
 
 print*,' sf history file?'
 read*, filename
 print*,' tmin,tmax,rmax?'
 read*, tmin,tmax,rmax
 print*,'# time,r bins?'
 read*, ntime,nr
 dt=(tmax-tmin)/ntime
 dr=2*rmax/nr
 allocate(sfh(ntime,nr),taxis(ntime),raxis(nr))
 
 do i=1,ntime
  taxis(i)=tmin+dt*(i-.5)
 enddo
 
 do i=1,nr
  raxis(i)=-rmax+dr*(i-.5)
 enddo
  sfh=0.
 open(unit=20,file=trim(filename)//'.sfh',status='OLD',IOSTAT=ioerror)
 if(ioerror.NE.0) then
  print*,' file error'
  stop
 endif
 
10 read(20,*,IOSTAT=ioerror) ig,is
   if(ioerror.EQ.0) then
    read(20,*) time
    read(20,*) pos
    read(20,*) vel
    read(20,*) rho
    read(20,*) temp
    read(20,*) xe
    read(20,*) fuv
    read(20,*) h2
    read(20,*) smass,gmass
    
    i=(time-tmin)/dt
    j=(pos(1)+rmax)/dr    
    if(i.ge.1.and.i.le.ntime.and.j.ge.1.and.j.le.nr) sfh(i,j)=sfh(i,j)+smass
    
    goto 10
   endif
  close(20)

  do i=1,nr
   do j=1,ntime
    sfh(j,i)=sfh(j,i)/dt
   enddo
  enddo

  filename=trim(filename)//'_sfh.fits'
  
  naxes(1)=ntime
  naxes(2)=nr
  call writefits(filename,2,naxes,sfh)
  
  deallocate(sfh,taxis)

end program

 subroutine writefits(filename,naxis,naxes,pic)
      integer status,unit,blocksize,bitpix,naxis,naxes(3)
      integer i,j,k,group,fpixel,nelements
      character filename*80
      logical simple,extend
      real pic(*)

      status=0
      print*,filename
      call deletefile(filename,status)
      call ftgiou(unit,status)

      blocksize=1
      call ftinit(unit,filename,blocksize,status)

      simple=.true.
      bitpix=-64
      extend=.true.

      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)

      group=1
      fpixel=1
      nelements=1
      do i=1,naxis
       nelements=naxes(i)*nelements
      enddo
      call ftpprd(unit,group,fpixel,nelements,pic,status)

      call ftclos(unit, status)
      call ftfiou(unit, status)
      
      if (status .gt. 0)call printerror(status)
      end subroutine
          
      subroutine printerror(status)


      integer status
      character errtext*30,errmessage*80

      if (status .le. 0)return
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      enddo
      end subroutine
      
      
      subroutine deletefile(filename,status)
      integer status,unit,blocksize
      character*(*) filename

      if (status .gt. 0)return

      call ftgiou(unit,status)

      call ftopen(unit,filename,1,blocksize,status)

      if (status .eq. 0)then
          call ftdelt(unit,status)
      else if (status .eq. 103)then
          status=0
          call ftcmsg
      else
          status=0
          call ftcmsg
          call ftdelt(unit,status)
      end if

      call ftfiou(unit, status)
      end subroutine

! bh is star particle, except:
!  tform indicates time of last 'activity'
!  tfeedb is the accretion rate ( >= 0)
!
subroutine skinnydensity_bh(n,h,ppos,pvel,lrho,ldrhodh, &
                              lhdivv,lhcurlv,lvdisp,lvbulk,lcsound)
  include 'globals.h'
  integer i,iwsm,n,p
  real hsminv,wnorm,distnorm,dr2p,drw,wsm,wmass,dr2, &
       wmass1,dwnorm,vdotdr,dwsm,dwmass,dx,dy,dz, &
       dvx,dvy,dvz,dwmnbi,curlvx,curlvy,curlvz,mv(3),mv2
  real h,ppos(3),pvel(3),lrho,ldrhodh,lhdivv, &
      lhcurlv,lvdisp,lvbulk,lcsound
  lrho=0.
  ldrhodh=0.
  lhdivv=0.
  lhcurlv=0.
  lvdisp=0.
  curlvx=0.;curlvy=0.;curlvz=0.
  mv=0.;mv2=0.
  lcsound=0.
  hsminv=1./h
  wnorm=piinv*hsminv*hsminv*hsminv
  dwnorm=piinv*hsminv**2*hsminv**2*hsminv
  distnorm=hsminv**2*deldr2i
  do i=1,n
    p=srlist(i)
    dx=ppos(1)-pos(p,1)
    dy=ppos(2)-pos(p,2)
    dz=ppos(3)-pos(p,3)		   
    if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
    if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
    if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
    if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
    if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
    if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
    dr2=dx*dx+dy*dy+dz*dz   
    dr2p=dr2*distnorm
    if(ninterp.GE.dr2p) then
      iwsm=INT(dr2p)		   
      drw=dr2p-iwsm
      wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
      wmass=wnorm*wsm
      lrho=lrho+mass(p)*wmass
      ldrhodh=ldrhodh-3*hsminv*mass(p)*wmass
      lcsound=lcsound+mass(p)*csound(p)*wmass

      mv(1)=mv(1)+veltpos(p,1)*mass(p)*wmass
      mv(2)=mv(2)+veltpos(p,2)*mass(p)*wmass
      mv(3)=mv(3)+veltpos(p,3)*mass(p)*wmass
      mv2=mv2+(veltpos(p,1)**2+veltpos(p,2)**2+ &
          veltpos(p,3)**2)*mass(p)*wmass

      dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
      dwmass=dwnorm*dwsm
      dwmnbi=mass(p)*dwmass
      dvx=pvel(1)-veltpos(p,1)
      dvy=pvel(2)-veltpos(p,2)
      dvz=pvel(3)-veltpos(p,3)
      vdotdr=dvx*dx+dvy*dy+dvz*dz 	    
      lhdivv=lhdivv-dwmnbi*vdotdr
      ldrhodh=ldrhodh-dr2*hsminv*dwmnbi
    
    
      curlvx=curlvx+dwmnbi*(dz*dvy-dy*dvz)
      curlvy=curlvy+dwmnbi*(dx*dvz-dz*dvx)
      curlvz=curlvz+dwmnbi*(dy*dvx-dx*dvy)
    endif
  enddo   
  lhdivv=h*lhdivv/lrho
  lhdivv=lhdivv/(1+h*ldrhodh/3/(rhomin+lrho)) ! f_i correction 
  lhcurlv=h*SQRT(curlvx**2+curlvy**2+curlvz**2)/lrho
  lcsound=lcsound/lrho 
  mv=mv/lrho
  mv2=mv2/lrho
   
  lvdisp=MAX(0.,(mv2-mv(1)**2-mv(2)**2-mv(3)**2))
  lvdisp=SQRT(lvdisp)
  lvbulk=SQRT(sum((pvel-mv)**2))
end subroutine

function bhmdot(bhmass,ppos,pvel,h,nneigh)
  include 'globals.h'
  real :: h,bhmass,hneigh,ppos(3),pvel(3), &
          lrho,ldrhodh,lhdivv,lhcurlv,lvdisp,lvbulk,lcsound, &
          bhmdot,mdot,mdot_edd,mdot_bondi,mdot_divv,ts,hbondi, &
          drhodt,reff
  integer :: i,j,nneigh
! real,parameter :: salpetertime=450. ! (Myr) 
! real, parameter :: bh_rad_eff=0.1
! integer, parameter :: bh_method=2  
  if(nneigh.eq.0) return   
  call skinnydensity_bh(nneigh,h,ppos,pvel,lrho,ldrhodh,lhdivv, &
    lhcurlv,lvdisp,lvbulk,lcsound)

! old mdot recipe
  mdot_bondi=4*pi*bhmass**2*lrho/(lcsound**2+lvbulk**2)**(3/2.) 
! new mdot recipe
  drhodt=-lrho*lhdivv/h
  hbondi=bhmass/lcsound**2
  reff=min(h,hbondi)
  if(drhodt.GT.0) then
    mdot_divv=4/3.*pi*reff**3*drhodt
  else
    mdot_divv=0.
  endif 
! Eddington
  ts=salpetertime*bh_rad_eff*year*1.e6/timescale
  mdot_edd=bhmass/ts

  select case( bh_method)
  case(1)
    mdot=mdot_bondi
    bhmdot=mdot
  case(2)
    mdot=mdot_divv
    bhmdot=mdot
  case(3)
    mdot=mdot_bondi
    bhmdot=min(mdot_edd,mdot)
  case(4)
    mdot=mdot_divv
    bhmdot=min(mdot_edd,mdot)
  case default
    mdot=mdot_edd
    bhmdot=mdot
  end select

  write(bhfilenr,'(20g14.6)') tpos,reff,lrho,lcsound,lvbulk,drhodt, &
    lcsound**2*mumhkg1/gamma/gamma1,mdot_bondi,mdot_divv,mdot_edd,bhmdot, &
    bhmass,h,ppos(1),ppos(2),ppos(3),ldrhodh,pvel(1),pvel(2),pvel(3)

end function

subroutine blackholes
  include 'globals.h'
  integer :: i,j,p,nneigh,ii,jj,k
  real :: mdot,bhmass,ppos(3),pvel(3),h,hneigh,dmass,dp(3)
  real :: bhmdot,d1,d2
  real,allocatable :: workvect(:)
  allocate(workvect(nsph))
 
  if(nbh.LE.0) return
 
  workvect(1:nsph)=-1.
  bodlist(1:nsph)=0

  open(unit=bhfilenr,file=TRIM(outputfile)//'.bh', &
   status='unknown',POSITION='APPEND')

  do i=1,nbh
    p=nbodies-nbh+i
    write(bhfilenr,'(i9,"  ")',advance='NO') nbexist(p)
  
    bhmass=mass(p)
    ppos=pos(p,1:3)
    pvel=vel(p,1:3)
    h=hsmooth(p)

    ii=0;jj=0;
    hneigh=0.;nneigh=0
    call gethsm(ppos,h,ii,jj)
    call search_d2(root,2*h,ppos,nneigh,srlist,tempvect)
    mdot=bhmdot(bhmass,ppos,pvel,h,nneigh)   

    hsmooth(p)=h   
    bhmass=mass(p)+mdot*(tpos-tbh)
    tfeedb(p)=mdot
 
    do k=1,nneigh
      if(tempvect(k).LT.4*h**2) then
        if(workvect(srlist(k)).LT.0.OR. &
           workvect(srlist(k)).GT.tempvect(k).OR. &
           (workvect(srlist(k)).EQ.tempvect(k).AND.p.GT.bodlist(srlist(k))) ) then
          workvect(srlist(k))=tempvect(k)
          bodlist(srlist(k))=p
        endif   
      endif
    enddo  
  enddo

  close(bhfilenr)

  if(tbh.EQ.tpos) then
    do i=1,nbh
      p=nbodies-nbh+i
      if(tfeedb(p).GT.0) tform(p)=tbh
    enddo
    return
  endif
 
  do i=1,nbh
    p=nbodies-nbh+i
    h=hsmooth(p)
    ppos=pos(p,1:3)
    hneigh=0.;nneigh=0
    call search_d2(root,2*h,ppos,nneigh,srlist,tempvect)
    call mrgrnk(nneigh,tempvect,templist)
    dmass=tfeedb(p)*(tpos-tbh)
    j=1
    dp=mass(p)*vel(p,1:3)
    do while(dmass.GT.0.AND.tempvect(templist(j)).LT.4*h**2.AND.j.LE.nneigh)
      k=srlist(templist(j))
      if(bodlist(k).LE.nbodies-nbh.OR.bodlist(k).GT.nbodies) then
        print*,nbodies,nbh,nneigh
        print*, k,templist(j),bodlist(k),workvect(k)
        call terror('BH id error')
      endif
      if(bodlist(k).EQ.p) then
        if(dmass.LT.mass(k)) then 
          dp=dp+dmass*vel(k,1:3)
          mass(k)=mass(k)-dmass
          dmass=0.
        else
          dmass=dmass-mass(k)
          dp=dp+mass(k)*vel(k,1:3)
          mass(k)=0.
      endif 
    endif
    j=j+1
    enddo    
    if(dmass.LT.0) call terror(' BH accr error')
!    if(dmass.GT.0) call terror(' BH accr mismatch')
    if(dmass.GT.tfeedb(p)*(tpos-tbh)) call terror(' BH accr mismatch')
    if(dmass.GT.0) then 
      print*,' accretion warning!'
      tfeedb(p)=tfeedb(p)-dmass/(tpos-tbh)
    endif
!    mass(p)=mass(p)+tfeedb(p)*(tpos-tbh)-dmass  
    mass(p)=mass(p)+tfeedb(p)*(tpos-tbh)   
    vel(p,1:3)=dp/mass(p)
    if(tfeedb(p).GT.0) tform(p)=tbh
  enddo
  tbh=tpos
  deallocate(workvect)
end subroutine

subroutine bhmergers
  include 'globals.h'
  integer :: p,i,j,k,nneigh
  real :: h2,dr,ppos(3),dv2,pvel(3),pacc(4),mp,bht,bheps,mdot

  call bhtree
  
  do i=1,nbh
    p=nbodies-nbh+i
    ppos=pos(p,1:3)
    pvel=vel(p,1:3)
    pacc=acc(p,1:4)
    mp=mass(p)
    bht=tform(p)
    bheps=hsmooth(p)
    mdot=tfeedb(p)
    h2=2*hsmooth(p)

! do search 
    nneigh=0
    call search(root,h2,ppos,nneigh,srlist)
    if(nneigh.GT.0) then
!sort?
      do j=1,nneigh
        k=srlist(j)
        if(p.NE.k) then
          if((mp.GT.mass(k).OR.(mp.EQ.mass(k).AND.p.GT.k)).AND. &
                                                  mp.GT.tiny) then
            dr=sqrt(sum((ppos-pos(k,1:3))**2)) 
            dv2=sum((pvel-vel(k,1:3))**2)     
            if(2*(mp+mass(k))/dr.GT.dv2) then       
              ppos=(ppos*mp+pos(k,1:3)*mass(k))/(mp+mass(k))
              pvel=(pvel*mp+vel(k,1:3)*mass(k))/(mp+mass(k))
              pacc=(pacc*mp+acc(k,1:4)*mass(k))/(mp+mass(k))
              mp=mp+mass(k)
              bht=MAX(bht,tform(k))
              bheps=MAX(bheps,hsmooth(k))
              mdot=mdot+tfeedb(k)

              mass(k)=0.           
            endif
          endif
        endif
      enddo
      pos(p,1:3)=ppos
      vel(p,1:3)=pvel
      acc(p,1:4)=pacc
      mass(p)=mp
      tform(p)=bht
      hsmooth(p)=bheps
      tfeedb(p)=mdot
    endif  
  enddo
end subroutine

subroutine maketree
  include 'globals.h'
  integer i

  if(treestatecount.EQ.ppropcount+pordercount) return
  call setbox('all ')
  call loadtree5('all ',0)
  incellsg=incells
  treestatecount=ppropcount+pordercount
  sphtreecount=sphtreecount-1
end subroutine
	
subroutine makesphtree
  include 'globals.h'

  if(sphtreecount.EQ.ppropcount+pordercount) return
  if(nsph.EQ.nbodies.AND. &
     treestatecount.EQ.ppropcount+pordercount) then
     call tree_reduction(root,incells,'sph ')
  else
    call setbox('sph ')
    call loadtree5('sph ',0)
  endif
  sphtreecount=ppropcount+pordercount
  treestatecount=treestatecount-1
end subroutine

subroutine startree
  include 'globals.h'
  
  call setbox('star')
  call loadtree5('star',0)
  incellsg=incells
end subroutine

subroutine bhtree
  call setbox('bh  ')
  call loadtree5('bh  ',0)
end subroutine
        
subroutine setbox(option)
  include 'globals.h'
  character(len=4) :: option
  integer :: low,up,k
  real posmax,posmin,absmax
  
  if(periodic) then
    rsize=pboxsize
    rmin(1)=-0.5*pboxsize
    rmin(2)=-0.5*pboxsize
    rmin(3)=-0.5*pboxsize
    return
  endif 
 
  select case (option)
  case('all ')
   low=1;up=nbodies
  case('sph ')
   low=1;up=nsph
  case('star')
   low=nbodies-nstar+1;up=nbodies
  case('coll')
   low=nsph+1;up=nbodies
  case('bh  ')
   low=nbodies-nbh+1;up=nbodies
  case default
   low=1;up=nbodies
  end select
 
  posmax=MAXVAL(pos(low:up,1:3))
  posmin=MINVAL(pos(low:up,1:3))
  absmax=1.001*MAX(ABS(posmax),ABS(posmin))
  k=CEILING(log(absmax)/log(2.))+1
 
  rsize=2.**k 
  rmin=-0.5*rsize
end subroutine setbox

! cell sort2: make indexing in order of cellsize
!  start: starting cell, numcells=number of cells to order
!         (useful for ordering subtrees)
!  ind: indexing in order of cellsize

subroutine cell_sort2(start,numcells,ind)
  include 'globals.h'
  integer,intent(out) :: ind(*)
  integer,intent(in)  :: start,numcells
  integer :: facell, lacell, nacell, k, i
 
  ind(numcells) = start
  facell = 1;lacell = 1;nacell = 1
10  if(lacell.LT.numcells) then  
      do k = 1, nsubcell 
        do i = facell,lacell 
          if (subp(ind(numcells-i+1),k).GE.nbods1) then 
            nacell = nacell + 1 
            ind(numcells-nacell+1) = subp(ind(numcells-i+1),k) 
          endif 
        end do 
      enddo
      facell = lacell + 1 
      lacell = nacell 
      go to 10 
    endif
  if (nacell .ne. numcells) then
!$omp critical
    print*, "cellsort2",nacell,numcells
    call terror ('  cell_sort2: INCONSISTENT CELL COUNT')
!$omp end critical
  endif 
end subroutine cell_sort2

! subcellindex: function to determine value of subcell index 

integer function subcellindex2(pcell,ppar)
  real,intent(in),dimension(3) :: pcell,ppar 
  integer, parameter,dimension(3) :: nindex=(/ 4,2,1 /)
  integer :: k 
 
  subcellindex2 = 1
  do k = 1, 3 
    if (ppar(k).GE.pcell(k)) subcellindex2 = subcellindex2 + nindex(k) 
  enddo
end function subcellindex2


! loadtree5: loadtree with explicit ordering of particles 
subroutine loadtree5(option,startcell)
  include 'globals.h'
  character (len=4), intent(in) :: option
  integer,intent(in) :: startcell
  integer :: ilower,iupper,i,j,success 
  integer :: lincells,lcell,hcell,llcell,lhcell,low,high
  integer :: mythread,totalthread,maxthread,shift,maxcell,lnumbodies,restbodies
  integer :: checkredu,checkbody,checkcell,totcell,totredu,totbody,targetn 
  integer :: omp_get_max_threads,omp_get_thread_num ,omp_get_num_threads
  real, parameter :: cellfactor=float(ncells)/nbodsmax
  real :: time1,time2,mintime,maxtime,tottime,utime1,utime2
   
  select case (option)
  case('all ')
    ilower = 1 
    iupper = nbodies 
  case('sph ')
    ilower = 1 
    iupper = nsph
  case('star')
    ilower = nbodies - nstar + 1 
    iupper = nbodies
  case('bh  ')
    ilower = nbodies - nbh +1
    iupper = nbodies 
  case default
    ilower = nsph + 1 
    iupper = nbodies
  end select
  
  incells=1
  root=nbods1+startcell
  subp(root,1:nsubcell)=0
  cellsize(root) = rsize
  pshape(root)=1
  do j=1,ndim
    pos(root,j) = rmin(j) + 0.5*rsize 
    bottom(root,j) = rmin(j) 
  enddo
 
  cellstart(root)=1
  do i=ilower,iupper
    order_bodlist(i-ilower+1)=i
  enddo
  restbodies=iupper-ilower+1
  npercell(root)=restbodies

  if(restbodies.eq.0) return
  if(restbodies.eq.1) then
    subp(root,1)=order_bodlist(1)
    call tree_reduction(root,1,option)
    return
  endif 

  hcell=root
  lcell=root-1 
  maxthread=1
!$ maxthread=omp_get_max_threads()
  lnumbodies=restbodies/maxthread
  if(lnumbodies.LT.100) lnumbodies=1

  call parttree(lcell,hcell,startcell+incells,lincells, &
                  lnumbodies,nbodcell,success) 
  incells=incells+lincells
  if(success.ne.0) then
    print*,success
    call terror(' loadtree error 1')
  endif
  restbodies=sum(npercell(lcell+1:hcell))
  totcell=0
  totredu=0
  totbody=0
 
  mintime=1.e10
  maxtime=0.
  tottime=0

!$omp parallel private(mythread,totalthread,shift,lincells,i,checkcell,checkbody,checkredu &
!$omp ,llcell,lhcell,maxcell,low,high,success,lnumbodies,targetn,time1,time2) &
!$omp shared(startcell,incells,lcell,hcell,option,restbodies) &
!$omp reduction( MIN : mintime) & 
!$omp reduction( MAX : maxtime) &
!$omp reduction(+ : totredu,totcell,totbody,tottime) if(hcell-lcell.gt.maxthread)
  call wall_time(time1)
  mythread=0
  totalthread=1
!$ mythread=omp_get_thread_num()    
!$ totalthread=omp_get_num_threads()

  maxcell=0
  lhcell=lcell
  i=0
  do while(i.LE.mythread)
    llcell=lhcell
    shift=maxcell
    lnumbodies=restbodies-maxcell
    targetn=lnumbodies/(totalthread-i)
    do while(maxcell-shift.LT.targetn.AND. &
              (maxcell-shift+npercell(lhcell+1)-targetn)*(totalthread-i-1).LT.(targetn-maxcell+shift))
      if(lhcell.GE.hcell) call terror(' loadtree distr')
      lhcell=lhcell+1
      maxcell=maxcell+npercell(lhcell) 
    enddo
    i=i+1
  enddo 

  lnumbodies=maxcell-shift
  shift=shift*cellfactor
  maxcell=maxcell*cellfactor

  shift=shift+incells+startcell
  maxcell=MIN(nbodcell,maxcell+nbodsmax+incells+startcell)
 
  checkbody=0
  checkcell=0
  checkredu=0
  do i=llcell+1,lhcell
    low=i-1;high=i
    call parttree(low,high,shift+checkcell,lincells,1, maxcell,success)
    if(success.ne.0.OR.high.NE.low) then
!$omp critical
      print*,shift,maxcell,lnumbodies
      print*,incells,restbodies
      print*,option,success,mythread,totalthread
      call terror(' loadtree error 2')
!$omp end critical    
    endif   
    call tree_reduction(i,lincells+1,option)
    checkbody=checkbody+npercell(i)
    checkredu=checkredu+lincells+1
    checkcell=checkcell+lincells
  enddo
  totcell=totcell+checkcell
  totbody=totbody+checkbody
  totredu=totredu+checkredu
  call wall_time(time2)
  mintime=MIN(mintime,time2-time1)
  maxtime=MAX(maxtime,time2-time1)
  tottime=tottime+time2-time1
!$omp end parallel
  totredu=totredu+lcell+1-nbods1-startcell
  totcell=totcell+incells
  if(restbodies.NE.totbody.OR.totredu.NE.totcell) then
    print*,restbodies,totredu,totcell,totbody
    call terror('loadtree mismatch')
  endif
  call tree_reduction(root,lcell+1-nbods1-startcell,option)
  incells=totcell
  if(verbosity.GT.0) then
    write(*,'(" <loadtree> time:", 3f8.2)') mintime,maxtime,tottime
    print*,'<loadtree> option, parts, cells: ',option,iupper-ilower+1, incells
  endif
end subroutine loadtree5

subroutine parttree(lcell,hcell,shift,nnewcell,mxincell,maxnewcell,success)
  include 'globals.h'
  integer, intent(inout) :: lcell,hcell,nnewcell,success
  integer, intent(in)    :: mxincell,shift,maxnewcell
  integer :: i,j, k,cellp(0:nsubcell)
  integer :: subcellindex2
  integer :: maxnsub,subind,particle,nsub,newcell,firstnew
  real :: ppos(3),cpos(3),pm1(nsubcell,ndim)
  data pm1/ 4* - 1., 4*1., 2* - 1., 2*1., 2* - 1., 2*1., -1., 1., &
                                              -1.,1.,-1., 1., -1., 1./
  success=0
  nnewcell=0
  if(hcell.LE.lcell) return
  maxnsub=0
  do i=lcell+1,hcell
    if(maxnsub.LT.npercell(i)) maxnsub=npercell(i)
  enddo
  newcell=nbodsmax+shift
  firstnew=nbodsmax+shift+1
  do while(maxnsub.GT.mxincell)
    maxnsub=0
    do i=lcell+1,hcell
      if(npercell(i).LT.2) then
        success=1
        return
      endif
! end tree if nbodies <= 8
      if(npercell(i).LE.8) then   
        subp(i,1:npercell(i))= &
          order_bodlist(cellstart(i):cellstart(i)+npercell(i)-1)
        cycle
      endif   
      do j=cellstart(i),cellstart(i)+npercell(i)-1
        particle=order_bodlist(j)
        cpos=pos(i,1:3)
        ppos=pos(particle,1:3)
        subind=subcellindex2(cpos,ppos)    
        subind=peanovalue(subind,pshape(i))
        srlist(j-cellstart(i)+1)=subind
        subp(i,subind)=subp(i,subind)+1
      enddo   
      cellp(0)=0
      nsub=0 
      do j=1,nsubcell
        cellp(j)=cellp(j-1)+nsub
        nsub=subp(i,j)
        if(nsub.GT.maxnsub) maxnsub=nsub
        if(nsub.GT.1) then
          nnewcell=nnewcell+1
          newcell=nbodsmax+nnewcell+shift
          if(newcell.GT.maxnewcell) then
            print*, "start DEBUG"
            print*, nsub,newcell,maxnewcell
            print*, pos(i,1:3)
            do k=1,nsub
              print*, k,pos(order_bodlist(cellp(j)+cellstart(i)+k-1),1:3)
            enddo
            print*, "end DEBUG"
            success=2
            return
          endif
          npercell(newcell)=nsub
          cellstart(newcell)=cellp(j)+cellstart(i)
          cellsize(newcell)=cellsize(i)/2
          do k=1,ndim
            pos(newcell,k)=pos(i,k)+pm1(indexfromp(j,pshape(i)),k)*cellsize(newcell)/2
!            pos(newcell,k)=pos(i,k)+pm1(j,k)*cellsize(newcell)/2
            bottom(newcell,k)=pos(newcell,k)-cellsize(newcell)/2
          enddo
          subp(newcell,1:nsubcell)=0
          subp(i,j)=newcell             
          pshape(newcell)=pshapefromp(j,pshape(i))
        endif
      enddo
             
      do j=cellstart(i),cellstart(i)+npercell(i)-1
        particle=order_bodlist(j)
        subind=srlist(j-cellstart(i)+1)
        bodlist(1+cellp(subind))=particle
        cellp(subind)=cellp(subind)+1
        if(subp(i,subind).EQ.1) then
          subp(i,subind)=particle
        endif
      enddo 
   
      order_bodlist(cellstart(i):cellstart(i)+npercell(i)-1)= &
        bodlist(1:npercell(i))   
    enddo
    lcell=firstnew-1
    hcell=newcell
    firstnew=hcell+1
  enddo
end subroutine parttree

subroutine tree_reduction(start,numcells,option)
  integer, intent(in) :: start,numcells
  character (len=4), intent(in) :: option

  if(numcells.LE.0) return
 
  select case (option)
  case('all ')
    call tree_reduction_grav(start,numcells)
  case('sph ')
    call tree_reduction_sph(start,numcells)
  case('star')
    call tree_reduction_fuv(start,numcells)
  case('bh  ')
    return
  case default
    call tree_reduction_grav(start,numcells)
  end select

end subroutine tree_reduction

subroutine tree_reduction_grav(start,numcells)
  include 'globals.h'
  integer,intent(in) :: start,numcells
  integer p,q,i,j,k,l,m,n,mupper

  call cell_sort2(start,numcells,bodlist)

  do i=1,numcells
    p=bodlist(i)
    mass(p)=0.
    starfuv(p)=0.
    pos(p,1)=0.
    pos(p,2)=0.
    pos(p,3)=0.
    epsgrav(p)=0.
  enddo

  if(usequad) then
    do k=1,2*ndim-1
      do i=1, numcells
        p=bodlist(i)
        quad(p,k)=0.
      enddo
    enddo    
  endif

  do i=1,numcells
    p=bodlist(i)
    do j=1,nsubcell 
      q=subp(p,j)
      if(q.GT.0) then
        mass(p)=mass(p)+mass(q)
        pos(p,1:3)=pos(p,1:3)+mass(q)*pos(q,1:3)
        starfuv(p)=starfuv(p)+starfuv(q)
        epsgrav(p)=epsgrav(p)+mass(q)*epsgrav(q)
      endif
    enddo
    if(mass(p).lt.0) call terror('tree_reduction_grav: mass<0')
    if(mass(p).ne.0) then
      pos(p,1:3)=pos(p,1:3)/mass(p)
      epsgrav(p)=epsgrav(p)/mass(p) 
    else
      pos(p,1:3)=bottom(p,1:3)+cellsize(p)/2
      epsgrav(p)=eps
    endif
  enddo
   
  if(usequad) then
    if(ndim.GT.2) then
      mupper=2
    else
      mupper=ndim
    endif


    do i=1,numcells
      p=bodlist(i)
      do j=1,nsubcell
        q=subp(p,j)
        if(q.GT.0) then
          do m=1,mupper
            do n=m,ndim
              l=(m-1)*(ndim-1)+n
              quad(p,l)=quad(p,l)+ & 
                mass(q)*(3.*(pos(q,m)-pos(p,m))*(pos(q,n)-pos(p,n)))
              if(m.EQ.n) then
                do k=1,ndim
                  quad(p,l)=quad(p,l)-mass(q)*(pos(q,k)-pos(p,k))**2
                enddo
              endif
              if(q.ge.nbods1) quad(p,l)=quad(p,l)+quad(q,l)
            enddo
          enddo
        endif 
      enddo
    enddo 
  endif
end subroutine tree_reduction_grav

subroutine tree_reduction_fuv(start,numcells)
  include 'globals.h'
  integer,intent(in) :: start,numcells
  integer p,q,i,j,k,l,m,n,mupper

  call cell_sort2(start,numcells,bodlist)

  do i=1,numcells
    p=bodlist(i)
    mass(p)=1.  ! not zero..
    starfuv(p)=0.
    pos(p,1)=0.
    pos(p,2)=0.
    pos(p,3)=0.
    epsgrav(p)=0.
  enddo

  do i=1,numcells
    p=bodlist(i)
    do j=1,nsubcell 
      q=subp(p,j)
      if(q.GT.0) then
        pos(p,1:3)=pos(p,1:3)+starfuv(q)*pos(q,1:3)
        starfuv(p)=starfuv(p)+starfuv(q)
        epsgrav(p)=epsgrav(p)+starfuv(q)*epsgrav(q)
      endif
    enddo
    if(starfuv(p).NE.0) then
      pos(p,1:3)=pos(p,1:3)/starfuv(p)
      epsgrav(p)=epsgrav(p)/starfuv(p) 
    else
      pos(p,1:3)=bottom(p,1:3)+cellsize(p)/2
      epsgrav(p)=eps
    endif
  enddo 
end subroutine tree_reduction_fuv

subroutine tree_reduction_sph(start,numcells)
  include 'globals.h'
  integer,intent(in) :: start,numcells
  integer p,q,i,j,k,l,m,n,mupper

  call cell_sort2(start,numcells,bodlist)

  do i=1,numcells
    p=bodlist(i)
    hsmooth(p)=0.
  enddo
 
! note: instead of max of hsmooth it is probably better to
! determine the max range (and convert that to 'hsmooth'
! so:
!  hsmooth=MAX(hsmooth,bottom(p)-(bottom(q)-hsmooth(q)))
!  hsmooth=MAX(hsmooth,bottom(q)+cellsize(q)+hsmooth(q)-
!   (bottom(p)+cellsize(p)))
! and for particles:
!  hsmooth=MAX(hsmooth, bottom(p)-(pos(q)-hsmooth(q)))
!  hsmooth=MAX(hsmooth, pos(q)+hsmooth(q)-(bottom(p)+cellsize(p))) 
  do i=1,numcells
    p=bodlist(i)
    do j=1,nsubcell 
      q=subp(p,j)
!   if(q.GT.0) then
!    hsmooth(p)=MAX(hsmooth(p),hsmooth(q))
!   endif
      if(q.LT.nbods1) then
        if(q.GT.0) then
          do k=1,3
            hsmooth(p)=MAX(pos(q,k)+2*hsmooth(q)-bottom(p,k)-cellsize(p),2*hsmooth(p))/2
            hsmooth(p)=MAX(bottom(p,k)-pos(q,k)+2*hsmooth(q),2*hsmooth(p))/2
          enddo
        endif
      else
        do k=1,3
          hsmooth(p)=MAX(bottom(q,k)+cellsize(q)+2*hsmooth(q)-bottom(p,k)-cellsize(p),2*hsmooth(p))/2
          hsmooth(p)=MAX(bottom(p,k)-bottom(q,k)+2*hsmooth(q),2*hsmooth(p))/2
        enddo
      endif
    enddo
  enddo 
end subroutine tree_reduction_sph

subroutine initparameters
        INTEGER input,output,firstsnap,stepout,steplog,nsteps,           &
     &    max_tbin, minppbin,targetnn,verbosity 
        REAL*8 pboxsize,unitl_in_kpc,unitm_in_msun,dtime, tstepcrit,     &
     &  tstpcr2,freev, freea, freevexp, freeaexp,bh_tol,eps,gdgtol,      &
     &  nn_tol
        LOGICAL usesph,radiate,starform,cosmo,sqrttstp,                  &
     &    acc_tstp,freetstp,usequad,directsum,selfgrav,fixthalo,         &
          adaptive_eps, gdgop
        CHARACTER*16 outputfile
        CHARACTER*30 halofile
        CHARACTER*16 inputfile
        CHARACTER*200 datadir
 
        COMMON/io_param/input(128),output(128),firstsnap,stepout,        &
     &    steplog,verbosity,datadir,inputfile,outputfile,halofile 
        COMMON/sim_param/pboxsize,usesph,radiate,starform,cosmo
        COMMON/units_param/unitl_in_kpc, unitm_in_msun
        COMMON/step_param/dtime, tstepcrit, tstpcr2, freev, freea,       &
     &    freevexp, freeaexp, nsteps, max_tbin, minppbin,                &
     &    sqrttstp, acc_tstp, freetstp
        COMMON/grav_param/bh_tol,eps,gdgtol,nn_tol,targetnn,             &
     &    usequad,directsum,selfgrav,fixthalo,adaptive_eps, gdgop



        REAL*8 epsgas, gamma, alpha, beta, epssph, courant,              & 
     &    removgas,consthsm,nsmtol,graineff,crionrate,heat_par1,         &
     &    heat_par2,cool_par,optdepth,tcollfac,masscrit,sfeff,           &
     &    tbubble,sne_eff, tsnbeg, rhomax
        INTEGER nsmooth
        LOGICAL smoothinput, consph, sphinit, uentropy, isotherm,        &
     &    eps_is_h,mingaseps,balsara
        CHARACTER*4 feedback
        CHARACTER*10 sfmode
        CHARACTER*4 hupdatemethod
        CHARACTER*4 sph_visc

        COMMON/sph_param/epsgas, gamma, alpha, beta, epssph, courant,    & 
     &    removgas,consthsm, nsmtol, nsmooth, smoothinput, consph,       &
     &    sphinit, uentropy, isotherm,eps_is_h,mingaseps,balsara,        &
     &    hupdatemethod,sph_visc
        COMMON/rad_param/graineff,crionrate,heat_par1,heat_par2,         &
     &    cool_par, optdepth
        COMMON/sf_param/tcollfac,masscrit,sfeff, tbubble,                &
     &    sne_eff, tsnbeg, rhomax, sfmode, feedback

 call muse_start

end subroutine

subroutine setup_module()
  call muse_reset
  call muse_init
end subroutine

subroutine cleanup_module
  call muse_end
  call muse_start
  call muse_reset
end subroutine

subroutine initialize_particles(time)
!f2py intent(callback,hide) external_acc
!f2py intent(callback,hide) external_pot
!f2py use call_external_acc__user__routines
!f2py use call_external_pot__user__routines
!f2py external external_acc
!f2py external external_pot
 real*8 :: time
  call muse_set_time(time)
  call muse_finalize_init 
end subroutine

subroutine reinitialize_particles
! ????????????
end subroutine

function add_dm_particle(ids,mass,x,y,z,vx,vy,vz,eps,npart) result(n)
integer :: npart
integer :: ids(npart),n,muse_get_nbodies
real*8 :: mass(npart),x(npart),y(npart),z(npart), &
 vx(npart),vy(npart),vz(npart),eps(npart)
  call muse_add_particle_dm(ids,mass,x,y,z,vx,vy,vz,eps,npart)
  n=muse_get_nbodies()
end function

function add_star_particle(ids,mass,x,y,z,vx,vy,vz,eps,tf,npart) result(n)
integer :: npart
integer :: ids(npart),n,muse_get_nbodies
real*8 :: mass(npart),x(npart),y(npart),z(npart), &
 vx(npart),vy(npart),vz(npart),eps(npart),tf(npart)
  call muse_add_particle_star(ids,mass,x,y,z,vx,vy,vz,eps,tf,npart)
  n=muse_get_nbodies()
end function

function add_sph_particle(ids,mass,x,y,z,vx,vy,vz,eps,u,npart) result(n)
integer :: npart
integer :: ids(npart),n,muse_get_nbodies
real*8 :: mass(npart),x(npart),y(npart),z(npart), &
 vx(npart),vy(npart),vz(npart),eps(npart),u(npart)
  call muse_add_particle_sph(ids,mass,x,y,z,vx,vy,vz,eps,u,npart)
  n=muse_get_nbodies()
end function

function set_particle(id1,id,mass,x,y,z,vx,vy,vz,eps,npart) result(n)
integer :: npart
integer :: id1(npart),id(npart),n
real*8 :: mass(npart),x(npart),y(npart),z(npart), &
 vx(npart),vy(npart),vz(npart),eps(npart)
! find id1, set it 
 n=1
end function

function set_mass(id,mass) result(error)
integer id,error
real*8 :: mass
 error=1
end function

function set_radius(id,r) result(error)
integer id,error
real*8 :: r
 error=1
end function

function set_pos(id,p) result(error)
integer id,error
real*8 :: p(3)
 error=1
end function

function set_vel(id,v) result(error)
integer id,error
real*8 :: v(3)
 error=1
end function

function remove_particle(id) result(n)
integer id,n
 n=-1
end function

function get_number() result(n)
 integer n,muse_get_nbodies
  n=muse_get_nbodies() 
end function

function get_dynamical_time_scale() result(td)
 real*8 :: td,muse_get_dynamical_time_scale
 td=muse_get_dynamical_time_scale()
end function

function get_time() result(t)
 real*8 :: t,muse_get_time
 t=muse_get_time()
end function

function get_time_step() result(dt)
 real*8 :: dt,muse_get_time_step
 dt=muse_get_time_step()
end function

function initialize_time_step() result(error)
integer :: error
 error=0
end function

function finalize_time_step() result(error)
integer :: error
 error=0
end function

function evolve(tend, sync) result(icoll)
!f2py intent(callback,hide) external_acc
!f2py intent(callback,hide) external_pot
!f2py use call_external_acc__user__routines
!f2py use call_external_pot__user__routines
!f2py external external_acc
!f2py external external_pot
 integer :: sync,icoll
 real*8 :: tend
 call muse_stepsys(tend,sync)
 icoll=-1
end function

function find_colliding_primary() result(ip)
 integer :: ip
 ip=0
end function 

function find_colliding_secondary(ip) result(is)
 integer :: ip,is
 is=0
end function 
 
subroutine get_state(id,mass,x,y,z,vx,vy,vz,eps)
integer :: id
real*8 :: mass,x,y,z,vx,vy,vz,eps
!f2py intent(in) id
!f2py intent(out) mass,x,y,z,vx,vy,vz,eps
  call muse_get_state(id,mass,x,y,z,vx,vy,vz,eps)
end subroutine

function get_mass(id) result(m)
 integer id
 real*8 :: m
 m=0
end function

function get_radius(id) result(r)
 integer id
 real*8 :: r
 r=0
end function

function get_kinetic_energy(mode) result(e)
!f2py intent(callback,hide) external_acc
!f2py intent(callback,hide) external_pot
!f2py use call_external_acc__user__routines
!f2py use call_external_pot__user__routines
!f2py external external_acc
!f2py external external_pot
 real*8 :: e,ek,ep,eth
 integer :: mode
 call muse_energies(mode,ek,ep,eth)
 e=ek
end function 

function get_potential_energy() result(e)
 real*8 :: e,ek,ep,eth
 call muse_energies(0,ek,ep,eth)
 e=ep
end function 

function get_thermal_energy() result(e)
 real*8 :: e,ek,ep,eth
 call muse_energies(0,ek,ep,eth)
 e=eth
end function 

function get_escaper() result(iesc)
 integer :: iesc
 iesc=-1
end function 

subroutine get_gravity(eps,x,y,z,ax,ay,az,n)
 integer :: n
 real*8 :: eps(n),x(n),y(n),z(n),ax(n),ay(n),az(n)
 call muse_get_gravity(eps,x,y,z,ax,ay,az,n) 
end subroutine

subroutine get_tidalfield(eps,x,y,z,tide,n)
 integer :: n
 real*8 :: eps(n),x(n),y(n),z(n),tide(6,n)
 call muse_get_tidalfield(eps,x,y,z,tide,n) 
end subroutine

subroutine get_pot(eps,x,y,z,pot,n)
 integer :: n
 real*8 :: eps(n),x(n),y(n),z(n),pot(n)
 call muse_get_pot(eps,x,y,z,pot,n) 
end subroutine

subroutine call_external_acc(eps,x,y,z,ax,ay,az,n)
  integer n
  double precision :: eps(n), x(n),y(n),z(n)
  double precision :: ax(n),ay(n),az(n)
!f2py intent(callback,hide) external_acc
!f2py external external_acc

 call external_acc(eps,x,y,z,ax,ay,az,n) 

end subroutine

subroutine call_external_pot(eps,x,y,z,phi,n)
  integer n
  double precision :: eps(n), x(n),y(n),z(n)
  double precision :: phi(n)
!f2py intent(callback,hide) external_pot
!f2py external external_pot

 call external_pot(eps,x,y,z,phi,n) 

end subroutine



subroutine set_nstar(nstar)
 integer :: nstar
 call muse_set_nstar(nstar) 
end subroutine

subroutine omp_entdotaccsphco
 include 'globals.h'
 integer p,k,nneigh,kmin,kmax
 integer, parameter :: nbuf=32
 integer :: ib,buf(nbuf),todo(nbuf),ntodo,totalsearches
 integer omp_get_max_threads,nchunk,chunk,maxthread
 real time1,time2,mintime,maxtime,tottime,utime1,utime2
 integer :: niter

 if(nsphact.EQ.0) return
 nnmin=nbodies; nnmax=0; nntot=0
 mintime=1.e10; maxtime=0; tottime=0

 maxthread=1
 nchunk=1
 niter=0
!$  maxthread=omp_get_max_threads()
!$  nchunk=MAX(MIN(10*maxthread,nsphact/nbuf),maxthread)	
 totalsearches=0
!$omp parallel private(p,k,nneigh,time1,time2,kmin,kmax, &
!$omp  buf,todo,ntodo,ib,chunk) shared(nchunk)&
!$omp reduction( + : tottime,nntot,totalsearches,niter) & 
!$omp reduction( MIN : mintime,nnmin) & 
!$omp reduction( MAX : maxtime,nnmax)
 call wall_time(time1)
 ncalls=0;nsearches=0
!$omp do schedule(guided,1)
 do chunk=1,nchunk
  kmin=int(nsphact*float(chunk-1)/nchunk)+1
  kmax=int(nsphact*float(chunk)/nchunk)
  buf=0
  reuseflag=1
  searchreuse=0
  do k=kmin,kmax
   call precomsearch(k,kmax,nbuf,buf,ntodo,todo)
   do ib=1,ntodo
    niter=niter+1
    p=todo(ib)
    call pcond_comsrch(root,p,nneigh,srlist)
    call pentdotaccsphco(p,nneigh)
    nnmin=MIN(nnmin,nneigh)
    nnmax=MAX(nnmax,nneigh)
    nntot=nntot+nneigh
   enddo
  enddo
 enddo
!$omp enddo nowait  
 call wall_time(time2)
 mintime=MIN(mintime,time2-time1)
 maxtime=MAX(maxtime,time2-time1)
 tottime=tottime+time2-time1
 totalsearches=totalsearches+nsearches
!$omp end parallel
 nnavg=nntot/nsphact
 if(verbosity.GT.0) print*,'<dentacc> parts,searches:', nsphact,totalsearches 
 if(verbosity.GT.0) print*,'<dentacc> mn,av,mx:',nnmin,nnavg,nnmax
 if(verbosity.GT.0) write(*,'(" <dentacc> time:", 3f8.2)') mintime,maxtime,tottime
 if(niter.NE.nsphact) call terror("inconsistent omp_entdotaccsphco iter count")
end

subroutine omp_accsphco
 include 'globals.h'
 integer p,k,nneigh,kmin,kmax
 integer, parameter :: nbuf=32
 integer :: ib,buf(nbuf),todo(nbuf),ntodo,totalsearches
 integer omp_get_max_threads,nchunk,chunk,maxthread
 real time1,time2,mintime,maxtime,tottime,utime1,utime2
 integer :: niter

 if(nsphact.EQ.0) return
 nnmin=nbodies; nnmax=0; nntot=0
 mintime=1.e10; maxtime=0; tottime=0

 maxthread=1
 nchunk=1
 niter=0
!$  maxthread=omp_get_max_threads()
!$  nchunk=MAX(MIN(10*maxthread,nsphact/nbuf),maxthread)	
totalsearches=0
!$omp parallel private(p,k,nneigh,time1,time2,kmin,kmax, &
!$omp  buf,todo,ntodo,ib,chunk) shared(nchunk)&
!$omp reduction( + : tottime,nntot,niter) & 
!$omp reduction( MIN : mintime,nnmin) & 
!$omp reduction( MAX : maxtime,nnmax)
 call wall_time(time1)
 ncalls=0;nsearches=0
!$omp do schedule(guided,1)
 do chunk=1,nchunk
  kmin=int(nsphact*float(chunk-1)/nchunk)+1
  kmax=int(nsphact*float(chunk)/nchunk)
  buf=0
  reuseflag=1
  searchreuse=0
  do k=kmin,kmax
   call precomsearch(k,kmax,nbuf,buf,ntodo,todo)
   do ib=1,ntodo
    niter=niter+1
    p=todo(ib)
    call pcond_comsrch(root,p,nneigh,srlist)
    call paccsphco(p,nneigh)
    nnmin=MIN(nnmin,nneigh)
    nnmax=MAX(nnmax,nneigh)
    nntot=nntot+nneigh
   enddo
  enddo
 enddo
!$omp enddo nowait  
 call wall_time(time2)
 mintime=MIN(mintime,time2-time1)
 maxtime=MAX(maxtime,time2-time1)
 tottime=tottime+time2-time1
 totalsearches=totalsearches+nsearches
!$omp end parallel
 nnavg=nntot/nsphact
 if(verbosity.GT.0) print*,'<accsph> parts,searches:', nsphact,totalsearches 
 if(verbosity.GT.0) print*,'<accsph> mn,av,mx:',nnmin,nnavg,nnmax
 if(verbosity.GT.0) write(*,'(" <accsph> time:", 3f8.2)') mintime,maxtime,tottime
 if(niter.NE.nsphact) call terror("inconsistent omp_accsphco iter count")
end


subroutine omp_entdot
 include 'globals.h'
 integer p,k,nneigh,kmin,kmax
 integer, parameter :: nbuf=32
 integer :: ib,buf(nbuf),todo(nbuf),ntodo,totalsearches
 integer omp_get_max_threads,nchunk,chunk,maxthread
 real time1,time2,mintime,maxtime,tottime,utime1,utime2
 integer :: niter

 if(nsphact.EQ.0) return
 nnmin=nbodies; nnmax=0; nntot=0
 mintime=1.e10; maxtime=0; tottime=0

 maxthread=1
 nchunk=1
 niter=0
!$  maxthread=omp_get_max_threads()
!$  nchunk=MAX(MIN(10*maxthread,nsphact/nbuf),maxthread)	
 totalsearches=0 
!$omp parallel private(p,k,nneigh,time1,time2,kmin,kmax, &
!$omp  buf,todo,ntodo,ib,chunk) shared(nchunk)&
!$omp reduction( + : tottime,nntot, niter) & 
!$omp reduction( MIN : mintime,nnmin) & 
!$omp reduction( MAX : maxtime,nnmax)
 call wall_time(time1)
 ncalls=0;nsearches=0
!$omp do schedule(guided,1)
 do chunk=1,nchunk
  kmin=int(nsphact*float(chunk-1)/nchunk)+1
  kmax=int(nsphact*float(chunk)/nchunk)
  buf=0
  reuseflag=1
  searchreuse=0
  do k=kmin,kmax
   call precomsearch(k,kmax,nbuf,buf,ntodo,todo)
   do ib=1,ntodo
    niter=niter+1
    p=todo(ib)
    call pcond_comsrch(root,p,nneigh,srlist)
    call pentdot(p,nneigh)
    nnmin=MIN(nnmin,nneigh)
    nnmax=MAX(nnmax,nneigh)
    nntot=nntot+nneigh
   enddo
  enddo
 enddo
!$omp enddo nowait  
 call wall_time(time2)
 mintime=MIN(mintime,time2-time1)
 maxtime=MAX(maxtime,time2-time1)
 tottime=tottime+time2-time1
 totalsearches=totalsearches+nsearches
!$omp end parallel
 nnavg=nntot/nsphact
 if(verbosity.GT.0) print*,'<entdot> parts,searches:', nsphact,totalsearches
 if(verbosity.GT.0) print*,'<entdot> mn,av,mx:',nnmin,nnavg,nnmax
 if(verbosity.GT.0) write(*,'(" <entdot> time:", 3f8.2)') mintime,maxtime,tottime
 if(niter.NE.nsphact) call terror("inconsistent omp_entdot iter count")
end

subroutine pentdot(p,n)
 include 'globals.h'
 integer n,p
 real h,ppos(3),pvel(3),lrho,lcsound,ldentdt,imumax
 real lhsmdivv,lhsmcurlv
  h=hsmooth(p)
  ppos=pos(p,1:3)
  pvel=veltpos(p,1:3)
  lrho=rho(p)
  lcsound=csound(p)
  lhsmdivv=hsmdivv(p)
  lhsmcurlv=hsmcurlv(p)
  call entdot(n,h,ppos,pvel,lrho,lcsound,ldentdt,imumax,lhsmdivv,lhsmcurlv)
  dentdt(p)=ldentdt
  mumaxdvh(p)=imumax
end

subroutine paccsphco(p,n)
 include 'globals.h'
 integer n,p
 real h,ppos(3),pvel(3),pacc(3),lrho,lcsound,ldrhodh
 real lhsmdivv,lhsmcurlv
  h=hsmooth(p)
  ppos=pos(p,1:3)
  pvel=veltpos(p,1:3)
  lrho=rho(p)
  ldrhodh=drhodh(p)
  lcsound=csound(p)
  lhsmdivv=hsmdivv(p)
  lhsmcurlv=hsmcurlv(p)
  call accsphco(n,h,ppos,pvel,pacc,lrho,lcsound,ldrhodh,lhsmdivv,lhsmcurlv)
  acc(p,1:3)=acc(p,1:3)+pacc(1:3)
end


subroutine entdot(n,hsm,ppos,pvel,lrho,lcsound,dent,tmuij,lhsmdivv,lhsmcurlv)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: ppos,pvel
 real,intent(in) :: hsm,lrho,lcsound
 real,intent(in) :: lhsmdivv,lhsmcurlv
 real,intent(inout) :: dent,tmuij
 integer :: i,nb,iwsm,iwsm1
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,drw1,tmass,dr2,dr2i,wsm
 real :: dwmass,dwmass1,dwsm,dwsm1,dwmnbi,dwnorm,wmass,muij,eij,piij
 real :: vdotdr,hsmavg
 real :: fbalsara1,fbalsara2
 dent=0
 tmuij=0
 if(lrho.EQ.0) return
 fbalsara1=1.
 if(abs(lhsmcurlv).GT.0) fbalsara1=abs(lhsmdivv)/(abs(lhsmdivv)+abs(lhsmcurlv))
 if(symmetry.EQ.'hk') then
  hsminv=1./hsm
  dwnorm=piinv*hsminv**5
  distnorm=hsminv*hsminv*deldr2i
  do i=1,n
  nb=srlist(i)
  dx=ppos(1)-pos(nb,1)
  dy=ppos(2)-pos(nb,2)
  dz=ppos(3)-pos(nb,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  if(dr2.GT.4*hsm**2.AND.dr2.GT.4*hsmooth(nb)**2) cycle
  dr2p=dr2*distnorm
  if(dr2p.LT.ninterp) then
   iwsm=INT(dr2p)
   drw=dr2p-iwsm
   dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
   dwmass=dwnorm*dwsm
  else
   dwmass=0.
  endif
  dr2i=dr2*deldr2i/(hsmooth(nb)*hsmooth(nb))
  if(dr2i.LT.ninterp) then
   iwsm1=INT(dr2i)
   drw1=dr2i-iwsm1
   dwsm1=(1.-drw1)*dwsmooth(iwsm1)+drw1*dwsmooth(1+iwsm1)
   dwmass1=piinv/(hsmooth(nb)**5)*dwsm1
  else
   dwmass1=0.
  endif
  vdotdr=(pvel(1)-veltpos(nb,1))*dx+ &
  	 (pvel(2)-veltpos(nb,2))*dy+ &
  	 (pvel(3)-veltpos(nb,3))*dz
  hsmavg=.5*(hsm+hsmooth(nb))
  muij=vdotdr*hsmavg/(dr2+epssph*hsmavg**2)
  if(vdotdr.GT.0.) muij=0.
  piij=(-alpha*muij*(max(lcsound,csound(nb)))+beta*muij**2)/ &
                                                 (min(lrho,rho(nb)))
  if(balsara) then
    fbalsara2=1
    if(abs(hsmcurlv(nb)).GT.0) fbalsara2=abs(hsmdivv(nb))/(abs(hsmdivv(nb))+abs(hsmcurlv(nb)))
    piij=piij*0.5*(fbalsara1+fbalsara2)
  endif
! gadget visc
!  if(dr2.NE.0) muij=vdotdr/sqrt(dr2)
!  if(vdotdr.GT.0..OR.dr2.EQ.0) muij=0.
!  piij=-alpha*muij*(lcsound+csound(nb)-3*muij)/(lrho+rho(nb))
  eij=vdotdr*0.5*piij
  dent=dent+eij*mass(nb)*0.5*(dwmass+dwmass1)
  tmuij=MAX(tmuij,ABS(muij))
! gadget visc  
!  tmuij=MAX(tmuij, lcsound+csound(nb)-3*muij)  
  enddo
 else
  do i=1,n
  nb=srlist(i)
  dx=ppos(1)-pos(nb,1)
  dy=ppos(2)-pos(nb,2)
  dz=ppos(3)-pos(nb,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  if(dr2.GT.(hsm+hsmooth(nb))**2) cycle
  hsminv=2./(hsm+hsmooth(nb))
  dwnorm=piinv*hsminv**5
  distnorm=hsminv**2*deldr2i
  dr2p=dr2*distnorm
  if(dr2p.LT.ninterp) then
   iwsm=INT(dr2p)
   drw=dr2p-iwsm
   dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
   dwmass=dwnorm*dwsm
  else
   dwmass=0.
  endif
   vdotdr=(pvel(1)-veltpos(nb,1))*dx+ &
	  (pvel(2)-veltpos(nb,2))*dy+ &
	  (pvel(3)-veltpos(nb,3))*dz
   hsmavg=0.5*(hsm+hsmooth(nb))
   muij=vdotdr*hsmavg/(dr2+epssph*hsmavg**2)
   if(vdotdr.GT.0.) muij=0.
   piij=(-alpha*muij*(max(lcsound,csound(nb)))+beta*muij**2)/ &
                                                 (min(lrho,rho(nb)))
   if(balsara) then
     fbalsara2=1
     if(abs(hsmcurlv(nb)).GT.0) fbalsara2=abs(hsmdivv(nb))/(abs(hsmdivv(nb))+abs(hsmcurlv(nb)))
     piij=piij*0.5*(fbalsara1+fbalsara2)
   endif
   eij=vdotdr*0.5*piij
   dent=dent+eij*mass(nb)*dwmass
   tmuij=MAX(tmuij,ABS(muij))
  enddo
 endif
 dent=dent*gamma1/(lrho**gamma1)
end

subroutine accsphco(n,hsm,ppos,pvel,pacc,lrho,lcsound,ldrhodh,lhsmdivv,lhsmcurlv)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: ppos,pvel
 real,dimension(3),intent(inout) :: pacc
 real,intent(in) :: hsm,lrho,lcsound,ldrhodh
 real,intent(in) :: lhsmdivv,lhsmcurlv
 integer :: i,nb,iwsm,iwsm1
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,drw1,tmass,dr2,dr2i,wsm
 real :: dwmass,dwmass1,dwsm,dwsm1,dwmnbi,dwnorm,wmass,muij,eij,piij
 real :: vdotdr,hsmavg,aij,aijmass,fi,fnbi
 real :: fbalsara1,fbalsara2

 pacc=0
 if(lrho.EQ.0) return
 fbalsara1=1.
 if(abs(lhsmcurlv).GT.0) fbalsara1=abs(lhsmdivv)/(abs(lhsmdivv)+abs(lhsmcurlv))
 hsminv=1./hsm
 dwnorm=piinv*hsminv**5
 distnorm=hsminv*hsminv*deldr2i
 do i=1,n
  nb=srlist(i)
  dx=ppos(1)-pos(nb,1)
  dy=ppos(2)-pos(nb,2)
  dz=ppos(3)-pos(nb,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  if(dr2.GT.4*hsm**2.AND.dr2.GT.4*hsmooth(nb)**2) cycle
  dr2p=dr2*distnorm
  if(dr2p.LT.ninterp) then
   iwsm=INT(dr2p)
   drw=dr2p-iwsm
   dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
   dwmass=dwnorm*dwsm
  else
   dwmass=0.
  endif
  dr2i=dr2*deldr2i/(hsmooth(nb)*hsmooth(nb))		    
  if(dr2i.LT.ninterp) then
   iwsm1=INT(dr2i)
   drw1=dr2i-iwsm1
   dwsm1=(1.-drw1)*dwsmooth(iwsm1)+drw1*dwsmooth(1+iwsm1)
   dwmass1=piinv/(hsmooth(nb)**5)*dwsm1
  else
   dwmass1=0.
  endif
  vdotdr=(pvel(1)-veltpos(nb,1))*dx+ &
	 (pvel(2)-veltpos(nb,2))*dy+ &
	 (pvel(3)-veltpos(nb,3))*dz
  hsmavg=.5*(hsm+hsmooth(nb))
  muij=vdotdr*hsmavg/(dr2+epssph*hsmavg**2)
  if(vdotdr.GT.0.) muij=0.
  piij=(-alpha*muij*(max(lcsound,csound(nb)))+beta*muij**2)/ &
                                                  (min(lrho,rho(nb)))
   if(balsara) then
     fbalsara2=1
     if(abs(hsmcurlv(nb)).GT.0) fbalsara2=abs(hsmdivv(nb))/(abs(hsmdivv(nb))+abs(hsmcurlv(nb)))
     piij=piij*0.5*(fbalsara1+fbalsara2)
   endif
!  gadget visc
!  if(dr2.NE.0) muij=vdotdr/sqrt(dr2)
!  if(vdotdr.GT.0..OR.dr2.EQ.0) muij=0.
!  piij=-alpha*muij*(lcsound+csound(nb)-3*muij)/(lrho+rho(nb))
  fi=1/(1+ldrhodh*hsm/3/(rhomin+lrho))
  fnbi=1/(1+drhodh(nb)*hsmooth(nb)/3/(rhomin+rho(nb)))
  
  aij=fi*lcsound**2/(gamma*lrho)*dwmass+ &
      fnbi*csound(nb)**2/(gamma*rho(nb))*dwmass1
  
  aij=aij+piij*0.5*(dwmass+dwmass1)
  aijmass=aij*mass(nb)
  pacc(1)=pacc(1)-aijmass*dx
  pacc(2)=pacc(2)-aijmass*dy
  pacc(3)=pacc(3)-aijmass*dz
 enddo
end

subroutine pentdotaccsphco(p,n)
 include 'globals.h'
 integer n,p
 real h,ppos(3),pvel(3),pacc(3),lrho,lcsound,ldrhodh,ldentdt,imumax
 real lhsmdivv,lhsmcurlv
  h=hsmooth(p)
  ppos=pos(p,1:3)
  pvel=veltpos(p,1:3)
  lrho=rho(p)
  ldrhodh=drhodh(p)
  lcsound=csound(p)
  lhsmdivv=hsmdivv(p)
  lhsmcurlv=hsmcurlv(p)  
  call entdotaccsphco(n,h,ppos,pvel,pacc,lrho,lcsound,ldrhodh,ldentdt,imumax,lhsmdivv,lhsmcurlv)
  acc(p,1:3)=acc(p,1:3)+pacc(1:3)
  dentdt(p)=ldentdt
  mumaxdvh(p)=imumax
end


subroutine entdotaccsphco(n,hsm,ppos,pvel,pacc,lrho,lcsound,ldrhodh,dent,tmuij,lhsmdivv,lhsmcurlv)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: ppos,pvel
 real,intent(inout) :: pacc(3),dent,tmuij
 real,intent(in) :: hsm,lrho,lcsound,ldrhodh
 real,intent(in) :: lhsmdivv,lhsmcurlv
 integer :: i,nb,iwsm,iwsm1
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,drw1,tmass,dr2,dr2i,wsm
 real :: dwmass,dwmass1,dwsm,dwsm1,dwmnbi,dwnorm,wmass,muij,eij,piij
 real :: vdotdr,hsmavg,aij,aijmass,fi,fnbi
 real :: fbalsara1,fbalsara2

 pacc=0
 dent=0
 tmuij=0
 if(lrho.EQ.0) return
 fbalsara1=1.
 if(abs(lhsmcurlv).GT.0) fbalsara1=abs(lhsmdivv)/(abs(lhsmdivv)+abs(lhsmcurlv))
 hsminv=1./hsm
 dwnorm=piinv*hsminv**5
 distnorm=hsminv*hsminv*deldr2i
 do i=1,n
  nb=srlist(i)
  dx=ppos(1)-pos(nb,1)
  dy=ppos(2)-pos(nb,2)
  dz=ppos(3)-pos(nb,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  if(dr2.GT.4*hsm**2.AND.dr2.GT.4*hsmooth(nb)**2) cycle
  dr2p=dr2*distnorm
  if(dr2p.LT.ninterp) then
   iwsm=INT(dr2p)
   drw=dr2p-iwsm
   dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
   dwmass=dwnorm*dwsm
  else
   dwmass=0.
  endif
  dr2i=dr2*deldr2i/(hsmooth(nb)*hsmooth(nb))		    
  if(dr2i.LT.ninterp) then
   iwsm1=INT(dr2i)
   drw1=dr2i-iwsm1
   dwsm1=(1.-drw1)*dwsmooth(iwsm1)+drw1*dwsmooth(1+iwsm1)
   dwmass1=piinv/(hsmooth(nb)**5)*dwsm1
  else
   dwmass1=0.
  endif
  
  vdotdr=(pvel(1)-veltpos(nb,1))*dx+ &
	 (pvel(2)-veltpos(nb,2))*dy+ &
	 (pvel(3)-veltpos(nb,3))*dz
  hsmavg=.5*(hsm+hsmooth(nb))
  muij=vdotdr*hsmavg/(dr2+epssph*hsmavg**2)
  if(vdotdr.GT.0.) muij=0.
  piij=(-alpha*muij*(max(lcsound,csound(nb)))+beta*muij**2)/ &
                                                  (min(lrho,rho(nb)))
  if(balsara) then
    fbalsara2=1
    if(abs(hsmcurlv(nb)).GT.0) fbalsara2=abs(hsmdivv(nb))/(abs(hsmdivv(nb))+abs(hsmcurlv(nb)))
    piij=piij*0.5*(fbalsara1+fbalsara2)
  endif
!  gadget visc
!  if(dr2.NE.0) muij=vdotdr/sqrt(dr2)
!  if(vdotdr.GT.0..OR.dr2.EQ.0) muij=0.
!  piij=-alpha*muij*(lcsound+csound(nb)-3*muij)/(lrho+rho(nb))


 		  
!  fi=1/(1+ldrhodh*hsm/3/(rhomin+lrho))
!  fnbi=1/(1+drhodh(nb)*hsmooth(nb)/3/(rhomin+rho(nb)))
  fi=(rhomin+lrho)/((rhomin+lrho)+ldrhodh*hsm/3.)
  fnbi=(rhomin+rho(nb))/((rhomin+rho(nb))+drhodh(nb)*hsmooth(nb)/3.)
  
  aij=fi*lcsound**2/(gamma*lrho)*dwmass+ &
      fnbi*csound(nb)**2/(gamma*rho(nb))*dwmass1
  
  aij=aij+piij*0.5*(dwmass+dwmass1)
  aijmass=aij*mass(nb)
  pacc(1)=pacc(1)-aijmass*dx
  pacc(2)=pacc(2)-aijmass*dy
  pacc(3)=pacc(3)-aijmass*dz
  
  eij=vdotdr*0.5*piij
  dent=dent+eij*mass(nb)*0.5*(dwmass+dwmass1)
  tmuij=MAX(tmuij,ABS(muij))
!  gadget visc
!  tmuij=MAX(tmuij, lcsound+csound(nb)-3*muij)
 enddo
 dent=dent*gamma1/(lrho**gamma1)
end


subroutine omp_ethdotaccsphco
 include 'globals.h'
 integer p,k,nneigh,kmin,kmax
 integer, parameter :: nbuf=32
 integer :: ib,buf(nbuf),todo(nbuf),ntodo,totalsearches
 integer omp_get_max_threads,nchunk,chunk,maxthread
 real time1,time2,mintime,maxtime,tottime,utime1,utime2
 integer :: niter

 if(nsphact.EQ.0) return
 nnmin=nbodies; nnmax=0; nntot=0
 mintime=1.e10; maxtime=0; tottime=0

 maxthread=1
 nchunk=1
 niter=0
!$  maxthread=omp_get_max_threads()
!$  nchunk=MAX(MIN(10*maxthread,nsphact/nbuf),maxthread)	
 totalsearches=0
!$omp parallel private(p,k,nneigh,time1,time2,kmin,kmax, &
!$omp  buf,todo,ntodo,ib,chunk) shared(nchunk)&
!$omp reduction( + : tottime,nntot,totalsearches,niter) & 
!$omp reduction( MIN : mintime,nnmin) & 
!$omp reduction( MAX : maxtime,nnmax)
 call wall_time(time1)
 ncalls=0;nsearches=0
!$omp do schedule(guided,1)
 do chunk=1,nchunk
  kmin=int(nsphact*float(chunk-1)/nchunk)+1
  kmax=int(nsphact*float(chunk)/nchunk)
  buf=0
  reuseflag=1
  searchreuse=0
  do k=kmin,kmax
   call precomsearch(k,kmax,nbuf,buf,ntodo,todo)
   do ib=1,ntodo
    niter=niter+1
    p=todo(ib)
    call pcond_comsrch(root,p,nneigh,srlist)
    call pethdotaccsphco(p,nneigh)
    nnmin=MIN(nnmin,nneigh)
    nnmax=MAX(nnmax,nneigh)
    nntot=nntot+nneigh
   enddo
  enddo
 enddo
!$omp enddo nowait  
 call wall_time(time2)
 mintime=MIN(mintime,time2-time1)
 maxtime=MAX(maxtime,time2-time1)
 tottime=tottime+time2-time1
 totalsearches=totalsearches+nsearches
!$omp end parallel
 nnavg=nntot/nsphact
 if(verbosity.GT.0) print*,'<dethacc> parts,searches:', nsphact,totalsearches 
 if(verbosity.GT.0) print*,'<dethacc> mn,av,mx:',nnmin,nnavg,nnmax
 if(verbosity.GT.0) write(*,'(" <dethacc> time:", 3f8.2)') mintime,maxtime,tottime
 if(niter.NE.nsphact) call terror("inconsistent omp_ethdotaccsphco iter count")
end

subroutine omp_ethdotco
 include 'globals.h'
 integer p,k,nneigh,kmin,kmax
 integer, parameter :: nbuf=32
 integer :: ib,buf(nbuf),todo(nbuf),ntodo,totalsearches
 integer omp_get_max_threads,nchunk,chunk,maxthread
 real time1,time2,mintime,maxtime,tottime,utime1,utime2
 integer :: niter

 if(nsphact.EQ.0) return
 nnmin=nbodies; nnmax=0; nntot=0
 mintime=1.e10; maxtime=0; tottime=0

 maxthread=1
 nchunk=1
 niter=0
!$  maxthread=omp_get_max_threads()
!$  nchunk=MAX(MIN(10*maxthread,nsphact/nbuf),maxthread)	
 totalsearches=0
!$omp parallel private(p,k,nneigh,time1,time2,kmin,kmax, &
!$omp  buf,todo,ntodo,ib,chunk) shared(nchunk)&
!$omp reduction( + : tottime,nntot,totalsearches,niter) & 
!$omp reduction( MIN : mintime,nnmin) & 
!$omp reduction( MAX : maxtime,nnmax)
 call wall_time(time1)
 ncalls=0;nsearches=0
!$omp do schedule(guided,1)
 do chunk=1,nchunk
  kmin=int(nsphact*float(chunk-1)/nchunk)+1
  kmax=int(nsphact*float(chunk)/nchunk)
  buf=0
  reuseflag=1
  searchreuse=0
  do k=kmin,kmax
   call precomsearch(k,kmax,nbuf,buf,ntodo,todo)
   do ib=1,ntodo
    niter=niter+1
    p=todo(ib)
    call pcond_comsrch(root,p,nneigh,srlist)
    call pethdotco(p,nneigh)
    nnmin=MIN(nnmin,nneigh)
    nnmax=MAX(nnmax,nneigh)
    nntot=nntot+nneigh
   enddo
  enddo
 enddo
!$omp enddo nowait  
 call wall_time(time2)
 mintime=MIN(mintime,time2-time1)
 maxtime=MAX(maxtime,time2-time1)
 tottime=tottime+time2-time1
 totalsearches=totalsearches+nsearches
!$omp end parallel
 nnavg=nntot/nsphact
 if(verbosity.GT.0) print*,'<deth> parts,searches:', nsphact,totalsearches 
 if(verbosity.GT.0) print*,'<deth> mn,av,mx:',nnmin,nnavg,nnmax
 if(verbosity.GT.0) write(*,'(" <deth> time:", 3f8.2)') mintime,maxtime,tottime
 if(niter.NE.nsphact) call terror("inconsistent omp_ethdotco iter count")
end


subroutine pethdotaccsphco(p,n)
 include 'globals.h'
 integer n,p
 real h,ppos(3),pvel(3),pacc(3),lrho,lcsound,ldrhodh,ldethdt,imumax
 real lhsmdivv,lhsmcurlv
  h=hsmooth(p)
  ppos=pos(p,1:3)
  pvel=veltpos(p,1:3)
  lrho=rho(p)
  ldrhodh=drhodh(p)
  lcsound=csound(p)
  lhsmdivv=hsmdivv(p)
  lhsmcurlv=hsmcurlv(p)
  call ethdotaccsphco(n,h,ppos,pvel,pacc,lrho,lcsound,ldrhodh,ldethdt,imumax,lhsmdivv,lhsmcurlv)
  acc(p,1:3)=acc(p,1:3)+pacc(1:3)
!  if(.NOT.isotherm) dethdt(p)=ldethdt
  dethdt(p)=ldethdt
  mumaxdvh(p)=imumax
end

subroutine pethdotco(p,n)
 include 'globals.h'
 integer n,p
 real h,ppos(3),pvel(3),pacc(3),lrho,lcsound,ldrhodh,ldethdt,imumax
 real lhsmdivv,lhsmcurlv
  h=hsmooth(p)
  ppos=pos(p,1:3)
  pvel=veltpos(p,1:3)
  lrho=rho(p)
  ldrhodh=drhodh(p)
  lcsound=csound(p)
  lhsmdivv=hsmdivv(p)
  lhsmcurlv=hsmcurlv(p)  
  call ethdotaccsphco(n,h,ppos,pvel,pacc,lrho,lcsound,ldrhodh,ldethdt,imumax,lhsmdivv,lhsmcurlv)
!  acc(p,1:3)=acc(p,1:3)+pacc(1:3)
  dethdt(p)=ldethdt
  mumaxdvh(p)=imumax
end


subroutine ethdotaccsphco(n,hsm,ppos,pvel,pacc,lrho,lcsound,ldrhodh,deth,tmuij,lhsmdivv,lhsmcurlv)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: ppos,pvel
 real,intent(inout) :: pacc(3),deth,tmuij
 real,intent(in) :: hsm,lrho,lcsound,ldrhodh
 real,intent(in) :: lhsmdivv,lhsmcurlv
 integer :: i,nb,iwsm,iwsm1
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,drw1,tmass,dr2,dr2i,wsm
 real :: dwmass,dwmass1,dwsm,dwsm1,dwmnbi,dwnorm,wmass,muij,eij,piij
 real :: vdotdr,hsmavg,aij,aijmass,fi,fnbi
 real :: fbalsara1,fbalsara2

 fbalsara1=1.
 if(abs(lhsmcurlv).GT.0) fbalsara1=abs(lhsmdivv)/(abs(lhsmdivv)+abs(lhsmcurlv))
 pacc=0
 deth=0
 tmuij=0
 if(lrho.EQ.0) return
 hsminv=1./hsm
 dwnorm=piinv*hsminv**5
 distnorm=hsminv*hsminv*deldr2i
 do i=1,n
  nb=srlist(i)
  dx=ppos(1)-pos(nb,1)
  dy=ppos(2)-pos(nb,2)
  dz=ppos(3)-pos(nb,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  if(dr2.GT.4*hsm**2.AND.dr2.GT.4*hsmooth(nb)**2) cycle
  dr2p=dr2*distnorm
  if(dr2p.LT.ninterp) then
   iwsm=INT(dr2p)
   drw=dr2p-iwsm
   dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
   dwmass=dwnorm*dwsm
  else
   dwmass=0.
  endif
  dr2i=dr2*deldr2i/(hsmooth(nb)*hsmooth(nb))		    
  if(dr2i.LT.ninterp) then
   iwsm1=INT(dr2i)
   drw1=dr2i-iwsm1
   dwsm1=(1.-drw1)*dwsmooth(iwsm1)+drw1*dwsmooth(1+iwsm1)
   dwmass1=piinv/(hsmooth(nb)**5)*dwsm1
  else
   dwmass1=0.
  endif
  
  vdotdr=(pvel(1)-veltpos(nb,1))*dx+ &
	 (pvel(2)-veltpos(nb,2))*dy+ &
	 (pvel(3)-veltpos(nb,3))*dz
  hsmavg=.5*(hsm+hsmooth(nb))
  muij=vdotdr*hsmavg/(dr2+epssph*hsmavg**2)
  if(vdotdr.GT.0.) muij=0.
  piij=(-alpha*muij*(max(lcsound,csound(nb)))+beta*muij**2)/ &
                                                  (min(lrho,rho(nb)))
  if(balsara) then
    fbalsara2=1
    if(abs(hsmcurlv(nb)).GT.0) fbalsara2=abs(hsmdivv(nb))/(abs(hsmdivv(nb))+abs(hsmcurlv(nb)))
    piij=piij*0.5*(fbalsara1+fbalsara2)
  endif

!  fi=1/(1+ldrhodh*hsm/3/(rhomin+lrho))
!  fnbi=1/(1+drhodh(nb)*hsmooth(nb)/3/(rhomin+rho(nb)))
  fi=(rhomin+lrho)/((rhomin+lrho)+ldrhodh*hsm/3.)
  fnbi=(rhomin+rho(nb))/((rhomin+rho(nb))+drhodh(nb)*hsmooth(nb)/3.)
  
  aij=fi*lcsound**2/(gamma*lrho)*dwmass+ &
      fnbi*csound(nb)**2/(gamma*rho(nb))*dwmass1
  
  aij=aij+piij*0.5*(dwmass+dwmass1)
  aijmass=aij*mass(nb)
  pacc(1)=pacc(1)-aijmass*dx
  pacc(2)=pacc(2)-aijmass*dy
  pacc(3)=pacc(3)-aijmass*dz
  
  eij=0.5*vdotdr*aij
  deth=deth+eij*mass(nb)
  tmuij=MAX(tmuij,ABS(muij))
 enddo
end

subroutine pcond_fuvwalk(node,p,nterms)
   include 'globals.h'
   real h,h2,ppos(3),peps
   integer nterms,p,node
   h=hsmooth(p)
   ppos=pos(p,1:3)
   call cond_fuvwalk(node,ppos,0.,nterms)    
end subroutine

subroutine cond_fuvwalk(node,ppos,delta,nterms)
  include 'globals.h'
  real peps,ppos(3),delta,dist
  integer nterms,node
  ncalls=ncalls+1
  if(searchreuse.EQ.0.OR.reuseflag.EQ.0) then
    searchpos=ppos
    searchn=0
    searchdelta=delta
  else
    dist=sqrt(sum((ppos-searchpos)**2))
    if(delta+dist.LE.searchdelta) then
      nterms=searchn
      return
    endif
    searchpos=ppos
    searchn=0
    searchdelta=delta
  endif
  nsearches=nsearches+1
  call fuvwalk(node,searchpos,searchdelta,searchn)
  nterms=searchn
  searchreuse=1
end subroutine

subroutine pcond_treewalk(node,p,nterms)
  include 'globals.h'
  real h,h2,ppos(3),peps,acc4
  integer nterms,p,node
  h=hsmooth(p)
  ppos=pos(p,1:3)
  peps=epsgrav(p)
  acc4=aacc(p)   
  call cond_treewalk(node,ppos,peps,acc4,0.,nterms)    
end subroutine

subroutine cond_treewalk(node,ppos,peps,acc4,delta,nterms)
  include 'globals.h'
  real peps,ppos(3),acc4,delta,dist
  integer nterms,node
  ncalls=ncalls+1
  if(searchreuse.EQ.0.OR.reuseflag.EQ.0) then
    searchpos=ppos
    searchh=peps
    searchn=0
    searchdelta=delta
    searchacc4=acc4   
  else
    dist=sqrt(sum((ppos-searchpos)**2))
    if(peps.LE.searchh.AND. &
          delta+dist.LE.searchdelta.AND. &
                          acc4.GE.searchacc4) then
      nterms=searchn
      return
    endif
    searchpos=ppos
    searchh=peps
    searchn=0
    searchdelta=delta
    searchacc4=acc4   
  endif
  nsearches=nsearches+1
  call treewalk(node,searchpos,searchh,searchacc4,searchdelta,searchn)
  nterms=searchn
  searchreuse=1
end subroutine

subroutine ptreewalk(node,p,nterms)
  include 'globals.h'
  integer, intent(in):: node,p
  integer, intent(inout)::nterms
  real :: ppos(3),peps,acc4
  ppos=pos(p,1:3)
  peps=epsgrav(p)
  acc4=aacc(p)
  call treewalk(node,ppos,peps,acc4,0.,nterms)
end subroutine

subroutine treewalk(node,ppos,peps,acc4,delta,nterms)
  include 'globals.h'
  integer, intent(in):: node
  integer, intent(inout)::nterms
  real,intent(in) :: ppos(3),peps,acc4,delta
  if(periodic) then
    call terror('periodic treewalk broken?')
  endif
  if(acc4.LE.0.OR.(.not.gdgop)) then 
    if(usepm) then
      call pmtreewalk(node,ppos,delta,nterms)
    else
      if(usequad) then
        call quadtreewalk(node,ppos,peps,delta,nterms)
      else   
        call monotreewalk(node,ppos,delta,nterms)
      endif
    endif
  else
    if(usepm) then
      call gdgpmtreewalk(node,ppos,acc4,delta,nterms)
    else
      if(usequad) then
        call gdgquadtreewalk(node,ppos,peps,acc4,delta,nterms)
      else
        call gdgmonotreewalk(node,ppos,acc4,delta,nterms)
      endif
    endif   
  endif
end subroutine

subroutine pfuvwalk(node,p,nterms)
  include 'globals.h'
  integer, intent(in):: node,p
  integer, intent(inout)::nterms
  real :: ppos(3)
  ppos=pos(p,1:3)
  call fuvwalk(node,ppos,0.,nterms)
end subroutine

subroutine fuvwalk(node,ppos,delta,nterms)
  include 'globals.h'
  integer, intent(in):: node
  integer, intent(inout)::nterms
  real, intent(in) :: ppos(3),delta
  if(periodic) then
    call terror('periodic treewalk broken!')
  endif
  call monotreewalk(node,ppos,delta,nterms)
end subroutine

subroutine monotreewalk(node,ppos,delta,nterms)
  include 'globals.h'
  integer, intent(in):: node
  real,intent(in) :: ppos(3),delta 
  integer, intent(inout)::nterms
  integer :: daughter,nstack,cstack(nsubcell*81)
  real :: bh_tol2,dist2,dx,dy,dz,dist2cell 
  bh_tol2=bh_tol*bh_tol
  cstack(1)=node
  nstack=1
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.GT.0) then 
      if(daughter.LT.nbods1) then
        nterms=nterms+1
        bodlist(nterms)=daughter
      else  
        dx=ppos(1)-pos(daughter,1)
        dy=ppos(2)-pos(daughter,2)
        dz=ppos(3)-pos(daughter,3)
        dist2=dx**2+dy**2+dz**2
        if(bh_tol2*dist2.GT.(cellsize(daughter)+delta*bh_tol)**2) then
          dist2=dist2cell(ppos,bottom(daughter,1:3),cellsize(daughter))
          if(dist2.GT.(delta+0.1*cellsize(daughter))**2) then
            nterms=nterms+1
            bodlist(nterms)=daughter
            cycle
          endif
        endif  
        cstack(nstack+1)=subp(daughter,8)
        cstack(nstack+2)=subp(daughter,7)
        cstack(nstack+3)=subp(daughter,6)
        cstack(nstack+4)=subp(daughter,5)
        cstack(nstack+5)=subp(daughter,4)
        cstack(nstack+6)=subp(daughter,3)
        cstack(nstack+7)=subp(daughter,2)
        cstack(nstack+8)=subp(daughter,1)
        nstack=nstack+8
      endif 
    endif
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" treewalk error")
!$omp end critical
  endif            
end subroutine

subroutine quadtreewalk(node,ppos,peps,delta,nterms)
  include 'globals.h'
  integer, intent(in):: node
  real,intent(in) :: ppos(3),peps,delta 
  integer, intent(inout)::nterms
  integer :: daughter,nstack,cstack(nsubcell*81)
  real :: bh_tol2,dist2,dx,dy,dz,dist2cell 
  cstack(1)=node
  nstack=1
  bh_tol2=bh_tol*bh_tol
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
  daughter=cstack(nstack)
  nstack=nstack-1
    if(daughter.LT.nbods1) then
      if(daughter.GT.0) then 
        nterms=nterms+1
        bodlist(nterms)=daughter
      endif
    else  
      dx=ppos(1)-pos(daughter,1)
      dy=ppos(2)-pos(daughter,2)
      dz=ppos(3)-pos(daughter,3)
      dist2=dx**2+dy**2+dz**2
      if(bh_tol2*dist2.GT.(bh_tol*delta+cellsize(daughter))**2) then
        if(dist2.GT.(delta+peps+epsgrav(daughter))**2) then
          dist2=dist2cell(ppos,bottom(daughter,1:3),cellsize(daughter))
          if(dist2.GT.(delta+0.1*cellsize(daughter))**2) then
            nterms=nterms+1
            bodlist(nterms)=daughter
            cycle
          endif
        endif
      endif  
      cstack(nstack+1)=subp(daughter,8)
      cstack(nstack+2)=subp(daughter,7)
      cstack(nstack+3)=subp(daughter,6)
      cstack(nstack+4)=subp(daughter,5)
      cstack(nstack+5)=subp(daughter,4)
      cstack(nstack+6)=subp(daughter,3)
      cstack(nstack+7)=subp(daughter,2)
      cstack(nstack+8)=subp(daughter,1)
      nstack=nstack+8
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" treewalk error")
!$omp end critical
  endif            
end subroutine

subroutine gdgmonotreewalk(node,ppos,acc4,delta,nterms)
  include 'globals.h'
  integer, intent(in):: node
  real,intent(in) :: ppos(3),acc4,delta 
  integer, intent(inout)::nterms
  integer :: daughter,nstack,cstack(nsubcell*81)
  real :: dist2,dx,dy,dz,dist2cell 
  cstack(1)=node
  nstack=1
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.LT.nbods1) then
      if(daughter.GT.0) then 
        nterms=nterms+1
        bodlist(nterms)=daughter
      endif
    else  
      dx=ppos(1)-pos(daughter,1)
      dy=ppos(2)-pos(daughter,2)
      dz=ppos(3)-pos(daughter,3)
      dist2=dx**2+dy**2+dz**2
      dist2=MAX((sqrt(dist2)-delta),0.)**2
      if(mass(daughter)*cellsize(daughter)**2.LT.gdgtol*acc4*dist2**2) then
        dist2=dist2cell(ppos,bottom(daughter,1:3),cellsize(daughter))
        if(dist2.GT.(delta+0.1*cellsize(daughter))**2) then
          nterms=nterms+1
          bodlist(nterms)=daughter
          cycle
        endif
      endif  
      cstack(nstack+1)=subp(daughter,8)
      cstack(nstack+2)=subp(daughter,7)
      cstack(nstack+3)=subp(daughter,6)
      cstack(nstack+4)=subp(daughter,5)
      cstack(nstack+5)=subp(daughter,4)
      cstack(nstack+6)=subp(daughter,3)
      cstack(nstack+7)=subp(daughter,2)
      cstack(nstack+8)=subp(daughter,1)
      nstack=nstack+8
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" treewalk error")
!$omp end critical
  endif            
end subroutine

subroutine gdgquadtreewalk(node,ppos,peps,acc4,delta,nterms)
  include 'globals.h'
  integer, intent(in):: node
  real,intent(in) :: ppos(3),peps,acc4 ,delta
  integer, intent(inout)::nterms
  integer :: daughter,nstack,cstack(nsubcell*81)
  real :: dist2,dx,dy,dz,dist2cell 
  cstack(1)=node
  nstack=1
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.LT.nbods1) then
      if(daughter.GT.0) then 
        nterms=nterms+1
        bodlist(nterms)=daughter
      endif 
    else  
      dx=ppos(1)-pos(daughter,1)
      dy=ppos(2)-pos(daughter,2)
      dz=ppos(3)-pos(daughter,3)
      dist2=dx**2+dy**2+dz**2
      dist2=MAX(sqrt(dist2)-delta,0.)
      if(mass(daughter)*cellsize(daughter)**4.LT.gdgtol*acc4*dist2**6) then
        if(dist2.GT.(peps+epsgrav(daughter))) then
          dist2=dist2cell(ppos,bottom(daughter,1:3),cellsize(daughter))
          if(dist2.GT.(delta+0.1*cellsize(daughter))**2) then
            nterms=nterms+1
            bodlist(nterms)=daughter
            cycle
          endif
        endif
      endif  
      cstack(nstack+1)=subp(daughter,8)
      cstack(nstack+2)=subp(daughter,7)
      cstack(nstack+3)=subp(daughter,6)
      cstack(nstack+4)=subp(daughter,5)
      cstack(nstack+5)=subp(daughter,4)
      cstack(nstack+6)=subp(daughter,3)
      cstack(nstack+7)=subp(daughter,2)
      cstack(nstack+8)=subp(daughter,1)
      nstack=nstack+8
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" treewalk error")
!$omp end critical
  endif            
end subroutine


subroutine pmtreewalk(node,ppos,delta,nterms)
  include 'globals.h'
  integer, intent(in):: node
  real,intent(in) :: ppos(3) ,delta
  integer, intent(inout)::nterms
  integer :: daughter,nstack,cstack(nsubcell*81)
  real :: bh_tol2,dist2,dx,dy,dz,dist2cell 
  cstack(1)=node
  nstack=1
  bh_tol2=bh_tol*bh_tol
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.LT.nbods1) then
      if(daughter.GT.0) then   
        nterms=nterms+1
        bodlist(nterms)=daughter
      endif
    else  
      dist2=dist2cell(ppos,bottom(daughter,1:3),cellsize(daughter))       
      if(dist2.GT.(rcut+delta)**2) cycle
      if(dist2.GT.(delta+0.1*cellsize(daughter))**2) then
        dx=ppos(1)-pos(daughter,1)
        dy=ppos(2)-pos(daughter,2)
        dz=ppos(3)-pos(daughter,3)
        dist2=dx**2+dy**2+dz**2
        if((bh_tol2*dist2).GT.(cellsize(daughter)+bh_tol*delta)**2) then
          if(dist2.LT.(rcut+delta)**2) then
            nterms=nterms+1
            bodlist(nterms)=daughter
          endif
          cycle
        endif 
      endif 
      cstack(nstack+1)=subp(daughter,8)
      cstack(nstack+2)=subp(daughter,7)
      cstack(nstack+3)=subp(daughter,6)
      cstack(nstack+4)=subp(daughter,5)
      cstack(nstack+5)=subp(daughter,4)
      cstack(nstack+6)=subp(daughter,3)
      cstack(nstack+7)=subp(daughter,2)
      cstack(nstack+8)=subp(daughter,1)
      nstack=nstack+8
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" treewalk error")
!$omp end critical
  endif            
end subroutine

subroutine gdgpmtreewalk(node,ppos,acc4,delta,nterms)
  include 'globals.h'
  integer, intent(in):: node
  real,intent(in) :: ppos(3),acc4,delta 
  integer, intent(inout)::nterms
  integer :: daughter,nstack,cstack(nsubcell*81)
  real :: dist2,dx,dy,dz,dist2cell 
  cstack(1)=node
  nstack=1
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.LT.nbods1) then
      if(daughter.GT.0) then 
        nterms=nterms+1
        bodlist(nterms)=daughter
      endif
    else  
      dist2=dist2cell(ppos,bottom(daughter,1:3),cellsize(daughter))       
      if(dist2.GT.(rcut+delta)**2) cycle
      if(dist2.GT.(delta+0.1*cellsize(daughter))**2) then
        dx=ppos(1)-pos(daughter,1)
        dy=ppos(2)-pos(daughter,2)
        dz=ppos(3)-pos(daughter,3)
        dist2=dx**2+dy**2+dz**2
        dist2=MAX(sqrt(dist2)-delta,0.)**2
        if(mass(daughter)*cellsize(daughter)**2.LT.gdgtol*acc4*dist2**2) then
          if(dist2.LT.rcut2) then
            nterms=nterms+1
            bodlist(nterms)=daughter
          endif
          cycle
        endif 
      endif 
      cstack(nstack+1)=subp(daughter,8)
      cstack(nstack+2)=subp(daughter,7)
      cstack(nstack+3)=subp(daughter,6)
      cstack(nstack+4)=subp(daughter,5)
      cstack(nstack+5)=subp(daughter,4)
      cstack(nstack+6)=subp(daughter,3)
      cstack(nstack+7)=subp(daughter,2)
      cstack(nstack+8)=subp(daughter,1)
      nstack=nstack+8
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" treewalk error")
!$omp end critical
  endif            
end subroutine

function dist2cell(spos,bot,csize) result(dist2)
  real :: spos(3),bot(3),csize,dist2
  integer :: k
  dist2=0 
  do k=1,3
    if(spos(k).LT.bot(k)) then
      dist2=dist2+(bot(k)-spos(k))**2
    else
      if(spos(k).GT.bot(k)+csize) then
        dist2=dist2+(spos(k)-(bot(k)+csize))**2
      endif
    endif
  enddo
end function

subroutine pretreewalk(k,kmax,nbuf,buf,ntodo,todo)
  include 'globals.h'
  integer :: k,kmax,nbuf,buf(nbuf),todo(nbuf),ntodo, &
    ib,p,q,nterms 
  real :: dist2,spos(3),ppos(3),qpos(3)
  real :: pacc4,qacc4,sacc4,peps,qeps,seps,delta,scale2,scale
  real :: getlocalscale
  ntodo=0
  if(buf(1).EQ.0) then
    p=pactive(k)
    ntodo=ntodo+1; todo(ntodo)=p
    if(.not.directsum) then
      ppos=pos(p,1:3); pacc4=aacc(p); peps=epsgrav(p)
      scale=getlocalscale(ppos)/bh_tol
      scale=MIN(eps*3,scale)
      scale2=scale**2
!   if(gdgop.AND.pacc4.GT.0.AND.mass(p).GT.0) then
!    if(usequad) then
!      scale2=(mass(p)*scale2**2/gdgtol/pacc4)**(1./3.)      
!    else
!      scale2=sqrt(mass(p)*scale**2/gdgtol/pacc4)
!    endif
!   endif
      if(scale.LE.0.OR.scale.GT.rsize) call terror('pretreewalk error')
      spos=ppos; sacc4=pacc4;seps=peps;delta=0.
      do ib=1,MIN(nbuf-1,kmax-k)
        if(buf(ib+1).NE.0) cycle
        q=pactive(k+ib)
        qpos=pos(q,1:3)
        dist2=sum((ppos-qpos)**2)
        if(dist2.LT.2*scale2) then
          buf(ib+1)=1        
          ntodo=ntodo+1; todo(ntodo)=q
          spos=((ntodo-1)*spos)/ntodo+qpos/ntodo             
        endif
      enddo
      do ib=1,ntodo
        q=todo(ib)
        qpos=pos(q,1:3); qacc4=aacc(q); qeps=epsgrav(q)
        seps=MAX(seps,qeps)
        dist2=sum((spos-qpos)**2)         
        delta=MAX(delta,sqrt(dist2))
        sacc4=MIN(sacc4,qacc4)
      enddo
      searchreuse=0
      call cond_treewalk(root,spos,seps,sacc4,delta,nterms)    
    endif
  endif
  do ib=1,nbuf-1
    buf(ib)=buf(ib+1)
  enddo 
  buf(nbuf)=0
end subroutine

subroutine prefuvwalk(k,kmax,nbuf,buf,ntodo,todo)
  include 'globals.h'
  integer :: k,kmax,nbuf,buf(nbuf),todo(nbuf),ntodo, &
    ib,p,q,nterms 
  real :: dist2,spos(3),ppos(3),qpos(3)
  real :: delta,scale2,scale
  ntodo=0
  if(buf(1).EQ.0) then
    p=pactive(k)
    ntodo=ntodo+1; todo(ntodo)=p
    if(.not.directsum) then
      ppos=pos(p,1:3)
      scale=epsgrav(p) ! =hsmooth(p) !!
      scale2=scale**2
      if(scale.LE.0.OR.scale.GT.rsize) call terror('prefuvwalk error')
      spos=ppos; delta=0.
      do ib=1,MIN(nbuf-1,kmax-k)
        if(buf(ib+1).NE.0) cycle
        q=pactive(k+ib)
        qpos=pos(q,1:3)
        dist2=sum((ppos-qpos)**2)
        if(dist2.LT.scale2) then
          buf(ib+1)=1        
          ntodo=ntodo+1; todo(ntodo)=q
          spos=((ntodo-1)*spos)/ntodo+qpos/ntodo             
        endif
      enddo
      do ib=1,ntodo
        q=todo(ib)
        qpos=pos(q,1:3);
        dist2=sum((spos-qpos)**2)         
        delta=MAX(delta,sqrt(dist2))
      enddo
      searchreuse=0
      call cond_fuvwalk(root,spos,delta,nterms)    
    endif
  endif
  do ib=1,nbuf-1
    buf(ib)=buf(ib+1)
  enddo 
  buf(nbuf)=0
end subroutine

subroutine clean
  include 'globals.h'
  integer :: p,j,ndel
  real :: tm,cm(3),cmv(3)
  logical del
  ndel=0
  do p=1,nbodies
    del=.false.
    do j=1,ndim
      if(pos(p,j).GT.pboxsize/2.OR.pos(p,j).LT.-pboxsize/2) then
        del=.true.
      endif
    enddo
    if(del)then 
      ndel=ndel+1
      templist(ndel)=p
    endif
  enddo

  if(periodic.AND.ndel.GT.0) then
    print*,ndel
    call terror(' particles outside box?') 
  endif

  if((nsph.GT.0.AND.ndel.GT.nsph/2).OR.ndel.GT.nbodies/2) then
    print*,"** WARNING: particle erasure (box size ok?) **"
    print*, ndel,nbodies,nsph
  endif

  tm=0;cm=0;cmv=0 
  do j=1,ndel
    p=templist(j)
    tm=tm+mass(p)
    cm(1:ndim)=cm(1:ndim)+mass(p)*pos(p,1:ndim)
    cmv(1:ndim)=cmv(1:ndim)+mass(p)*vel(p,1:ndim)
    mass(p)=0.
  enddo

  if(ndel.GT.0) then
    if(verbosity.GT.0) print*,' mass erased:',tm
    open(unit=erasenr,file=TRIM(outputfile)//'.del',status='unknown',position='APPEND')
    write(erasenr,*) tnow,tm,cm/tm,cmv/tm
    close(erasenr)
  endif 

end subroutine

subroutine copysph(p,i) ! copy sph part p to spot i
  include 'globals.h'
  integer i,p

  if(i.GT.nsphmax.OR.p.GT.nsphmax) then
    print*, p,i
    call terror(' sph part copy error')
  endif
  call copypart(p,i)
  rho(i)=rho(p)
  drhodh(i)=drhodh(p)
  csound(i)=csound(p)
  derad(i)=derad(p)
  hsmdivv(i)=hsmdivv(p)
  mumaxdvh(i)=mumaxdvh(p)
  hsmcurlv(i)=hsmcurlv(p)
  veltpos(i,1)=veltpos(p,1)
  veltpos(i,2)=veltpos(p,2)
  veltpos(i,3)=veltpos(p,3)
  fuvheat(i)=fuvheat(p)
  tcollaps(i)=tcollaps(p)
  esnthdt(i)=esnthdt(p)
  temperat(i)=temperat(p)
  elecfrac(i)=elecfrac(p)
  ethold(i)=ethold(p)
  dethold(i)=dethold(p)
  h2frac(i)=h2frac(p)
  vdisp(i)=vdisp(p)
  entropy(i)=entropy(p) ! equiv ethermal
  dentdt(i)=dentdt(p)   ! equiv dethdt  
end subroutine

subroutine copypart(p,i) ! copy part p to spot i
  include 'globals.h'
  integer i,p
  if(i.GT.nbodsmax.OR.p.GT.nbodsmax) then
    print*, p,i
    call terror(' sph part copy error')
  endif
  mass(i)=mass(p)
  pos(i,1)=pos(p,1)
  pos(i,2)=pos(p,2)
  pos(i,3)=pos(p,3)
  vel(i,1)=vel(p,1)
  vel(i,2)=vel(p,2)
  vel(i,3)=vel(p,3)
  acc(i,1)=acc(p,1)
  acc(i,2)=acc(p,2)
  acc(i,3)=acc(p,3)
  aacc(i)=aacc(p)
  phi(i)=phi(p)
  phiext(i)=phiext(p)
  epsgrav(i)=epsgrav(p)
  itimestp(i)=itimestp(p)
  otimestp(i)=otimestp(p)
  tform(i)=tform(p)
  starfuv(i)=starfuv(p)
  tfeedb(i)=tfeedb(p)
  tvel(i)=tvel(p)
  snentropy(i)=snentropy(p)
  hsmooth(i)=hsmooth(p)
  nbexist(i)=nbexist(p)
end subroutine

subroutine partremoval
  include 'globals.h'
  integer i,lastsph,lastdm,laststar,lastbh 
  integer onsph,onstar,onbh
  integer nnewremovals
  
  pordercount=pordercount+1
  nnewremovals=0
  do i=1,nsph
    if(mass(i).LT.tiny) then
      removedidssph(nremovals+1) = nbexist(i)
      nremovals=nremovals+1
      nnewremovals=nnewremovals+1
    endif
  enddo
  
  lastsph=nsph
  lastdm=nbodies-nstar
  laststar=nbodies-nbh
  lastbh=nbodies
  i=1
  do while(i.LE.lastsph) 
    if(mass(i).LT.tiny) then
      if(mass(lastsph).GE.tiny) then
        call copysph(lastsph,i)
        mass(lastsph)=0
      endif
      lastsph=lastsph-1
    else
      i=i+1
    endif 
  enddo

  do while(i.LE.lastdm) 
    if(mass(i).LT.tiny) then
      if(mass(lastdm).GE.tiny) then
        call copypart(lastdm,i)
        mass(lastdm)=0
      endif
      lastdm=lastdm-1
    else
      i=i+1
    endif 
  enddo

  do while(i.LE.laststar) 
    if(mass(i).LT.tiny) then
      if(mass(laststar).GE.tiny) then
        call copypart(laststar,i)
        mass(laststar)=0
      endif
      laststar=laststar-1
    else
      i=i+1
    endif 
  enddo

  do while(i.LE.lastbh) 
    if(mass(i).LT.tiny) then
      if(mass(lastbh).GE.tiny) then
        call copypart(lastbh,i)
        mass(lastbh)=0
      endif
        lastbh=lastbh-1
    else
      i=i+1
    endif 
  enddo
  
  if(nsph.NE.nnewremovals+lastsph) call terror('partremoval count mismatch')
   
  nsph=lastsph
  nstar=lastbh-lastdm ! bh is also a star
  nbh=lastbh-laststar
  nbodies=lastbh 
end subroutine 

subroutine zeropart(p,n)
  include 'globals.h'
  integer p,n

  mass(p:p+n-1)=0
  pos(p:p+n-1,1)=0
  pos(p:p+n-1,2)=0
  pos(p:p+n-1,3)=0
  vel(p:p+n-1,1)=0
  vel(p:p+n-1,2)=0
  vel(p:p+n-1,3)=0
  acc(p:p+n-1,1)=0
  acc(p:p+n-1,2)=0
  acc(p:p+n-1,3)=0
  aacc(p:p+n-1)=0
  phi(p:p+n-1)=0
  phiext(p:p+n-1)=0
  epsgrav(p:p+n-1)=0
  itimestp(p:p+n-1)=0
  otimestp(p:p+n-1)=0
  tform(p:p+n-1)=0
  starfuv(p:p+n-1)=0
  tfeedb(p:p+n-1)=0
  tvel(p:p+n-1)=0
  snentropy(p:p+n-1)=0
  hsmooth(p:p+n-1)=0
  nbexist(p:p+n-1)=0
end subroutine

subroutine zerosph(p,n)
  include 'globals.h'
  integer p,n

  call zeropart(p,n)

  rho(p:p+n-1)=0
  drhodh(p:p+n-1)=0
  csound(p:p+n-1)=0
  derad(p:p+n-1)=0
  hsmdivv(p:p+n-1)=0
  mumaxdvh(p:p+n-1)=0
  hsmcurlv(p:p+n-1)=0
  veltpos(p:p+n-1,1)=0
  veltpos(p:p+n-1,2)=0
  veltpos(p:p+n-1,3)=0
  fuvheat(p:p+n-1)=0
  tcollaps(p:p+n-1)=0
  esnthdt(p:p+n-1)=0
  temperat(p:p+n-1)=0
  elecfrac(p:p+n-1)=0
  ethold(p:p+n-1)=0
  dethold(p:p+n-1)=0
  h2frac(p:p+n-1)=0
  vdisp(p:p+n-1)=0
  entropy(p:p+n-1)=0
  dentdt(p:p+n-1)=0
end subroutine

function addspace_bh(n) result(p)
  include 'globals.h'
  integer p,n

  if(nbodies+n.GT.nbodsmax) call terror('add_bh: exceed nbodsmax')

  pordercount=pordercount+1

  p=nbodies+1
  call zeropart(p,n)
  nbodies=nbodies+n
  nbh=nbh+n
  nstar=nstar+n
 
end function

function addspace_star(n) result(p)
  include 'globals.h'
  integer i,p,n

  if(nbodies+n.GT.nbodsmax) call terror('add_star: exceed nbodsmax')

  pordercount=pordercount+1

  do i=1,min(n,nbh)
    call copypart(nbodies-nbh+i,nbodies+n-min(n,nbh)+i)
  enddo

  p=nbodies-nbh+1
  call zeropart(p,n)
  nbodies=nbodies+n
  nstar=nstar+n
end function

function addspace_dm(n) result(p)
  include 'globals.h'
  integer i,p,n

  if(nbodies+n.GT.nbodsmax) call terror('add_dm: exceed nbodsmax')

  pordercount=pordercount+1

  do i=1,min(n,nbh)
    call copypart(nbodies-nbh+i,nbodies+n-min(n,nbh)+i)
  enddo

  do i=1,min(n,nstar-nbh)
    call copypart(nbodies-nstar+i,nbodies-nbh+n-min(n,nstar-nbh)+i)
  enddo

  p=nbodies-nstar+1
  call zeropart(p,n)
  nbodies=nbodies+n 
end function

function addspace_gas(n) result(p)
  include 'globals.h'
  integer i,p,n

  if(nbodies+n.GT.nbodsmax.OR.nsph+n.GT.nsphmax) &
    call terror('add_gas: exceed nbodsmax')

  pordercount=pordercount+1

  do i=1,min(n,nbh)
    call copypart(nbodies-nbh+i,nbodies+n-min(n,nbh)+i)
  enddo

  do i=1,min(n,nstar-nbh)
    call copypart(nbodies-nstar+i,nbodies-nbh+n-min(n,nstar-nbh)+i)
  enddo

  do i=1,min(n,nbodies-nsph-nstar)
    call copypart(nsph+i,nbodies-nstar+n-min(n,nbodies-nsph-nstar)+i)
  enddo

  p=nsph+1
  call zerosph(p,n)
  nbodies=nbodies+n
  nsph=nsph+n 
end function

module hashMod
! simple integer hash

private
public :: initHash, find, endHash

 integer, save, allocatable :: nextkey(:)
 integer, save :: nkey

 contains
 
function hashfunc(dat)
 integer :: dat,hashfunc
 hashfunc=ABS(mod(dat,nkey))+1
end function
 
subroutine initHash(nk,n,dat)
 integer :: nk,n,dat(n)
 nkey=nk
 if(allocated(nextkey)) call endHash() 
 allocate(nextkey(nkey+n))
 call insert(n,dat)
end subroutine

subroutine insert(n,dat)
 integer :: i,n,next,dat(n)
 nextkey(1:nkey)=0
 do i=1,n
   next=hashfunc(dat(i))
   do while(nextkey(next).NE.0)
      next=nextkey(next)
   enddo
   nextkey(next)=nkey+i
   nextkey(nkey+i)=0
 enddo
end subroutine

function find(item,dat) result(next)
 integer :: item,dat(*)
 integer :: next
 next=hashfunc(item)
 next=nextkey(next)
 do
   if(next.EQ.0) exit
   if(dat(next-nkey).EQ.item) exit
   next=nextkey(next)
 enddo
 if(next.NE.0) next=next-nkey  
end function

subroutine endHash()
  deallocate(nextkey)
end subroutine

end module


subroutine test
 use hashMod
 integer :: n,i,dat(13)
 
 n=13
 dat=(/12,2,3,4,5,5,6,12,13,16,-6,0,-8383/)
 
 call inithash(10,6,dat(8:13))
 
10 read*,i
  if(i.eq.-999) stop
  i=find(i,dat(8:13))
  if(i.NE.0) print*,i,dat(i+7)  
  goto 10
 
 call endHash

end subroutine

 subroutine gravity(option)
  use pmgravMod
 include 'globals.h'
 character*4 option
 integer :: i,p

 call external_gravity(option)

 if(selfgrav) then
  if(adaptive_eps) call seteps('coll ')
 
  if(.NOT.directsum.AND.usepm) call pmaccgrav(option)
 
  if((.NOT.directsum).OR.adaptive_eps) call maketree
 
  call accgrav(option)
 endif
 
 if(fixthalo) call acchalo(option)

 if(option.NE.'pot ') THEN
  do i=1,npactive
    p=pactive(i)
    aacc(p)=SQRT(acc(p,1)**2+acc(p,2)**2+acc(p,3)**2)
  enddo
 endif
 end subroutine

 subroutine accgrav(option)
  include 'globals.h'
  character*4 option
  integer :: p,i,j,nterms
  real :: lesoft,time1,time2,mintime,maxtime,tottime,utime1,utime2
  integer, parameter :: nbuf=32
  integer :: omp_get_max_threads,totalsearches
  integer :: maxthread, nchunk,k,imin,imax,ib, buf(nbuf),todo(nbuf),ntodo
  integer :: niter

  if(npactive.EQ.0) return
  nttot=0; ntmin=nbodies; ntmax=0
  mintime=1.e10; maxtime=0.; tottime=0

  maxthread=1
  nchunk=1
  niter=0
!$  maxthread=omp_get_max_threads()
!$  nchunk=MAX(MIN(10*maxthread,npactive/nbuf),maxthread)	
   totalsearches=0
!$omp parallel &
!$omp shared(root,nchunk) & 
!$omp private(p,nterms,lesoft,time1,time2, &
!$omp imin,imax,ib,i,k,buf,todo,ntodo) &
!$omp reduction( + : nttot, esofttot,tottime,totalsearches,niter) & 
!$omp reduction( MIN : ntmin,mintime) &
!$omp reduction( MAX : ntmax,maxtime)
   call wall_time(time1)
   ncalls=0;nsearches=0		
!$omp do schedule(guided,1)
   do k=1,nchunk
    buf=0
    imin=int(npactive*float(k-1)/nchunk)+1
    imax=int(npactive*float(k)/nchunk)
    reuseflag=1; searchreuse=0
    do i=imin,imax
      call pretreewalk(i,imax,nbuf,buf,ntodo,todo)	   
      do ib=1,ntodo
       niter=niter+1	 
       p=todo(ib)
       if(.NOT.directsum) then
        call pcond_treewalk(root,p,nterms)
       else
        nterms=nbodies
        do j=1,nbodies
         bodlist(j)=j
        enddo
       endif

       if(.not.periodic) then
        lesoft=0.
        call pgravsum(p,nterms,option,lesoft)
        if(npactive.EQ.nbodies) esofttot=esofttot+lesoft
       else
! in this case we will use pm gravity...
        call terror('periodic broken at the moment..')
       endif                 
       nttot=nttot+nterms
       ntmin=MIN(ntmin,nterms)
       ntmax=MAX(ntmax,nterms)
      enddo
    enddo  
   enddo	  
!$omp enddo nowait 
   call wall_time(time2)
   mintime=MIN(mintime,time2-time1)
   maxtime=MAX(maxtime,time2-time1)
   tottime=tottime+time2-time1
   totalsearches=totalsearches+nsearches
!$omp end parallel
  ntavg=nttot/npactive
  if(verbosity.GT.0) then
   print*,'<accgrav> parts,searches:', npactive,totalsearches
   write(*,'(" <accgrav> time:", 3f8.2)') maxtime,mintime, tottime
   print*,'<accgrav> mn,av,mx:',ntmin,ntavg,ntmax
  endif
  if(niter.NE.npactive) then
    print*, niter,npactive
    print*, nchunk,maxthread
    call terror("accgrav inconsistent iter count")
  endif
 end subroutine

 subroutine pmaccgrav(option)
   use pmgravMod
  include 'globals.h'
  character*4 option
  integer :: p,i
  real :: lesoft,dtpm,vmax 
  real :: time1,time2,mintime,maxtime,tottime,utime1,utime2

  mintime=1.e10; maxtime=0.; tottime=0

! at the moment the box for pm grav is fixed, particles outside the 
! box are set to zero mass, and those are ignored in the pm CIC
! and in the acc. (hence they do not experience grav acc)
! this could be changed later to be more flexible)
 
   call wall_time(utime1)
   if(tnow.GE.tpm) then 
    call pmgrav(nbodies,mass,pos)
    vmax=maxval(vel(1:nbodies,1:3))
    if(vmax.GT.0) dtpm=dmeshQ()/vmax/2.
    if(verbosity.GT.0) print*,'<pmaccgrav> timestep:',dtpm
    tpm=tpm+dtpm
   endif
   call wall_time(utime2)
!$omp parallel  &
!$omp private(p,i,time1,time2) &
!$omp reduction( + : tottime) &
!$omp reduction( MIN : mintime) & 
!$omp reduction( MAX : maxtime)
   call wall_time(time1)
!$omp do schedule(guided,200)
   do i=1,npactive
    p=pactive(i) 
    if(mass(p).GT.0) call pmgravsum(p,option)
   enddo
!$omp enddo nowait 
   call wall_time(time2)
   mintime=MIN(mintime,time2-time1)
   maxtime=MAX(maxtime,time2-time1)
   tottime=tottime+time2-time1
!$omp end parallel

   if(verbosity.GT.0) then
    write(*,'(" <pmaccgrav> time:", 3f8.2)') utime2-utime1,maxtime,mintime
   endif
        
 end subroutine

subroutine acchalo(option)
 include 'globals.h'
 character*4 option
 real :: ppos(3),pacc(3),pphi
 integer :: i,p

 do i=1,npactive
  p=pactive(i)
  ppos(1:3)=pos(p,1:3)
  pacc(1:3)=0.
  pphi=0.
  call accpothalo(ppos,pacc,pphi,option)
  acc(p,1:3)=acc(p,1:3)+pacc
  phiext(p)=phiext(p)+pphi 
 enddo
end subroutine

subroutine system_gravity(peps,ppos,pphi,pacc,option,lesofttot)
 include 'globals.h'
 character*4 :: option
 real,intent(in) :: ppos(3),peps
 real,intent(inout) :: pphi,pacc(3),lesofttot
 integer i,nterms
! periodic - 
  if(.NOT.directsum) then
   nterms=0
   call treewalk(root,ppos,peps,0.,0.,nterms)
  else
   nterms=nbodies
   do i=1,nbodies
    bodlist(i)=i
   enddo
  endif 
  call gravsum(peps,ppos,pphi,pacc,nterms,option,lesofttot)
end subroutine

subroutine evaluate_gravity(peps,ppos,pphi,pacc,option)
 include 'globals.h'
 character*4 :: option
 real,intent(in) :: ppos(3),peps
 real,intent(inout) :: pphi,pacc(3)
 real :: dummy
 integer i
 
 pphi=0.
 pacc(1:3)=0
 if(selfgrav) call system_gravity(peps,ppos,pphi,pacc,option,dummy)
 if(fixthalo) call accpothalo(ppos,pacc,pphi,option)

end subroutine

!
! basic search routines for range search 
! (with and without distance list)
!

subroutine search_d2(node,h,ppos,npnear,nblist,d2list)
  include 'globals.h'
  integer, intent(in):: node
  real, intent(in) :: h,ppos(3)
  integer, intent(inout)::npnear,nblist(*)
  real, intent(inout) :: d2list(*) 
  integer :: i,daughter,nstack,cnode,cstack(nsubcell*81)
  real :: dist2,xnode,ynode,znode,dx,dy,dz,hsearch2

  if(periodic.AND.h.GT.rsize/2) call terror('search h>rsize/2')
  hsearch2=h**2
  cstack(1)=node
  nstack=1
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.LT.nbods1) then              
      if(daughter.GT.0) then 
        dx=ppos(1)-pos(daughter,1)
        dy=ppos(2)-pos(daughter,2)
        dz=ppos(3)-pos(daughter,3)
        if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
        if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
        if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
        if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
        if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
        if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
        dist2=dx**2+dy**2+dz**2
        if(dist2.LT.hsearch2) then
          npnear=npnear+1
          nblist(npnear)=daughter
          d2list(npnear)=dist2
        endif
      endif 
    else
      xnode=bottom(daughter,1)+0.5*cellsize(daughter)
      ynode=bottom(daughter,2)+0.5*cellsize(daughter)
      znode=bottom(daughter,3)+0.5*cellsize(daughter)
      dx=ppos(1)-xnode
      dy=ppos(2)-ynode
      dz=ppos(3)-znode      
      if(dx.GE.hboxsize.AND.periodic) xnode=xnode+pboxsize
      if(dx.LT.-hboxsize.AND.periodic) xnode=xnode-pboxsize
      if(dy.GE.hboxsize.AND.periodic) ynode=ynode+pboxsize
      if(dy.LT.-hboxsize.AND.periodic) ynode=ynode-pboxsize
      if(dz.GE.hboxsize.AND.periodic) znode=znode+pboxsize
      if(dz.LT.-hboxsize.AND.periodic) znode=znode-pboxsize
      dist2=0
      if(ppos(1).LT.xnode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(1)-xnode+0.5*cellsize(daughter))**2
      else
        if(ppos(1).GT.xnode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(1)-xnode-0.5*cellsize(daughter))**2
        endif
      endif
      if(ppos(2).LT.ynode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(2)-ynode+0.5*cellsize(daughter))**2
      else
        if(ppos(2).GT.ynode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(2)-ynode-0.5*cellsize(daughter))**2
        endif
      endif
      if(ppos(3).LT.znode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(3)-znode+0.5*cellsize(daughter))**2
      else
        if(ppos(3).GT.znode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(3)-znode-0.5*cellsize(daughter))**2
        endif
      endif 
      if(dist2.LT.hsearch2) then
        cstack(nstack+1)=subp(daughter,8)
        cstack(nstack+2)=subp(daughter,7)
        cstack(nstack+3)=subp(daughter,6)
        cstack(nstack+4)=subp(daughter,5)
        cstack(nstack+5)=subp(daughter,4)
        cstack(nstack+6)=subp(daughter,3)
        cstack(nstack+7)=subp(daughter,2)
        cstack(nstack+8)=subp(daughter,1)
        nstack=nstack+8
      endif
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" search_d2 error")
!$omp end critical
  endif            
end subroutine search_d2

subroutine search(node,h,ppos,npnear,nblist)
  include 'globals.h'
  integer, intent(in):: node
  real, intent(in) :: h,ppos(3)
  integer, intent(inout)::npnear,nblist(*)
  integer :: i,daughter,nstack,cnode,cstack(nsubcell*81)
  real :: dist2,xnode,ynode,znode,dx,dy,dz,hsearch2
  if(periodic.AND.h.GT.rsize/2) call terror('search h>rsize/2')
  hsearch2=h**2
  cstack(1)=node
  nstack=1
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.LT.nbods1) then              
      if(daughter.GT.0) then 
        dx=ppos(1)-pos(daughter,1)
        dy=ppos(2)-pos(daughter,2)
        dz=ppos(3)-pos(daughter,3)
        if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
        if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
        if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
        if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
        if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
        if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
        dist2=dx**2+dy**2+dz**2
        if(dist2.LT.hsearch2) then
          npnear=npnear+1
          nblist(npnear)=daughter
        endif
      endif 
    else
      xnode=bottom(daughter,1)+0.5*cellsize(daughter)
      ynode=bottom(daughter,2)+0.5*cellsize(daughter)
      znode=bottom(daughter,3)+0.5*cellsize(daughter)
      dx=ppos(1)-xnode
      dy=ppos(2)-ynode
      dz=ppos(3)-znode      
      if(dx.GE.hboxsize.AND.periodic) xnode=xnode+pboxsize
      if(dx.LT.-hboxsize.AND.periodic) xnode=xnode-pboxsize
      if(dy.GE.hboxsize.AND.periodic) ynode=ynode+pboxsize
      if(dy.LT.-hboxsize.AND.periodic) ynode=ynode-pboxsize
      if(dz.GE.hboxsize.AND.periodic) znode=znode+pboxsize
      if(dz.LT.-hboxsize.AND.periodic) znode=znode-pboxsize
      dist2=0
      if(ppos(1).LT.xnode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(1)-xnode+0.5*cellsize(daughter))**2
      else
        if(ppos(1).GT.xnode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(1)-xnode-0.5*cellsize(daughter))**2
        endif
      endif
      if(ppos(2).LT.ynode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(2)-ynode+0.5*cellsize(daughter))**2
      else
        if(ppos(2).GT.ynode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(2)-ynode-0.5*cellsize(daughter))**2
        endif
      endif
      if(ppos(3).LT.znode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(3)-znode+0.5*cellsize(daughter))**2
      else
        if(ppos(3).GT.znode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(3)-znode-0.5*cellsize(daughter))**2
        endif
      endif 
      if(dist2.LT.hsearch2) then
        cstack(nstack+1)=subp(daughter,8)
        cstack(nstack+2)=subp(daughter,7)
        cstack(nstack+3)=subp(daughter,6)
        cstack(nstack+4)=subp(daughter,5)
        cstack(nstack+5)=subp(daughter,4)
        cstack(nstack+6)=subp(daughter,3)
        cstack(nstack+7)=subp(daughter,2)
        cstack(nstack+8)=subp(daughter,1)
        nstack=nstack+8
      endif
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" search error")
!$omp end critical
  endif            
end subroutine search

!
! basic search routines for complementary range search 
! (with and without distance list)
!

subroutine comsearch_d2(node,h,delta,ppos,npnear,nblist,d2list)
  include 'globals.h'
  integer, intent(in):: node
  real, intent(in) :: h,ppos(3),delta
  integer, intent(inout)::npnear,nblist(*)
  real,intent(inout) ::  d2list(*)
  integer :: i,daughter,nstack,cnode,cstack(nsubcell*81)
  real :: dist2,xnode,ynode,znode,dx,dy,dz,hsearch2

  if(periodic.AND. &
      (h.GT.rsize/2.OR.(2*hsmooth(node)+delta).GT.rsize/2)) &
    call terror('comsearch h>rsize/2')
  hsearch2=h**2
  cstack(1)=node
  nstack=1
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.LT.nbods1) then              
      if(daughter.GT.0) then 
        dx=ppos(1)-pos(daughter,1)
        dy=ppos(2)-pos(daughter,2)
        dz=ppos(3)-pos(daughter,3)
        if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
        if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
        if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
        if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
        if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
        if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
        dist2=dx**2+dy**2+dz**2
        if(dist2.LT.hsearch2.OR. &
                   dist2.LT.(2*hsmooth(daughter)+delta)**2) then        
          npnear=npnear+1
          nblist(npnear)=daughter
          d2list(npnear)=dist2
        endif
      endif  
    else
      xnode=bottom(daughter,1)+0.5*cellsize(daughter)
      ynode=bottom(daughter,2)+0.5*cellsize(daughter)
      znode=bottom(daughter,3)+0.5*cellsize(daughter)
      dx=ppos(1)-xnode
      dy=ppos(2)-ynode
      dz=ppos(3)-znode      
      if(dx.GE.hboxsize.AND.periodic) xnode=xnode+pboxsize
      if(dx.LT.-hboxsize.AND.periodic) xnode=xnode-pboxsize
      if(dy.GE.hboxsize.AND.periodic) ynode=ynode+pboxsize
      if(dy.LT.-hboxsize.AND.periodic) ynode=ynode-pboxsize
      if(dz.GE.hboxsize.AND.periodic) znode=znode+pboxsize
      if(dz.LT.-hboxsize.AND.periodic) znode=znode-pboxsize
      dist2=0
      if(ppos(1).LT.xnode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(1)-xnode+0.5*cellsize(daughter))**2
      else
        if(ppos(1).GT.xnode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(1)-xnode-0.5*cellsize(daughter))**2
        endif
      endif
      if(ppos(2).LT.ynode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(2)-ynode+0.5*cellsize(daughter))**2
      else
        if(ppos(2).GT.ynode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(2)-ynode-0.5*cellsize(daughter))**2
        endif
      endif
      if(ppos(3).LT.znode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(3)-znode+0.5*cellsize(daughter))**2
      else
        if(ppos(3).GT.znode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(3)-znode-0.5*cellsize(daughter))**2
        endif
      endif 
      if(dist2.LT.hsearch2.OR. &
         dist2.LT.(2*hsmooth(daughter)+delta)**2) then
        cstack(nstack+1)=subp(daughter,8)
        cstack(nstack+2)=subp(daughter,7)
        cstack(nstack+3)=subp(daughter,6)
        cstack(nstack+4)=subp(daughter,5)
        cstack(nstack+5)=subp(daughter,4)
        cstack(nstack+6)=subp(daughter,3)
        cstack(nstack+7)=subp(daughter,2)
        cstack(nstack+8)=subp(daughter,1)
        nstack=nstack+8
      endif
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" comsearch_d2 error")
!$omp end critical
  endif            
end subroutine comsearch_d2

subroutine comsearch(node,h,delta,ppos,npnear,nblist)
  include 'globals.h'
  integer, intent(in):: node
  real, intent(in) :: h,ppos(3),delta
  integer, intent(inout)::npnear,nblist(*)
  integer :: i,daughter,nstack,cnode,cstack(nsubcell*81)
  real :: dist2,xnode,ynode,znode,dx,dy,dz,hsearch2
  
  if(periodic.AND. &
      (h.GT.rsize/2.OR.(2*hsmooth(node)+delta).GT.rsize/2)) then
    print*,h,rsize,hsmooth(node),delta
    print*,node,ppos
    call terror('comsearch h>rsize/2')
  endif  
  hsearch2=h**2
  cstack(1)=node
  nstack=1
  do while(nstack.GT.0.AND.nstack.LE.nsubcell*80)
    daughter=cstack(nstack)
    nstack=nstack-1
    if(daughter.LT.nbods1) then              
      if(daughter.GT.0) then 
        dx=ppos(1)-pos(daughter,1)
        dy=ppos(2)-pos(daughter,2)
        dz=ppos(3)-pos(daughter,3)
        if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
        if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
        if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
        if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
        if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
        if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
        dist2=dx**2+dy**2+dz**2
        if(dist2.LT.hsearch2.OR. &
             dist2.LT.(2*hsmooth(daughter)+delta)**2) then        
          npnear=npnear+1
          nblist(npnear)=daughter
        endif
      endif  
    else

      xnode=bottom(daughter,1)+0.5*cellsize(daughter)
      ynode=bottom(daughter,2)+0.5*cellsize(daughter)
      znode=bottom(daughter,3)+0.5*cellsize(daughter)
      dx=ppos(1)-xnode
      dy=ppos(2)-ynode
      dz=ppos(3)-znode      
      if(dx.GE.hboxsize.AND.periodic) xnode=xnode+pboxsize
      if(dx.LT.-hboxsize.AND.periodic) xnode=xnode-pboxsize
      if(dy.GE.hboxsize.AND.periodic) ynode=ynode+pboxsize
      if(dy.LT.-hboxsize.AND.periodic) ynode=ynode-pboxsize
      if(dz.GE.hboxsize.AND.periodic) znode=znode+pboxsize
      if(dz.LT.-hboxsize.AND.periodic) znode=znode-pboxsize
      dist2=0
      if(ppos(1).LT.xnode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(1)-xnode+0.5*cellsize(daughter))**2
      else
        if(ppos(1).GT.xnode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(1)-xnode-0.5*cellsize(daughter))**2
        endif
      endif
      if(ppos(2).LT.ynode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(2)-ynode+0.5*cellsize(daughter))**2
      else
        if(ppos(2).GT.ynode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(2)-ynode-0.5*cellsize(daughter))**2
        endif
      endif
      if(ppos(3).LT.znode-0.5*cellsize(daughter)) then
        dist2=dist2+(ppos(3)-znode+0.5*cellsize(daughter))**2
      else
        if(ppos(3).GT.znode+0.5*cellsize(daughter)) then
          dist2=dist2+(ppos(3)-znode-0.5*cellsize(daughter))**2
        endif
      endif 
      if(dist2.LT.hsearch2.OR. &
           dist2.LT.(2*hsmooth(daughter)+delta)**2) then
        cstack(nstack+1)=subp(daughter,8)
        cstack(nstack+2)=subp(daughter,7)
        cstack(nstack+3)=subp(daughter,6)
        cstack(nstack+4)=subp(daughter,5)
        cstack(nstack+5)=subp(daughter,4)
        cstack(nstack+6)=subp(daughter,3)
        cstack(nstack+7)=subp(daughter,2)
        cstack(nstack+8)=subp(daughter,1)
        nstack=nstack+8
      endif
    endif 
  enddo
  if(nstack.NE.0) then
!$omp critical
    call terror(" comsearch error")
!$omp end critical
  endif            
end subroutine comsearch

!
! particle-index search routines for range search 
! (with and without distance list)
!
subroutine psearch(node,p,npnear,nblist)
  include 'globals.h'
  integer, intent(in):: node,p
  real :: h,ppos(3)
  integer, intent(inout)::npnear,nblist(*)
  h=2*hsmooth(p)
  ppos=pos(p,1:3)
  call search(node,h,ppos,npnear,nblist)
end subroutine

subroutine psearch_d2(node,p,npnear,nblist,d2list)
  include 'globals.h'
  integer, intent(in):: node,p
  real :: h,ppos(3)
  integer, intent(inout)::npnear,nblist(*)
  real  :: d2list(*)
  h=2*hsmooth(p)
  ppos=pos(p,1:3)
  call search_d2(node,h,ppos,npnear,nblist,d2list)     
end subroutine

!
! particle-index search routines for complementary range search 
! (with and without distance list)
!

subroutine pcomsearch(node,p,npnear,nblist)
  include 'globals.h'
  integer, intent(in):: node,p
  real :: h,ppos(3), delta
  integer, intent(inout)::npnear,nblist(*)
  h=2*hsmooth(p)
  ppos=pos(p,1:3)
  call comsearch(node,h,0.,ppos,npnear,nblist)
end subroutine

subroutine pcomsearch_d2(node,p,npnear,nblist,d2list)
  include 'globals.h'
  integer, intent(in):: node,p
  real :: h,ppos(3),delta
  integer, intent(inout)::npnear,nblist(*)
  real :: d2list(*)
  h=2*hsmooth(p)
  ppos=pos(p,1:3)
  delta=0.
  call comsearch_d2(node,h,delta,ppos,npnear,nblist,d2list)
end subroutine

!
! particle-index search routines for conditional (ie reusable) range search 
! (with and without distance list)
!

subroutine pcond_srch(node,p,nneigh,nblist)
  include 'globals.h'
  real h,h2,ppos(3)
  integer nneigh,p,node,nblist(*)
  h=hsmooth(p)
  ppos=pos(p,1:3)
  call cond_srch(ppos,h,node,nneigh,nblist)
end subroutine

subroutine pcond_srch_d2(node,p,nneigh,nblist,d2list)
  include 'globals.h'
  real h,h2,ppos(3)
  integer nneigh,p,node,nblist(*)
  real :: d2list(*)
  h=hsmooth(p)
  ppos=pos(p,1:3)
  call cond_srch_d2(ppos,h,node,nneigh,nblist,d2list)
end subroutine

!
! driver search routines for conditional (ie reusable) range search 
! (with and without distance list)
!

subroutine cond_srch(ppos,h,node,nneigh,nblist)
  include 'globals.h'
  real h,ppos(3),dist
  integer nneigh,node,nblist(*)
  ncalls=ncalls+1
  if(searchreuse.EQ.0.OR.reuseflag.EQ.0) then
    searchpos=ppos
    searchh=h
    searchn=0
  else
    dist=sqrt(sum((ppos-searchpos)**2))
    if(h+dist/2.LE.searchh.AND.h.GT.searchmagic*searchh) then
      nneigh=searchn
      return
    endif
    searchn=0
    searchpos=ppos
    searchh=h
  endif
  nsearches=nsearches+1
  call search(node,2*searchh,searchpos,searchn,nblist)
  nneigh=searchn
  searchreuse=1
end subroutine

subroutine cond_srch_d2(ppos,h,node,nneigh,nblist,d2list)
  include 'globals.h'
  real h,ppos(3),dist
  integer nneigh,node,nblist(*)
  real :: d2list(*)
  ncalls=ncalls+1
  if(searchreuse.EQ.0.OR.reuseflag.EQ.0) then
    searchpos=ppos
    searchh=h
    searchn=0
  else
    dist=sqrt(sum((ppos-searchpos)**2))
    if(h+dist/2.LE.searchh.AND.h.GT.searchmagic*searchh) then
      nneigh=searchn
      return
    endif
    searchn=0
    searchpos=ppos
    searchh=h
  endif
  nsearches=nsearches+1
  call search_d2(node,2*searchh,searchpos,searchn,nblist,d2list)
  nneigh=searchn
  searchreuse=1
end subroutine

!
! particle-index search routines for conditional (ie reusable) 
! and complementary range search 
! (with and without distance list)
!

subroutine pcond_comsrch(node,p,nneigh,nblist)
  include 'globals.h'
  real h,h2,ppos(3),delta
  integer nneigh,p,node,nblist(*)
  h=hsmooth(p)
  ppos=pos(p,1:3)
  delta=0.
  call cond_comsrch(ppos,h,delta,node,nneigh,nblist)
end subroutine

subroutine pcond_comsrch_d2(node,p,nneigh,nblist,d2list)
  include 'globals.h'
  real h,h2,ppos(3),delta
  integer nneigh,p,node,nblist(*)
  real :: d2list(*)
  h=hsmooth(p)
  ppos=pos(p,1:3)
  delta=0.
  call cond_comsrch_d2(ppos,h,delta,node,nneigh,nblist,d2list)
end subroutine

!
! driver search routines for conditional (ie reusable)
!  and complementary range search 
! (with and without distance list)
!
subroutine cond_comsrch(ppos,h,delta,node,nneigh,nblist)
  include 'globals.h'
  real h,ppos(3),dist,delta
  integer nneigh,node,nblist(*)
  ncalls=ncalls+1
  if(searchreuse.EQ.0.OR.reuseflag.EQ.0) then
    searchpos=ppos
    searchh=h
    searchn=0
    searchdelta=delta
  else
    dist=sqrt(sum((ppos-searchpos)**2))
    if(h+dist/2.LE.searchh.AND. &
        delta+dist.LE.searchdelta.AND. &
         h.GT.searchmagic*searchh) then
      nneigh=searchn
      return
    endif
    searchn=0
    searchpos=ppos
    searchh=h 
    searchdelta=delta
  endif
  nsearches=nsearches+1
  call comsearch(node,2*searchh,searchdelta,searchpos,searchn,nblist)
  nneigh=searchn
  searchreuse=1
end subroutine

subroutine cond_comsrch_d2(ppos,h,delta,node,nneigh,nblist,d2list)
  include 'globals.h'
  real h,ppos(3),dist,delta
  integer nneigh,node,nblist(*)
  real d2list(*)
  ncalls=ncalls+1
  if(searchreuse.EQ.0.OR.reuseflag.EQ.0) then
    searchpos=ppos
    searchh=h
    searchn=0
    searchdelta=delta
  else
    dist=sqrt(sum((ppos-searchpos)**2))
    if(h+dist/2.LE.searchh.AND. &
         delta+dist.LE.searchdelta.AND. &
         h.GT.searchmagic*searchh) then
      nneigh=searchn
      return
    endif
    searchn=0
    searchpos=ppos
    searchh=h 
    searchdelta=delta
  endif
  nsearches=nsearches+1
  call comsearch_d2(node,2*searchh,searchdelta, &
                       searchpos,searchn,nblist,d2list)
  nneigh=searchn
  searchreuse=1
end subroutine

!
! pre search routines
!  these try to determine a search such that multiple particles
!  can reuse the same search list

subroutine presearch(k,kmax,nbuf,buf,ntodo,todo)
  include 'globals.h'
  integer :: k,kmax,nbuf,buf(nbuf),todo(nbuf),ntodo,ib,p,q,nneigh 
  real :: dist2,spos(3),ppos(3),ph,qh,sh,qpos(3)
  ntodo=0
  if(buf(1).EQ.0) then
    p=pactive(k)
    ntodo=ntodo+1 
    todo(ntodo)=p
    if(hsmooth(p).GT.0) then
      ppos=pos(p,1:3); ph=hsmooth(p)
      spos=ppos; sh=ph
      do ib=1,MIN(nbuf-1,kmax-k)
        if(buf(ib+1).NE.0) cycle
        q=pactive(k+ib)
        qpos=pos(q,1:3); qh=hsmooth(q)
        dist2=sum((ppos-qpos)**2)
        if(dist2.LT.ph**2) then
          buf(ib+1)=1  
          ntodo=ntodo+1; todo(ntodo)=q
          spos=((ntodo-1)*spos)/ntodo+qpos/ntodo      
        endif
      enddo
      do ib=1,ntodo
        q=todo(ib)
        qpos=pos(q,1:3); qh=hsmooth(q)
        dist2=sum((spos-qpos)**2)         
        sh=MAX(sh,qh+sqrt(dist2)/2)
      enddo
      sh=sh*1.02
      searchreuse=0
      call cond_srch(spos,sh,root,nneigh,srlist)
    endif
  endif
  do ib=1,nbuf-1
    buf(ib)=buf(ib+1)
  enddo 
  buf(nbuf)=0
end subroutine

subroutine precomsearch(k,kmax,nbuf,buf,ntodo,todo)
  include 'globals.h'
  integer :: k,kmax,nbuf,buf(nbuf),todo(nbuf),ntodo,ib,p,q,nneigh 
  real :: dist2,spos(3),ppos(3),ph,qh,sh,qpos(3),delta
  ntodo=0
  if(buf(1).EQ.0) then
    p=pactive(k)
    ntodo=ntodo+1 
    todo(ntodo)=p
    if(hsmooth(p).GT.0) then
      ppos=pos(p,1:3); ph=hsmooth(p)
      spos=ppos; sh=ph; delta=0
      do ib=1,MIN(nbuf-1,kmax-k)
        if(buf(ib+1).NE.0) cycle
        q=pactive(k+ib)
        qpos=pos(q,1:3); qh=hsmooth(q)
        dist2=sum((ppos-qpos)**2)
        if(dist2.LT.ph**2) then
          buf(ib+1)=1  
          ntodo=ntodo+1; todo(ntodo)=q
          spos=((ntodo-1)*spos)/ntodo+qpos/ntodo      
        endif
      enddo
      do ib=1,ntodo
        q=todo(ib)
        qpos=pos(q,1:3); qh=hsmooth(q)
        dist2=sum((spos-qpos)**2)         
        sh=MAX(sh,qh+sqrt(dist2)/2)
        delta=MAX(delta,sqrt(dist2))
      enddo
      searchreuse=0
      call cond_comsrch(spos,sh,delta,root,nneigh,srlist)
    endif
  endif
  do ib=1,nbuf-1
    buf(ib)=buf(ib+1)
  enddo 
  buf(nbuf)=0
end subroutine

MODULE AmuseInterface
    use MuseHelpers
    
    integer, external :: get_image_angle, get_upvector, get_image_target, &
      get_viewpoint, set_viewpoint, get_image_ratio, set_image_angle, set_image_target
    
CONTAINS

function initialize_code() result(ret)
  use StoppingConditions
  integer :: ret
  integer :: error
  call muse_start
  call muse_reset(0.0)
  call muse_set_time(0.0)
  error = set_support_for_condition(TIMEOUT_DETECTION)
  error = set_support_for_condition(NUMBER_OF_STEPS_DETECTION)
  error = set_support_for_condition(OUT_OF_BOX_DETECTION)
  error = set_support_for_condition(DENSITY_LIMIT_DETECTION)
  error = set_support_for_condition(INTERNAL_ENERGY_LIMIT_DETECTION)
  ret=0
end function

function cleanup_code() result(ret)
  integer :: ret
  call muse_end
  call muse_start
  call muse_reset(0.0)
  ret=0
end function


function commit_particles() result(ret)
  integer :: ret
  call muse_finalize_init 
  ret=0
end function

function recommit_particles() result(ret)
  integer :: ret
  ret=muse_reinitialize()
end function


function commit_parameters() result(ret)
  integer :: ret
  call muse_init
  ret=0
end function

function recommit_parameters() result(ret)
  integer :: ret
  ret=0
end function

function get_number_of_particles(n) result(ret)
  integer n,ret
  n=muse_get_nbodies() 
  ret=0
end function

function get_index_of_first_particle(id) result(ret)
  integer :: id,ret
  ret=muse_index_of_first_particle(id)
end function

function get_index_of_next_particle(id,id1) result(ret)
  integer :: id,id1,ret
  ret=muse_index_of_next_particle(id,id1)
end function

function get_time(t) result(ret)
  integer :: ret
  real*8 :: t
  t=muse_get_time()
  ret=0
end function

function set_begin_time(t) result(ret)
  integer :: ret
  real*8 :: t
  call muse_set_begin_time(t)
  ret = 0
end function

function get_begin_time(t) result(ret)
  integer :: ret
  real*8 :: t
  t = muse_get_begin_time()
  ret = 0
end function


function evolve_model(tend) result(ret)
  integer :: ret
  real*8 :: tend
  call muse_stepsys(tend,1)
  ret=0
end function

function synchronize_model() result(ret)
  integer :: ret
  real*8 :: dum1,dum2,dum3 
  ret=amuse_synchronize_model()
end function

function get_kinetic_energy(e) result(ret)
  integer :: ret
  real*8 :: e,ek,ep,eth
  call muse_energies(0,ek,ep,eth)
  e=ek
  ret=0
end function

function get_potential_energy(e) result(ret)
  integer :: ret
  real*8 :: e,ek,ep,eth
  call muse_energies(0,ek,ep,eth)
  e=ep
  ret=0
end function

function get_thermal_energy(e) result(ret)
  integer :: ret
  real*8 :: e,ek,ep,eth
  call muse_energies(0,ek,ep,eth)
  e=eth
  ret=0
end function

function get_total_energy(e) result(ret)
  integer :: ret
  real*8 :: e,ek,ep,eth
  call muse_energies(0,ek,ep,eth)
  e=ek+ep+eth
  ret=0
end function


function new_dm_particle(ids,mass,x,y,z,vx,vy,vz,eps) result(ret)
  integer :: ids,ret,oldnp
  real*8 :: mass,eps,x,y,z,vx,vy,vz
  integer :: idsa(1)
  real*8 :: massa(1),epsa(1),xa(1),ya(1),za(1),vxa(1),vya(1),vza(1)
  ids=new_id()
  oldnp=muse_get_nbodies()
  idsa = ids
  massa = mass
  xa = x
  ya = y
  za = z
  vxa = vx
  vya = vy
  vza = vz
  epsa = eps
  ret=add_dm_particle(idsa,massa,xa,ya,za,vxa,vya,vza,epsa,1)
  if(ret.EQ.oldnp+1) then
    ret=0
  else
    ret=-1
  endif 
end function

function new_sph_particle(ids,mass,x,y,z,vx,vy,vz,u,eps) result(ret)
  integer :: ids,ret,oldnp
  real*8 :: mass,eps,x,y,z,vx,vy,vz,u
  integer :: idsa(1)
  real*8 :: massa(1),epsa(1),xa(1),ya(1),za(1),vxa(1),vya(1),vza(1),ua(1)
  ids=new_id()
  oldnp=muse_get_nsph()
  
  idsa = ids
  massa = mass
  xa = x
  ya = y
  za = z
  vxa = vx
  vya = vy
  vza = vz
  epsa = eps
  ua = u
  
  ret=add_sph_particle(idsa,massa,xa,ya,za,vxa,vya,vza,epsa,ua,1)
  if(ret.EQ.oldnp+1) then
    ret=0
  else
    ret=-1
  endif 
end function

function new_star_particle(ids,mass,x,y,z,vx,vy,vz,tf,eps) result(ret)
  integer :: ids,ret,oldnp
  real*8 :: mass,eps,x,y,z,vx,vy,vz,tf
  integer :: idsa(1)
  real*8 :: massa(1),epsa(1),xa(1),ya(1),za(1),vxa(1),vya(1),vza(1),tfa(1)
  ids=new_id()
  oldnp=muse_get_nstar()
  idsa = ids
  massa = mass
  xa = x
  ya = y
  za = z
  vxa = vx
  vya = vy
  vza = vz
  epsa = eps
  tfa = tf
  
  ret=add_star_particle(idsa,massa,xa,ya,za,vxa,vya,vza,epsa,tfa,1)
  if(ret.EQ.oldnp+1) then
    ret=0
  else
    ret=-1
  endif 
end function

function add_dm_particle(ids,mass,x,y,z,vx,vy,vz,eps,npart) result(n)
  integer :: npart
  integer :: ids(npart),n
  real*8 :: mass(npart),x(npart),y(npart),z(npart), &
    vx(npart),vy(npart),vz(npart),eps(npart)
  call muse_add_particle_dm(ids,mass,x,y,z,vx,vy,vz,eps,npart)
  n=muse_get_nbodies()
end function

function add_star_particle(ids,mass,x,y,z,vx,vy,vz,eps,tf,npart) result(n)
  integer :: npart
  integer :: ids(npart),n
  real*8 :: mass(npart),x(npart),y(npart),z(npart), &
    vx(npart),vy(npart),vz(npart),eps(npart),tf(npart)
  call muse_add_particle_star(ids,mass,x,y,z,vx,vy,vz,eps,tf,npart)
  n=muse_get_nstar()
end function

function add_sph_particle(ids,mass,x,y,z,vx,vy,vz,eps,u,npart) result(n)
  integer :: npart
  integer :: ids(npart),n
  real*8 :: mass(npart),x(npart),y(npart),z(npart), &
    vx(npart),vy(npart),vz(npart),eps(npart),u(npart)
  call muse_add_particle_sph(ids,mass,x,y,z,vx,vy,vz,eps,u,npart)
  n=muse_get_nsph()
end function

function set_state(id,mass,x,y,z,vx,vy,vz,eps) result(ret)
  integer id,ret
  real*8 mass,eps,x,y,z,vx,vy,vz 
  ret=amuse_set_state(id,mass,x,y,z,vx,vy,vz,eps)
end function

function set_state_sph(id,mass,x,y,z,vx,vy,vz,u,eps) result(ret)
  integer id,ret
  real*8 mass,eps,x,y,z,vx,vy,vz,u 
  ret=amuse_set_state_sph(id,mass,x,y,z,vx,vy,vz,eps,u)
end function

function set_state_star(id,mass,x,y,z,vx,vy,vz,tf,eps) result(ret)
  integer id,ret
  real*8 mass,eps,x,y,z,vx,vy,vz,tf 
  ret=amuse_set_state_star(id,mass,x,y,z,vx,vy,vz,eps,tf)
end function

function get_state(id,mass,x,y,z,vx,vy,vz,eps) result(ret)
  integer :: id,ret
  real*8 :: mass,x,y,z,vx,vy,vz,eps
  ret=amuse_get_state(id,mass,x,y,z,vx,vy,vz,eps)
end function

function get_state_sph(id,mass,x,y,z,vx,vy,vz,u,eps) result(ret)
  integer :: id,ret
  real*8 :: mass,x,y,z,vx,vy,vz,eps,u
  ret=amuse_get_state_sph(id,mass,x,y,z,vx,vy,vz,eps,u)
end function

function get_state_star(id,mass,x,y,z,vx,vy,vz,tf,eps) result(ret)
  integer :: id,ret
  real*8 :: mass,x,y,z,vx,vy,vz,eps,tf
  ret=amuse_get_state_star(id,mass,x,y,z,vx,vy,vz,eps,tf)
end function

function set_mass(id,mass) result(ret)
  integer id,ret
  real*8 mass 
  ret=amuse_set_mass(id,mass)
end function
function set_radius(id,r) result(ret)
  integer id,ret
  real*8 :: r
  ret=amuse_set_epsgrav(id,r)
end function
function set_smoothing_length(id,eps) result(ret)
  integer id,ret
  real*8 eps
  ret=amuse_set_hsmooth(id,eps)
end function
function set_position(id,x,y,z) result(ret)
  integer id,ret
  real*8 x,y,z 
  ret=amuse_set_position(id,x,y,z)
end function
function set_velocity(id,vx,vy,vz) result(ret)
  integer id,ret
  real*8 vx,vy,vz 
  ret=amuse_set_velocity(id,vx,vy,vz)
end function
function set_internal_energy(id,u) result(ret)
  integer id,ret
  real*8 u 
  ret=amuse_set_internal_energy(id,u)
end function
function set_star_tform(id,tf) result(ret)
  integer id,ret
  real*8 tf 
  ret=amuse_set_star_tform(id,tf)
end function

function get_mass(id,mass) result(ret)
  integer :: id,ret
  real*8 :: mass
  ret=amuse_get_mass(id,mass)
end function
function get_radius(id,eps) result(ret)
  integer id,ret
  real*8 :: eps
  ret=amuse_get_epsgrav(id,eps)
end function
function get_smoothing_length(id,eps) result(ret)
  integer :: id,ret
  real*8 :: eps
  ret=amuse_get_hsmooth(id,eps)
end function
function get_density(id,density) result(ret)
  integer :: id,ret
  real*8 :: density
  ret=amuse_get_density(id,density)
end function

function get_pressure(id,pressure) result(ret)
  integer :: id,ret
  real*8 :: pressure
  ret=amuse_get_pressure(id,pressure)
end function

function get_position(id,x,y,z) result(ret)
  integer :: id,ret
  real*8 :: x,y,z
  ret=amuse_get_position(id,x,y,z)
end function
function get_velocity(id,vx,vy,vz) result(ret)
  integer :: id,ret
  real*8 :: vx,vy,vz
  ret=amuse_get_velocity(id,vx,vy,vz)
end function
function get_internal_energy(id,u) result(ret)
  integer :: id,ret
  real*8 :: u
  ret=amuse_get_internal_energy(id,u)
end function
function get_dinternal_energy_dt(id,dudt) result(ret)
  integer :: id,ret
  real*8 :: dudt
  ret=amuse_get_dinternal_energy_dt(id,dudt)
end function
function get_star_tform(id,tf) result(ret)
  integer :: id,ret
  real*8 :: tf
  ret=amuse_get_star_tform(id,tf)
end function

function delete_particle(id) result(ret)
  integer id,ret
  ret=muse_remove_particle(id)
end function

function get_gravity_at_point(eps, x, y, z, ax, ay, az, n) result(ret)
  integer :: ret,n  
  real*8 :: eps(n), x(n), y(n), z(n), ax(n), ay(n), az(n)
  ax=0;ay=0;az=0
  call muse_get_gravity(eps,x,y,z,ax,ay,az,n)
  ret=0
end function

function get_potential_at_point(eps, x, y, z, phi, n) result(ret)
  integer :: ret,n
  real*8 :: eps(n),x(n), y(n), z(n), phi(n)
  call muse_get_pot(eps,x,y,z,phi,n)
  ret=0  
end function

function get_potential(id, phi) result(ret)
  integer:: ret, id
  real*8 :: phi
  ret = amuse_get_potential(id, phi)
end function

function get_hydro_state_at_point(x, y, z, vx, vy, vz, rho, rhovx, rhovy, rhovz, rhoe,n) result(ret)
  integer :: ret,n
  real*8 :: x(n), y(n), z(n), vx(n), vy(n), vz(n), rho(n), rhovx(n), &
    rhovy(n), rhovz(n), rhoe(n)
  rho=0.
  rhovx=0.
  rhovy=0.
  rhovz=0.
  rhoe=0.  
  call muse_get_hydro_state(x,y,z,vx,vy,vz,rho,rhovx,rhovy,rhovz,rhoe,n)
  ret=0  
end function


! setting/ getting parameters

function set_use_hydro(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_usesph(.TRUE.)
  if(flag.EQ.0) call amuse_set_usesph(.FALSE.)
  ret=0
end function
function get_use_hydro(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_usesph(x) 
  if(x) flag=1
  ret=0
end function

function set_radiate(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_radiate(.TRUE.)
  if(flag.EQ.0) call amuse_set_radiate(.FALSE.)
  ret=0
end function
function get_radiate(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_radiate(x) 
  if(x) flag=1
  ret=0
end function

function set_starform(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_starform(.TRUE.)
  if(flag.EQ.0) call amuse_set_starform(.FALSE.)
  ret=0
end function
function get_starform(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_starform(x) 
  if(x) flag=1
  ret=0
end function

function set_cosmo(zeroiftrue) result(ret)
  integer :: zeroiftrue,ret
  if(zeroiftrue.EQ.0) call amuse_set_cosmo(.TRUE.)
  if(zeroiftrue.NE.0) call amuse_set_cosmo(.FALSE.)
  ret=0
end function
function get_cosmo(zeroiftrue) result(ret)
  integer :: ret,zeroiftrue
  logical :: x
  zeroiftrue=1
  call amuse_get_cosmo(x) 
  if(x) zeroiftrue=0
  ret=0
end function

function set_sqrttstp(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_sqrttstp(.TRUE.)
  if(flag.EQ.0) call amuse_set_sqrttstp(.FALSE.)
  ret=0
end function
function get_sqrttstp(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_sqrttstp(x) 
  if(x) flag=1
  ret=0
end function

function set_acc_tstp(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_acc_tstp(.TRUE.)
  if(flag.EQ.0) call amuse_set_acc_tstp(.FALSE.)
  ret=0
end function
function get_acc_tstp(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_acc_tstp(x) 
  if(x) flag=1
  ret=0
end function

function set_freetstp(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_freetstp(.TRUE.)
  if(flag.EQ.0) call amuse_set_freetstp(.FALSE.)
  ret=0
end function
function get_freetstp(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_freetstp(x) 
  if(x) flag=1
  ret=0
end function

function set_usequad(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_usequad(.TRUE.)
  if(flag.EQ.0) call amuse_set_usequad(.FALSE.)
  ret=0
end function
function get_usequad(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_usequad(x) 
  if(x) flag=1
  ret=0
end function

function set_directsum(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_directsum(.TRUE.)
  if(flag.EQ.0) call amuse_set_directsum(.FALSE.)
  ret=0
end function
function get_directsum(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_directsum(x) 
  if(x) flag=1
  ret=0
end function

function set_selfgrav(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_selfgrav(.TRUE.)
  if(flag.EQ.0) call amuse_set_selfgrav(.FALSE.)
  ret=0
end function
function get_selfgrav(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_selfgrav(x) 
  if(x) flag=1
  ret=0
end function

function set_fixthalo(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_fixthalo(.TRUE.)
  if(flag.EQ.0) call amuse_set_fixthalo(.FALSE.)
  ret=0
end function
function get_fixthalo(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_fixthalo(x) 
  if(x) flag=1
  ret=0
end function

function set_adaptive_eps(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_adaptive_eps(.TRUE.)
  if(flag.EQ.0) call amuse_set_adaptive_eps(.FALSE.)
  ret=0
end function
function get_adaptive_eps(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_adaptive_eps(x) 
  if(x) flag=1
  ret=0
end function

function set_gdgop(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_gdgop(.TRUE.)
  if(flag.EQ.0) call amuse_set_gdgop(.FALSE.)
  ret=0
end function
function get_gdgop(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_gdgop(x) 
  if(x) flag=1
  ret=0
end function

function set_smoothinput(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_smoothinput(.TRUE.)
  if(flag.EQ.0) call amuse_set_smoothinput(.FALSE.)
  ret=0
end function
function get_smoothinput(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_smoothinput(x) 
  if(x) flag=1
  ret=0
end function

function set_consph(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_consph(.TRUE.)
  if(flag.EQ.0) call amuse_set_consph(.FALSE.)
  ret=0
end function
function get_consph(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_consph(x) 
  if(x) flag=1
  ret=0
end function

function set_sphinit(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_sphinit(.TRUE.)
  if(flag.EQ.0) call amuse_set_sphinit(.FALSE.)
  ret=0
end function
function get_sphinit(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_sphinit(x) 
  if(x) flag=1
  ret=0
end function

function set_uentropy(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_uentropy(.TRUE.)
  if(flag.EQ.0) call amuse_set_uentropy(.FALSE.)
  ret=0
end function
function get_uentropy(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_uentropy(x) 
  if(x) flag=1
  ret=0
end function

function set_isotherm(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_isotherm(.TRUE.)
  if(flag.EQ.0) call amuse_set_isotherm(.FALSE.)
  ret=0
end function
function get_isotherm(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_isotherm(x) 
  if(x) flag=1
  ret=0
end function

function set_eps_is_h(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_eps_is_h(.TRUE.)
  if(flag.EQ.0) call amuse_set_eps_is_h(.FALSE.)
  ret=0
end function
function get_eps_is_h(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_eps_is_h(x) 
  if(x) flag=1
  ret=0
end function

function set_balsara(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_balsara(.TRUE.)
  if(flag.EQ.0) call amuse_set_balsara(.FALSE.)
  ret=0
end function
function get_balsara(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_balsara(x) 
  if(x) flag=1
  ret=0
end function

function set_mingaseps(flag) result(ret)
  integer :: flag,ret
  if(flag.NE.0) call amuse_set_mingaseps(.TRUE.)
  if(flag.EQ.0) call amuse_set_mingaseps(.FALSE.)
  ret=0
end function
function get_mingaseps(flag) result(ret)
  integer :: ret,flag
  logical :: x
  flag=0
  call amuse_get_mingaseps(x) 
  if(x) flag=1
  ret=0
end function


! integers

function set_firstsnap(i) result(ret)
  integer :: ret,i
  call amuse_set_firstsnap(i)
  ret=0
end function
function get_firstsnap(i) result(ret)
  integer :: ret,i
  call amuse_get_firstsnap(i) 
  ret=0
end function

function set_stepout(i) result(ret)
  integer :: ret,i
  call amuse_set_stepout(i)
  ret=0
end function
function get_stepout(i) result(ret)
  integer :: ret,i
  call amuse_get_stepout(i) 
  ret=0
end function

function set_steplog(i) result(ret)
  integer :: ret,i
  call amuse_set_steplog(i)
  ret=0
end function
function get_steplog(i) result(ret)
  integer :: ret,i
  call amuse_get_steplog(i) 
  ret=0
end function

function set_max_tbin(i) result(ret)
  integer :: ret,i
  call amuse_set_max_tbin(i)
  ret=0
end function
function get_max_tbin(i) result(ret)
  integer :: ret,i
  call amuse_get_max_tbin(i) 
  ret=0
end function

function set_minppbin(i) result(ret)
  integer :: ret,i
  call amuse_set_minppbin(i)
  ret=0
end function
function get_minppbin(i) result(ret)
  integer :: ret,i
  call amuse_get_minppbin(i) 
  ret=0
end function

function set_targetnn(i) result(ret)
  integer :: ret,i
  call amuse_set_targetnn(i)
  ret=0
end function
function get_targetnn(i) result(ret)
  integer :: ret,i
  call amuse_get_targetnn(i) 
  ret=0
end function

function set_verbosity(i) result(ret)
  integer :: ret,i
  call amuse_set_verbosity(i)
  ret=0
end function
function get_verbosity(i) result(ret)
  integer :: ret,i
  call amuse_get_verbosity(i) 
  ret=0
end function

function set_nsmooth(i) result(ret)
  integer :: ret,i
  call amuse_set_nsmooth(i)
  ret=0
end function
function get_nsmooth(i) result(ret)
  integer :: ret,i
  call amuse_get_nsmooth(i) 
  ret=0
end function

! reals

function set_pboxsize(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_pboxsize(x)
  ret=0
end function
function get_pboxsize(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_pboxsize(x) 
  ret=0
end function

function set_unitm_in_msun(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_unitm_in_msun(x)
  ret=0
end function
function get_unitm_in_msun(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_unitm_in_msun(x) 
  ret=0
end function

function set_unitl_in_kpc(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_unitl_in_kpc(x)
  ret=0
end function
function get_unitl_in_kpc(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_unitl_in_kpc(x) 
  ret=0
end function

function set_dtime(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_dtime(x)
  ret=0
end function

function set_time_step(time_step) result(ret)
  integer :: ret
  real*8 :: time_step
  ret=set_dtime(time_step)
end function

function get_dtime(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_dtime(x) 
  ret=0
end function

function get_time_step(time_step) result(ret)
  integer :: ret
  real*8 :: time_step
  ret=get_dtime(time_step) 
end function

function set_tstepcrit(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_tstepcrit(x)
  ret=0
end function

function get_tstepcrit(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_tstepcrit(x) 
  ret=0
end function

function set_tstpcr2(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_tstpcr2(x)
  ret=0
end function
function get_tstpcr2(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_tstpcr2(x) 
  ret=0
end function

function set_freev(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_freev(x)
  ret=0
end function

function get_freev(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_freev(x) 
  ret=0
end function

function set_freea(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_freea(x)
  ret=0
end function
function get_freea(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_freea(x) 
  ret=0
end function

function set_freevexp(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_freevexp(x)
  ret=0
end function
function get_freevexp(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_freevexp(x) 
  ret=0
end function

function set_freeaexp(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_freeaexp(x)
  ret=0
end function

function get_freeaexp(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_freeaexp(x) 
  ret=0
end function

function set_bh_tol(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_bh_tol(x)
  ret=0
end function

function get_bh_tol(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_bh_tol(x) 
  ret=0
end function

function set_eps(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_eps(x)
  ret=0
end function

function get_eps(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_eps(x) 
  ret=0
end function

function set_gdgtol(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_gdgtol(x)
  ret=0
end function
function get_gdgtol(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_gdgtol(x) 
  ret=0
end function

function set_nn_tol(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_nn_tol(x)
  ret=0
end function

function get_nn_tol(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_nn_tol(x) 
  ret=0
end function

function set_epsgas(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_epsgas(x)
  ret=0
end function
function get_epsgas(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_epsgas(x) 
  ret=0
end function

function set_gamma(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_gamma(x)
  ret=0
end function
function get_gamma(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_gamma(x) 
  ret=0
end function

function set_alpha(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_alpha(x)
  ret=0
end function

function get_alpha(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_alpha(x) 
  ret=0
end function

function set_beta(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_beta(x)
  ret=0
end function
function get_beta(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_beta(x) 
  ret=0
end function

function set_epssph(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_epssph(x)
  ret=0
end function
function get_epssph(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_epssph(x) 
  ret=0
end function

function set_courant(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_courant(x)
  ret=0
end function
function get_courant(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_courant(x) 
  ret=0
end function

function set_removgas(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_removgas(x)
  ret=0
end function
function get_removgas(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_removgas(x) 
  ret=0
end function

function set_consthsm(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_consthsm(x)
  ret=0
end function
function get_consthsm(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_consthsm(x) 
  ret=0
end function

function set_nsmtol(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_nsmtol(x)
  ret=0
end function
function get_nsmtol(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_nsmtol(x) 
  ret=0
end function

function set_graineff(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_graineff(x)
  ret=0
end function
function get_graineff(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_graineff(x) 
  ret=0
end function

function set_crionrate(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_crionrate(x)
  ret=0
end function
function get_crionrate(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_crionrate(x) 
  ret=0
end function

function set_heat_par1(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_heat_par1(x)
  ret=0
end function
function get_heat_par1(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_heat_par1(x) 
  ret=0
end function

function set_heat_par2(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_heat_par2(x)
  ret=0
end function
function get_heat_par2(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_heat_par2(x) 
  ret=0
end function

function set_cool_par(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_cool_par(x)
  ret=0
end function
function get_cool_par(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_cool_par(x) 
  ret=0
end function

function set_optdepth(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_optdepth(x)
  ret=0
end function
function get_optdepth(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_optdepth(x) 
  ret=0
end function

function set_tcollfac(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_tcollfac(x)
  ret=0
end function
function get_tcollfac(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_tcollfac(x) 
  ret=0
end function

function set_masscrit(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_masscrit(x)
  ret=0
end function
function get_masscrit(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_masscrit(x) 
  ret=0
end function

function set_sfeff(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_sfeff(x)
  ret=0
end function
function get_sfeff(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_sfeff(x) 
  ret=0
end function

function set_tbubble(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_tbubble(x)
  ret=0
end function
function get_tbubble(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_tbubble(x) 
  ret=0
end function

function set_sne_eff(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_sne_eff(x)
  ret=0
end function
function get_sne_eff(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_sne_eff(x) 
  ret=0
end function

function set_tsnbeg(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_tsnbeg(x)
  ret=0
end function
function get_tsnbeg(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_tsnbeg(x) 
  ret=0
end function

function set_rhomax(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_set_rhomax(x)
  ret=0
end function
function get_rhomax(x) result(ret)
  integer :: ret
  real*8 :: x
  call amuse_get_rhomax(x) 
  ret=0
end function


! character

function set_halofile(x) result(ret)
  integer :: ret
  character(len=30) :: x
  call amuse_set_halofile(x)
  ret=0
end function
function get_halofile(x) result(ret)
  integer :: ret
  character(len=30) :: x
  call amuse_get_halofile(x)
  ret=0
end function

function set_feedback(x) result(ret)
  integer :: ret
  character(len=4) :: x
  call amuse_set_feedback(x)
  ret=0
end function
function get_feedback(x) result(ret)
  integer :: ret
  character(len=4) :: x
  call amuse_get_feedback(x) 
  ret=0
end function

function set_sfmode(x) result(ret)
  integer :: ret
  character(len=10) :: x
  call amuse_set_sfmode(x)
  ret=0
end function
function get_sfmode(x) result(ret)
  integer :: ret
  character(len=10) :: x
  call amuse_get_sfmode(x)
  ret=0
end function

function set_hupdatemethod(x) result(ret)
  integer :: ret
  character(len=4) :: x
  call amuse_set_hupdatemethod(x)
  ret=0
end function
function get_hupdatemethod(x) result(ret)
  integer :: ret
  character(len=4) :: x
  call amuse_get_hupdatemethod(x) 
  ret=0
end function

function set_sph_visc(x) result(ret)
  integer :: ret
  character(len=4) :: x
  call amuse_set_sph_visc(x)
  ret=0
end function
function get_sph_visc(x) result(ret)
  integer :: ret
  character(len=4) :: x
  call amuse_get_sph_visc(x)
  ret=0
end function

function set_fi_data_directory(x) result(ret)
  integer :: ret
  character(len=200) :: x
  call amuse_set_fi_data_directory(x)
  ret=0
end function
function get_fi_data_directory(x) result(ret)
  integer :: ret
  character(len=200) :: x
  call amuse_get_fi_data_directory(x)
  ret=0
end function


function get_number_of_sph_particles_removed(x)
  integer :: get_number_of_sph_particles_removed
  integer, intent(out) :: x
  get_number_of_sph_particles_removed = amuse_get_number_of_sph_particles_removed(x)
end function

function get_id_of_removed_sph_particle(x, id_of_removed_particle)
  integer :: get_id_of_removed_sph_particle
  integer, intent(in) :: x
  integer, intent(out) :: id_of_removed_particle
  get_id_of_removed_sph_particle = amuse_get_id_of_removed_sph_particle(x, id_of_removed_particle)
end function

subroutine trigger_partremoval
  integer :: ret
  call partremoval
  ret=0
end subroutine

END MODULE

subroutine outbods(fname)
 include 'globals.h'
 integer,parameter :: ndigits=6
 character(len=ndigits) :: nstring
 character(len=24) :: filenaam
 character(len=*) :: fname
 if(fname(1:6).EQ.'XXXXXX') then
  call itos(nsnap,ndigits,nstring)
  filenaam=TRIM(outputfile)//'.'//nstring
  nsnap=nsnap+1 
 else
  filenaam=fname
 endif 
  call writebods(filenaam)
end subroutine outbods


subroutine writebods(filenaam)
 include 'globals.h'
 character(len=*) :: filenaam 
 integer :: nbods,nkeep,p
 integer(kind=4), parameter :: nihead=32,nrhead=32,nphead=64
 integer(kind=4) :: ioversion
 integer(kind=4) :: header(8),ihead(nihead)
 real(kind=8) :: rhead(nrhead)
 integer(kind=4) :: phead(nphead)
 
 call prepareoutput
 
 ioversion=2
  
 header(1)=nihead
 header(2)=nrhead
 header(3)=nphead
 header(4)=0
 header(5)=0
 header(6)=0
 header(7)=0
 header(8)=0
 
 ihead(1:nihead)=0
 rhead(1:nrhead)=0
 phead(1:nphead)=0
  
 ihead(1)=nbodies
 ihead(2)=nsph
 ihead(3)=nstar
 ihead(4)=nbodies-nstar-nsph
 ihead(5)=totptag
 ihead(6)=nbh

 ihead(8)=syncflag
 if(syncflag.NE.0) then
  print*, ' ** warning ** async output??'
  stop 
 endif

 
 rhead(1)=tnow
 rhead(2)=mtot
 rhead(3)=ektot
 rhead(4)=eptot
 rhead(5)=snheat
 rhead(6)=eradiate
 rhead(7)=esofttot
 rhead(8)=enerror
 rhead(9)=estar
 rhead(10)=efuvheat
 rhead(11)=eradcool
 rhead(12)=tpos
 rhead(13)=teth
 rhead(14)=trad
 rhead(15)=meanmwt
 rhead(16)=timescale
 rhead(17)=unitm_in_msun
 rhead(18)=lengthscale
 rhead(19)=densconst
 rhead(20)=massres
 rhead(21)=fhydrogn
 rhead(22)=tstarform
 rhead(23)=tsnfeedback
 rhead(24)=tbh
 rhead(25)=eps

! rhead(31)=redshift
! rhead(32)=redshift0
 
 phead(1:nphead)=output(1:nphead) 
 if(nsph.eq.0) then
  phead(10:25)=0
 endif
 if(nstar.eq.0) then
  phead(33:35)=0
 endif
  
 open(unit=ubodsout,FILE=filenaam,status='UNKNOWN',form='UNFORMATTED')
 
 WRITE(ubodsout) ioversion
 WRITE(ubodsout) (header(p),p=1,8)
 WRITE(ubodsout) (ihead(p),p=1,nihead)
 WRITE(ubodsout) (rhead(p),p=1,nrhead)
 WRITE(ubodsout) (phead(p),p=1,nphead)

 IF(phead(1).EQ.1) WRITE(ubodsout) (mass(p),p=1,nbodies)
 IF(phead(2).EQ.1) WRITE(ubodsout) (pos(p,1),p=1,nbodies)
 IF(phead(2).EQ.1) WRITE(ubodsout) (pos(p,2),p=1,nbodies)
 IF(phead(2).EQ.1) WRITE(ubodsout) (pos(p,3),p=1,nbodies)
 IF(phead(3).EQ.1) WRITE(ubodsout) (vel(p,1),p=1,nbodies)
 IF(phead(3).EQ.1) WRITE(ubodsout) (vel(p,2),p=1,nbodies)
 IF(phead(3).EQ.1) WRITE(ubodsout) (vel(p,3),p=1,nbodies)
 IF(phead(4).EQ.1) WRITE(ubodsout) (epsgrav(p),p=1,nbodies)
 IF(phead(5).EQ.1) WRITE(ubodsout) (tform(p),p=1,nbodies)
 IF(phead(6).EQ.1) WRITE(ubodsout) (acc(p,1),p=1,nbodies)
 IF(phead(6).EQ.1) WRITE(ubodsout) (acc(p,2),p=1,nbodies)
 IF(phead(6).EQ.1) WRITE(ubodsout) (acc(p,3),p=1,nbodies)

IF(nsph.GT.0) THEN
 IF(phead(10).EQ.1) WRITE(ubodsout) (rho(p),p=1,nsph)
 IF(phead(11).EQ.1) THEN
  IF(uentropy) THEN
   WRITE(ubodsout) (tempvect(p),p=1,nsph)
  ELSE
   WRITE(ubodsout) (ethermal(p),p=1,nsph)  
  ENDIF
 ENDIF
 IF(phead(12).EQ.1) THEN
  IF(uentropy) THEN
   WRITE(ubodsout) (entropy(p),p=1,nsph)
  ELSE
   WRITE(ubodsout) (tempvect(p),p=1,nsph)  
  ENDIF
 ENDIF
 IF(phead(13).EQ.1) WRITE(ubodsout) (hsmooth(p),p=1,nsph) 
 IF(phead(14).EQ.1) WRITE(ubodsout) (fuvheat(p),p=1,nsph)
 IF(phead(15).EQ.1) WRITE(ubodsout) (esnthdt(p),p=1,nsph)
 IF(phead(16).EQ.1) WRITE(ubodsout) (tcollaps(p),p=1,nsph)
 IF(phead(17).EQ.1) WRITE(ubodsout) (temperat(p),p=1,nsph)
 IF(phead(18).EQ.1) WRITE(ubodsout) (elecfrac(p),p=1,nsph)
 IF(phead(19).EQ.1) WRITE(ubodsout) (csound(p),p=1,nsph)
 IF(phead(20).EQ.1) WRITE(ubodsout) &
  (csound(p)**2*rho(p)/gamma,p=1,nsph)
 IF(phead(21).EQ.1) WRITE(ubodsout) (hsmdivv(p),p=1,nsph)
 IF(phead(22).EQ.1) WRITE(ubodsout) (mumaxdvh(p),p=1,nsph) 
 IF(phead(23).EQ.1) WRITE(ubodsout) (hsmcurlv(p),p=1,nsph)
 IF(phead(24).EQ.1) WRITE(ubodsout) (vdisp(p),p=1,nsph)
 IF(phead(25).EQ.1) WRITE(ubodsout) (h2frac(p),p=1,nsph)
 IF(phead(26).EQ.1) THEN
  IF(uentropy) THEN
   WRITE(ubodsout) (tempvect(p),p=nsph+1,2*nsph)
  ELSE
   WRITE(ubodsout) (dethdt(p),p=1,nsph)  
  ENDIF
 ENDIF
 IF(phead(27).EQ.1) THEN
  IF(uentropy) THEN
   WRITE(ubodsout) (dentdt(p),p=1,nsph)
  ELSE
   WRITE(ubodsout) (tempvect(p),p=nsph+1,2*nsph)  
  ENDIF
 ENDIF
ENDIF

IF(nstar.GT.0) THEN 
 IF(phead(34).EQ.1) WRITE(ubodsout) (starfuv(p),p=nbodies-nstar+1,nbodies)
 IF(phead(35).EQ.1) WRITE(ubodsout) (snentropy(p),p=nbodies-nstar+1,nbodies)
ENDIF

 IF(phead(40).EQ.1) WRITE(ubodsout) (phi(p),p=1,nbodies)
 IF(phead(41).EQ.1) WRITE(ubodsout) (phiext(p),p=1,nbodies)
 IF(phead(42).EQ.1) WRITE(ubodsout) (nbexist(p),p=1,nbodies)
 IF(phead(43).EQ.1) WRITE(ubodsout) (itimestp(p),p=1,nbodies)

 close(ubodsout)

end subroutine writebods

subroutine readbods(filenaam)
 include 'globals.h'
 character(len=*) :: filenaam 
 integer :: nbods,nkeep,p,ioerr
 integer(kind=4),parameter ::  nihead=32,nrhead=32,nphead=64
 integer(kind=4) :: ioversion
 integer(kind=4) :: header(8),ihead(nihead)
 real(kind=8) :: rhead(nrhead)
 integer(kind=4) :: phead(nphead)
 
 print*,' ...reading data... ',filenaam
 open(unit=ubodsin,FILE=filenaam,status='OLD',form='UNFORMATTED',IOSTAT=ioerr)
 
 IF(ioerr.NE.0) THEN
  print*, ' stop -- error reading file ', filenaam
  stop         
 ENDIF
  
 READ(ubodsin) ioversion
 READ(ubodsin) (header(p),p=1,8)
 
 ihead(1:nihead)=0
 rhead(1:nrhead)=0
 phead(1:nphead)=0
 

 if(header(1).GT.nihead.OR.header(2).GT.nrhead.OR. &
                 header(3).GT.nphead.OR.ioversion.GT.2) then
  print*,' warning: file input from newer file format?'
 endif
 
 READ(ubodsin) (ihead(p),p=1,MIN(nihead,header(1)))
 READ(ubodsin) (rhead(p),p=1,MIN(nrhead,header(2)))
 READ(ubodsin) (phead(p),p=1,MIN(nphead,header(3)))

 nbodies=ihead(1)
 nsph=ihead(2)
 nstar=ihead(3)
 IF(nbodies-nstar-nsph.NE.ihead(4)) THEN
  print*,' inconsistent body count'
  STOP
 ENDIF  
 IF(nbodies.GT.nbodsmax.OR.nsph.gt.nsphmax) THEN
  PRINT*,nbodies,nbodsmax,nsph,nsphmax
  PRINT*,' particle overflow '  
  PRINT*,'(increase compiled limits)'
  STOP
 ENDIF
 IF(nbodies-nstar-nsph.GT.0.AND.fixthalo) THEN
  PRINT*,'** warning ** rigid halo used and DM particles found' 
 ENDIF
 totptag=ihead(5)
 nbh=ihead(6)
 
 syncflag=ihead(8)
 if(syncflag.NE.0) print*,' ** warning ** async input'
  
 tnow=rhead(1)
 mtot=rhead(2)
 ektot=rhead(3)
 eptot=rhead(4)
 snheat=rhead(5)
 eradiate=rhead(6)
 esofttot=rhead(7)
 enerror=rhead(8)
 estar=rhead(9)
 efuvheat=rhead(10)
 eradcool=rhead(11)
 tpos=rhead(12)
 teth=rhead(13)
 trad=rhead(14)
 if(meanmwt.LE.0) meanmwt=rhead(15)
 massres=rhead(20)
 ! tstarform=rhead(22)
 tstarform=tnow
 tsnfeedback=tnow
 tbh=tnow
 if(rhead(25).NE.0) eps=rhead(25) 

 input(1:nphead)=phead(1:nphead)

 pordercount=pordercount+1
 ppropcount=ppropcount+1

 IF(phead(1).EQ.1) READ(ubodsin) (mass(p),p=1,nbodies)
 IF(phead(2).EQ.1) READ(ubodsin) (pos(p,1),p=1,nbodies)
 IF(phead(2).EQ.1) READ(ubodsin) (pos(p,2),p=1,nbodies)
 IF(phead(2).EQ.1) READ(ubodsin) (pos(p,3),p=1,nbodies)
 IF(phead(3).EQ.1) READ(ubodsin) (vel(p,1),p=1,nbodies)
 IF(phead(3).EQ.1) READ(ubodsin) (vel(p,2),p=1,nbodies)
 IF(phead(3).EQ.1) READ(ubodsin) (vel(p,3),p=1,nbodies)
 IF(phead(4).EQ.1) READ(ubodsin) (epsgrav(p),p=1,nbodies)
 IF(phead(5).EQ.1) READ(ubodsin) (tform(p),p=1,nbodies)
 IF(phead(6).EQ.1) READ(ubodsin) (acc(p,1),p=1,nbodies)
 IF(phead(6).EQ.1) READ(ubodsin) (acc(p,2),p=1,nbodies)
 IF(phead(6).EQ.1) READ(ubodsin) (acc(p,3),p=1,nbodies)


IF(nsph.GT.0) THEN
 IF(phead(10).EQ.1) READ(ubodsin) (rho(p),p=1,nsph)
 IF(phead(11).EQ.1) THEN
  IF(uentropy) THEN
   READ(ubodsin) (tempvect(p),p=1,nsph)
  ELSE
   READ(ubodsin) (ethermal(p),p=1,nsph)  
  ENDIF
 ENDIF
 IF(phead(12).EQ.1) THEN
  IF(uentropy) THEN
   READ(ubodsin) (entropy(p),p=1,nsph)
  ELSE
   READ(ubodsin) (tempvect(p),p=1,nsph)  
  ENDIF
 ENDIF
 IF(phead(13).EQ.1) READ(ubodsin) (hsmooth(p),p=1,nsph) 
 IF(phead(14).EQ.1) READ(ubodsin) (fuvheat(p),p=1,nsph)
 IF(phead(15).EQ.1) READ(ubodsin) (esnthdt(p),p=1,nsph)
 IF(phead(16).EQ.1) READ(ubodsin) (tcollaps(p),p=1,nsph)
 IF(phead(17).EQ.1) READ(ubodsin) (temperat(p),p=1,nsph)
 IF(phead(18).EQ.1) READ(ubodsin) (elecfrac(p),p=1,nsph)
 IF(phead(19).EQ.1) READ(ubodsin) (csound(p),p=1,nsph)
 IF(phead(20).EQ.1) READ(ubodsin) (csound(p),p=1,nsph)
 IF(phead(21).EQ.1) READ(ubodsin) (hsmdivv(p),p=1,nsph)
 IF(phead(22).EQ.1) READ(ubodsin) (mumaxdvh(p),p=1,nsph)
 IF(phead(23).EQ.1) READ(ubodsin) (hsmcurlv(p),p=1,nsph)
 IF(phead(24).EQ.1) READ(ubodsin) (vdisp(p),p=1,nsph)
 IF(phead(25).EQ.1) READ(ubodsin) (h2frac(p),p=1,nsph)
 IF(phead(26).EQ.1) READ(ubodsin) ! ignore 
 IF(phead(27).EQ.1) READ(ubodsin) ! ignore
 ENDIF

IF(nstar.GT.0) THEN
 IF(phead(34).EQ.1) READ(ubodsin) (starfuv(p),p=nbodies-nstar+1,nbodies)
 IF(phead(35).EQ.1) READ(ubodsin) (snentropy(p),p=nbodies-nstar+1,nbodies)
ENDIF
 
 IF(phead(40).EQ.1) READ(ubodsin) (phi(p),p=1,nbodies)
 IF(phead(41).EQ.1) READ(ubodsin) (phiext(p),p=1,nbodies)
 IF(phead(42).EQ.1) READ(ubodsin) (nbexist(p),p=1,nbodies)
 IF(phead(43).EQ.1) READ(ubodsin) (itimestp(p),p=1,nbodies)

 close(ubodsin)
 
end subroutine readbods


subroutine prepareoutput
 include 'globals.h'
 integer :: nkeep,nbods
 if(uentropy) then
  tempvect(1:nsph)=entropy(1:nsph)/gamma1*rho(1:nsph)**gamma1
  tempvect(nsph+1:2*nsph)=dentdt(1:nsph)/gamma1*rho(1:nsph)**gamma1
 else
  if(.NOT.isotherm) then
   tempvect(1:nsph)=ethermal(1:nsph)*gamma1/rho(1:nsph)**gamma1 
   tempvect(nsph+1:2*nsph)=dethdt(1:nsph)*gamma1/rho(1:nsph)**gamma1 
  else
   ethermal(1:nsph)=csound(1:nsph)**2
   tempvect(1:nsph)=csound(1:nsph)**2
   tempvect(nsph+1:2*nsph)=0. 
   temperat(1:nsph)=csound(1:nsph)**2*meanmwt*mhboltz
  endif
 endif 
end subroutine

subroutine itos(i,n,s)
 integer,intent(in) :: i,n
 character(len=n), intent(inout) :: s
 character(len=11) :: nstring
 data nstring/'0123456789X'/
 integer :: j,k,l

 if(i.LT.0.OR.i.GE.10**n) then
  do k=1,n
  s(k:k)=nstring(11:11)
  enddo
  return
 endif 
 j=1
 do k=1,n
 l=1+mod(i,10*j)/j
 s(n-k+1:n-k+1)=nstring(l:l)
 j=j*10
 enddo

end subroutine

! insert autmatically generated code below

subroutine writedump(n) 
 include 'globals.h' 
 integer i,n 
 real dummy 
 logical ldummy
 open(unit=uboddump,file=dumpfile,status='UNKNOWN',form='UNFORMATTED') 

write(uboddump) n 

      write(uboddump)  output,firstsnap,stepout,steplog,verbosity,       &
   datadir,inputfile,outputfile,halofile
      write(uboddump)  pboxsize,usesph,radiate,starform,cosmo
      write(uboddump)  unitl_in_kpc,unitm_in_msun
      write(uboddump)  dtime,tstepcrit,tstpcr2,freev,freea,freevexp,   &
   freeaexp,nsteps,max_tbin,minppbin,sqrttstp,acc_tstp, &
   freetstp
      write(uboddump)  bh_tol,eps,gdgtol,nn_tol,targetnn,usequad,         &
   directsum,selfgrav,fixthalo,adaptive_eps,gdgop
      write(uboddump)  epsgas,gamma,alpha,beta,epssph,courant,removgas, &
   consthsm,nsmtol,nsmooth,smoothinput,consph,sphinit,uentropy, &
   isotherm,eps_is_h,mingaseps,balsara,hupdatemethod,sph_visc
      write(uboddump)  graineff,crionrate,heat_par1,heat_par2,cool_par,    &
   optdepth
      write(uboddump)  comove
      write(uboddump)  tcollfac,masscrit,sfeff,tbubble,sne_eff,tsnbeg,   &
   rhomax,sfmode,feedback
      write(uboddump)  rndtable,rnseed
      write(uboddump)  nbodies,nsnap
      write(uboddump)  rmin,rsize,incells,incellsg
      write(uboddump)  root
      write(uboddump)  nttot,ntmin,ntmax,ntavg,nttotfuv,ntminfuv,        &
   ntmaxfuv,ntavgfuv
      write(uboddump)  nstot,nsmin,nsmax,nsavg
      write(uboddump)  tnow,tpos
      write(uboddump)  tiny
      write(uboddump)  mtot,etot,ektot,eptot,mstar,mgas,snheat,esofttot, &
   enerror,amvec,cmpos,cmvel
      write(uboddump)  input
      write(uboddump)  npactive,nsphact
      write(uboddump)  etol,dummy,tsteppos,active_bin
      write(uboddump)  syncflag,entropyflag
      write(uboddump)  teth,ethtot
      write(uboddump)  symmetry
      write(uboddump)  dummy,dummy,gamma1,nstar,nsph
      write(uboddump)  massres
      write(uboddump)  deldr2i
      write(uboddump)  wsmooth,dwsmooth
      write(uboddump)  nntot,nnmin,nnmax,nnavg
      write(uboddump)  hboxsize
      write(uboddump)  poshalo,masshalo
      write(uboddump)  eradiate,trad,meanmwt,     &
   mhboltz,fhydrogn,mumhkbol,mumhkgam, &
   mumhkg1,efuvheat,eradcool,mcold,mluke,mwarm,mhot,estar, &
   heatconst,densconst,timescale,lengthscale,velscale,flxscale, &
   massscale
      write(uboddump)  tstarform,tsnfeedback,snenergy,totptag
      write(uboddump)  h2time
      write(uboddump)  smoothuv
      write(uboddump)  tbh,nbh
      write(uboddump)  tpm,rcut,rcut2,pmsoft,pmdr,pmpot,       &
   pmacc
      write(uboddump)  searchpos,searchh,searchdelta,searchacc4,     &
   searchn,searchreuse,reuseflag,ncalls,nsearches
 write(uboddump) ( itimestp(i),i=1,nbodies) 
 write(uboddump) ( nbexist(i),i=1,nbodies) 
 write(uboddump) ( order_bodlist(i),i=1,nbodies) 
 write(uboddump) ( otimestp(i),i=1,nbodies) 
 write(uboddump) ( pactive(i),i=1,nbodies) 
 write(uboddump) ( acc(i,1:ndim),aacc(i),i=1,nbodies) 
 write(uboddump) ( csound(i),i=1,nsph) 
 write(uboddump) ( derad(i),i=1,nsph) 
 write(uboddump) ( dethdt(i),i=1,nsph) 
 write(uboddump) ( dethold(i),i=1,nsph) 
 write(uboddump) ( drhodh(i),i=1,nsph) 
 write(uboddump) ( elecfrac(i),i=1,nsph) 
 write(uboddump) ( epsgrav(i),i=1,nbodies) 
 write(uboddump) ( esnthdt(i),i=1,nsph) 
 write(uboddump) ( ethermal(i),i=1,nsph) 
 write(uboddump) ( ethold(i),i=1,nsph) 
 write(uboddump) ( fuvheat(i),i=1,nbodies) 
 write(uboddump) ( h2frac(i),i=1,nsph) 
 write(uboddump) ( hsmcurlv(i),i=1,nsph) 
 write(uboddump) ( hsmdivv(i),i=1,nsph) 
 write(uboddump) ( hsmooth(i),i=1,nbodies) 
 write(uboddump) ( mass(i),i=1,nbodies) 
 write(uboddump) ( mumaxdvh(i),i=1,nsph) 
 write(uboddump) ( oldderad(i),i=1,nsph) 
 write(uboddump) ( phi(i),i=1,nbodies) 
 write(uboddump) ( phiext(i),i=1,nbodies) 
 write(uboddump) ( pos(i,1:ndim),i=1,nbodies) 
 write(uboddump) ( rho(i),i=1,nsph) 
 write(uboddump) ( snentropy(i),i=1,nbodies) 
 write(uboddump) ( starfuv(i),i=1,nbodies) 
 write(uboddump) ( tcollaps(i),i=1,nsph) 
 write(uboddump) ( temperat(i),i=1,nsph) 
 write(uboddump) ( tfeedb(i),i=1,nbodies) 
 write(uboddump) ( tform(i),i=1,nbodies) 
 write(uboddump) ( tvel(i),i=1,nbodies) 
 write(uboddump) ( vdisp(i),i=1,nsph) 
 write(uboddump) ( vel(i,1:ndim),i=1,nbodies) 
 write(uboddump) ( veltpos(i,1:ndim),i=1,nsph) 
 close(uboddump) 
end subroutine

subroutine readdump(n) 
 include 'globals.h' 
 integer ioerror,n,i,idummy,idummy2
 real dummy 
 logical ldummy
 open(unit=uboddump,file=dumpfile,status='OLD',form='UNFORMATTED',iostat=ioerror) 
 if(ioerror.NE.0) then 
 print*,' dump file not present' 
 stop 
 endif 

read(uboddump) n 

      read(uboddump)  output,firstsnap,stepout,steplog,verbosity,       &
   datadir,inputfile,outputfile,halofile
      read(uboddump)  pboxsize,usesph,radiate,starform,cosmo
      read(uboddump)  unitl_in_kpc,unitm_in_msun
      read(uboddump)  dtime,tstepcrit,tstpcr2,freev,freea,freevexp,   &
   freeaexp,nsteps,max_tbin,minppbin,sqrttstp,acc_tstp, &
   freetstp
      read(uboddump)  bh_tol,eps,gdgtol,nn_tol,targetnn,usequad,         &
   directsum,selfgrav,fixthalo,adaptive_eps,gdgop
      read(uboddump)  epsgas,gamma,alpha,beta,epssph,courant,removgas, &
   consthsm,nsmtol,nsmooth,smoothinput,consph,sphinit,uentropy, &
   isotherm,eps_is_h,mingaseps,balsara,hupdatemethod,sph_visc
      read(uboddump)  graineff,crionrate,heat_par1,heat_par2,cool_par,    &
   optdepth
      read(uboddump)  comove
      read(uboddump)  tcollfac,masscrit,sfeff,tbubble,sne_eff,tsnbeg,   &
   rhomax,sfmode,feedback
      read(uboddump)  rndtable,rnseed
      read(uboddump)  nbodies,nsnap
      read(uboddump)  rmin,rsize,incells,incellsg
      read(uboddump)  root
      read(uboddump)  nttot,ntmin,ntmax,ntavg,nttotfuv,ntminfuv,        &
   ntmaxfuv,ntavgfuv
      read(uboddump)  nstot,nsmin,nsmax,nsavg
      read(uboddump)  tnow,tpos
      read(uboddump)  tiny
      read(uboddump)  mtot,etot,ektot,eptot,mstar,mgas,snheat,esofttot, &
   enerror,amvec,cmpos,cmvel
      read(uboddump)  input
      read(uboddump)  npactive,nsphact
      read(uboddump)  etol,dummy,tsteppos,active_bin
      read(uboddump)  syncflag,entropyflag
      read(uboddump)  teth,ethtot
      read(uboddump)  symmetry
      read(uboddump)  dummy,dummy,gamma1,nstar,nsph
      read(uboddump)  massres
      read(uboddump)  deldr2i
      read(uboddump)  wsmooth,dwsmooth
      read(uboddump)  nntot,nnmin,nnmax,nnavg
      read(uboddump)  hboxsize
      read(uboddump)  poshalo,masshalo
      read(uboddump)  eradiate,trad,meanmwt,     &
   mhboltz,fhydrogn,mumhkbol,mumhkgam, &
   mumhkg1,efuvheat,eradcool,mcold,mluke,mwarm,mhot,estar, &
   heatconst,densconst,timescale,lengthscale,velscale,flxscale, &
   massscale
      read(uboddump)  tstarform,tsnfeedback,snenergy,totptag
      read(uboddump)  h2time
      read(uboddump)  smoothuv
      read(uboddump)  tbh,nbh
      read(uboddump)  tpm,rcut,rcut2,pmsoft,pmdr,pmpot,       &
   pmacc
      read(uboddump)  searchpos,searchh,searchdelta,searchacc4,     &
   searchn,searchreuse,reuseflag,ncalls,nsearches
 read(uboddump) ( itimestp(i),i=1,nbodies) 
 read(uboddump) ( nbexist(i),i=1,nbodies) 
 read(uboddump) ( order_bodlist(i),i=1,nbodies) 
 read(uboddump) ( otimestp(i),i=1,nbodies) 
 read(uboddump) ( pactive(i),i=1,nbodies) 
 read(uboddump) ( acc(i,1:ndim),aacc(i),i=1,nbodies) 
 read(uboddump) ( csound(i),i=1,nsph) 
 read(uboddump) ( derad(i),i=1,nsph) 
 read(uboddump) ( dethdt(i),i=1,nsph) 
 read(uboddump) ( dethold(i),i=1,nsph) 
 read(uboddump) ( drhodh(i),i=1,nsph) 
 read(uboddump) ( elecfrac(i),i=1,nsph) 
 read(uboddump) ( epsgrav(i),i=1,nbodies) 
 read(uboddump) ( esnthdt(i),i=1,nsph) 
 read(uboddump) ( ethermal(i),i=1,nsph) 
 read(uboddump) ( ethold(i),i=1,nsph) 
 read(uboddump) ( fuvheat(i),i=1,nbodies) 
 read(uboddump) ( h2frac(i),i=1,nsph) 
 read(uboddump) ( hsmcurlv(i),i=1,nsph) 
 read(uboddump) ( hsmdivv(i),i=1,nsph) 
 read(uboddump) ( hsmooth(i),i=1,nbodies) 
 read(uboddump) ( mass(i),i=1,nbodies) 
 read(uboddump) ( mumaxdvh(i),i=1,nsph) 
 read(uboddump) ( oldderad(i),i=1,nsph) 
 read(uboddump) ( phi(i),i=1,nbodies) 
 read(uboddump) ( phiext(i),i=1,nbodies) 
 read(uboddump) ( pos(i,1:ndim),i=1,nbodies) 
 read(uboddump) ( rho(i),i=1,nsph) 
 read(uboddump) ( snentropy(i),i=1,nbodies) 
 read(uboddump) ( starfuv(i),i=1,nbodies) 
 read(uboddump) ( tcollaps(i),i=1,nsph) 
 read(uboddump) ( temperat(i),i=1,nsph) 
 read(uboddump) ( tfeedb(i),i=1,nbodies) 
 read(uboddump) ( tform(i),i=1,nbodies) 
 read(uboddump) ( tvel(i),i=1,nbodies) 
 read(uboddump) ( vdisp(i),i=1,nsph) 
 read(uboddump) ( vel(i,1:ndim),i=1,nbodies) 
 read(uboddump) ( veltpos(i,1:ndim),i=1,nsph) 
 close(uboddump) 
end subroutine

module rndmod

 integer, parameter :: nrndtable=2048
 real :: rndtable(nrndtable)

contains

! simple code for random number sequences
! from numerical recipes..
function ranfb(ix)
  real :: y,ranfb
  integer :: ix,ix1,ix2,ia1,ia2,ic,j1,j2,j3

  ia1=273
  ia2=25301
  ic=226908345
  
  if (ix.lt.0) ix=-ix
  if (ix.gt.2**30) ix=MOD(ix,2**30)

  ix1=ix/(2**15)
  ix2=ix-ix1*(2**15)
  j1=MOD(ix1*ia2,2**15)*2**15
  j2=MOD(ix2*ia1,2**15)*2**15
  j3=ix2*ia2
  ix=MOD(j1+j2,2**30)
  ix=MOD(ix+j3,2**30)
  ix=MOD(ix+ic,2**30)
  y=FLOAT(ix)

  ranfb=y/2**30

end function

end module

subroutine setRND(rnseed)
  use rndmod
  integer i,rnseed
  do i=1,nrndtable
    rndtable(i)=ranfb(rnseed)
  enddo
end subroutine

function pRND(i)
  use rndmod
  real :: pRND
  integer :: i
  pRND=rndtable(mod(i,nrndtable)+1)
end function

module map_helpers  
  integer :: randomseed=45678910
  
  integer :: nmax=0

  real,allocatable :: gpos(:,:),radius(:),mass(:),opac(:)
  integer,allocatable :: pindex(:)
  
  integer :: nbod=0,firstfree=1
  
  logical :: searcheable=.FALSE.
  
  integer :: imsize(2)=(/640,480/)
  real :: width=1.
  real :: angle=45.
  real :: focus(3) = (/ 0.,0.,0. /)
  real :: viewpoint(3) = (/ 0.,1.,0. /)
  real :: direction(3)=(/ 0.,-1.,0. /)
  real :: upvector(3)=(/ 0.,0.,1. /)
  integer :: ext=0
  real :: zm=0.001
  character(len=11) :: projection_mode="parallel"
  
  
contains

subroutine reallocate_arrays(n)
  integer :: n,test
  real,allocatable :: gpos_(:,:),radius_(:),mass_(:),opac_(:)
  integer,allocatable :: pindex_(:)

  if(nbod.GT.0) then
    if(.not.allocated(gpos)) call terror("mem alloc impossible error 1")
    allocate(gpos_(nbod,3),radius_(nbod),mass_(nbod),opac_(nbod),pindex_(nbod),stat=test)
    if(test.NE.0) call terror('mem alloc error')
    gpos_(1:nbod,1:3)=gpos(1:nbod,1:3)
    radius_(1:nbod)=radius(1:nbod)
    mass_(1:nbod)=mass(1:nbod)
    opac_(1:nbod)=opac(1:nbod)
    pindex_(1:nbod)=pindex(1:nbod)
  endif
    if(allocated(gpos)) deallocate(gpos,radius,mass,opac,pindex)
    allocate(gpos(n,3),radius(n),mass(n),opac(n),pindex(n),stat=test)
    if(test.NE.0) call terror('mem alloc error')
  if(nbod.GT.0) then
    gpos(1:nbod,1:3)=gpos_(1:nbod,1:3)
    radius(1:nbod)=radius_(1:nbod)
    mass(1:nbod)=mass_(1:nbod)
    opac(1:nbod)=opac_(1:nbod)
    pindex(1:nbod)=pindex_(1:nbod)
    deallocate(gpos_,radius_,mass_,opac_,pindex_)
  endif  
  nmax=n
end subroutine

function map_init() result(ret)
  integer :: ret
  ret=-1
  if(projection_mode.EQ."parallel") then
    call map_init_parallel_projection()
    ret=0
  else
    if(projection_mode.EQ."perspective") call map_init_perspective_projection()
    ret=0
  endif
end function

subroutine map_init_parallel_projection()
  use makemapmod
  call InitMap(imsize,width,focus,direction,upvector,0,ext,zm)  
end subroutine

subroutine map_init_perspective_projection()
  use makemapmod
  call InitMap(imsize,angle,focus,viewpoint,upvector,1,ext,zm)  
end subroutine

subroutine map_generate_projection()
  use makemapmod
  call setRND(randomseed)
  call clean_array()
  call project(nbod,gpos,radius,mass,opac,pindex)
end subroutine

subroutine map_reset()
  use makemapmod
  call EndMap()
end subroutine

subroutine map_erase()
  use makemapmod
  call EraseMap()
end subroutine

subroutine clean_array()
  integer :: n,i
  n=0
  i=0
  do while(n.LT.nbod)
    i=i+1
    if(mass(i).GE.0) then
      n=n+1
      mass(n)=mass(i)
      gpos(n,1:3)=gpos(i,1:3)
      radius(n)=radius(i)
      opac(n)=opac(i)
      pindex(n)=pindex(i)
    endif
  enddo
  firstfree=nbod+1
  searcheable=.FALSE.
end subroutine

function add_particle(id,m,x,y,z,r,o,i) result(ret)
  integer ret
  integer id,i
  real :: m,x,y,z,r,o
   
  if(firstfree.GT.nmax) then
    call clean_array()
    if(firstfree.GT.nmax) then
        call reallocate_arrays(max(nmax*2,1024))
    endif
  endif
   
  gpos(firstfree,1)=x  
  gpos(firstfree,2)=y  
  gpos(firstfree,3)=z  
  mass(firstfree)=m
  radius(firstfree)=r
  opac(firstfree)=o
  pindex(firstfree)=i
  if(pindex(firstfree).LT.0) pindex(firstfree)=firstfree
  id=pindex(firstfree)

  firstfree=firstfree+1
  nbod=nbod+1
   
  searcheable=.FALSE.
   
  ret=0
 end function

function set_particle_state(id,m,x,y,z,r,o) result(ret)
  integer ret
  integer id,index
  real :: m,x,y,z,r,o

  index=map_find_particle(id,nbod,pindex)
  if(index.LT.0) then
    ret=index
    return
  endif  

  gpos(index,1)=x  
  gpos(index,2)=y  
  gpos(index,3)=z  
  mass(index)=m
  radius(index)=r
  opac(index)=o
   
  ret=0
 end function

function set_particle_weight(id,m) result(ret)
  integer ret
  integer id,index
  real :: m

  index=map_find_particle(id,nbod,pindex)
  if(index.LT.0) then
    ret=index
    return
  endif  

  mass(index)=m
   
  ret=0
end function

function set_particle_opacity_area(id,m) result(ret)
  integer ret
  integer id,index
  real :: m

  index=map_find_particle(id,nbod,pindex)
  if(index.LT.0) then
    ret=index
    return
  endif  

  opac(index)=m
   
  ret=0
end function

function get_particle_state(id,m,x,y,z,r,o) result(ret)
  integer ret
  integer id,index
  real :: m,x,y,z,r,o

  index=map_find_particle(id,nbod,pindex)
  if(index.LT.0) then
    ret=index
    return
  endif  

  x=gpos(index,1)
  y=gpos(index,2)  
  z=gpos(index,3)  
  m=mass(index)
  r=radius(index)
  o=opac(index)
   
  ret=0
end function

function map_remove_particle(id) result(ret)
  integer :: id
  integer :: index,ret

  index=map_find_particle(id,nbod,pindex)
  if(index.LT.0) then
    ret=index
    return
  endif  

  mass(index)=-1
  nbod=nbod-1

  ret=0
end function

function map_find_particle(id,n,ids) result(p)
  use hashMod
  integer :: id,n,p,ids(*)
  integer, save :: nsearch
  
  p=-1
  
  if(.not.searcheable) then
    call clean_array()
    nsearch=n
    if(n.GT.0) call initHash(nsearch/2+1,nsearch,ids) 
    searcheable=.TRUE.
  endif  
   
  if(n.GT.0) p=find(id,ids)

end function

subroutine map_set_projection_mode(x)
  character(len=15), intent(in) :: x
  projection_mode=x
end subroutine
subroutine map_get_projection_mode(x)
  character(len=15), intent(out) :: x
  x=projection_mode
end subroutine


function map_set_random_seed(rs) result(ret)
  integer :: rs,ret
  randomseed=rs
  ret=0
end function 

function map_get_random_seed(rs) result(ret)
  integer :: rs,ret
  rs=randomseed
  ret=0
end function 

subroutine map_set_zm(x)
  real :: x
  zm=x
end subroutine
subroutine map_get_zm(x)
  real :: x
  x=zm
end subroutine

subroutine map_set_ext(x)
  integer :: x
  ext=x
end subroutine
subroutine map_get_ext(x)
  integer :: x
  x=ext
end subroutine

subroutine map_set_angle(x)
  real :: x
  angle=x
end subroutine
subroutine map_get_angle(x)
  real :: x
  x=angle
end subroutine

subroutine map_set_width(x)
  real :: x
  width=x
end subroutine
subroutine map_get_width(x)
  real :: x
  x=width
end subroutine

subroutine map_set_imsize(nx,ny)
  integer :: nx,ny
  imsize(1)=nx
  imsize(2)=ny
end subroutine
subroutine map_get_imsize(nx,ny)
  integer :: nx,ny
  nx=imsize(1)
  ny=imsize(2)
end subroutine

subroutine map_set_focus(x,y,z)
  real :: x,y,z
  focus(1)=x
  focus(2)=y
  focus(3)=z
end subroutine
subroutine map_get_focus(x,y,z)
  real :: x,y,z
  x=focus(1)
  y=focus(2)
  z=focus(3)
end subroutine

subroutine map_set_viewpoint(x,y,z)
  real :: x,y,z
  viewpoint(1)=x
  viewpoint(2)=y
  viewpoint(3)=z
end subroutine
subroutine map_get_viewpoint(x,y,z)
  real :: x,y,z
  x=viewpoint(1)
  y=viewpoint(2)
  z=viewpoint(3)
end subroutine

subroutine map_set_direction(x,y,z)
  real :: x,y,z
  direction(1)=x
  direction(2)=y
  direction(3)=z
end subroutine
subroutine map_get_direction(x,y,z)
  real :: x,y,z
  x=direction(1)
  y=direction(2)
  z=direction(3)
end subroutine

subroutine map_set_upvector(x,y,z)
  real :: x,y,z
  upvector(1)=x
  upvector(2)=y
  upvector(3)=z
end subroutine
subroutine map_get_upvector(x,y,z)
  real :: x,y,z
  x=upvector(1)
  y=upvector(2)
  z=upvector(3)
end subroutine

function map_get_pic(i,j,pvalues,n) result(ret)
  use makemapMod
  integer :: ret,n,i(n),j(n),k
  real :: pvalues(n)
  
  if(any(i.LT.1).OR.any(i.GT.imsize(1)).OR.any(j.LT.1).OR.any(j.GT.imsize(2))) then
    ret=-1
    return
  endif  

  do k=1,n
    pvalues(k)=pic(i(k),j(k))
  enddo

  ret=0
  
end function

function map_get_opdepth(i,j,pvalues,n) result(ret)
  use makemapMod
  integer :: ret,n,i(n),j(n),k
  real :: pvalues(n)
    
  if(any(i.LT.1).OR.any(i.GT.imsize(1)).OR.any(j.LT.1).OR.any(j.GT.imsize(2))) then
    ret=-1
    return
  endif  

  do k=1,n
    pvalues(k)=opdepth(i(k),j(k))
  enddo

  ret=0
  
end function


end module

subroutine report(level,message)
  include 'globals.h'
  integer level
  character(len=*) message
  
  if(verbosity.GT.level) print*, message 

end subroutine


subroutine diagnostics
  include 'globals.h'
  integer :: i,p,k,nblist,nbwarm
  logical :: firstc
  real :: temp

  mgas=0. 
  mstar=0.
  mtot=0.
  ektot=0.
  eptot=0.
  ethtot=0.

  mcold=0.
  mluke=0.
  mwarm=0.
  mhot=0.

  cmpos(1:3)=0.
  cmvel(1:3)=0.
  amvec(1:3)=0.
  mgas=sum(mass(1:nsph))
  mstar=sum(mass(nbodies-nstar+1:nbodies))

  do p=1,nbodies
    mtot=mtot+mass(p)
    eptot=eptot+mass(p)*phiext(p)
  enddo

  if(selfgrav) then
    if(periodic) call terror('check pot. for periodic')
    do p=1,nbodies
      eptot=eptot+.5*mass(p)*phi(p)
    enddo
  endif  

  if(.NOT.isotherm) then
    do p=1,nsph
      ethtot=ethtot+mass(p)*csound(p)**2/(gamma*gamma1)
    enddo
  else
    do p=1,nsph
      ethtot=ethtot+mass(p)*csound(p)**2
    enddo
  endif
  
  do k=1,3
    do p=1,nbodies
      ektot=ektot+.5*mass(p)*vel(p,k)*vel(p,k)
      cmpos(k)=cmpos(k)+mass(p)*pos(p,k)
      cmvel(k)=cmvel(k)+mass(p)*vel(p,k)
    enddo
    cmvel(k)=cmvel(k)/mtot
    cmpos(k)=cmpos(k)/mtot
  enddo
  etot=ektot+eptot+ethtot
  if(ndim.EQ.2) then
    do p=1,nbodies
      amvec(3)=amvec(3)+mass(p)*(pos(p,1)*vel(p,2)-pos(p,2)*vel(p,1))
    enddo
  endif
  if(ndim.EQ.3) then
    do p=1,nbodies
      amvec(1)=amvec(1)+mass(p)*(pos(p,2)*vel(p,3)-pos(p,3)*vel(p,2))
      amvec(2)=amvec(2)+mass(p)*(pos(p,3)*vel(p,1)-pos(p,1)*vel(p,3))
      amvec(3)=amvec(3)+mass(p)*(pos(p,1)*vel(p,2)-pos(p,2)*vel(p,1))
    enddo
  endif

  do p=1,nsph
    temp=meanmwt*mhboltz*csound(p)**2/gamma
    if(temp.LT.1000) mcold=mcold+mass(p)
    if(temp.GE.3.e4) mhot=mhot+mass(p)
    if(temp.LT.3.e4.AND.temp.GE.8000) mwarm=mwarm+mass(p)
  enddo
  mluke=mgas-mcold-mwarm-mhot
  if(verbosity.GT.0) print*,'<energy>',tnow,etot
end subroutine

subroutine outstate(n)
  include 'globals.h'
  logical :: testcrit
  integer :: n,ioerror,sstatus
  real :: dumpt,tend,tstep,tcurrent
  real :: rtime
  character(len=4) sstring
  real, save :: tlastdump=0.,tprevious=0.
  
  tcurrent=rtime()
  if(tcurrent.lt.tprevious) then
    print*,' timer error (overflow) tcurrent:', tcurrent, ', tprevious:', tprevious
    tprevious = 0.
    return
  endif          
  tstep=tcurrent-tprevious
  tprevious=tcurrent

  sstatus=-1
  open(unit=upars,file='stop',status='OLD',iostat=ioerror)
  if(ioerror.EQ.0) then
    read(upars,'(a)',iostat=ioerror) sstring
    if(ioerror.EQ.0) then
      if(sstring.EQ.'exit') sstatus=3
      if(sstring.EQ.'stop') sstatus=2
      if(sstring.EQ.'snap') sstatus=1
      if(sstring.EQ.'dump') then
        sstatus=0
        read(upars,*,iostat=ioerror) dumpt
        if(ioerror.NE.0) then
          dumpt=12.
          print*,'...assuming tdump of 12 hrs...'
        endif 
        read(upars,*,iostat=ioerror) tend
        if(ioerror.NE.0) tend=8760.
      endif 
    endif
    if(sstatus.GT.0) then
      rewind(upars)
      write(upars,'(a)') 'ok..',sstring
    endif
    close(upars)
  endif

  if(sstatus.EQ.0.AND.tcurrent.GT.tend-2*tstep) sstatus=3

  if(sstatus.EQ.0) then
    if(tcurrent-tlastdump.GT.dumpt-2*tstep) then
      call writedump(n)
      tlastdump=tcurrent
    endif
  endif

  if(sstatus.GE.2) call writedump(n)

  if(MOD(n,steplog).EQ.0.OR.MOD(n,stepout).EQ.0.OR. &
        sstatus.EQ.1.OR.sstatus.EQ.2) then

    call activateparts

    testcrit=MOD(n,stepout).EQ.0.OR.n.EQ.0.OR.sstatus.EQ.1.OR.sstatus.EQ.2
    call corrpos(itimestp,'sync')
    if(n.NE.0) then
      call zeropot
      call gravity('pot ')
    endif

    if(MOD(n,steplog).EQ.0) then 
      call outlog(n)
      call diagnostics
      call outenrgy
    endif
    
    if(testcrit) call outbods('XXXXXX')
    call corrpos(itimestp,'desync')
  endif
   
  if(sstatus.GE.2) then
    print*,' stopped as requested'
    stop
  endif
end subroutine

module StarsMod
 implicit none
 private
 public:: InitStars,FUV,dFUV,nbandsQ,mbands,Ha,axavQ,Nlya

! call subroutine InitStars before use
! FUV(t): far UV in erg/sec/Msolar of initial mass for t in years
! dFUV(t) far UV corrected for absorption by parental cloud
! nbandsQ(): Queries number of colorbands read in
! mbands(): gives luminosities in UBV.. in 10^magnitude/Msolar ? 
! Ha(): halpha flux in erg/sec/Msolar/ Lya->Ha factor
! Nlya(): Ly a continuum in # photons/sec (yr?)/Msol
 character(len=30) :: Stellarpropertiesfile
 character(len=30) :: modelprefix='ssp_salp_' ! single stellar burst
                                              ! salpeter IMF

 integer, save :: nbands,ntimetable
 real, allocatable,save :: axav(:)
 real, allocatable,save :: timetable(:),bands(:,:)
 real, allocatable,save :: bolometric(:),farUV(:), &
                           mass(:),snr(:),halpha(:),lya(:) 
 character(len=200),save :: datadir

 real, parameter :: tdark=4.e6
 real, parameter :: obscuration=.75

 logical, parameter :: debug=.FALSE.

 contains

subroutine InitStars(indatadir,Z)
 character :: dummy
 character(len=200) :: indatadir
 real, optional :: Z ! Z=Zsolar=0.02
 integer :: i,j

 datadir=indatadir
 if(allocated(axav)) then
   print*, '** warning Starsmod already initialized **'
   return
 endif
 Stellarpropertiesfile=trim(modelprefix)//'z02'//'.starmodel'
 if(present(Z)) then 
  if(Z.LE.0.0002)  &
   Stellarpropertiesfile=trim(modelprefix)//'z0001'//'.starmodel'
  if(Z.GT.0.0002.AND.Z.LE.0.001) &
   Stellarpropertiesfile=trim(modelprefix)//'z0004'//'.starmodel'
  if(Z.GT.0.001.AND.Z.LE.0.006) &
   Stellarpropertiesfile=trim(modelprefix)//'z004'//'.starmodel'
  if(Z.GT.0.006.AND.Z.LE.0.015) &
   Stellarpropertiesfile=trim(modelprefix)//'z008'//'.starmodel'
  if(Z.GT.0.015.AND.Z.LE.0.03) &
   Stellarpropertiesfile=trim(modelprefix)//'z02'//'.starmodel'
  if(Z.GT.0.03.AND.Z.LE.0.075) &
   Stellarpropertiesfile=trim(modelprefix)//'z05'//'.starmodel'
  if(Z.GT.0.075) &
   Stellarpropertiesfile=trim(modelprefix)//'z10'//'.starmodel'
 endif ! these are somewhat subjective limits!

 write(*,*) ' > starcluster model: ',Stellarpropertiesfile
 open(unit=19,file=trim(datadir)//Stellarpropertiesfile,status='old')
 
 read(19,*) nbands
 allocate(axav(nbands))
 read(19,*) (axav(i),i=1,nbands)
 read(19,*) ntimetable
 allocate(bands(ntimetable,nbands),bolometric(ntimetable),     &
          farUV(ntimetable),mass(ntimetable),snr(ntimetable),  &
          timetable(ntimetable),halpha(ntimetable),lya(ntimetable))
 read(19,*) dummy
 do i=1,ntimetable
 read(19,*) timetable(i), (bands(i,j),j=1,nbands),bolometric(i), &
            farUV(i),mass(i),snr(i),lya(i)
 enddo
 close(19)
 farUV=10**farUV
 bands=10**(-.4*bands)
 halpha=10**(lya-11.52)
 lya=10**lya
 
end subroutine

function mbands(t) result(x)
 real :: t,x(nbands),dt
 integer :: ntime
 call findtbin(t,dt,ntime)
  x=bands(ntime,1:nbands)+dt*(bands(ntime+1,1:nbands)-bands(ntime,1:nbands))
end function 

function dFUV(t) result(x)
 real :: t,x,obsc
 obsc=0.
 if(t.lt.tdark) obsc=obscuration*(1-t/tdark)
 if(t.lt.0) obsc=obscuration
 x=FUV(t)*(1.-obsc)
end function 

function FUV(t) result(x)
 real :: t,x,dt
 integer :: ntime
 call findtbin(t,dt,ntime)
 x=farUV(ntime)+dt*(farUV(ntime+1)-farUV(ntime))
end function

function Ha(t) result(x)
 real :: t,x,dt
 integer :: ntime
 call findtbin(t,dt,ntime)
 x=halpha(ntime)+dt*(halpha(ntime+1)-halpha(ntime))
end function

function Nlya(t) result(x)
 real :: t,x,dt
 integer :: ntime
 call findtbin(t,dt,ntime)
 x=lya(ntime)+dt*(lya(ntime+1)-lya(ntime))
end function

function nbandsQ() result(x)
 integer :: x
 x=nbands
end function

function axavQ(i) result(x)
 integer :: i
 real :: x
 x=axav(i)
end function


subroutine findtbin(t,dt,ntime)
 real,intent(inout) :: t
 real,intent(out) :: dt
 integer, intent(out) :: ntime
 integer :: ntime1,itime
 
 if(debug) then
  if(t.lt.timetable(1).OR.t.gt.timetable(ntimetable)) print*,' starprop:',t
 endif 
 
 t=max(timetable(1),t)
 t=min(timetable(ntimetable),t)
 
 ntime=1
 ntime1=ntimetable 
 do while((ntime1-ntime).GT.1)
  itime=(ntime+ntime1)/2
  if(t.GT.timetable(itime)) then
   ntime=itime  
  else
   ntime1=itime
  endif
 enddo
 dt=(t-timetable(ntime))/(timetable(ntime1)-timetable(ntime))
end subroutine


end module

!program test
! use StarsMod
! real t,ff
! character(len=200) :: indatadir

! indatadir="/home/pelupes/fish/stars/data/"
! call InitStars(indatadir)
 
!10 read*,t
! if(t.eq.0) stop
! ff=FUV(t)
! print*,t,ff
! goto 10 
!end program

subroutine basicinput
 include 'globals.h'
 character*24 filenaam
 integer i,mapnr,nfeedback
 real,allocatable :: weights(:)
 
 call set_parameters(0)

 print*,'filenaam?'
 read*,filenaam

 call readbods(filenaam)

 call heattabel
        
 call initpars

 if(periodic) call initbc

 call initnewstar

 if(usepm) then
  if(verbosity.GT.0) print*,' ...initPM...'
  call initpm
 endif

 call postprocessread

end subroutine

program snapreader
 use StarsMod
 use ionMod
 use sphray_io_mod
 include 'globals.h'
 integer i,p,nsources
 real timefac,starage,ltot,lout,l
 real ttemp,temp,xelec,nh,xh,xhe1,xhe2
 real,save ::xhii(nsphmax),xheii(nsphmax),xheiii(nsphmax)
 real(kind=4),save :: rblock(nsphmax)
 integer(kind=4),save :: iblock(nsphmax)
 integer(kind=8),save :: iblock2(nsphmax)
 real codemass,codevel
 integer*8,save :: ids(nsphmax)
 type(sphray_snap_type) :: s
 character*200 :: outfilename

 real hboxl,maxx,minx

 call initmem(nbodsmax,nsphmax,ncells)
 call basicinput

 do p=1,nsph 
  ttemp=temperat(p)
  nh=densconst*rho(p)
  call Ionh(ttemp,temp,xelec,xh,xhe1,xhe2,nh,crionrate)
  xhii(p)=xh
  xheii(p)=xhe1
  xheiii(p)=xhe2
!  print*, temperat(p),temp,elecfrac(p),xelec
 enddo

 timefac=timescale/year
 ltot=0
 lout=0
 nsources=0
 print*,'writing GABE sources'
 open(unit=1,file='sources.raw',status='unknown')
 do p=nbodies-nstar+1,nbodies 
  starage=(tnow-tform(p))*timefac
  l=Nlya(starage)*unitm_in_msun*mass(p)
  if(starage.LT.3.e7) then 
   nsources=nsources+1
   write(1,'( 4g16.6 )') pos(p,1:3), l
   lout=lout+l
  endif
  ltot=ltot+l 
 enddo
 close(1)
 write(*,'("wrote ",i," sources with ",g8.2," of total luminosity")'),nsources,lout/ltot

    print*, 'convert to GABE unit'

    s%CGSlen=3.08568e21 
    s%CGSlum=3.826e33
    s%CGStime=3.1556926e14
    codemass=s%CGSlum * s%CGStime**3/ s%CGSlen**2
    codevel=s%CGSlen/s%CGStime
    print*, 'massunit (msol):', codemass/solarmass 
    print*, 'velunit (km/s):', codevel/1.e5 
    print*, 'length unit (kpc):',s%CGSlen/kpc

    mass(1:nsph)=mass(1:nsph)*unitm_in_msun*solarmass/codemass
    pos(1:nsph,1:3)=pos(1:nsph,1:3)*unitl_in_kpc/s%CGSlen*kpc
    hsmooth(1:nsph)=hsmooth(1:nsph)*unitl_in_kpc/s%CGSlen*kpc
    rho(1:nsph)=rho(1:nsph)*unitm_in_msun*solarmass/codemass &
                 /unitl_in_kpc**3*s%CGSlen**3/kpc**3
    vel(1:nsph,1:3)=vel(1:nsph,1:3)*velscale/codevel
    ids(1:nsph)=nbexist(1:nsph)
    tnow=tnow*timescale/s%CGStime

    maxx=maxval(pos(1:nsph,1:3))
    minx=minval(pos(1:nsph,1:3))

    hboxl=max(maxx,abs(minx))

!    phead%int(1:7)%name=i_header_variable_names(1:7)
!    phead%real(1:21)%name=r_header_variable_names(1:21)

 s%NparSnap=nsph
 s%NparFile=nsph
 s%Nfiles=1
 s%NsphNbrs=nsmooth
 s%RayBCs=0
 if(periodic) s%RayBCS=1
 s%OnTheSpot=0
 s%NraysTraced=0

 s%Time=0
 s%IsoMass=0
 s%IsoTemp=0
 s%ScaleFac=1.
 s%BoxLow(1:3)=-hboxl
 s%BoxHigh(1:3)=hboxl
 s%OmegaM=0.3
 s%OmegaB=0.04
 s%OmegaL=0.7
 s%LittleH=0.7
 s%RecRayTol=0

 s%DataPresent=0
 s%DataPresent(1:9)=1
 s%DataPresent(10:11)=1
 s%DataPresent(12:14)=1
 s%DataPresent(18)=1
    
 call alloc_sphray_snapshot(s)
    
! convert to gadget smoothing lengths
    hsmooth(1:nsph)=2*hsmooth(1:nsph)    
    
    s%id(1:nsph)= ids(1:nsph)
    s%pos(1:nsph,1)=pos(1:nsph,1)
    s%pos(1:nsph,2)=pos(1:nsph,2)
    s%pos(1:nsph,3)=pos(1:nsph,3)
    s%vel(1:nsph,1)=vel(1:nsph,1)
    s%vel(1:nsph,2)=vel(1:nsph,2)
    s%vel(1:nsph,3)=vel(1:nsph,3)
    s%hsml(1:nsph)= hsmooth(1:nsph)
    s%rho(1:nsph)= rho(1:nsph)
    s%mass(1:nsph)= mass(1:nsph)
    s%T(1:nsph)= temperat(1:nsph)
    s%xHII(1:nsph)= xhii(1:nsph)
    s%xHeII(1:nsph)= xheii(1:nsph)
    s%xHeIII(1:nsph)= xheiii(1:nsph)
    s%lasthit(1:nsph)=0

    print*, 'writing GABE file'
    outfilename='gas_000.1'
    call write_sphray_snapshot(s,outfilename)
    
    print*, 'done'

end program

module HeatingMod
 implicit none
 private
 public :: crheat
 
 real, parameter :: sece = 35

contains

 function crheat_f1(x) result(f1)
  real :: x,f1
  f1=.9971*(1-(1-x**.2663)**1.3163)
 end function
 
 function crheat_f2(e) result(f2)
  real :: e,f2
  f2=2*e-13.6
 end function 
 
 function crheat_f3(x) result(f3)
  real :: x,logx,f3
  logx=log10(x)
  f3=-.265*(-2.37+logx)*(4.69+logx)*(15.62+7.21*logx+logx**2)
 end function
 
 function crheat(x)
  real :: crheat,x,xe
  xe=x 
  if(x.lt.5.e-5) xe=5.e-5
  if(x.gt.1) xe=1
  crheat=crheat_f1(xe)+1./(crheat_f2(sece)/crheat_f3(xe)+1./(1-crheat_f1(xe))) 
  crheat=crheat*sece
 end function
 
end module 

!program test
!use heatingMod
!real xe

!10 read*, xe
!   if(xe.eq.0) stop
!   print*, crheat(xe)
!   goto 10
   
!end program   

module sphray_io_mod
implicit none

public
public :: read_sphray_snapshot,write_sphray_snapshot,sphray_snap_type

integer, parameter, private :: i4b = selected_int_kind(9)       
integer, parameter, private :: i8b = selected_int_kind(18)      
integer, parameter, private :: r4b  = selected_real_kind(6,37)  
integer, parameter, private :: r8b  = selected_real_kind(15,307)
integer, parameter, private :: taglen = 24
integer, parameter, private :: NdataBlocks = 30
integer, parameter, private :: NheadEntries = 25

  ! names of the header entries
  character(taglen), parameter :: Htags(NheadEntries) = &  
       (/ "NparSnap                ", "NparFile                ", &  ! 1,2
          "NumFiles                ", "NsphNeighbors           ", &  ! 3,4
          "RayBoundaryConditions   ", "OnTheSpot               ", &  ! 5,6
          "TotalRaysTraced         ", "Time                    ", &  ! 7,1
          "IsoMass                 ", "IsoTemperature          ", &  ! 2,3
          "ScaleFactor             ", "BoxLowX                 ", &  ! 4,5
          "BoxLowY                 ", "BoxLowZ                 ", &  ! 6,7
          "BoxHighX                ", "BoxHighY                ", &  ! 8,9
          "BoxHighZ                ", "CodeLenINcm             ", &  ! 10,11
          "CodeLumINergs           ", "CodeTimeINs             ", &  ! 12,13 
          "OmegaMatter             ", "OmegaBaryon             ", &  ! 14,15
          "OmegaLambda             ", "LittleHubble            ", &  ! 16,17
          "RecombRayTolerance      " /)                              ! 18

  ! names of the possible snapshot data fields
  character(taglen), parameter :: Dtags(NdataBlocks) = &  
       (/ "id                      ", "xpos                    ", &  ! 1,2
          "ypos                    ", "zpos                    ", &  ! 3,4
          "xvel                    ", "yvel                    ", &  ! 5,6
          "zvel                    ", "hsml                    ", &  ! 7,8
          "rho                     ", "mass                    ", &  ! 9,10
          "temperature             ", "xHII                    ", &  ! 11,12
          "xHeII                   ", "xHeIII                  ", &  ! 13,14
          "xHIIrc                  ", "xHeIIrc                 ", &  ! 15,16
          "xHeIIIrc                ", "lasthit                 ", &  ! 17,18
          "undefined               ", "undefined               ", &  ! 19,20
          "undefined               ", "undefined               ", &  ! 21,22
          "undefined               ", "undefined               ", &  ! 23,24
          "undefined               ", "undefined               ", &  ! 25,26
          "undefined               ", "undefined               ", &  ! 27,28
          "undefined               ", "undefined               " /)  ! 29,30


  
type sphray_snap_type
! header entries
 integer(i8b) :: NparSnap
 integer(i8b) :: NparFile
 integer(i8b) :: Nfiles
 integer(i8b) :: NsphNbrs
 integer(i8b) :: RayBCs
 integer(i8b) :: OnTheSpot
 integer(i8b) :: NraysTraced

 real(r8b) :: Time
 real(r8b) :: IsoMass
 real(r8b) :: IsoTemp
 real(r8b) :: ScaleFac
 real(r8b) :: BoxLow(3)
 real(r8b) :: BoxHigh(3)
 real(r8b) :: CGSlen
 real(r8b) :: CGSlum
 real(r8b) :: CGStime
 real(r8b) :: OmegaM
 real(r8b) :: OmegaB
 real(r8b) :: OmegaL
 real(r8b) :: LittleH
 real(r8b) :: RecRayTol

 integer(i4b) :: DataPresent(30)
 
! data blocks
 integer(i8b), allocatable :: id(:)    !< particle id
 real(r4b), allocatable    :: pos(:,:) !< x,y,z coordinates
 real(r4b), allocatable    :: vel(:,:) !< x,y,z velocities
 real(r4b), allocatable    :: hsml(:)  !< smoothing length
 real(r4b), allocatable    :: rho(:)   !< density = mass * NsphNnb / hsml^3 
 real(r4b), allocatable    :: mass(:)  !< particle mass
 real(r4b), allocatable    :: T(:)     !< temperature in K       
 real(r4b), allocatable    :: xHII(:)  !< HII ionization fraction
 real(r4b), allocatable    :: xHeII(:) !< HeII ionization fraction
 real(r4b), allocatable    :: xHeIII(:)   !< HeIII ionization fraction
 real(r4b), allocatable    :: xHIIrc(:)   !< HII recombination fraction
 real(r4b), allocatable    :: xHeIIrc(:)  !< HeII recombination fraction
 real(r4b), allocatable    :: xHeIIIrc(:) !< HeIII recombination fraction
 integer(i8b), allocatable :: lasthit(:)  !< last ray to cross this particle

end type

contains

subroutine read_sphray_snapshot(s,file)
  type(sphray_snap_type) :: s
  integer, parameter :: lun = 28
  character(200), optional :: file
  character(200) :: snapfile
  integer :: i
  integer(i8b) :: Npar
  character(taglen) :: tag

  if(present(file)) then
   snapfile=file
  else 
   write(*,*) "enter snapshot file to read:"
   read(*,"(A)") snapfile
  endif
  
  write(*,*) "reading ", trim(snapfile)
  open(unit=lun,file=snapfile,status="old",form="unformatted")
  read(lun) tag, &
            tag, s%NparSnap,    tag, s%NparFile,   tag, s%Nfiles, &
            tag, s%NsphNbrs,    tag, s%RayBCs,     tag, s%OnTheSpot,  &
            tag, s%NraysTraced, tag, s%Time,       tag, s%IsoMass,    &
            tag, s%IsoTemp,     tag, s%ScaleFac,   tag, s%BoxLow(1),  &
            tag, s%BoxLow(2),   tag, s%BoxLow(3),  tag, s%BoxHigh(1), &
            tag, s%BoxHigh(2),  tag, s%BoxHigh(3), tag, s%CGSlen,     &
            tag, s%CGSlum,      tag, s%CGStime,    tag, s%OmegaM,     &
            tag, s%OmegaB,      tag, s%OmegaL,     tag, s%LittleH,    &
            tag, s%RecRayTol, s%DataPresent
  
  
  do i = 1,18
     if (s%DataPresent(i) .EQ. 1) then
        write(*,*) Dtags(i), " present"
     else if (s%DataPresent(i) .EQ. 0) then
        write(*,*) Dtags(i), " absent"
     end if
  end do
  Npar = s%NparSnap

  write(*,*) "Npar = ", Npar
 
  if (s%DataPresent(1)) then
     allocate(s%id(Npar))
     read(lun) tag,s%id
     write(*,*) "min/max id = ", minval(s%id), maxval(s%id)
  end if
  
  if (s%DataPresent(2)) then
     allocate(s%pos(Npar,3))
     read(lun) tag, s%pos(:,1)
     read(lun) tag, s%pos(:,2)
     read(lun) tag, s%pos(:,3)
     write(*,*) "min/max pos = ", minval(s%pos), maxval(s%pos)
  end if
  
  if (s%DataPresent(5)) then
     allocate(s%vel(Npar,3))
     read(lun) tag, s%vel(:,1)
     read(lun) tag, s%vel(:,2)
     read(lun) tag, s%vel(:,3)
     write(*,*) "min/max vel = ", minval(s%vel), maxval(s%vel)
  end if
  
  if (s%DataPresent(8)) then
     allocate(s%hsml(Npar))
     read(lun) tag, s%hsml
     write(*,*) "min/max hsml = ", minval(s%hsml), maxval(s%hsml)
  end if
  
  if (s%DataPresent(9)) then
     allocate(s%rho(Npar))
     read(lun) tag, s%rho
     write(*,*) "min/max rho = ", minval(s%rho), maxval(s%rho)
  end if
  
  if (s%DataPresent(10)) then
     allocate(s%mass(Npar))
     read(lun) tag, s%mass
     write(*,*) "min/max mass = ", minval(s%mass), maxval(s%mass)
  end if
  
  if (s%DataPresent(11)) then
     allocate(s%T(Npar))
     read(lun) tag, s%T
     write(*,*) "min/max T = ", minval(s%T), maxval(s%T)
  end if
  
  if (s%DataPresent(12)) then
     allocate(s%xHII(Npar))
     read(lun) tag, s%xHII
     write(*,*) "min/max xHII = ", minval(s%xHII), maxval(s%xHII)
  end if
  
  if (s%DataPresent(13)) then
     allocate(s%xHeII(Npar))
     read(lun) tag, s%xHeII
     write(*,*) "min/max xHeII = ", minval(s%xHeII), maxval(s%xHeII)
  end if
  
  if (s%DataPresent(14)) then
     allocate(s%xHeIII(Npar))
     read(lun) tag, s%xHeIII
     write(*,*) "min/max xHeIII = ", minval(s%xHeIII), maxval(s%xHeIII)
  end if
  
  if (s%DataPresent(15)) then
     allocate(s%xHIIrc(NPar))
     read(lun) tag, s%xHIIrc
     write(*,*) "min/max xHIIrc = ", minval(s%xHIIrc), maxval(s%xHIIrc)
  end if
  
  if (s%DataPresent(16)) then
     allocate(s%xHeIIrc(Npar))
     read(lun) tag, s%xHeIIrc
     write(*,*) "min/max xHeIIrc = ", minval(s%xHeIIrc), maxval(s%xHeIIrc)
  end if
  
  if (s%DataPresent(17)) then
     allocate(s%xHeIIIrc(Npar))
     read(lun) tag, s%xHeIIIrc
     write(*,*) "min/max xHeIIIrc = ", minval(s%xHeIIIrc), maxval(s%xHeIIIrc)
  end if
  
  if (s%DataPresent(18)) then
     allocate(s%lasthit(Npar))
     read(lun) tag, s%lasthit
     write(*,*) "min/max lasthit = ", minval(s%lasthit), maxval(s%lasthit) 
  end if
  
end subroutine read_sphray_snapshot
 

! writes whatever is loaded into the variables in this module into a 
! snapshot. 
subroutine write_sphray_snapshot(s,file)
 type(sphray_snap_type) :: s
 character(200),optional :: file
 character(200) :: newfile 
 integer(i8b) :: i
 character(taglen) :: tag

   if(present(file)) then
    newfile=file
   else 
    newfile = "this_is_a_new_sphray_snapshot_change_my_name.unf"
   endif
   
   open(unit=150,file=newfile,form="unformatted")

   tag = "header"
   write(150) tag, &
        Htags(1),  s%NparSnap,    Htags(2),  s%NparFile,   Htags(3),  s%Nfiles, &
        Htags(4),  s%NsphNbrs,    Htags(5),  s%RayBCs,     Htags(6),  s%OnTheSpot,  &
        Htags(7),  s%NraysTraced, Htags(8),  s%Time,       Htags(9),  s%IsoMass,    &
        Htags(10), s%IsoTemp,     Htags(11), s%ScaleFac,   Htags(12), s%BoxLow(1),  &
        Htags(13), s%BoxLow(2),   Htags(14), s%BoxLow(3),  Htags(15), s%BoxHigh(1), &
        Htags(16), s%BoxHigh(2),  Htags(17), s%BoxHigh(3), Htags(18), s%CGSlen,     &
        Htags(19), s%CGSlum,      Htags(20), s%CGStime,    Htags(21), s%OmegaM,     &
        Htags(22), s%OmegaB,      Htags(23), s%OmegaL,     Htags(24), s%LittleH,    &
        Htags(25), s%RecRayTol, s%DataPresent

   if (s%DataPresent(1)) write(150) Dtags(1), s%id 
   if (s%DataPresent(2)) write(150) Dtags(2), s%pos(:,1) 
   if (s%DataPresent(3)) write(150) Dtags(3), s%pos(:,2) 
   if (s%DataPresent(4)) write(150) Dtags(4), s%pos(:,3) 
   if (s%DataPresent(5)) write(150) Dtags(5), s%vel(:,1) 
   if (s%DataPresent(6)) write(150) Dtags(6), s%vel(:,2) 
   if (s%DataPresent(7)) write(150) Dtags(7), s%vel(:,3)
   if (s%DataPresent(8)) write(150) Dtags(8), s%hsml
   if (s%DataPresent(9)) write(150) Dtags(9), s%rho
   if (s%DataPresent(10)) write(150) Dtags(10), s%mass
   if (s%DataPresent(11)) write(150) Dtags(11), s%T
   if (s%DataPresent(12)) write(150) Dtags(12), s%xHII
   if (s%DataPresent(13)) write(150) Dtags(13), s%xHeII
   if (s%DataPresent(14)) write(150) Dtags(14), s%xHeIII
   if (s%DataPresent(15)) write(150) Dtags(15), s%xHIIrc
   if (s%DataPresent(16)) write(150) Dtags(16), s%xHeIIrc
   if (s%DataPresent(17)) write(150) Dtags(17), s%xHeIIIrc
   if (s%DataPresent(18)) write(150) Dtags(18), s%lasthit
   close(150)

end subroutine write_sphray_snapshot

subroutine alloc_sphray_snapshot(s)
 type(sphray_snap_type) :: s
 integer(i8b) :: Npar
 
  Npar = s%NparSnap

  if(Npar.LE.0) call error('set number of particles first')
   
  if (s%DataPresent(1)) then
     allocate(s%id(Npar))
  end if
  
  if (s%DataPresent(2)) then
     allocate(s%pos(Npar,3))
  end if
  
  if (s%DataPresent(5)) then
     allocate(s%vel(Npar,3))
  end if
  
  if (s%DataPresent(8)) then
     allocate(s%hsml(Npar))
  end if
  
  if (s%DataPresent(9)) then
     allocate(s%rho(Npar))
  end if
  
  if (s%DataPresent(10)) then
     allocate(s%mass(Npar))
  end if
  
  if (s%DataPresent(11)) then
     allocate(s%T(Npar))
  end if
  
  if (s%DataPresent(12)) then
     allocate(s%xHII(Npar))
  end if
  
  if (s%DataPresent(13)) then
     allocate(s%xHeII(Npar))
  end if
  
  if (s%DataPresent(14)) then
     allocate(s%xHeIII(Npar))
  end if
  
  if (s%DataPresent(15)) then
     allocate(s%xHIIrc(NPar))
  end if
  
  if (s%DataPresent(16)) then
     allocate(s%xHeIIrc(Npar))
  end if
  
  if (s%DataPresent(17)) then
     allocate(s%xHeIIIrc(Npar))
  end if
  
  if (s%DataPresent(18)) then
     allocate(s%lasthit(Npar))
  end if

end subroutine
  
end module sphray_io_mod

! code to reduce an existing tree structure parallel
! counts the number of cells
recursive subroutine update_reduction(start,tthread,option,ind)
  include 'globals.h'
 integer, intent(in) :: start,tthread
 character (len=4), intent(in) :: option
 integer,intent(out) :: ind(*)
 integer :: facell, lacell, nacell, k, i

 ind(1) = start
 facell = 1;lacell = 1;nacell = 1
 do while(lacell-facell+1.GT.0)  
       do k = 1, nsubcell 
        do i = facell,lacell 
         if (subp(ind(i),k).GE.nbods1) then 
          nacell = nacell + 1 
          ind(nacell) = subp(ind(i),k) 
         endif 
        enddo 
       enddo
       facell = lacell + 1 
       lacell = nacell 
       if(tthread.GT.1.AND.lacell-facell+1.GT.4*tthread) then
!$omp parallel do private(i,k)       
        do i=facell,lacell
         k=ind(i)
         call update_reduction(k,1,option,srlist)
        enddo
	exit
       endif		
 enddo
 call tree_reduction(start,facell-1,option)
 end subroutine

subroutine set_parameters_to_defaults
  include 'globals.h'

  datadir='./datadir/'
  inputfile='input'
  outputfile='output'
  firstsnap=0
  nsteps=0
  stepout=5
  steplog=5
  dtime=1.
  bh_tol=0.5
  eps=0.
  adaptive_eps=.FALSE.
  targetnn=32
  nn_tol=0.1
  usequad=.FALSE.
  directsum=.FALSE.
  max_tbin=4096
  minppbin=1
  usesph=.TRUE.
  sphinit=.TRUE.
  uentropy=.TRUE.
  isotherm=.FALSE.
  sph_visc='sph '
  epsgas=0.005
  gamma=1.6666667
  alpha=0.5
  beta=1.
  epssph=0.01
  courant=0.3
  eps_is_h=.TRUE.
  mingaseps=.FALSE.
  balsara=.FALSE.
  consthsm=0.2
  nsmooth=64
  nsmtol=0.1
  symmetry='hk'
  radiate=.FALSE.
  graineff=0.05
  crionrate=3.6
  heat_par1=0.0
  heat_par2=0.0
  cool_par=1.
  unitl_in_kpc=1.0
  unitm_in_msun=1.e9
  halofile='none'
  fixthalo=.FALSE.
  selfgrav=.TRUE.
  starform=.FALSE.
  cosmo=.FALSE.
  comove=.FALSE.
  pboxsize=10000.
  optdepth=0.
  tcollfac=1.
  masscrit=1.e5
  removgas=0.25
  sfeff=0.25
  tbubble=3.e7
  sne_eff=0.
  tsnbeg=3.e6
  feedback='fuv '
  verbosity=0
  hupdatemethod='mass'
  smoothinput=.FALSE.
  consph=.TRUE.
  sfmode='gerritsen'
  rhomax=100
  sqrttstp=.FALSE.
  acc_tstp=.TRUE.
  tstepcrit=1.
  tstpcr2=0.25
  freetstp=.FALSE.
  freev=0.5
  freea=.35
  freevexp=0.
  freeaexp=-1.
  gdgop=.TRUE.
  gdgtol=0.01

  output=0

end subroutine

subroutine write_parameters(restart)
  include 'globals.h'
  integer :: restart
  integer :: out(64),i,no,nout=64
  character(len=256) :: outfile=""
  character(len=256) :: outline=""
  character(len=20) :: keys(64)
  data keys/ "mass","pos","vel","eps","tform","acc", &
"","","","rho","ethermal","entropy","hsmooth","fuvheat","esnthdt", &
"tcollaps","temperat","elecfrac","csound","pressure","hsmdivv","mumaxdvh", &
"hsmcurlv","vdisp","h2frac","dethdt","dentdt","","","","","","","starfuv","snentropy", &
"itimestp","","","","phi","phiext","nbexist","","","","","","","","","","", &
"","","","","","","","","","","","" /

  if(restart.EQ.0) then
    outfile='parameters_used.txt'
  else
    outfile='restart_parameters_used.txt'
  endif    

  open(unit=upars,file=TRIM(outfile), status='unknown')
  
  write(upars, '(" datadir:   ",a)')  '"'//TRIM(datadir)//'"'
  write(upars, '(" inputfile:   ",a)')  '"'//TRIM(inputfile)//'"'
  write(upars, '(" outputfile:   ",a)')  '"'//TRIM(outputfile)//'"'
  write(upars,*) "firstsnap:   ",  firstsnap
  write(upars,*) "nsteps:   ",  nsteps
  write(upars,*) "stepout:   ",  stepout
  write(upars,*) "steplog:   ",  steplog
  write(upars,*) "dtime:   ",  dtime
  write(upars,*) "bh_tol:   ",  bh_tol
  write(upars,*) "eps:   ",  eps
  write(upars,*) "adaptive_eps:   ",  adaptive_eps
  write(upars,*) "targetnn:   ",  targetnn
  write(upars,*) "nn_tol:   ",  nn_tol
  write(upars,*) "usequad:   ",  usequad
  write(upars,*) "directsum:   ",  directsum
  write(upars,*) "periodic:   ",  periodic
  write(upars,*) "max_tbin:   ",  max_tbin
  write(upars,*) "minppbin:   ",  minppbin
  write(upars,*) "usesph:   ",  usesph
  write(upars,*) "sphinit:   ",  sphinit
  write(upars,*) "uentropy:   ",  uentropy
  write(upars,*) "isotherm:   ",  isotherm
  write(upars, '(" sph_visc:   ",a)')  '"'//TRIM(sph_visc)//'"'
  write(upars,*) "epsgas:   ",  epsgas
  write(upars,*) "gamma:   ",  gamma
  write(upars,*) "alpha:   ",  alpha
  write(upars,*) "beta:   ",  beta
  write(upars,*) "epssph:   ",  epssph
  write(upars,*) "courant:   ",  courant
  write(upars,*) "eps_is_h:   ",  eps_is_h 
  write(upars,*) "mingaseps:   ",  mingaseps 
  write(upars,*) "balsara:   ",  balsara 
  write(upars,*) "consthsm:   ",  consthsm
  write(upars,*) "nsmooth:   ",  nsmooth
  write(upars,*) "nsmtol:   ",  nsmtol
  write(upars, '(" symmetry:   ",a)')  '"'//TRIM(symmetry)//'"'
  write(upars,*) "radiate:   ",  radiate
  write(upars,*) "graineff:   ",  graineff
  write(upars,*) "crionrate:   ",  crionrate
  write(upars,*) "heat_par1:   ",  heat_par1
  write(upars,*) "heat_par2:   ",  heat_par2
  write(upars,*) "cool_par:   ",  cool_par
  write(upars,*) "unitl_in_kpc:   ",  unitl_in_kpc
  write(upars,*) "unitm_in_msun:   ",  unitm_in_msun
  write(upars, '(" halofile:   ",a)')  '"'//TRIM(halofile)//'"'
  write(upars,*) "fixthalo:   ",  fixthalo
  write(upars,*) "selfgrav:   ",  selfgrav
  write(upars,*) "starform:   ",  starform
  write(upars,*) "cosmo:   ",  cosmo
  write(upars,*) "comove:   ",  comove
  write(upars,*) "pboxsize:   ",  pboxsize
  write(upars,*) "optdepth:   ",  optdepth
  write(upars,*) "tcollfac:   ",  tcollfac
  write(upars,*) "masscrit:   ",  masscrit
  write(upars,*) "removgas:   ",  removgas
  write(upars,*) "sfeff:   ",  sfeff
  write(upars,*) "tbubble:   ",  tbubble
  write(upars,*) "sne_eff:   ",  sne_eff
  write(upars,*) "tsnbeg:   ",  tsnbeg
  write(upars, '(" feedback:   ",a)')  '"'//TRIM(feedback)//'"'
  write(upars,*) "verbosity:   ",  verbosity
  write(upars, '(" hupdatemethod:   ",a)')  '"'//TRIM(hupdatemethod)//'"'
  write(upars,*) "smoothinput:   ",  smoothinput
  write(upars,*) "consph:   ",  consph
  write(upars, '(" sfmode:   ",a)')  '"'//TRIM(sfmode)//'"'
  write(upars,*) "rhomax:   ",  rhomax
  write(upars,*) "sqrttstp:   ",  sqrttstp
  write(upars,*) "acc_tstp:   ",  acc_tstp
  write(upars,*) "tstepcrit:   ",  tstepcrit
  write(upars,*) "tstpcr2:   ",  tstpcr2
  write(upars,*) "freetstp:   ",  freetstp
  write(upars,*) "freev:   ",  freev
  write(upars,*) "freea:   ",  freea
  write(upars,*) "freevexp:   ",  freevexp
  write(upars,*) "freeaexp:   ",  freeaexp
  write(upars,*) "gdgop:   ",  gdgop
  write(upars,*) "gdgtol:   ",  gdgtol

  no=0
  outline=''
  do i=1,nout
    if(output(i).NE.0.AND.keys(i).NE."") then
      if(no.NE.0) outline=TRIM(outline)//','
      outline=TRIM(outline)//TRIM(keys(i))
      no=1
    endif  
  enddo
  write(upars,'("output:   ",a)') TRIM(outline)
  no=0
  outline=''
  do i=1,nout
    if(output(i).EQ.0.AND.keys(i).NE."") then
      if(no.NE.0) outline=TRIM(outline)//','
      outline=TRIM(outline)//TRIM(keys(i))
      no=1
    endif  
  enddo
  write(upars,'("non-output:   ",a)') TRIM(outline)
  
  close(upars)

end subroutine

subroutine get_output(line,unit,output,set)
  integer :: output(64),nout=64
  character(len=256) line
  character(len=20) key
  character(len=256) :: outline=""
  character(len=20) :: keys(64)
  data keys/"mass","pos","vel","eps","tform","acc",&
  "","","","rho","ethermal","entropy","hsmooth","fuvheat","esnthdt",      &
  "tcollaps","temperat","elecfrac","csound","pressure","hsmdivv","mumaxdvh",&
  "hsmcurlv","vdisp","h2frac","dethdt","dentdt","","","","","","","starfuv","snentropy",&
  "itimestp","","","","phi","phiext","nbexist","","","","","","","","","","", &
  "","","","","","","","","","","","" /
  integer :: i,j,unit,set
  i=0
  do
    line=line(i+1:)
    i=index(line,',')
    if(i.EQ.0) then 
      key=line
    else
      if(i.EQ.1) cycle
      key=line(1:i-1)
    endif
    key=adjustl(key) 
    if(key.EQ.'') then
      read(unit,'(a)',iostat=i) line
      line=adjustl(line)
      cycle
    endif
    j=0
    do while(j.LE.nout)
      if(keys(j).EQ.key) then
        output(j)=set
        exit
      endif  
      j=j+1
    enddo
    if(j.EQ.nout+1) then
       print*,'not found:', key 
       stop
    endif   
    if(i.eq.0) exit 
  enddo
end subroutine

subroutine read_parameters(restart)
  include 'globals.h'
  integer :: restart
  character(len=20) key, value
  character(len=256) line
  character(len=20) varc1,varc2
  character :: commentchar(6)=(/'!','#','$','%',';',':'/)
  integer ierr,i,isok
  
  print*,' ...reading run info...'
  open(unit=upars,file=parsfile,status='OLD',iostat=ierr)
  if(ierr.NE.0.AND.restart.EQ.0) then
    print*,' cannot read parameters from file: ',parsfile
    print*,' using defaults'
    return
  endif

  isok=0
  do 
    read(upars,'(a)',iostat=ierr) line
    if(ierr.NE.0) exit
    line=adjustl(line)
    i=index(line,':')
    if(any(line(1:1).EQ.commentchar).OR.line.EQ."") cycle
    if(i.LE.1) then
      print*,"in file ",TRIM(parsfile),", I don't understand:"
      print*, TRIM(line)
      print*,"(comments start with: %)"
      isok=1
      cycle
    endif
    key=line(1:i-1)
    line=line(i+1:)
    line=adjustl(line)
    i=index(line,' ')

    select case(key)
    
      case ("datadir")
        if(restart.EQ.0) read(line,*,iostat=ierr) datadir        
      case ("inputfile")
        if(restart.EQ.0) read(line,*,iostat=ierr) inputfile       
      case ("outputfile")
        read(line,*,iostat=ierr) outputfile       
      case ("firstsnap")
        if(restart.EQ.0) read(line,*,iostat=ierr) firstsnap      
      case ("nsteps")
        read(line,*,iostat=ierr) nsteps         
      case ("stepout")
        read(line,*,iostat=ierr) stepout        
      case ("steplog")
        read(line,*,iostat=ierr) steplog        
      case ("dtime")
        if(restart.EQ.0) read(line,*,iostat=ierr) dtime          
      case ("bh_tol")
        if(restart.EQ.0) read(line,*,iostat=ierr) bh_tol            
      case ("eps")
        if(restart.EQ.0) read(line,*,iostat=ierr) eps            
      case ("adaptive_eps")
        if(restart.EQ.0) read(line,*,iostat=ierr) adaptive_eps       
      case ("targetnn")
        if(restart.EQ.0) read(line,*,iostat=ierr) targetnn       
      case ("nn_tol")
        if(restart.EQ.0) read(line,*,iostat=ierr) nn_tol         
      case ("usequad")
        if(restart.EQ.0) read(line,*,iostat=ierr) usequad        
      case ("directsum")
        if(restart.EQ.0) read(line,*,iostat=ierr) directsum       
      case ("periodic")
      case ("max_tbin")
        read(line,*,iostat=ierr) max_tbin       
      case ("minppbin")
        read(line,*,iostat=ierr) minppbin       
      case ("usesph")
        if(restart.EQ.0) read(line,*,iostat=ierr) usesph         
      case ("sphinit")
        if(restart.EQ.0) read(line,*,iostat=ierr) sphinit        
      case ("uentropy")
        if(restart.EQ.0) read(line,*,iostat=ierr) uentropy       
      case ("isotherm")
        if(restart.EQ.0) read(line,*,iostat=ierr) isotherm       
      case ("sph_visc")
        if(restart.EQ.0) read(line,*,iostat=ierr) sph_visc       
      case ("epsgas")
        if(restart.EQ.0) read(line,*,iostat=ierr) epsgas         
      case ("gamma")
        if(restart.EQ.0) read(line,*,iostat=ierr) gamma          
      case ("alpha")
        if(restart.EQ.0) read(line,*,iostat=ierr) alpha          
      case ("beta")
        if(restart.EQ.0) read(line,*,iostat=ierr) beta           
      case ("epssph")
        if(restart.EQ.0) read(line,*,iostat=ierr) epssph         
      case ("courant")
        if(restart.EQ.0) read(line,*,iostat=ierr) courant        
      case ("eps_is_h")
        if(restart.EQ.0) read(line,*,iostat=ierr) eps_is_h       
      case ("mingaseps")
        if(restart.EQ.0) read(line,*,iostat=ierr) mingaseps       
      case ("balsara")
        if(restart.EQ.0) read(line,*,iostat=ierr) balsara       
      case ("consthsm")
        if(restart.EQ.0) read(line,*,iostat=ierr) consthsm       
      case ("nsmooth")
        if(restart.EQ.0) read(line,*,iostat=ierr) nsmooth        
      case ("nsmtol")
        if(restart.EQ.0) read(line,*,iostat=ierr) nsmtol         
      case ("symmetry")
        if(restart.EQ.0) read(line,*,iostat=ierr) symmetry       
      case ("radiate")
        if(restart.EQ.0) read(line,*,iostat=ierr) radiate        
      case ("graineff")
        if(restart.EQ.0) read(line,*,iostat=ierr) graineff       
      case ("crionrate")
        if(restart.EQ.0) read(line,*,iostat=ierr) crionrate      
      case ("heat_par1")
        if(restart.EQ.0) read(line,*,iostat=ierr) heat_par1        
      case ("heat_par2")
        if(restart.EQ.0) read(line,*,iostat=ierr) heat_par2       
      case ("cool_par")
        if(restart.EQ.0) read(line,*,iostat=ierr) cool_par       
      case ("unitl_in_kpc")
        if(restart.EQ.0) read(line,*,iostat=ierr) unitl_in_kpc        
      case ("unitm_in_msun")
        if(restart.EQ.0) read(line,*,iostat=ierr) unitm_in_msun       
      case ("halofile")
        if(restart.EQ.0) read(line,*,iostat=ierr) halofile       
      case ("fixthalo")
        if(restart.EQ.0) read(line,*,iostat=ierr) fixthalo       
      case ("selfgrav")
        if(restart.EQ.0) read(line,*,iostat=ierr) selfgrav       
      case ("starform")
        if(restart.EQ.0) read(line,*,iostat=ierr) starform       
      case ("cosmo")
        if(restart.EQ.0) read(line,*,iostat=ierr) cosmo          
      case ("comove")
        if(restart.EQ.0) read(line,*,iostat=ierr) comove         
      case ("pboxsize")
        if(restart.EQ.0) read(line,*,iostat=ierr) pboxsize       
      case ("optdepth")
        if(restart.EQ.0) read(line,*,iostat=ierr) optdepth       
      case ("tcollfac")
        if(restart.EQ.0) read(line,*,iostat=ierr) tcollfac       
      case ("masscrit")
        if(restart.EQ.0) read(line,*,iostat=ierr) masscrit       
      case ("removgas")
        if(restart.EQ.0) read(line,*,iostat=ierr) removgas       
      case ("sfeff")
        if(restart.EQ.0) read(line,*,iostat=ierr) sfeff          
      case ("tbubble")
        if(restart.EQ.0) read(line,*,iostat=ierr) tbubble        
      case ("sne_eff")
        if(restart.EQ.0) read(line,*,iostat=ierr) sne_eff        
      case ("tsnbeg")
        if(restart.EQ.0) read(line,*,iostat=ierr) tsnbeg         
      case ("feedback")
        if(restart.EQ.0) read(line,*,iostat=ierr) feedback       
      case ("verbosity")
        if(restart.EQ.0) read(line,*,iostat=ierr) verbosity           
      case ("hupdatemethod")
        if(restart.EQ.0) read(line,*,iostat=ierr) hupdatemethod  
      case ("smoothinput")
        if(restart.EQ.0) read(line,*,iostat=ierr) smoothinput    
      case ("consph")
        if(restart.EQ.0) read(line,*,iostat=ierr) consph         
      case ("sfmode")
        if(restart.EQ.0) read(line,*,iostat=ierr) sfmode         
      case ("rhomax")
        if(restart.EQ.0) read(line,*,iostat=ierr) rhomax         
      case ("sqrttstp")
        if(restart.EQ.0) read(line,*,iostat=ierr) sqrttstp        
      case ("acc_tstp")
        if(restart.EQ.0) read(line,*,iostat=ierr) acc_tstp        
      case ("tstepcrit")
        if(restart.EQ.0) read(line,*,iostat=ierr) tstepcrit      
      case ("tstpcr2")
        if(restart.EQ.0) read(line,*,iostat=ierr) tstpcr2        
      case ("freetstp")
        if(restart.EQ.0) read(line,*,iostat=ierr) freetstp       
      case ("freev")
        if(restart.EQ.0) read(line,*,iostat=ierr) freev          
      case ("freea")
        if(restart.EQ.0) read(line,*,iostat=ierr) freea          
      case ("freevexp")
        if(restart.EQ.0) read(line,*,iostat=ierr) freevexp       
      case ("freeaexp")
        if(restart.EQ.0) read(line,*,iostat=ierr) freeaexp       
      case ("gdgop")
        if(restart.EQ.0) read(line,*,iostat=ierr) gdgop          
      case ("gdgtol")
        if(restart.EQ.0) read(line,*,iostat=ierr) gdgtol         
      case ("output")
        if(restart.EQ.0) call get_output(line,upars,output,1)
      case ("non-output")
        if(restart.EQ.0) call get_output(line,upars,output,0)
      case default
        print*,'unknown key: ', key
        isok=1
        cycle
    end select
    if(ierr.NE.0) then
      print*,'invalid value for: ', key
      isok=1
      cycle
    endif  
  enddo
   
  close(upars)
  
  if(isok.NE.0) then
    call terror("parameterfile error")
  endif
end subroutine

subroutine check_parameters
  include 'globals.h'
  integer nerror,i
  
  if(firstsnap.LT.0.OR.firstsnap.GT.999999) call terror(' parameter error: firstsnap ')
  if(nsteps.LT.0.OR.nsteps.GT.10000000) call terror(' parameter error: nsteps ')
  if(stepout.LT.0) call terror(' parameter error: stepout ')
  if(steplog.LT.0) call terror(' parameter error: steplog ')
  if(dtime.LE.0.0.OR.dtime.GT.1.e20) call terror(' parameter error: dtime ')
  if((.NOT.directsum).AND.(bh_tol.LT.0.0.OR.bh_tol.GT.1.5)) call terror(' parameter error: bh_tol ')
  if(eps.LT.0.0.OR.eps.GT.1.e20) call terror(' parameter error: eps ')
  if(adaptive_eps.AND.(targetnn.LE.0.OR.targetnn.GT.nbodsmax)) call terror(' parameter error: targetnn ')
  if(max_tbin.LT.1.OR.max_tbin.GT.2**20) call terror(' parameter error: max_tbin ')
  if(minppbin.LE.0.OR.minppbin.GT.nbodsmax) call terror(' parameter error: minppbin ')
  if(usesph) THEN
    if(sph_visc.NE.'bulk'.AND.sph_visc.NE.'sphv'.AND. &
       sph_visc.NE.'sph ') call terror(' parameter error: sph_visc ')
    if(sph_visc.EQ.'bulk') call terror(' check bulk viscosity!')
    if(epsgas.LE.0.0) call terror(' parameter error: epsgas ')
    if(gamma.LE.0.0.OR.gamma.GT.20.) call terror(' parameter error: gamma ')
    if(alpha.LT.0.0.OR.alpha.GT.10) call terror(' parameter error: alpha ')
    if(beta.LT.0.0.OR.beta.GT.10) call terror(' parameter error: beta ')
    if(epssph.LE.0.) call terror(' parameter error: epssph ')
    if(courant.LE.0.0.OR.courant.GT.1.) call terror(' parameter error: courant ')
    if(consthsm.LT.0.AND.hupdatemethod.EQ.'none') call terror(' parameter error: consthsm ')
    if(nsmooth.LE.0.OR.nsmooth.GT.nbodsmax.AND.hupdatemethod.EQ.'none') call terror(' parameter error: nsmooth ')
    if(symmetry.NE.'hk'.AND.symmetry.NE.'be') call terror(' parameter error: symmetry ')
    if(graineff.LT.0.0.OR.graineff.GT.1) call terror(' parameter error: graineff ')
    if(crionrate.LT.0.0) call terror(' parameter error: crionrate ')
    if(heat_par1.LT.0.0) call terror(' parameter error: heat_par1 ')
    if(heat_par2.LT.0.0) call terror(' parameter error: heat_par2 ')
    if(cool_par.LT.0.0) call terror(' parameter error: cool_par ')
    if(isotherm.AND.ABS(gamma-1.0).GT.1.e-6) call terror(' gamma must be 1.0 for isothermal gas')
    if(uentropy.AND.isotherm) call terror(' uentropy must be .FALSE. for isothermal gas')
  endif

  if(pboxsize.LE.0.0) call terror(' parameter error: pboxsize ')
  if(cosmo.OR.comove) call terror(' cosmo/comove not implemented yet')
  if((.NOT.cosmo).AND.comove) call terror(' comove allowed only if cosmo is true ')
  if(usequad.AND.periodic) call terror(' quad. option allowed only with vacuum b.c. ')
  if(usequad.AND.usepm) call terror(' quad. option not allowed for PM gravity ')
  if(starform.AND.(.NOT.radiate.OR.isotherm)) call terror(' radiate=.TRUE., isotherm=.FALSE. when starform=.TRUE.')
  if(.NOT.isotherm.AND.gamma.EQ.1.0) call terror(' gamma may not be 1.0 for non isothermal')
  if(starform.OR.radiate) then
    if(optdepth.LT.0) call terror('parameter error: optdepth ')
    if(tcollfac.LT.0) call terror('parameter error: tcollfac ')
    if(masscrit.LT.0) call terror('parameter error: masscrit ')
    if(removgas.LT.0.0.OR.removgas.GT.1.0) call terror('parameter error: removgas ')
    if(sfeff.LE.0.0.OR.sfeff.GT.1.0) call terror(' parameter error: sfeff ')
    if(tbubble.LT.0.0) call terror(' parameter error: tbubble ')
    if(sne_eff.GT.100.0.OR.sne_eff.LT.0.0) call terror(' parameter error: sne_eff ')
    if(sfmode.NE.'nieuw'.AND.sfmode.NE.'gerritsen'.AND. &
       sfmode.NE.'molecular'.AND.sfmode.NE.'molecular2') call terror(' parameter error: sfmode ')	      
    if(tsnbeg.LT.0.0) call terror(' parameter error: tsnbeg ')
    if(feedback.NE.'fuv '.AND.feedback.NE.'pres'.AND.feedback.NE.'kine'.AND. &
       feedback.NE.'solo'.AND.feedback.NE.'solh') call terror(' parameter error: feedback ')
  endif
        
end subroutine



subroutine set_parameters(restart)
  include 'globals.h'
  integer restart,ierr,ierr2
  character(len=256) line


  open(unit=upars,file=parsfile,status='OLD',iostat=ierr)
  read(upars,*,iostat=ierr2) line
  close(upars)
  
  if(line(1:16).EQ."C**********Basic".OR. &
    ierr.NE.0) then
    print*,"old style input"
    if(restart.EQ.0) call inparams
    if(restart.EQ.1) call someparams
  else
    if(restart.EQ.0)  call set_parameters_to_defaults
    call read_parameters(restart)
  endif
  
  call write_parameters(restart)
  call check_parameters

end subroutine

program read_snapshot

   !------------------------------------------------------------------
   ! This Fortran 90 routine shows how a snapshot of GADGET
   ! which is distributed into several files may be read in.
   ! In this example, coodinates of particles type 1 are read.
   !
   ! Each dump consists of several files, each with a variable 
   ! number of particles. However, these files all have the same format. 
   ! The sequence of information in the files is as follows:
   !
   ! Header
   ! Positions
   ! Velocities
   ! Particle ID's
   !  
   ! Masses (for particle types with vanishing mass entry in the header)
   ! Internal Energy (Gas)
   ! Density (Gas)
   !
   !-------------------------------------------------------------------


   include 'globals.h'
   integer :: NFILES        

   character*200 fileroot,filename, fnumber

   integer*4 npfile(1:6), nall(1:6)
   real*8    massarr(1:6)
   real*8    a
   real*8    z
   integer*4 unused(34)
   integer*4 fn,i,nstart,flag_sfr,flag_feedback
   integer*4 N,Ntot,Nwithmass,Ntotwithmass,nmass


   real*4,allocatable    :: rpos(:,:),rvel(:,:),rmass(:)
   integer*4,allocatable :: id(:)
   real :: mscale,vscale,tscale,lscale
   call initmem(nbodsmax,nsphmax,ncells)

   unitm_in_msun=1.e9
   unitl_in_kpc=1.
   timescale=1.488e19*unitl_in_kpc*sqrt(unitl_in_kpc/unitm_in_msun)
   lengthscale=3.086e21*unitl_in_kpc
   velscale=lengthscale/timescale

   print*,'single gadget file conversion'
   print*,'fileroot?'
   read*,fileroot
   print*,'mscale (in msun)?'
   read*,mscale
   mscale=mscale/unitm_in_msun
   print*,'vscale (in km/s)?'
   read*,vscale
   vscale=1.e5*vscale/velscale
   print*,'tscale (in Myr)?'
   read*,tscale
   tscale=tscale/timescale*year*1.e6
   print*,'m,v,t factor:',mscale,vscale,tscale
   lscale=1
   
   filename=trim(fileroot)

   print *,'opening...  '//trim(filename)

   ! now, read in the header

   open (1, file=filename, form='unformatted')
   read (1) npfile, massarr ,a, z, flag_sfr,flag_feedback, nall, unused

   do i=1,6
      print *,'Type,npfile,massarr',i, nall(i), massarr(i)
   end do
   
   Ntot= sum(nall)
   N=sum(npfile)

   Nwithmass=0
   do i=1,6
    if(massarr(i).EQ.0) Nwithmass=Nwithmass+npfile(i)  
   enddo

   allocate(rpos(1:3,1:N),rvel(1:3,1:N),id(1:N))
   if(Nwithmass.gt.0) allocate(rmass(1:Nwithmass))

   read (1) rpos
   read (1) rvel
   read (1) id
   if(Nwithmass.gt.0) read (1) rmass
   close (1)
 
   print *,'Done with reading.'
 
   nbodies=Ntot
   nsph=npfile(1)
   nstar=sum(npfile(3:6))
   nbh=npfile(6)
   totptag=nbodies
   tnow=a*tscale   
   massres=0.

   if(nbodies.GT.nbodsmax.OR.nsph.GT.nsphmax) then
    print*,"particle overflow:",nbodies,nsph
    stop
   endif

   outputfile=fileroot
   firstsnap=0
   uentropy=.FALSE.
   output=0
   output(1:3)=1
   
   do i=1,nbodies  
   pos(i,1:3)=rpos(1:3,i)*lscale
   vel(i,1:3)=rvel(1:3,i)*vscale
   enddo
   nmass=1
   nstart=1
   do i=1,6
    if(massarr(i).eq.0) then
      mass(nstart:nstart+npfile(i)-1)=rmass(nmass:nmass+npfile(i)-1)
      nstart=nstart+npfile(i)
      nmass=nmass+npfile(i)
    else
      mass(nstart:nstart+npfile(i)-1)=massarr(i)
      nstart=nstart+npfile(i)  
    endif
   enddo
   mass=mass*mscale
  
   if(Nwithmass.gt.0) deallocate(rmass)
   deallocate(rpos,rvel,id)

   print*,'fill ethermal (T= 10^4 K)'
   output(11)=0   
   if(nsph.gt.0) then
    output(11)=1
    ethermal(1:nsph) =1.e4/4.86e5 ! 10^4 K
   endif
   
   print*,'fill tform (age=12.e9 yr)'
   output(5)=1
   tform(1:nbodies)=0.
   allocate(rmass(nstar))
   call random_number(rmass)
   tform(nbodies-nstar+1:nbodies)=-rmass*800
deallocate(rmass)

   call outbods(trim(fileroot)//".new")
end program

subroutine basicinput
include 'globals.h'
character*200 filenaam
integer i,mapnr,nfeedback
real,allocatable :: weights(:)
 
 call set_parameters(0)

 print*,'filenaam?'
 read(*,'(a)') filenaam
 

 call readbods(filenaam)

 call heattabel
        
 call initpars

 if(periodic) call initbc

 call initnewstar

 if(usepm) then
  if(verbosity.GT.0) print*,' ...initPM...'
  call initpm
 endif

 call postprocessread

end subroutine

program snapreader
 use StarsMod
 use ionMod
 use ElementsMod
 include 'globals.h'
 integer i,p,nvertex,nn,nlum,hy
 real timefac,starage, h,d,dd,meant,meanxe,ttemp,temp,xe,ndens

 real, allocatable :: x(:),y(:),z(:),dens(:),xf(:),vtemp(:),lum(:)
 real, allocatable :: weights1(:),weights2(:)
 
 call initmem(nbodsmax,nsphmax,ncells)
 call basicinput

 print*,densconst,crionrate,mumhkg1

 timefac=timescale/year

! insert code after this
 call makesphtree

 nvertex=nsph
 do p=nbodies-nstar+1,nbodies 
  starage=(tnow-tform(p))*timefac
  if(starage.LT.3.e7) nvertex=nvertex+1
 enddo
 
 allocate( x(nvertex),y(nvertex),z(nvertex), &
      lum(nvertex),dens(nvertex),vtemp(nvertex),xf(nvertex))
 allocate(weights1(nsph),weights2(nsph))

 x(1:nsph)=pos(1:nsph,1)
 y(1:nsph)=pos(1:nsph,2)
 z(1:nsph)=pos(1:nsph,3)
 lum(1:nsph)=0.
 dens(1:nsph)=rho(1:nsph)*densconst*meanmwt*amu
 vtemp(1:nsph)=temperat(1:nsph)
 xf(1:nsph)=elecfrac(1:nsph)
 
 weights1(1:nsph)=temperat(1:nsph)*mass(1:nsph)
 weights2(1:nsph)=elecfrac(1:nsph)*mass(1:nsph)

 nlum=0
 do i=1,nstar-nbh
  p=nbodies-nstar+i 
  starage=(tnow-tform(p))*timefac
  if(starage.LT.3.e7) then
   nlum=nlum+1
   x(nsph+nlum)=pos(p,1)
   y(nsph+nlum)=pos(p,2)
   z(nsph+nlum)=pos(p,3)
   lum(nsph+nlum)=Nlya(starage)*unitm_in_msun*mass(p)
   call hsmdenspos2(pos(p,1:3),h,d,dd,nn)
   bodlist(1:nn)=srlist(1:nn) ! dirty fix
   call gatter3(nn,pos(p,1:3),h,d,dd,meant,weights1)
   call gatter3(nn,pos(p,1:3),h,d,dd,meanxe,weights2)
   meant=meant/d
   meanxe=meanxe/d
   dens(nsph+nlum)=d*densconst*meanmwt*amu
   vtemp(nsph+nlum)=meant
   xf(nsph+nlum)=meanxe
  endif
 enddo

 hy=elementnrQ("H   ")
 
 
 open(unit=1,file='vertices.txt',status='unknown')
 write(1, '(a, g14.6)') "meanmwt: ", meanmwt
 write(1, '(a, g14.6)') "f_hydrogen: ", fractionQ(hy)
 write(1, *) "nvertex: ", nvertex
 write(1,'(7a14)') "x(kpc)","y(kpc)","z(kpc)","Nlya(#/s)","rho(g/cm^3)","T(K)","x_e"
 do i=1,nvertex
   write(1,'(4X,7g14.6)') x(i),y(i),z(i),lum(i),dens(i),vtemp(i),xf(i)
 enddo 
 close(1)
 print*,nlum

 
end program

! ionization eq solved including cosmic rays + photoion.

module IonMod
 implicit none
 private
 public :: InitIon,Ion,EndIon,Ionh
 
  logical, parameter :: dbg=.FALSE.
  integer, parameter :: ntemptable=256,ncrtable=256
  real, parameter :: logTmin=1,logTmax=9,logcrmin=-6,logcrmax=8
  real, parameter :: dlogT=(logTmax-logTmin)/ntemptable
  real, parameter :: dlogcr=(logcrmax-logcrmin)/ncrtable
  real, parameter :: amu=1.6605e-24
  real, parameter :: crunit=1.e-17
  real, parameter :: Eel=40
  real, parameter :: tablerho=1.

 
  integer, save :: nelements
  integer, save :: H,He,C
  real,save :: meanmwt, minion,tablecr


  real, dimension(ntemptable), save :: logTin
  real, dimension(ncrtable), save :: logcrin
  real, dimension(ntemptable,ncrtable),save :: logTout,logeout,loghout, &
                                                loghe1out,loghe2out

  real,  allocatable, save :: abundances(:)
  real,  allocatable, save :: weights(:)
  real,  allocatable, save :: fractions(:), wfractions(:)
  character(len=4),dimension(:), allocatable, save :: elementnames
    
 contains
 
  subroutine ion(rtemp,temp,elecfrac,rho,cr)
   real,intent(in) :: rtemp
   real,intent(out):: temp,elecfrac
   real,intent(in),optional :: rho,cr
   real lrho,lcr
   
   if(.not.present(cr)) then 
    lcr=tablecr/crunit
   else
    lcr=cr
   endif
   
   if(.not.present(rho)) then
    lrho=tablerho 
   else
    lrho=rho
   endif

   call eTinterpol(rtemp,temp,elecfrac,lrho,lcr)
  end subroutine ion

  subroutine ionh(rtemp,temp,xe,xhii,xheii,xheiii,rho,cr)
   real,intent(in) :: rtemp
   real,intent(out):: temp
   real,intent(in),optional :: rho,cr
   real,intent(out) :: xe,xhii,xheii,xheiii
   real lrho,lcr
   
   if(.not.present(cr)) then 
    lcr=tablecr/crunit
   else
    lcr=cr
   endif
   
   if(.not.present(rho)) then
    lrho=tablerho 
   else
    lrho=rho
   endif

   call hTinterpol(rtemp,temp,xe,xhii,xheii,xheiii,lrho,lcr)
  end subroutine ionh

 
  subroutine Ioniter(rtemp,temp,x,rho,cr)
   real,intent(in) :: rtemp,rho,cr
   real,intent(out) :: temp,x
   real :: xnew,ttemp
   integer :: j
  
    call eTinterpol(rtemp,temp,x,rho,cr)
    call ionize(temp,cr,rho,xnew)
    j=0
    do while(ABS((x-xnew)/x).GT.0.001.AND.j.LT.200)
    j=j+1
    x=(xnew+x)/2.
    temp=tempIon(rtemp,x)
    call ionize(temp,cr,rho,xnew)
    enddo
    x=(xnew+x)/2.
  end subroutine Ioniter
 
  subroutine EndIon
   integer :: test
   deallocate(abundances,weights,fractions, elementnames,wfractions,STAT=test)
   if(test.NE.0) call IonError(99)
  end subroutine EndIon
  
  subroutine InitIon(unitm_in_msun,unitl_in_kpc,cr)
  use ElementsMod
   real, intent(in) :: unitm_in_msun,unitl_in_kpc
   real, intent(in), optional :: cr
   integer :: test
  
   if(present(cr)) then
    tablecr=cr*crunit
   else
    tablecr=1.8*crunit
   endif
  
   if(allocated(abundances)) call EndIon

   call InitElements
   nelements=nelementsQ()
   if(nelements.LE.0) call IonError(0)
  
   allocate(abundances(nelements),weights(nelements),fractions(nelements), &
            wfractions(nelements),elementnames(nelements),STAT=test)
   if(test.NE.0) call IonError(1)

   H=elementnrQ("H   ")
   He=elementnrQ("He  ")
   C=elementnrQ("C   ")
   if(H.EQ.0.OR.He.EQ.0.OR.C.EQ.0) call IonError(2)
   
   abundances=abundancesQ()
   weights=weightsQ()
   fractions=fractionsQ()
   meanmwt=meanmwtQ()
   wfractions=wfractionsQ()   
   call elementnamesQ(elementnames)
   
   minion=fractions(C)/fractions(H)
   
   if(dbg) print*,"InitIon:",minion
   
   call preparetemp
  end subroutine InitIon
  
  real function tempIon( t, elecfrac)
   real :: t,elecfrac 
   tempion=t/(1+fractions(H)*elecfrac)
  end function
  
  subroutine eTinterpol(tin,t,e,rho,crin)
   real :: tin,t,e,logT,dt,h
   real :: lcr,dc,cr,rho,crin
   integer :: ti,ti1,ci,ci1
   
    cr=crin/rho

   if(dbg) then
    if(cr.LT.10**logcrmin.OR.cr.GT.10**logcrmax) call IonError(3)
   endif

   if(dbg) then
    if(tin.LT.10**logTmin.OR.tin.GT.10**logTmax) call IonError(4)
   endif
   
   logT=log10(tin)
   ti=(logT-logTmin)/dlogT+1
   ti1=max(ti,1);ti1=min(ntemptable-1,ti1)
   dt=(logT-logTmin)/dlogT-ti+1

   lcr=log10(cr)
   ci=(lcr-logcrmin)/dlogcr+1
   ci1=max(ci,1);ci1=min(ncrtable-1,ci1)
   dc=(lcr-logcrmin)/dlogcr+1-ci 

   t=(1-dt)*(1-dc)*logTout(ti1,ci1)+dt*(1-dc)*logTout(ti1+1,ci1)+ &
     (1-dt)*dc*logTout(ti1,ci1+1)+dt*dc*logTout(ti1+1,ci1+1)
   t=10.**t
   e=(1-dt)*(1-dc)*logeout(ti1,ci1)+dt*(1-dc)*logeout(ti1+1,ci1)+ &
     (1-dt)*dc*logeout(ti1,ci1+1)+dt*dc*logeout(ti1+1,ci1+1)
   e=10.**e
  end subroutine 

  subroutine hTinterpol(tin,t,e,xhii,xheii,xheiii,rho,crin)
   real :: tin,t,e,logT,dt,xhii,xheii,xheiii
   real :: lcr,dc,cr,rho,crin
   integer :: ti,ti1,ci,ci1
   
    cr=crin/rho

   if(dbg) then
    if(cr.LT.10**logcrmin.OR.cr.GT.10**logcrmax) call IonError(3)
   endif

   if(dbg) then
    if(tin.LT.10**logTmin.OR.tin.GT.10**logTmax) call IonError(4)
   endif
   
   logT=log10(tin)
   ti=(logT-logTmin)/dlogT+1
   ti1=max(ti,1);ti1=min(ntemptable-1,ti1)
   dt=(logT-logTmin)/dlogT-ti+1

   lcr=log10(cr)
   ci=(lcr-logcrmin)/dlogcr+1
   ci1=max(ci,1);ci1=min(ncrtable-1,ci1)
   dc=(lcr-logcrmin)/dlogcr+1-ci 

   t=(1-dt)*(1-dc)*logTout(ti1,ci1)+dt*(1-dc)*logTout(ti1+1,ci1)+ &
     (1-dt)*dc*logTout(ti1,ci1+1)+dt*dc*logTout(ti1+1,ci1+1)
   t=10.**t
   e=(1-dt)*(1-dc)*logeout(ti1,ci1)+dt*(1-dc)*logeout(ti1+1,ci1)+ &
     (1-dt)*dc*logeout(ti1,ci1+1)+dt*dc*logeout(ti1+1,ci1+1)
   e=10.**e
   xhii=(1-dt)*(1-dc)*loghout(ti1,ci1)+dt*(1-dc)*loghout(ti1+1,ci1)+ &
     (1-dt)*dc*loghout(ti1,ci1+1)+dt*dc*loghout(ti1+1,ci1+1)
   xhii=10.**xhii
   xheii=(1-dt)*(1-dc)*loghe1out(ti1,ci1)+dt*(1-dc)*loghe1out(ti1+1,ci1)+ &
     (1-dt)*dc*loghe1out(ti1,ci1+1)+dt*dc*loghe1out(ti1+1,ci1+1)
   xheii=10.**xheii
   xheiii=(1-dt)*(1-dc)*loghe2out(ti1,ci1)+dt*(1-dc)*loghe2out(ti1+1,ci1)+ &
     (1-dt)*dc*loghe2out(ti1,ci1+1)+dt*dc*loghe2out(ti1+1,ci1+1)
   xheiii=10.**xheiii
  end subroutine 


  
  subroutine preparetemp
   integer :: i,j,k
   real :: temp,rtemp, rho, cr,x,xnew,xhii,xheii,xheiii
   rho=tablerho
   do j=1,ncrtable
    do i=1,ntemptable
      logTin(i)=logTmin+(i-1)*dlogT
      rtemp=10**logTin(i)
      logcrin(j)=logcrmin+(j-1)*dlogcr
      cr=10**logcrin(j)
      x=0.1
      xnew=0.
      k=0
      do while(ABS((x-xnew)/x).GT.0.00001.AND.k.LT.200)
       k=k+1
       x=(xnew+x)/2.
       temp=tempIon(rtemp,x)
       call ionize(temp,cr,rho,xnew,xhii,xheii,xheiii)
      enddo
      x=(xnew+x)/2.
      logTout(i,j)=log10(temp)
      logeout(i,j)=log10(x)
      loghout(i,j)=log10(xhii)   
      loghe1out(i,j)=log10(xheii)   
      loghe2out(i,j)=log10(xheiii)   
    enddo
   enddo
  end subroutine
    
  subroutine ionize(temp,crrate,dens,elecfrac,xhii,xheii,xheiii)
      real :: temp,crrate,dens,elecfrac
      real,optional :: xhii,xheii,xheiii
      real :: ndens
      real :: xh,xhe1,xhe2
      real :: crh
      real :: cih,cihe1,cihe2
      real :: arh,arhe1,arhe2
      real :: abund
      integer :: i     
      
      ndens=dens

      call cfit(1,1,temp,cih)
      call rrfit(1,1,temp,arh)
      call cfit(2,2,temp,cihe1)
      call rrfit(2,2,temp,arhe1)
      call cfit(2,1,temp,cihe2)
      call rrfit(2,1,temp,arhe2)
      cih=cih*ndens
      arh=ndens*arh
      cihe1=cihe1*ndens
      arhe1=ndens*arhe1      
      cihe2=cihe2*ndens
      arhe2=ndens*arhe2
      
      elecfrac=minion+cih/(cih+arh)
      
      do i=1,8
      
      crh=crunit*crrate*(1+fih(elecfrac)+fihe(elecfrac))/elecfrac
      
      xh=(cih+crh)/(cih+crh+arh)      
      xhe1=(cihe1+crh)/((cihe1+crh)*(1+(cihe2+crh)/arhe2)+arhe1) 
      xhe2=xhe1*(cihe2+crh)/arhe2
!      elecfrac=.75*( xh+fractions(He)/fractions(H)*(xhe1+2*xhe2)+minion)+ &
!               .25*elecfrac
      elecfrac=.75*( xh+abundances(He)*(xhe1+2*xhe2)+minion)+ &
               .25*elecfrac
      enddo
      if(present(xhii)) xhii=xh               
      if(present(xheii)) xheii=abundances(He)*xhe1               
      if(present(xheiii)) xheiii=abundances(He)*xhe2               
      end subroutine

  
  
 real function fih(x)
  real :: x
  fih=0;if(x.gt.1) return
  fih=(Eel/13.6-1.)*.39*(1-x**.41)**1.76*(Eel/1000.)**(2.3*x)
 end function
      
 real function fihe(x)
  real :: x
  fihe=0;if(x.gt.1) return
  fihe=(Eel/24.6-1.)*0.055*(1-x**.46)**1.67*(Eel/1000.)**(2.3*x)
 end function
  
        subroutine cfit(iz,in,t,c)
!******************************************************************************
!*** This subroutine calculates rates of direct collisional ionization 
!*** for all ionization stages of all elements from H to He (Z=2)
!*** by use of the fits from G. S. Voronov, 1997, ADNDT, 65, 1
!*** Input parameters:  iz - atomic number 
!***                    in - number of electrons from 1 to iz 
!***                    t  - temperature, K
!*** Output parameter:  c  - rate coefficient, cm^3 s^(-1)
!******************************************************************************
       integer :: iz,in,i
       real :: t,c,te,u 
       REAL CF(5,2,2)
      
      DATA(CF(I, 1, 1),I=1,5)/   13.6,0.,2.91E-08,0.2320,0.39/
      DATA(CF(I, 2, 2),I=1,5)/   24.6,0.,1.75E-08,0.1800,0.35/
      DATA(CF(I, 2, 1),I=1,5)/   54.4,1.,2.05E-09,0.2650,0.25/
      
      c=0.0
       te=t*8.617385e-05
       u=cf(1,iz,in)/te
       if(u.gt.80.0)return
      c=cf(3,iz,in)*(1.0+cf(2,iz,in)*sqrt(u))/(cf(4,iz,in)+u)*u**cf(5,iz,in)*exp(-u)
      return
      end subroutine

            subroutine rrfit(iz,in,t,r)
!*** adapted from D. A. Verner, verner@pa.uky.edu 
!******************************************************************************
!*** This subroutine calculates rates of radiative recombination for all ions
!*** of all elements from H and He, case b rcombination for H:
!*** Input parameters:  iz - atomic number 
!***                    in - number of electrons from 1 to iz 
!***                    t  - temperature, K
!*** Output parameter:  r  - rate coefficient, cm^3 s^(-1)
!******************************************************************************
       real :: t,r,tt
       integer :: iz,in,i
       REAL rnew(4,2,2)
             
      data(rnew(i, 1, 1),i=1,4)/7.782e-11,0.7070,2.781e+00,1.656e+05/
      data(rnew(i, 2, 1),i=1,4)/1.891e-10,0.7524,9.370e+00,2.774e+06/
      data(rnew(i, 2, 2),i=1,4)/9.356e-10,0.7892,4.266e-02,4.677e+06/

      r=0.0
       tt=sqrt(t/rnew(3,iz,in))
       r=rnew(1,iz,in)/(tt*(tt+1.0)**(1.0-rnew(2,iz,in))* &
             (1.0+sqrt(t/rnew(4,iz,in)))**(1.0+rnew(2,iz,in)))
      return 
      end subroutine

      subroutine IonError(i)
       integer i
       
       print*,'Ion error:',i
       stop
      end subroutine
  
 end module IonMod
 
!program testion
! use ElementsMod
! use IonMod
! use CoolingMod
! integer i,j
! real x,xh,rtemp,temp,e,rho,cr,lambda,fractions(8),meanmwt
! character(len=200),save :: datadir
! datadir='/home/pelupes/fish/stars/data/'

! call InitCooling(datadir) 
! call InitIon(1.e9,1.)
! fractions=fractionsQ()
! meanmwt=meanmwtQ()
! amu=1.6605e-24
! cr=1800
! rho=.1
!10 read*,rtemp
!if(rtemp.eq.0) stop
! call ion(rtemp,temp,x,rho,cr)
! call ionh(rtemp,temp,xh,rho,cr)
! print*,temp,x,xh
! goto 10
!  rho=.3
!  x=.1
!   do i=1,256
!    rtemp=10**(1+(i-1)/32.)
!    call ion(rtemp,temp,x,rho,cr)
!    lambda=CoolFunc(x,temp)
!    print*,alog10(temp),alog10((amu/fractions(1)*meanmwt)**2*lambda)
!   enddo
!   do j=1,nelementsQ()
!   do i=1,256
!    rtemp=10**(1+(i-1)/32.)
!    call ion(rtemp,temp,x,rho,cr)
!    lambda=ElementCool(x,max(10.,temp),j)
!    print*,alog10(temp),alog10(lambda)
!   enddo
!   enddo


!   print*, ' '
!  enddo
 
!end program testion  

program makecube
 use MakeMapMod
 use StarsMod
 include 'globals.h'
 integer nba,omap
 character*80 filenaam
 character(len=5) :: mapmode
 call initmem(nbodsmax,nsphmax,ncells)

 interface
   subroutine WriteMap(filename,tauname)
     character, optional :: filename*80,tauname*80
   end subroutine
 end interface
 
 CALL set_parameters(0)

 print*,'filenaam?'
 read*,filenaam
 if(filenaam.EQ."debug") goto 5
 CALL readbods(filenaam)

 CALL heattabel
        
 CALL initpars

 IF(periodic) CALL initbc

 CALL initnewstar

 if(usepm) then
  if(verbosity.GT.0) print*,' ...initPM...'
  call initpm
 endif

 CALL postprocessread
 
 nba=nbandsQ()

 if(input(42).EQ.0) then
  call nbexistinit
 endif

5 continue
  
 call InitMap

 print*,' nbands=', nba
 print*,'  HI         = HI,'
 print*,'  1...nbands = band i,'
 print*,'  H2         = H_2,'
 print*,'  Ha         = Halpha,'
 print*,'  FUV        = FUV,'
 print*,'  stars      = stellar mass,'
 print*,'  gas        = gas mass,'
 print*,'  dark       = DM mass,'
 print*,'  all        = all mass,'
 print*,'  new        = new star mass,'
 print*,'  unst       = unstable gas,'
 print*,'  C          = C,'
 print*,'  CO         = CO' 
 print*,'  Ccool      = C+ cooling' 
 print*,' map?'
 read*, mapmode

 call projectparticles(mapmode)
 call WriteMap
 call EndMap

print*,'other map?(1=yes)'
read*,omap
if(omap.eq.1) goto 5
 
end program

subroutine basicinput
 include 'globals.h'
 character*24 filenaam
 integer i,mapnr,nfeedback
 real,allocatable :: weights(:)
 
 call set_parameters(0)

 print*,'filenaam?'
 read*,filenaam

 call readbods(filenaam)

 call heattabel
        
 call initpars

 if(periodic) call initbc

 call initnewstar

 if(usepm) then
  if(verbosity.GT.0) print*,' ...initPM...'
  call initpm
 endif

 call postprocessread

end subroutine

program snapreader
 use StarsMod
 use ionMod
 include 'globals.h'
 integer i,p,nsources
 real timefac,starage,ltot,lout,l
 real ttemp,temp,xelec,nh,xh,xhe1,xhe2
 real,save ::xhii(nsphmax),xheii(nsphmax),xheiii(nsphmax)
 real(kind=4),save :: rblock(nsphmax)
 integer(kind=4),save :: iblock(nsphmax)
 integer(kind=8),save :: iblock2(nsphmax)
 real codemass,codevel
 integer*8,save :: ids(nsphmax)

!    this is an array of the possible data fields that can appear in an
!    output/restart snapshot.
  integer, parameter :: ntagl = 24

  ! names for the integer part of the header
  integer*4, parameter :: Nint_header_entries = 7
  character(ntagl), parameter :: i_header_variable_names(Nint_header_entries) = &
       (/ "NparSnap                ", &    ! 1
          "NparFile                ", &    ! 2
          "NumFiles                ", &    ! 3
          "NsphNeighbors           ", &    ! 4
          "RayBoundaryConditions   ", &    ! 5
          "OnTheSpot               ", &    ! 6
          "TotalRaysTraced         " /)    ! 7

  ! names for the real part of the header
  integer*4, parameter :: Nreal_header_entries = 18
  character(ntagl), parameter :: r_header_variable_names(Nreal_header_entries) = &
       (/ "Time                    ", &  ! 1
          "IsoMass                 ", &  ! 2
          "IsoTemperature          ", &  ! 3
          "ScaleFactor             ", &  ! 4
          "BoxLowX                 ", &  ! 5
          "BoxLowY                 ", &  ! 6
          "BoxLowZ                 ", &  ! 7
          "BoxHighX                ", &  ! 8
          "BoxHighY                ", &  ! 9
          "BoxHighZ                ", &  ! 10
          "CodeLenINcm             ", &  ! 11
          "CodeLumINergs_per_s     ", &  ! 12
          "CodeTimeINs             ", &  ! 13
          "OmegaMatter             ", &  ! 14
          "OmegaBaryon             ", &  ! 15
          "OmegaLambda             ", &  ! 16
          "LittleHubble            ", &  ! 17
          "RecombRayTolerance      " /)  ! 18


  ! names of the possible snapshot data fields
  integer*4, parameter :: ndatablocks = 30
  character(ntagl), parameter :: data_field_names(ndatablocks) = &  
       (/ "id                      ",&  ! 1
          "xpos                    ",&  ! 2
          "ypos                    ",&  ! 3
          "zpos                    ",&  ! 4
          "xvel                    ",&  ! 5
          "yvel                    ",&  ! 6
          "zvel                    ",&  ! 7
          "hsml                    ",&  ! 8
          "rho                     ",&  ! 9
          "mass                    ",&  ! 10
          "temperature             ",&  ! 11
          "xHII                    ",&  ! 12
          "xHeII                   ",&  ! 13
          "xHeIII                  ",&  ! 14
          "xHIIrc                  ",&  ! 15
          "xHeIIrc                 ",&  ! 16
          "xHeIIIrc                ",&  ! 17
          "lasthit                 ",&  ! 18
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               " /)

  type integer_header_entry
     character(ntagl) :: name
     integer*8 :: var
  end type integer_header_entry

  type real_header_entry
     character(ntagl) :: name
     real*8 :: var
  end type real_header_entry

  type particle_header_type
     type(integer_header_entry) :: int(Nint_header_entries)
     type(real_header_entry) :: real(Nreal_header_entries)
     integer*4 :: DataPresent(ndatablocks)
  end type particle_header_type

 type(particle_header_type) phead
 character(ntagl) :: DataFieldLabel
 real hboxl,maxx,minx

 call initmem(nbodsmax,nsphmax,ncells)
 call basicinput

 do p=1,nsph 
  ttemp=temperat(p)
  nh=densconst*rho(p)
  call Ionh(ttemp,temp,xelec,xh,xhe1,xhe2,nh,crionrate)
  xhii(p)=xh
  xheii(p)=xhe1
  xheiii(p)=xhe2
!  print*, temperat(p),temp,elecfrac(p),xelec
 enddo

 timefac=timescale/year
 ltot=0
 lout=0
 nsources=0
 print*,'writing GABE sources'
 open(unit=1,file='sources.raw',status='unknown')
 do p=nbodies-nstar+1,nbodies 
  starage=(tnow-tform(p))*timefac
  l=Nlya(starage)*unitm_in_msun*mass(p)
  if(starage.LT.3.e7) then 
   nsources=nsources+1
   write(1,'( 4g16.6 )') pos(p,1:3), l
   lout=lout+l
  endif
  ltot=ltot+l 
 enddo
 close(1)
 write(*,'("wrote ",i," sources with ",g9.2," of total luminosity")'),nsources,lout/ltot

    print*, 'convert to GABE unit'

    phead%real(11)%var=3.08568e21 
    phead%real(12)%var=3.826e33
    phead%real(13)%var=3.1556926e14

   codemass=phead%real(12)%var * phead%real(13)%var**3 / phead%real(11)%var**2
   codevel=phead%real(11)%var/phead%real(13)%var
    print*, 'massunit (msol):', codemass/solarmass 
    print*, 'velunit (km/s):', codevel/1.e5 
    print*, 'length unit (kpc):',phead%real(11)%var/kpc

    mass(1:nsph)=mass(1:nsph)*unitm_in_msun*solarmass/codemass
    pos(1:nsph,1:3)=pos(1:nsph,1:3)*unitl_in_kpc/phead%real(11)%var*kpc
    hsmooth(1:nsph)=hsmooth(1:nsph)*unitl_in_kpc/phead%real(11)%var*kpc
    rho(1:nsph)=rho(1:nsph)*unitm_in_msun*solarmass/codemass &
                 /unitl_in_kpc**3*phead%real(11)%var**3/kpc**3
    vel(1:nsph,1:3)=vel(1:nsph,1:3)*velscale/codevel
    ids(1:nsph)=nbexist(1:nsph)
    tnow=tnow*timescale/phead%real(13)%var

    maxx=maxval(pos(1:nsph,1:3))
    minx=minval(pos(1:nsph,1:3))

    hboxl=max(maxx,abs(minx))

    phead%int(1:7)%name=i_header_variable_names(1:7)
    phead%real(1:21)%name=r_header_variable_names(1:21)

    phead%int(1)%var=nsph
    phead%int(2)%var=nsph
    phead%int(3)%var=1
    phead%int(4)%var=nsmooth
    phead%real(1)%var=0
    phead%real(2)%var=0
    phead%real(3)%var=0
    phead%real(4)%var=1.
    phead%real(8:10)%var=hboxl
    phead%real(5:7)%var=-hboxl
    phead%int(5)%var=0
    if(periodic) phead%int(5)%var=1
!    phead%MeanHsml=sum(hsmooth(1:nsph))/nsph
    phead%real(14)%var=0.3
    phead%real(15)%var=0.04
    phead%real(16)%var=0.7
    phead%real(17)%var=0.7
    phead%real(18)%var=0
    phead%real(19)%var=0
    phead%real(20)%var=0
    phead%real(21)%var=0
    phead%int(6)%var=0
    phead%int(7)%var=0
    phead%Datapresent=0.

    
    phead%DataPresent(1:9)=1
    phead%DataPresent(10:11)=1
    phead%DataPresent(12:14)=1
    phead%DataPresent(18)=1
    
! convert to gadget smoothing lengths
    hsmooth(1:nsph)=2*hsmooth(1:nsph)    
    
    print*, 'writing GABE file'
    open(unit=1,file='gas_000.1',status='unknown',form='UNFORMATTED')
    DataFieldLabel="header";write(1) DataFieldLabel, phead
    DataFieldLabel=data_field_names(1);iblock2(1:nsph)= ids;write(1) DataFieldLabel,iblock2(1:nsph)
    DataFieldLabel=data_field_names(2);rblock(1:nsph)=pos(1:nsph,1);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(3);rblock(1:nsph)=pos(1:nsph,2);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(4);rblock(1:nsph)=pos(1:nsph,3);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(5);rblock(1:nsph)=vel(1:nsph,1);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(6);rblock(1:nsph)=vel(1:nsph,2);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(7);rblock(1:nsph)=vel(1:nsph,3);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(8);rblock(1:nsph)= hsmooth(1:nsph);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(9);rblock(1:nsph)= rho(1:nsph);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(10);rblock(1:nsph)= mass(1:nsph);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(11);rblock(1:nsph)= temperat(1:nsph);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(12);rblock(1:nsph)= xhii(1:nsph);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(13);rblock(1:nsph)= xheii(1:nsph);write(1) DataFieldLabel,rblock(1:nsph)
    DataFieldLabel=data_field_names(14);rblock(1:nsph)= xheiii(1:nsph);write(1) DataFieldLabel,rblock(1:nsph)


!    rblock(1:nsph)= elecfrac(1:nsph);write(1) rblock(1:nsph)

    DataFieldLabel=data_field_names(18);iblock2(1:nsph)= 0   ;write(1) DataFieldLabel,iblock2(1:nsph)

    close(1)
    print*, 'done'
end program

subroutine mortonsort
 include 'globals.h'
 integer i,jg,js,jh,jb,k
  
 call maketree

 pordercount=pordercount+1
    
 jg=0
 js=0
 jh=0
 jb=0
 do i=1,nbodies
  k=order_bodlist(i)
  if(k.LE.nsph) then
   jg=jg+1
   bodlist(jg)=k
   templist(jg)=i
  endif
  if(k.GT.nsph.AND.k.LE.nbodies-nstar) then
   jh=jh+1
   bodlist(jh+nsph)=k
   templist(jh+nsph)=i
  endif
  if(k.GT.nbodies-nstar.AND.k.LE.nbodies-nbh) then
   js=js+1
   bodlist(js+nbodies-nstar)=k
   templist(js+nbodies-nstar)=i
  endif
  if(k.GT.nbodies-nbh) then
   jb=jb+1
   bodlist(jb+nbodies-nbh)=k
   templist(jb+nbodies-nbh)=i
  endif

 enddo
! bh=star 
 if(jg.NE.nsph.OR. &
    js.NE.nstar-nbh.OR. & 
    jh.NE.nbodies-nstar-nsph.OR. &
    jb.NE.nbh) call terror('ordering error') 

 do i=1,nbodies
  order_bodlist(templist(i))=i
 enddo

 tempvect(1:nbodies)=mass(bodlist(1:nbodies))
 mass(1:nbodies)=tempvect(1:nbodies)

 do i=1,ndim
  tempvect(1:nbodies)=pos(bodlist(1:nbodies),i)
  pos(1:nbodies,i)=tempvect(1:nbodies)
 enddo

 do i=1,ndim
  tempvect(1:nbodies)=vel(bodlist(1:nbodies),i)
  vel(1:nbodies,i)=tempvect(1:nbodies)
 enddo

 do i=1,ndim
  tempvect(1:nbodies)=acc(bodlist(1:nbodies),i)
  acc(1:nbodies,i)=tempvect(1:nbodies)
 enddo

 tempvect(1:nbodies)=aacc(bodlist(1:nbodies))
 aacc(1:nbodies)=tempvect(1:nbodies)

 tempvect(1:nbodies)=phi(bodlist(1:nbodies))
 phi(1:nbodies)=tempvect(1:nbodies)

 tempvect(1:nbodies)=phiext(bodlist(1:nbodies))
 phiext(1:nbodies)=tempvect(1:nbodies)

 tempvect(1:nbodies)=epsgrav(bodlist(1:nbodies))
 epsgrav(1:nbodies)=tempvect(1:nbodies)

 templist(1:nbodies)=itimestp(bodlist(1:nbodies))
 itimestp(1:nbodies)=templist(1:nbodies)

 templist(1:nbodies)=otimestp(bodlist(1:nbodies))
 otimestp(1:nbodies)=templist(1:nbodies)

 tempvect(1:nbodies)=tform(bodlist(1:nbodies))
 tform(1:nbodies)=tempvect(1:nbodies)

 tempvect(1:nbodies)=starfuv(bodlist(1:nbodies))
 starfuv(1:nbodies)=tempvect(1:nbodies)

 tempvect(1:nbodies)=tfeedb(bodlist(1:nbodies))
 tfeedb(1:nbodies)=tempvect(1:nbodies)

 tempvect(1:nbodies)=tvel(bodlist(1:nbodies))
 tvel(1:nbodies)=tempvect(1:nbodies)

 tempvect(1:nbodies)=snentropy(bodlist(1:nbodies))
 snentropy(1:nbodies)=tempvect(1:nbodies)

 tempvect(1:nbodies)=hsmooth(bodlist(1:nbodies))
 hsmooth(1:nbodies)=tempvect(1:nbodies)

 templist(1:nbodies)=nbexist(bodlist(1:nbodies))
 nbexist(1:nbodies)=templist(1:nbodies)

 tempvect(1:nsph)=rho(bodlist(1:nsph))
 rho(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=drhodh(bodlist(1:nsph))
 drhodh(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=csound(bodlist(1:nsph))
 csound(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=derad(bodlist(1:nsph))
 derad(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=hsmdivv(bodlist(1:nsph))
 hsmdivv(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=mumaxdvh(bodlist(1:nsph))
 mumaxdvh(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=hsmcurlv(bodlist(1:nsph))
 hsmcurlv(1:nsph)=tempvect(1:nsph)

 do i=1,ndim
  tempvect(1:nsph)=veltpos(bodlist(1:nsph),i)
  veltpos(1:nsph,i)=tempvect(1:nsph)
 enddo

 tempvect(1:nsph)=fuvheat(bodlist(1:nsph))
 fuvheat(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=tcollaps(bodlist(1:nsph))
 tcollaps(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=esnthdt(bodlist(1:nsph))
 esnthdt(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=temperat(bodlist(1:nsph))
 temperat(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=elecfrac(bodlist(1:nsph))
 elecfrac(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=ethold(bodlist(1:nsph))
 ethold(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=dethold(bodlist(1:nsph))
 dethold(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=h2frac(bodlist(1:nsph))
 h2frac(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=vdisp(bodlist(1:nsph))
 vdisp(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=ethermal(bodlist(1:nsph))
 ethermal(1:nsph)=tempvect(1:nsph)

 tempvect(1:nsph)=dethdt(bodlist(1:nsph))
 dethdt(1:nsph)=tempvect(1:nsph)
 
end subroutine

! to sort additional (callable only after mortonsort) 
subroutine sort_additional_real(n,array)
  include 'globals.h'
  integer :: n
  real :: array(n)
  tempvect(1:n)=array(bodlist(1:n))
  array(1:n)=tempvect(1:n)
end subroutine

subroutine outbods(fname)
 character(len=*) :: fname
end subroutine outbods


subroutine writebods(filenaam)
 character(len=*) :: filenaam 
end subroutine writebods

subroutine readbods(filenaam)
 character(len=*) :: filenaam 
end subroutine readbods


subroutine prepareoutput
end subroutine

subroutine itos(i,n,s)
 integer,intent(in) :: i,n
 character(len=n), intent(inout) :: s
 character(len=11) :: nstring
 data nstring/'0123456789X'/
 integer :: j,k,l

 if(i.LT.0.OR.i.GE.10**n) then
  do k=1,n
  s(k:k)=nstring(11:11)
  enddo
  return
 endif 
 j=1
 do k=1,n
 l=1+mod(i,10*j)/j
 s(n-k+1:n-k+1)=nstring(l:l)
 j=j*10
 enddo

end subroutine

! insert autmatically generated code below

subroutine writedump(n) 
 integer n 
end subroutine

subroutine readdump(n) 
 integer n
end subroutine

module H2coolMod
 implicit none
 private
 public :: InitH2, H2CoolFunc
 
  logical, parameter :: debug=.FALSE.
  integer, parameter :: coolTableTLength=61
  integer, parameter :: coolTablenLength=9
  real, parameter :: logTmin=1,logTmax=4,dlogT=0.05
  real, parameter :: lognmin=0.3010300,lognmax=4.3010300,dlogn=.5
  real, parameter :: amu=1.6605e-24

  integer, save :: nelements
  integer, save :: H,He,C
  real, save :: meanmwt
  real, save :: Tfac
  
  real, save :: coolUnit=1.
  real,  allocatable, save :: abundances(:)
  real,  allocatable, save :: weights(:)
  real,  allocatable, save :: fractions(:), wfractions(:)
  real,  allocatable, save :: coolTemp(:), cooln(:),coolTable(:,:)
  character(len=4),dimension(:), allocatable, save :: elementnames
  character(len=200),save :: datadir

 contains

 subroutine EndH2
 integer :: test
  deallocate(abundances,weights,fractions,wfractions,coolTemp,cooln, &
  coolTable,elementnames,STAT=test)
  if(test.NE.0) call H2coolError(99)
 end subroutine
 
 subroutine InitH2(indatadir)
   use ElementsMod
  integer :: i,test
  character(len=200) :: indatadir
 
  datadir=indatadir
  if(allocated(abundances)) call EndH2
  call InitElements
  nelements=nelementsQ()
  if(nelements.LE.0) call H2CoolError(0)
  
  allocate(abundances(nelements),weights(nelements),fractions(nelements), &
            wfractions(nelements),coolTemp(coolTableTLength),cooln(coolTablenLength), &
            coolTable(coolTableTLength,coolTablenLength),elementnames(nelements), &
            STAT=test)
   if(test.NE.0) call H2CoolError(1)

   H=elementnrQ("H   ")
   He=elementnrQ("He  ")
   C=elementnrQ("C   ")
   if(H.EQ.0.OR.He.EQ.0.OR.C.EQ.0) call H2CoolError(2)
   
   abundances=abundancesQ()
   weights=weightsQ()
   fractions=fractionsQ()
   meanmwt=meanmwtQ()
   wfractions=wfractionsQ()   
   call elementnamesQ(elementnames)
   
   coolTable=-50.
   call ReadCool

  coolTemp=10**coolTemp
  cooln=10**cooln
  coolTable=10**coolTable
 
  Tfac=0.54
 
 end subroutine

 subroutine ReadCool
  integer:: i,j,imax,jmax
  character(len=215) :: filename
  
  filename=trim(datadir)//'H2.HH2cool'
  open(unit=19,file=filename,status='OLD')
  read(19,*) imax,jmax
  if(imax.ne.coolTableTLength.OR.jmax.ne.coolTablenLength) call H2coolError(3) 
  do j=1,jmax 
   do i=1,imax
    read(19,*) coolTemp(i),cooln(j),coolTable(i,j)
   if(debug) print*,coolTemp(j),coolTable(i,j)
   enddo
  enddo
  close(19)
 end subroutine
 
 function H2Cool(T,n)
  real :: H2cool
  real, intent(in) :: T,n
  real :: ln,dt,logT,dn,logn,lT
  integer :: ti,ti1,ti2,ni,ni1,ni2
  
  ln=max(10**lognmin,n)
  ln=min(10**lognmax,ln)
  lT=max(10**logTmin,T)
  lT=min(10**logTmax,lT)
 
  logT=log10(lT)
  ti=(logT-logTmin)/dlogT+1
  ti1=max(ti,1);ti1=min(coolTableTLength-1,ti1)
  dt=(lT-coolTemp(ti1))/(coolTemp(ti1+1)-coolTemp(ti1))
  
  logn=log10(ln)
  ni=(logn-lognmin)/dlogn+1
  ni1=max(ni,1);ni1=min(coolTablenLength-1,ni1)
  dn=(ln-cooln(ni1))/(cooln(ni1+1)-cooln(ni1))
 
  H2cool=(1-dt)*(1-dn)*coolTable(ti1,ni1)+   &
             dt*(1-dn)*coolTable(ti1+1,ni1)+ &
             (1-dt)*dn*coolTable(ti1,ni1+1)+ &
                 dt*dn*coolTable(ti1+1,ni1+1)
 
 end function

 function H2CoolFunc(T,n) result(x)
  real :: x,ln
  real, intent(in) :: T
  real, intent(in), optional :: n
  
  if(.NOT.present(n)) then
   ln=10**lognmin
  else
   ln=n
  endif  
    
  x=H2Cool(T/Tfac,ln)
  x=(fractions(H)/meanmwt/amu)**2*x*coolUnit
  
 end function
 
 subroutine H2coolError(i)
  integer ::i
  
  print*,' H2 cool error:',i
  stop
 
 end subroutine

end module H2coolMod

subroutine pmgravsum(p,option)
 use pmgravMod
 include 'globals.h'
 character (LEN=4), intent(in):: option
 integer, intent(in):: p
 real :: peps,ppos(3),pacc(3),ppot

 peps=epsgrav(p)
 ppos=pos(p,1:3)
 pacc=0.
 ppot=0.
 select case (option)
 case('acc ')
  call pmgravaccpot(ppos,pacc=pacc)
 case('pot ')
  call pmgravaccpot(ppos,ppot=ppot)
 case default
  call pmgravaccpot(ppos,pacc=pacc,ppot=ppot)
 end select
 acc(p,1:3)=acc(p,1:3)+pacc   
 phi(p)=phi(p)+ppot
end subroutine pmgravsum

subroutine pgravsum(p,nterms,option,lesofttot)
 include 'globals.h'
 character (LEN=4), intent(in):: option
 integer, intent(in):: p,nterms
 real,intent(inout):: lesofttot
 real :: peps,ppos(3),pacc(3),pphi

 peps=epsgrav(p)
 ppos=pos(p,1:3)
 call gravsum(peps,ppos,pphi,pacc,nterms,option,lesofttot)
 lesofttot=lesofttot*mass(p)*0.5
 select case (option)
 case('acc ')
   acc(p,1:3)=acc(p,1:3)+pacc   
 case('pot ')
   phi(p)=phi(p)+pphi+1.4/epsgrav(p)*mass(p) ! correct for self interaction potential
 case default
   acc(p,1:3)=acc(p,1:3)+pacc   
   phi(p)=phi(p)+pphi+1.4/epsgrav(p)*mass(p)
 end select
end subroutine pgravsum

subroutine gravsum(peps,ppos,pphi,pacc,nterms,option,lesofttot)
 include 'globals.h'
 character (LEN=4), intent(in):: option
 integer, intent(in):: nterms
 real,intent(in) :: peps,ppos(3)
 real,intent(inout):: lesofttot,pphi,pacc(3)

 pacc=0.
 pphi=0.
 lesofttot=0.
 select case (option)
 case('acc ')
  call gravsuma(peps,ppos,pacc,nterms,lesofttot)
 case('pot ')
  call gravsump(peps,ppos,pphi,nterms,lesofttot)
 case default
  call gravsumpa(peps,ppos,pphi,pacc,nterms,lesofttot)
 end select
end subroutine

! epseff=peps**2+epsgrav**2 expected
subroutine gravsuma(peps,ppos,pacc,nterms,lesofttot)
 include 'globals.h'
 integer, intent(in):: nterms
 real,intent(in) :: peps,ppos(3)
 real,intent(inout):: lesofttot,pacc(3)
 real :: dx,dy,dz,dist2,dist,epseff,epseffi,rinveff,drdeldrg, &
  &  r2inveff,r3inveff,phiquad,qr5inv,acci,drsm,accfac,rhinv
 integer :: i,q,smindex
 accfac=1
 do i=1,nterms
   q=bodlist(i)
   dx=ppos(1)-pos(q,1)
   dy=ppos(2)-pos(q,2)
   dz=ppos(3)-pos(q,3)
   dist2=dx*dx+dy*dy+dz*dz
   if(usepm) then
    if(dist2.GT.rcut2) cycle
    drdeldrg=dist2*pmdr
    smindex=FLOOR(drdeldrg)
    drsm=drdeldrg-smindex
    accfac=pmacc(smindex)*(1-drsm)+drsm*pmacc(smindex+1)
   endif
   dist=SQRT(dist2)     
   epseff=peps+epsgrav(q)  
   if(dist.GE.epseff) then
    rinveff=1./dist
    r3inveff=rinveff**3
   else
    epseffi=1./epseff
    rhinv=dist*epseffi
    if(rhinv.LT.0.5) then
      r3inveff=4./3.+rhinv**2*(4.*rhinv-4.8)
      rinveff=1.4-rhinv**2*(8./3.+rhinv**2*(3.2*rhinv-4.8))
    else
      r3inveff=8./3.-6.*rhinv+4.8*rhinv**2- &
            4./3.*rhinv**3-1./120./rhinv**3
      rinveff=1.6-1/(30.*rhinv)-rhinv**2* &
           (16./3.+rhinv*(-8.+rhinv*(4.8-rhinv*16./15.)))
    endif   
    rinveff=rinveff*2*epseffi   
    r3inveff=r3inveff*8*epseffi**3
   endif
              
   acci=accfac*mass(q)*r3inveff    
   pacc(1)=pacc(1)-dx*acci
   pacc(2)=pacc(2)-dy*acci
   pacc(3)=pacc(3)-dz*acci
   
   if(.not.usepm) then
   if(usequad.AND.q.GE.nbods1) then
    r2inveff=rinveff*rinveff
    qr5inv=r3inveff*r2inveff
    phiquad=(-.5*((dx**2-dz**2)*quad(q,1)+(dy**2-dz**2)*quad(q,4)) &
            -(dx*dy*quad(q,2)+dx*dz*quad(q,3)+dy*dz*quad(q,5)))*qr5inv
    phiquad=5.*phiquad*r2inveff
    pacc(1)=pacc(1)+dx*phiquad+(dx*quad(q,1)+dy*quad(q,2)+dz*quad(q,3))*qr5inv
    pacc(2)=pacc(2)+dy*phiquad+(dy*quad(q,4)+dx*quad(q,2)+dz*quad(q,5))*qr5inv
    pacc(3)=pacc(3)+dz*phiquad &
            +(dz*(-quad(q,1)-quad(q,4))+dx*quad(q,3)+dy*quad(q,5))*qr5inv
   endif
   endif
 enddo
end subroutine gravsuma

subroutine gravsump(peps,ppos,pphi,nterms,lesofttot)
 include 'globals.h'
 integer, intent(in):: nterms
 real,intent(in) :: peps,ppos(3)
 real,intent(inout):: lesofttot,pphi
 real :: dx,dy,dz,dist2,dist,epseff,epseffi,drdeldrg,rinveff, &
  &  r2inveff,r3inveff,phiquad,qr5inv,acci,drsm,potfac,rhinv
 integer :: i,q,smindex
 potfac=1 
 do i=1,nterms
   q=bodlist(i)
   dx=ppos(1)-pos(q,1)
   dy=ppos(2)-pos(q,2)
   dz=ppos(3)-pos(q,3)
   dist2=dx*dx+dy*dy+dz*dz
   if(usepm) then
    if(dist2.GT.rcut2) cycle
    drdeldrg=dist2*pmdr
    smindex=FLOOR(drdeldrg)
    drsm=drdeldrg-smindex
    potfac=pmpot(smindex)*(1-drsm)+drsm*pmpot(smindex+1)
   endif
   dist=SQRT(dist2)     
   epseff=peps+epsgrav(q)  
   if(dist.GE.epseff) then
    rinveff=1./dist
    r3inveff=rinveff**3
   else
    epseffi=1./epseff
    rhinv=dist*epseffi
    if(rhinv.LT.0.5) then
      r3inveff=4./3.+rhinv**2*(4.*rhinv-4.8)
      rinveff=1.4-rhinv**2*(8./3.+rhinv**2*(3.2*rhinv-4.8))
    else
      r3inveff=8./3.-6.*rhinv+4.8*rhinv**2- &
            4./3.*rhinv**3-1./120./rhinv**3
      rinveff=1.6-1/(30.*rhinv)-rhinv**2* &
           (16./3.+rhinv*(-8.+rhinv*(4.8-rhinv*16./15.)))
    endif   
    rinveff=rinveff*2*epseffi   
    r3inveff=r3inveff*8*epseffi**3
   endif
   
   pphi=pphi-potfac*mass(q)*rinveff
   lesofttot=lesofttot+mass(q)*(rinveff-dist2*r3inveff)
   
   if(.not.usepm) then   
   if(usequad.AND.q.GE.nbods1) then   
    r2inveff=rinveff*rinveff
    qr5inv=r3inveff*r2inveff
    phiquad=(-.5*((dx**2-dz**2)*quad(q,1)+(dy**2-dz**2)*quad(q,4)) &
            -(dx*dy*quad(q,2)+dx*dz*quad(q,3)+dy*dz*quad(q,5)))*qr5inv
    pphi=pphi+phiquad
   endif
   endif
 enddo
         
end subroutine gravsump

subroutine gravsumpa(peps,ppos,pphi,pacc,nterms,lesofttot)
 include 'globals.h'
 integer, intent(in):: nterms
 real,intent(in) :: peps,ppos(3)
 real,intent(inout):: lesofttot,pphi,pacc(3)
 real :: dx,dy,dz,dist2,dist,epseff,epseffi,drdeldrg,rinveff, &
  &  r2inveff,r3inveff,phiquad,qr5inv,acci,drsm,accfac,potfac,rhinv
 integer :: i,q,smindex

 accfac=1
 potfac=1 
 do i=1,nterms
   q=bodlist(i)
   dx=ppos(1)-pos(q,1)
   dy=ppos(2)-pos(q,2)
   dz=ppos(3)-pos(q,3)
   dist2=dx*dx+dy*dy+dz*dz
   if(usepm) then
    if(dist2.GT.rcut2) cycle
    drdeldrg=dist2*pmdr
    smindex=FLOOR(drdeldrg)
    drsm=drdeldrg-smindex
    accfac=pmacc(smindex)*(1-drsm)+drsm*pmacc(smindex+1)
    potfac=pmpot(smindex)*(1-drsm)+drsm*pmpot(smindex+1)
   endif
   dist=SQRT(dist2)     
   epseff=peps+epsgrav(q)  
   if(dist.GE.epseff) then
    rinveff=1./dist
    r3inveff=rinveff**3
   else
    epseffi=1./epseff
    rhinv=dist*epseffi
    if(rhinv.LT.0.5) then
      r3inveff=4./3.+rhinv**2*(4.*rhinv-4.8)
      rinveff=1.4-rhinv**2*(8./3.+rhinv**2*(3.2*rhinv-4.8))
    else
      r3inveff=8./3.-6.*rhinv+4.8*rhinv**2- &
            4./3.*rhinv**3-1./120./rhinv**3
      rinveff=1.6-1/(30.*rhinv)-rhinv**2* &
           (16./3.+rhinv*(-8.+rhinv*(4.8-rhinv*16./15.)))
    endif   
    rinveff=rinveff*2*epseffi   
    r3inveff=r3inveff*8*epseffi**3
   endif
   
      pphi=pphi-potfac*mass(q)*rinveff
      lesofttot=lesofttot+mass(q)*(rinveff-dist2*r3inveff)
   
    acci=accfac*mass(q)*r3inveff
    pacc(1)=pacc(1)-dx*acci
    pacc(2)=pacc(2)-dy*acci
    pacc(3)=pacc(3)-dz*acci
   
   if(.not.usepm) then
   if(usequad.AND.q.GE.nbods1) then
   
    r2inveff=rinveff*rinveff
    qr5inv=r3inveff*r2inveff
    phiquad=(-.5*((dx**2-dz**2)*quad(q,1)+(dy**2-dz**2)*quad(q,4)) &
            -(dx*dy*quad(q,2)+dx*dz*quad(q,3)+dy*dz*quad(q,5)))*qr5inv
    pphi=pphi+phiquad
    phiquad=5.*phiquad*r2inveff
    pacc(1)=pacc(1)+dx*phiquad+(dx*quad(q,1)+dy*quad(q,2)+dz*quad(q,3))*qr5inv
    pacc(2)=pacc(2)+dy*phiquad+(dy*quad(q,4)+dx*quad(q,2)+dz*quad(q,5))*qr5inv
    pacc(3)=pacc(3)+dz*phiquad &
            +(dz*(-quad(q,1)-quad(q,4))+dx*quad(q,3)+dy*quad(q,5))*qr5inv
   endif
   endif
 enddo
         
end subroutine gravsumpa

subroutine pfuvsum(p,nterms)
 include 'globals.h'
 integer, intent(in):: p,nterms
 real :: peps,ppos(3),pheat
 peps=epsgrav(p)
 ppos=pos(p,1:3)
 pheat=0.
 call fuvsum(peps,ppos,pheat,nterms)
 fuvheat(p)=fuvheat(p)+pheat         
end subroutine pfuvsum

subroutine fuvsum(peps,ppos,pheat,nterms)
 include 'globals.h'
 integer, intent(in):: nterms
 real,intent(in) :: ppos(3),peps
 real, intent(inout) :: pheat
 real :: pmass,dx,dy,dz,drdotdr,epseff,epseffi,drdeldrg,distance,r2inveff,drsm
 integer :: i,q,smindex
 real, parameter :: uvfac=uvinterp/uvedge
 
 do i=1,nterms
   q=bodlist(i)
   dx=ppos(1)-pos(q,1)
   dy=ppos(2)-pos(q,2)
   dz=ppos(3)-pos(q,3)
   IF(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
   IF(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
   IF(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
   IF(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
   IF(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
   IF(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
   drdotdr=dx*dx+dy*dy+dz*dz
   epseff=peps+epsgrav(q)
   epseffi=1./epseff
   drdeldrg=drdotdr*epseffi*epseffi
   if(drdeldrg.GE.uvedge) then
    r2inveff=1/drdotdr
   else
    drsm=uvfac*drdeldrg
    smindex=INT(drsm)
    drsm=drsm-smindex
    r2inveff=(1-drsm)*smoothuv(smindex)+drsm*smoothuv(1+smindex)
    r2inveff=r2inveff*4*epseffi**2
   endif
   
   if(optdepth.LT.tiny) then
    pheat=pheat+starfuv(q)*r2inveff
   else
    distance=sqrt( drdotdr)
    pheat=pheat+starfuv(q)*r2inveff*exp(-optdepth*distance)
   endif
   
 enddo
end subroutine fuvsum

module fccoMod
 implicit none
 private
 public :: fccoInit,fcco,q1c,q1co

 real, parameter :: n0=1520, &    	! cm^-3
                    xifuv=3.      	! FUV absorption constant (2-4)
		    		    
 real, save :: metal
 integer, save :: poly

 contains

subroutine fccoInit
 use ElementsMod
 use MoleculeMod
 
 call InitElements()
 metal=zQ()/solarzQ()
 poly=polyQ()
 if(poly.NE.0.AND.poly.NE.1) call fccoError('poly error',poly)

end subroutine

function fcco(n,G0,Pe,Z)
 real :: fcco,n,G0,Pe,zz
 real, optional :: Z
 
 zz=metal
 if(present(Z)) zz=Z
 if(poly.EQ.0) then
  fcco=fccoco(n,G0,zz,Pe)
 else
  fcco=fccolog(n,G0,zz,Pe)
 endif
end function

function q1c(t)
 real :: q1c,t
 real, parameter :: e1=23.6,e2=62.4 ! K
 integer, parameter :: g0=1,g1=3,g2=5
 q1c=g1*exp(-e1/t)/(g0+g1*exp(-e1/t)+g2*exp(-e2/t)) 
end function

function q1co(t)
 real :: q1co,t
 real, parameter :: e1=5.5 ! K
 integer, parameter :: g1=3
 q1co=g1*exp(-e1/t)/(2*t/e1) 
end function

function e2solvelog(a1,a2) result(xnew)
 real :: a1,a2,x,xnew,en(0:2)
 integer :: i,nmax=100
 xnew=1.0001
 call ENXB(2,alog(xnew)*a1,en)
 if(en(2)-a2*xnew.LT.0) return
 i=0
10 i=i+1
  x=xnew
  call ENXB(2,alog(x)*a1,en)
  xnew=x+(en(2)-a2*x)/(en(1)*a1/x+a2)
  if(xnew.LT.1) then
   xnew=1.
   return
  endif
  if(abs(xnew-x).GT.1.e-5.AND.i.LT.nmax) goto 10  
  call enxb(2,alog(xnew)*a1,en)
  if(abs(en(2)-a2*xnew).GT.1.e-3) then 
   call fccoError('e2solvelog error',i)
  stop
 endif

end function

function e2solve(x)
 real :: x,thnew,th,e2solve
 integer :: i,nmax=100

thnew=1.d-9
if(x.gt.exp(-thnew)-thnew*E1(thnew)) then
 e2solve=thnew
 return
endif 
if(x.LE.1.d-40) then
 e2solve=87.6081992538658
 return
endif  
i=0
10 i=i+1
 th=thnew
 thnew=th+(exp(-th)-th*E1(th)-x)/E1(th)
 if(abs(thnew-th).GT.1.e-5.AND.i.LE.nmax) goto 10
 if((exp(-th)-th*E1(th)-x).GT.1.e-5) then 
  call fccoError(' e2solve error',i)
  stop
 endif
 e2solve=thnew 
end function

function fccolog(n,G0,Z,Pe) result(fcoc)
 real :: n,G0,Z,Pe,a1,a2,x,fcoc

 a1=1.11*Z*n0/1.d3*sqrt(pe/1.d4)*xifuv
 a2=(1+24.8*Z)*8./9.*n/1.d6/G0
 x=e2solvelog(a1,a2)
 fcoc=1/x**2
end function

function fccoco(n,G0,Z,Pe)
 real :: n,G0,Z,Pe,xia,fccoco

 xia=e2solve(REAL(4./3.*n/1.d6/G0*(1+24.8*Z))) 
 fccoco=MAX(0.d0,1-xiA*1.d3/n0/xifuv/1.66/Z/sqrt(Pe/1.d4))**3
end function

        SUBROUTINE ENXB(N,X,EN)
!
!       ===============================================
!       Purpose: Compute exponential integral En(x)
!       Input :  x --- Argument of En(x)
!                n --- Order of En(x)  (n = 0,1,2,...)
!       Output:  EN(n) --- En(x)
!       ===============================================
!
        REAL X,EN,R,S,RP,PS,ENS,T,T0,S0
        INTEGER N,J,K,L,M
        DIMENSION EN(0:N)
        IF (X.EQ.0.0) THEN
           EN(0)=1.0D+300
           EN(1)=1.0D+300
           DO 10 K=2,N
10            EN(K)=1.0D0/(K-1.0)
           RETURN
        ELSE IF (X.LE.1.0) THEN
           EN(0)=EXP(-X)/X
           DO 40 L=1,N
              RP=1.0D0
              DO 15 J=1,L-1
15               RP=-RP*X/J
              PS=-0.5772156649015328D0
              DO 20 M=1,L-1
20               PS=PS+1.0D0/M
              ENS=RP*(-LOG(X)+PS)
              S=0.0D0
              DO 30 M=0,20
                 IF (M.EQ.L-1) GO TO 30
                 R=1.0D0
                 DO 25 J=1,M
25                  R=-R*X/J
                 S=S+R/(M-L+1.0D0)
                 IF (ABS(S-S0).LT.ABS(S)*1.0D-15) GO TO 35
                 S0=S
30            CONTINUE
35            EN(L)=ENS-S
40         CONTINUE
        ELSE
           EN(0)=EXP(-X)/X
           M=15+INT(100.0/X)
           DO 50 L=1,N
              T0=0.0D0
              DO 45 K=M,1,-1
45               T0=(L+K-1.0D0)/(1.0D0+K/(X+T0))
              T=1.0D0/(X+T0)
50            EN(L)=EXP(-X)*T
        ENDIF
        END SUBROUTINE

        FUNCTION E1(X)
!
!       ============================================
!       Purpose: Compute exponential integral E1(x)
!       Input :  x  --- Argument of E1(x) 
!       Output:  E1 --- E1(x) ( x > 0 )
!       ============================================
!
        REAL X,E1,ES1,ES2
        IF (X.EQ.0.0) THEN
           E1=1.0D+300
        ELSE IF (X.LE.1.0) THEN
           E1=-LOG(X)+((((1.07857D-3*X-9.76004D-3)*X+5.519968D-2)*X &
     &        -0.24991055D0)*X+0.99999193D0)*X-0.57721566D0
        ELSE
           ES1=(((X+8.5733287401D0)*X+18.059016973D0)*X &
     &         +8.6347608925D0)*X+0.2677737343D0
           ES2=(((X+9.5733223454D0)*X+25.6329561486D0)*X &
     &         +21.0996530827D0)*X+3.9584969228D0
           E1=EXP(-X)/X*ES1/ES2
        ENDIF
        RETURN
        END FUNCTION

 subroutine fccoError(string,i)
  character(*) :: string
  integer, optional :: i

  print*,' fccoError detected:'

  if(present(i)) then
   print*,string,i
  else
   print*,string
  endif

  stop
 end subroutine

end module

subroutine fccotest
 use fccoMod
 real :: x,y,n,G0,Z,Pe
 
 call fccoInit
 
 10 read*,n,G0,Z,Pe
 if(n.LT.0) stop
 y=fcco(n,G0,Pe,Z)
 print*,n,G0,Z,Pe,y
 goto 10
end 

subroutine exstepp(p,totaldt,eth,deth,drad,lerad,lhe,imax,jmax)
 include 'globals.h'
 integer p,i,j,jmax,imax
 real eth,totaldt,deth,drad
 real eth0,eth1,eth2,deth0,deth1,deth2
 real tpart,dt,he,co,ethmax,ethmin
 logical tnowpassed,laststep
 real ttolerance,tmin,tmax,safefac
 real lerad,lhe
 parameter( ttolerance=0.01,safefac=.9,tmin=10.,tmax=1.e9)
 
 if(totaldt.LE.0) return
 i=0  
 jmax=0
 lhe=0
 lerad=0
 ethmax=tmax/mumhkg1
 ethmin=tmin/mumhkg1
 if(.NOT.radiate) then
  i=i+1
  eth0=eth+totaldt*deth	
  if(eth0.LT.ethmin/10) eth0=ethmin/10
  if(eth0.GT.ethmax) eth0=ethmax
 else
  tpart=0	  
  eth0=eth
  call heco(he,co,eth0,p)	   
  deth1=deth+(he-co)
  if(eth0.GT.ethmax) eth0=ethmax
  if(eth0.LT.ethmin) eth0=ethmin
  dt=totaldt
  laststep=.TRUE.
  if(deth1.NE.0) dt=min(dt,SQRT(ABS(eth0*dt/deth1)))
  if(dt.LT.totaldt) laststep=.FALSE.
  tnowpassed=.FALSE.
  do while((.NOT.tnowpassed).AND.i.LE.250)
   i=i+1	   	   	   
   if(ethmax-eth0.LE.dt*deth1) then
    laststep=.FALSE.
    if(deth1.NE.0) dt=(ethmax-eth0)/deth1
   endif
   if(ethmin-eth0.GE.dt*deth1) then
    laststep=.FALSE.
    if(deth1.NE.0) dt=(ethmin-eth0)/deth1
   endif 
   j=0
10 continue
  j=j+1
  if(j.GT.1000000) call terror('j overflow')
  eth1=eth0+dt*deth1	  
  eth2=eth0+0.5*dt*deth1	  
  call heco(he,co,eth2,p)	   
  deth2=deth+(he-co)
  eth2=eth2+0.5*dt*deth2
  if(ABS(eth1-eth2).LE.ttolerance*eth0) then	    	    
   tpart=tpart+dt
   tnowpassed=laststep

   lerad=lerad+dt*(he-co)
   lhe=lhe+dt*he

   laststep=.TRUE.
   if(eth1.NE.eth2) then
    dt=safefac*dt*SQRT(ABS((ttolerance*eth0)/(eth1-eth2)))
   else
    dt=totaldt-tpart
   endif
   if(dt.GE.totaldt-tpart) then
    dt=totaldt-tpart
   else
    laststep=.FALSE.
   endif
   eth0=eth2
   if(eth0.LE.ethmin) then
      eth0=ethmin
      tnowpassed=.TRUE.
   endif  
   if(eth0.GE.ethmax) then
      eth0=ethmax
      tnowpassed=.TRUE.
   endif  
  else	    
   laststep=.FALSE.
   dt=safefac*dt*SQRT(ABS((ttolerance*eth0)/(eth1-eth2)))
   goto 10	   
  endif
  jmax=MAX(jmax,j)
  call heco(he,co,eth0,p)	   
  deth1=deth+(he-co)
 enddo
 endif
 drad=he-co
 deth=(eth0-eth)/totaldt
 eth=eth0
 imax=max(i,imax)
end subroutine

subroutine extrapethrho   ! extrapolate rho, etc??
 include 'globals.h'
 real dt
 dt=tnow-teth
 if(.NOT.isotherm) then
  call extrapeth(dt)
  if(radiate) call temperature
 else
  call extraprho(dt)
 endif
 estar=estar+sum(starfuv(nbodies-nstar+1:nbodies))*dt
 teth=tnow
end subroutine

subroutine extraprho(dt)
  include 'globals.h'
  real dt,hsmfac
  integer p
!$omp parallel do shared(dt) private(p,hsmfac)
  do p=1,nsph
    rho(p)=rho(p)*exp(-hsmdivv(p)/hsmooth(p)*dt)
    hsmfac=exp(hsmdivv(p)/hsmooth(p)*dt/3)
    hsmooth(p)=hsmooth(p)*hsmfac
    hsmdivv(p)=hsmdivv(p)*hsmfac
    hsmcurlv(p)=hsmcurlv(p)*hsmfac

    if(eps_is_h) then
      if(mingaseps) then 
        epsgrav(p)=max(epsgas,hsmooth(p))
      else
        epsgrav(p)=hsmooth(p)
      endif  
    endif

  enddo
end subroutine

subroutine extrapeth(dt)
!  extrapolate eth to current tnow
!  using old dethdt
!  take eth/ ent step (isochoric approx.) by explicit integration
!  stabilized by use of adaptive int. 
!  note: interpolation in density ?
!  note2: control variables (eradiate etc) ok?
!  note3: cosmo ok?		
 include 'globals.h'
 integer p,i,imax,j,jmax
 real dt,eth,deth,drad,lerad,lhe
 real l_eradiate,l_snheat,l_efuvheat,l_eradcool
 real ethtoent,hsmfac
 real time1,time2,mintime,maxtime,tottime
				
  imax=0
  jmax=0
  mintime=1.e10
  maxtime=0.
  tottime=0.

!$omp parallel private(deth,eth,p,lhe,lerad,drad, &
!$omp ethtoent,time1,time2,hsmfac) &
!$omp shared(dt) &
!$omp reduction(+ : tottime) & 
!$omp reduction(max : jmax,imax,maxtime)	&
!$omp reduction(min : mintime)
  call wall_time(time1)
!$omp do
  do p=1,nsph
   if(rho(p).EQ.0) cycle
   dethdt(p)=dethdt(p) ! note that here extrapolation should be done (only cosmo??)	         
   if(uentropy) then
    ethtoent=gamma1/rho(p)**gamma1
   else
    ethtoent=1
   endif  
   eth=ethermal(p)/ethtoent
   deth=dethdt(p)/ethtoent
   drad=derad(p)
   call exstepp(p,dt,eth,deth,drad,lerad,lhe,imax,jmax)

   rho(p)=rho(p)*exp(-hsmdivv(p)/hsmooth(p)*dt)
   hsmfac=exp(hsmdivv(p)/hsmooth(p)*dt/3)
   hsmooth(p)=hsmooth(p)*hsmfac
   hsmdivv(p)=hsmdivv(p)*hsmfac
   hsmcurlv(p)=hsmcurlv(p)*hsmfac

   if(eps_is_h) then
     if(mingaseps) then 
      epsgrav(p)=max(epsgas,hsmooth(p))
     else
      epsgrav(p)=hsmooth(p)
     endif  
   endif

   if(uentropy) then
    ethtoent=gamma1/rho(p)**gamma1
   else
    ethtoent=1
   endif  

   ethermal(p)=eth*ethtoent
   csound(p)=SQRT(gamma*gamma1*eth)
   derad(p)=drad  
  enddo
!$omp enddo nowait 
  call wall_time(time2)
  mintime=MIN(mintime,time2-time1)
  maxtime=MAX(maxtime,time2-time1)
  tottime=tottime+time2-time1
!$omp end parallel
  if(verbosity.GT.0) then
   write(*,'(" <exstep> time:", 3f8.2)') mintime,maxtime,tottime
   print*,'<exstep> max iterations:',imax,jmax
  endif	
 end


subroutine exstep2(pc)
!  take half an ethermal step
!  using ethold
!  take eth/ ent step (isochoric approx.) by explicit integration
!  stabilized by use of adaptive int. 
!  note: interpolation in density ?
!  note2: control variables (eradiate etc) ok?
!  note3: cosmo ok?		
 include 'globals.h'
 integer pc
 integer k,p,i,imax,j,jmax
 real dt,eth,deth,drad,lerad,lhe
 real l_eradiate,l_snheat,l_efuvheat,l_eradcool
 real ethtoent
 real time1,time2,mintime,maxtime,tottime
				
  imax=0
  jmax=0
  mintime=1.e10
  maxtime=0.
  tottime=0.
!$omp parallel private(deth,eth,p,k,drad,dt, &
!$omp l_eradiate,l_snheat,l_efuvheat,l_eradcool, &
!$omp ethtoent,time1,time2,lhe,lerad) &
!$omp reduction(+ : eradiate,snheat,efuvheat,eradcool,tottime) & 
!$omp reduction(max : jmax,imax,maxtime)	 &
!$omp reduction(min : mintime) 
        call wall_time(time1)
!$omp do
  do k=1,nsphact
   p=pactive(k)
   if(rho(p).EQ.0) cycle
   if(uentropy) then
    ethtoent=gamma1/rho(p)**gamma1
   else
    ethtoent=1
   endif  
   eth=ethold(p)/ethtoent
   deth=dethdt(p)/ethtoent ! note: no cosmo correction
   drad=derad(p)
   dt=dtime/2**itimestp(p)
!   if(dt.NE.tnow-tvel(p)) print*,'TE',p,dt,tnow-tvel(p) ! should be the same 
   call exstepp(p,dt,eth,deth,drad,lerad,lhe,imax,jmax)
   if(pc.EQ.1.OR.pc.EQ.2) then
    csound(p)=SQRT(gamma*gamma1*eth)
    ethermal(p)=eth*ethtoent
    derad(p)=drad  
   endif
   if(pc.EQ.2.OR.pc.EQ.3) then
    ethold(p)=eth*ethtoent
    l_eradiate=mass(p)*lerad
    l_snheat=dt*mass(p)*esnthdt(p)
    l_efuvheat=mass(p)*(lhe/fhydrogn-2*dt*esnthdt(p))
    l_eradcool=l_eradiate/fhydrogn
    eradiate=eradiate+l_eradiate
    snheat=snheat+l_snheat
    efuvheat=efuvheat+l_efuvheat
    eradcool=eradcool+l_eradcool
   endif 
  enddo
!$omp enddo nowait 
  call wall_time(time2)
  mintime=MIN(mintime,time2-time1)
  maxtime=MAX(maxtime,time2-time1)
  tottime=tottime+time2-time1
!$omp end parallel
  if(verbosity.GT.0) then
   write(*,'(" <exstep2> time:", 3f8.2)') mintime,maxtime,tottime
   print*,'<exstep2> max iterations:',imax,jmax
  endif	
 end

Subroutine mrgrnk (NVAL,XDONT, IRNGT)
! from: ORDERPACK (Michel Olagnon) 
! __________________________________________________________
!   MRGRNK = Merge-sort ranking of an array
!   For performance reasons, the first 2 passes are taken
!   out of the standard loop, and use dedicated coding.
! __________________________________________________________
! __________________________________________________________
      Real, Dimension (*), Intent (In) :: XDONT
      Integer, Dimension (*), Intent (Out) :: IRNGT
! __________________________________________________________
      Real :: XVALA, XVALB
!
      Integer, allocatable :: JWRKT(:)
      Integer :: LMTNA, LMTNC, IRNG1, IRNG2
      Integer :: NVAL, IIND, IWRKD, IWRK, IWRKF, JINDA, IINDA, IINDB
!
      Select Case (NVAL)
      Case (:0)
         Return
      Case (1)
         IRNGT (1) = 1
         Return
      Case Default
         Continue
      End Select

      allocate(jwrkt(NVAL))
!
!  Fill-in the index array, creating ordered couples
!
      Do IIND = 2, NVAL, 2
         If (XDONT(IIND-1) <= XDONT(IIND)) Then
            IRNGT (IIND-1) = IIND - 1
            IRNGT (IIND) = IIND
         Else
            IRNGT (IIND-1) = IIND
            IRNGT (IIND) = IIND - 1
         End If
      End Do
      If (Modulo(NVAL, 2) /= 0) Then
         IRNGT (NVAL) = NVAL
      End If
!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into     C   -   C   - ...
!
      LMTNA = 2
      LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
      Do
         If (NVAL <= 2) Exit
!
!   Loop on merges of A and B into C
!
         Do IWRKD = 0, NVAL - 1, 4
            If ((IWRKD+4) > NVAL) Then
               If ((IWRKD+2) >= NVAL) Exit
!
!   1 2 3
!
               If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Exit
!
!   1 3 2
!
               If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
                  IRNG2 = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNG2
!
!   3 1 2
!
               Else
                  IRNG1 = IRNGT (IWRKD+1)
                  IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+2)
                  IRNGT (IWRKD+2) = IRNG1
               End If
               Exit
            End If
!
!   1 2 3 4
!
            If (XDONT(IRNGT(IWRKD+2)) <= XDONT(IRNGT(IWRKD+3))) Cycle
!
!   1 3 x x
!
            If (XDONT(IRNGT(IWRKD+1)) <= XDONT(IRNGT(IWRKD+3))) Then
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+2) = IRNGT (IWRKD+3)
               If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   1 3 2 4
                  IRNGT (IWRKD+3) = IRNG2
               Else
!   1 3 4 2
                  IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+4) = IRNG2
               End If
!
!   3 x x x
!
            Else
               IRNG1 = IRNGT (IWRKD+1)
               IRNG2 = IRNGT (IWRKD+2)
               IRNGT (IWRKD+1) = IRNGT (IWRKD+3)
               If (XDONT(IRNG1) <= XDONT(IRNGT(IWRKD+4))) Then
                  IRNGT (IWRKD+2) = IRNG1
                  If (XDONT(IRNG2) <= XDONT(IRNGT(IWRKD+4))) Then
!   3 1 2 4
                     IRNGT (IWRKD+3) = IRNG2
                  Else
!   3 1 4 2
                     IRNGT (IWRKD+3) = IRNGT (IWRKD+4)
                     IRNGT (IWRKD+4) = IRNG2
                  End If
               Else
!   3 4 1 2
                  IRNGT (IWRKD+2) = IRNGT (IWRKD+4)
                  IRNGT (IWRKD+3) = IRNG1
                  IRNGT (IWRKD+4) = IRNG2
               End If
            End If
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 4
         Exit
      End Do
!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
      Do
         If (LMTNA >= NVAL) Exit
         IWRKF = 0
         LMTNC = 2 * LMTNC
!
!   Loop on merges of A and B into C
!
         Do
            IWRK = IWRKF
            IWRKD = IWRKF + 1
            JINDA = IWRKF + LMTNA
            IWRKF = IWRKF + LMTNC
            If (IWRKF >= NVAL) Then
               If (JINDA >= NVAL) Exit
               IWRKF = NVAL
            End If
            IINDA = 1
            IINDB = JINDA + 1
!
!   Shortcut for the case when the max of A is smaller
!   than the min of B. This line may be activated when the
!   initial set is already close to sorted.
!
!          IF (XDONT(IRNGT(JINDA)) <= XDONT(IRNGT(IINDB))) CYCLE
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
            JWRKT (1:LMTNA) = IRNGT (IWRKD:JINDA)
!
            XVALA = XDONT (JWRKT(IINDA))
            XVALB = XDONT (IRNGT(IINDB))
!
            Do
               IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
               If (XVALA > XVALB) Then
                  IRNGT (IWRK) = IRNGT (IINDB)
                  IINDB = IINDB + 1
                  If (IINDB > IWRKF) Then
!  Only A still with unprocessed values
                     IRNGT (IWRK+1:IWRKF) = JWRKT (IINDA:LMTNA)
                     Exit
                  End If
                  XVALB = XDONT (IRNGT(IINDB))
               Else
                  IRNGT (IWRK) = JWRKT (IINDA)
                  IINDA = IINDA + 1
                  If (IINDA > LMTNA) Exit! Only B still with unprocessed values
                  XVALA = XDONT (JWRKT(IINDA))
               End If
!
            End Do
         End Do
!
!  The Cs become As and Bs
!
         LMTNA = 2 * LMTNA
      End Do
!
      deallocate(jwrkt)

!
End Subroutine mrgrnk

subroutine terror(message)
  character(len=*) message
  print*, message
  stop "aborting"
end subroutine

function rtime()
  real :: rtime
  real, save :: ttot=-1.
  integer, save :: c1
  integer :: c2,c,cr,cmax,threads
!$ integer :: omp_get_num_threads

  threads=1
!$ threads=omp_get_num_threads()
  
  if(ttot.lt.0) then
    if(threads.NE.1) then
      call terror("error: call rtime first outside openmp region") 
    endif
    call system_clock(count=c1,count_rate=cr,count_max=cmax)
!    write(*,'("  max. timestep (hrs):", f8.2)') float(cmax)/float(cr)/3600.
    ttot=0.
  endif 

  call system_clock(count=c2,count_rate=cr,count_max=cmax)
  c=(c2-c1)
  if(c.lt.0) c=c+cmax
  if(threads.EQ.1) then
    c1=c2
    ttot=ttot+float(c)/float(cr)
    rtime=ttot/3600.0
    return
  endif
  rtime=(ttot+float(c)/float(cr))/3600.0
end function

subroutine wall_time(x)
  real :: x,rtime
  x=rtime()*3600.
end subroutine

subroutine aggtimers(k)
 integer k,i
 real, save :: timers(0:7)=0.
 real, save :: t1=0.,t2=0.
 real :: rtime
  t1=t2
  t2=rtime() 
  timers(0)=timers(0)+(t2-t1)
 if(k.LT.0) timers=0.
 if(k.GT.0.AND.k.LE.7) then
  timers(k)=timers(k)+(t2-t1)
 endif
 if(k.eq.0) &
 write(*,'("timings:", e10.2, e10.2,7f7.3)') timers(0), sum(timers(1:7)),(timers(i)/sum(timers(1:7)),i=1,7)
end subroutine

module pmgravMod
 implicit none
 private
 public :: pmgravInit,pmgravEnd,pmgrav,pmgravaccpot,dmeshQ,softQ,rcutQ, & 
            ficorrect,forcecorrect
 real,parameter ::  PI=3.14159265358979323846
 integer :: ngrid            ! treePM grid size
 real  :: rsoft=.75          ! treePM softening parameter (cells)
 real :: rcut=4.5            ! cutoff radius (for tree) (*rsoft)
 real :: dmesh
 real :: boxmin(3)=0.,boxmax(3)=0.
 
 real, allocatable :: pot(:,:,:)
 real, allocatable :: accx(:,:,:),accy(:,:,:),accz(:,:,:)
 complex, allocatable :: fpot(:,:,:),fkernel(:,:,:)

 integer*8 :: plan,iplan

 logical, parameter :: periodic=.false.
   
 contains
 
 subroutine pmgravInit(n,bmin,bmax,rs)
 include 'fftw3.f'
  integer :: n,test,nthreads,i(3),i1(3)
  real :: bmin(3),bmax(3),bc(3),bs,dx(3)
  real, optional :: rs
!$  integer,external :: omp_get_max_threads
  
  ngrid=n
  bs=maxval(bmax-bmin)
  if(bs.LE.0) call Error("zero box size")
  
  if(periodic) dmesh=bs/ngrid
  if(.not.periodic) dmesh=bs/(ngrid/2-6)
  bc=0.5*(boxmax+boxmin)
  if(periodic) then
   boxmin=bc-dmesh*ngrid/2.
   boxmax=bc+dmesh*ngrid/2.
  else
   boxmin=bc-dmesh*ngrid/4.
   boxmax=bc+dmesh*3*ngrid/4.
  endif
  if(present(rs)) rsoft=rs  


  allocate(pot(ngrid,ngrid,ngrid), & 
	      fkernel(ngrid/2+1,ngrid,ngrid), &
	      fpot(ngrid/2+1,ngrid,ngrid),stat=test)
  if(test.NE.0) call Error("memory allocation failure 1") 

  if(.not.periodic) &
  allocate(accx(ngrid/2-2,ngrid/2-2,ngrid/2-2), & 
	   accy(ngrid/2-2,ngrid/2-2,ngrid/2-2), &
	   accz(ngrid/2-2,ngrid/2-2,ngrid/2-2), stat=test)
  if(periodic) &
  allocate(accx(ngrid,ngrid,ngrid), & 
	   accy(ngrid,ngrid,ngrid), &
	   accz(ngrid,ngrid,ngrid), stat=test)	   
  if(test.NE.0) call Error("memory allocation failure 2") 

! fftw init  
 nthreads=1
!$ nthreads=omp_get_max_threads()
!$ call dfftw_init_threads
!$ call dfftw_plan_with_nthreads(nthreads)

 call dfftw_plan_dft_r2c_3d(plan,n,n,n,pot,fpot,FFTW_ESTIMATE)
 call dfftw_plan_dft_c2r_3d(iplan,n,n,n,fpot,pot,FFTW_ESTIMATE)

 call makekernel

 end subroutine 
 
 subroutine pmgravEnd
 
  if(allocated(pot)) deallocate(pot,accx,accy,accz,fpot,fkernel)
  
! fftw stuff  
 call dfftw_destroy_plan(plan) 
 call dfftw_destroy_plan(iplan) 
!$ call dfftw_cleanup_threads
 
 end subroutine
 
 subroutine makeKernel
  integer :: i,j,k
  real :: x,y,z,fx,fy,fz,fac,kx,ky,kz,r,u,k2

  pot=0.
  fkernel=0.
  
!$omp parallel do  private(i,j,k,x,y,z,fx,fy,fz,fac,kx,ky,kz,r,u,k2) &
!$omp shared(pot,rsoft,ngrid)
  do k=1,ngrid
   do j=1,ngrid
    do i=1,ngrid
      x=(i-1.)/ngrid
      if(x.GE.0.5) x=x-1.
      y=(j-1.)/ngrid
      if(y.GE.0.5) y=y-1.
      z=(k-1.)/ngrid
      if(z.GE.0.5) z=z-1.
      r=sqrt(x**2+y**2+z**2)
      u=0.5*r/rsoft*ngrid
      fac=1-erfc(u)
      if(r.GT.0) then 
       pot(i,j,k)=-fac/r
      else
       pot(i,j,k)=-1/sqrt(PI)/rsoft*ngrid
      endif
    enddo
   enddo
  enddo  
  call dfftw_execute(plan)

!$omp parallel do  private(i,j,k,x,y,z,fx,fy,fz,fac,kx,ky,kz,r,u,k2) &
!$omp shared(fpot,fkernel,rsoft,ngrid)
 do k=1,ngrid
  do j=1,ngrid
   do i=1,ngrid/2+1
    kx=(i-1)
    if(kx.GT.ngrid/2) kx=(i-1)-ngrid
    ky=(j-1)
    if(ky.GT.ngrid/2) ky=(j-1)-ngrid
    kz=(k-1)
    if(kz.GT.ngrid/2) kz=(k-1)-ngrid
    k2=kx**2+ky**2+kz**2
    if(k2.GT.0) then
      fx=1;fy=1;fz=1
      if(kx.NE.0) fx=sin(PI*kx/ngrid)*ngrid/PI/kx
      if(ky.NE.0) fy=sin(PI*ky/ngrid)*ngrid/PI/ky
      if(kz.NE.0) fz=sin(PI*kz/ngrid)*ngrid/PI/kz
      fac=(fx*fy*fz)**(-4)
      fkernel(i,j,k)=fpot(i,j,k)*fac
    endif
   enddo
  enddo
 enddo   
 fkernel(1,1,1)=fpot(1,1,1) 
 end subroutine
 
 
 subroutine pmgrav(n,mass,pos)
  integer, intent(in) :: n
  integer :: k
  real,intent(in) :: mass(:), pos(:,:)

 if(.not.allocated(pot)) call Error(" pmgravInit not called")

 pot=0.
 call cic(n,mass,pos) 
 call dfftw_execute(plan)

!$omp parallel do shared(fpot,fkernel,dmesh,ngrid)
 do k=1,ngrid
 fpot(1:ngrid/2+1,1:ngrid,k)=fpot(1:ngrid/2+1,1:ngrid,k)* &
      fkernel(1:ngrid/2+1,1:ngrid,k)/REAL(ngrid)**4/dmesh
 enddo
 call dfftw_execute(iplan)
 
 call setacc
 
 end subroutine
 
 subroutine setacc
  integer :: i,j,k
!$omp parallel do private( i,j,k) &
!$omp shared(pot,accx,accy,accz)
 do k=3,ngrid/2-2
  do j=3,ngrid/2-2
   do i=3,ngrid/2-2
 accx(i,j,k)=-1/dmesh* &
  (pot(i-2,j,k)/12-2*pot(i-1,j,k)/3+2*pot(i+1,j,k)/3-pot(i+2,j,k)/12)
 accy(i,j,k)=-1/dmesh* &
  (pot(i,j-2,k)/12-2*pot(i,j-1,k)/3+2*pot(i,j+1,k)/3-pot(i,j+2,k)/12)
 accz(i,j,k)=-1/dmesh* &
  (pot(i,j,k-2)/12-2*pot(i,j,k-1)/3+2*pot(i,j,k+1)/3-pot(i,j,k+2)/12)
    enddo
   enddo
  enddo  
 end subroutine

 subroutine setacc2
  integer :: i,j,k,i1,i2,i22,i11,j1,j2,j11,j22,k1,k2,k11,k22
!$omp parallel do private( i,j,k,i1,i2,i22,i11,j1,j2,j11,j22,k1,k2,k11,k22) &
!$omp shared(pot,accx,accy,accz)
 do k=1,ngrid
  do j=1,ngrid
   do i=1,ngrid
 i2=MODULO(i-3,ngrid)+1
 i1=MODULO(i-2,ngrid)+1
 i11=MODULO(i,ngrid)+1
 i22=MODULO(i+1,ngrid)+1
 j2=MODULO(j-3,ngrid)+1
 j1=MODULO(j-2,ngrid)+1
 j11=MODULO(j,ngrid)+1
 j22=MODULO(j+1,ngrid)+1
 k2=MODULO(k-3,ngrid)+1
 k1=MODULO(k-2,ngrid)+1
 k11=MODULO(k,ngrid)+1
 k22=MODULO(k+1,ngrid)+1
 accx(i,j,k)=-1/dmesh* &
  (pot(i2,j,k)/12-2*pot(i1,j,k)/3+2*pot(i11,j,k)/3-pot(i22,j,k)/12)
 accy(i,j,k)=-1/dmesh* &
  (pot(i,j2,k)/12-2*pot(i,j1,k)/3+2*pot(i,j11,k)/3-pot(i,j22,k)/12)
 accz(i,j,k)=-1/dmesh* &
  (pot(i,j,k2)/12-2*pot(i,j,k1)/3+2*pot(i,j,k11)/3-pot(i,j,k22)/12)
    enddo
   enddo
  enddo  
 end subroutine

 
 subroutine pmgravaccpot(ppos,pacc,ppot)
  real :: ppos(3)
  real, optional :: pacc(3),ppot
  real :: dx(3)
  integer :: i(3),i1(3)

  call getindices(ppos,i,i1,dx)
  if(i1(1).GT.ngrid) i1(1)=1
  if(i1(2).GT.ngrid) i1(2)=1
  if(i1(3).GT.ngrid) i1(3)=1
  if(present(pacc)) then
   pacc(1)=pacc(1)+interpolate(i,i1,dx,accx)
   pacc(2)=pacc(2)+interpolate(i,i1,dx,accy)
   pacc(3)=pacc(3)+interpolate(i,i1,dx,accz) 
  endif
  if(present(ppot)) ppot=ppot+interpolate(i,i1,dx,pot)
 end subroutine
  
 subroutine cic(n,mass,pos)
  integer,intent(in) :: n
  real,intent(in) :: mass(:),pos(:,:)
  integer :: p,i(3),j,k,i1(3),ii,iii,jj,kk
  real :: dx(3),ppos(3),pmass    
  real, allocatable :: localpot(:,:,:) 
  integer :: mythread,totalthread
  integer :: imin(3),imax(3),pmin,pmax,test
!$  integer, external :: omp_get_thread_num,omp_get_num_threads
!$omp parallel &
!$omp default(private) &
!$omp shared(pot,ngrid,pos,mass,n)
  mythread=0
  totalthread=1
!$ mythread=omp_get_thread_num()
!$ totalthread=omp_get_num_threads()
  pmin=(mythread*n)/totalthread+1
  pmax=MIN(((mythread+1)*n)/totalthread,n)
  if(pmax-pmin+1.GT.0) then
! find local extent 
  imin=ngrid
  imax=1
  do p=pmin,pmax
   ppos=pos(p,1:3)
   pmass=mass(p)
   if(pmass.GT.0) then
    call getindices(ppos,i,i1,dx) 
    imin=min(imin,i)   
    imax=max(imax,i1)  
   endif  
  enddo
  allocate(localpot(imin(1):imax(1),imin(2):imax(2),imin(3):imax(3)), &
        stat=test)  
  if(test.NE.0) call Error("local mem. alloc fails")  
  localpot=0.
  do p=pmin,pmax
   ppos=pos(p,1:3)
   pmass=mass(p)
   if(pmass.GT.0) then
    call getindices(ppos,i,i1,dx)
    localpot(i1(1),i1(2),i1(3))=localpot(i1(1),i1(2),i1(3))+pmass*dx(1)*dx(2)*dx(3)
    localpot(i(1), i1(2),i1(3))=localpot(i(1), i1(2),i1(3))+pmass*(1-dx(1))*dx(2)*dx(3)
    localpot(i1(1),i(2), i1(3))=localpot(i1(1),i(2), i1(3))+pmass*dx(1)*(1-dx(2))*dx(3)
    localpot(i(1), i(2), i1(3))=localpot(i(1), i(2), i1(3))+pmass*(1-dx(1))*(1-dx(2))*dx(3)
    localpot(i1(1),i1(2),i(3)) =localpot(i1(1),i1(2),i(3)) +pmass*dx(1)*dx(2)*(1-dx(3))
    localpot(i(1), i1(2),i(3)) =localpot(i(1), i1(2),i(3)) +pmass*(1-dx(1))*dx(2)*(1-dx(3))
    localpot(i1(1),i(2), i(3)) =localpot(i1(1),i(2), i(3)) +pmass*dx(1)*(1-dx(2))*(1-dx(3))
    localpot(i(1), i(2), i(3)) =localpot(i(1), i(2), i(3)) +pmass*(1-dx(1))*(1-dx(2))*(1-dx(3))
   endif
  enddo  
!$omp critical
  do k=imin(3),imax(3)
   do j=imin(2),imax(2)
    do ii=imin(1),imax(1)
    iii=ii;jj=j;kk=k
    if(ii.GT.ngrid) iii=1
    if(j.GT.ngrid) jj=1
    if(k.GT.ngrid) kk=1
    pot(iii,jj,kk)=pot(iii,jj,kk)+localpot(ii,j,k)
    enddo
   enddo
  enddo  
 !$omp end critical  
  deallocate(localpot)
  endif  
!$omp end parallel  
 end subroutine 

 subroutine getindices(ppos,i,i1,dx)
  real ppos(3),dx(3)
  integer :: i(3),i1(3),k
   do k=1,3
    dx(k)=(ppos(k)-boxmin(k))/dmesh
    if(dx(k).lt.0.OR.dx(k).GT.ngrid) call Error("part. outside box")   
    i(k)=FLOOR(dx(k))+1
    i1(k)=i(k)+1
    dx(k)=dx(k)-(i(k)-1)
   enddo   
 end subroutine

 subroutine spread(mass,i,i1,dx,arr)
  real :: dx(3),arr(:,:,:),mass
  integer :: i(3),i1(3)
  arr(i1(1),i1(2),i1(3))=arr(i1(1),i1(2),i1(3))+mass*dx(1)*dx(2)*dx(3)
  arr(i(1), i1(2),i1(3))=arr(i(1), i1(2),i1(3))+mass*(1-dx(1))*dx(2)*dx(3)
  arr(i1(1),i(2), i1(3))=arr(i1(1),i(2), i1(3))+mass*dx(1)*(1-dx(2))*dx(3)
  arr(i(1), i(2), i1(3))=arr(i(1), i(2), i1(3))+mass*(1-dx(1))*(1-dx(2))*dx(3)
  arr(i1(1),i1(2),i(3)) =arr(i1(1),i1(2),i(3)) +mass*dx(1)*dx(2)*(1-dx(3))
  arr(i(1), i1(2),i(3)) =arr(i(1), i1(2),i(3)) +mass*(1-dx(1))*dx(2)*(1-dx(3))
  arr(i1(1),i(2), i(3)) =arr(i1(1),i(2), i(3)) +mass*dx(1)*(1-dx(2))*(1-dx(3))
  arr(i(1), i(2), i(3)) =arr(i(1), i(2), i(3)) +mass*(1-dx(1))*(1-dx(2))*(1-dx(3))
 end subroutine

 function interpolate(i,i1,dx,arr) result(y)
  real :: dx(3),arr(:,:,:),y
  integer :: i(3),i1(3)
 y= arr(i1(1),i1(2),i1(3))*dx(1)*dx(2)*dx(3)+ &
    arr(i(1),i1(2),i1(3))  *(1-dx(1))*dx(2)*dx(3)+ &
    arr(i1(1),i(2),i1(3))  *dx(1)*(1-dx(2))*dx(3)+ &
    arr(i(1),i(2),i1(3)) *(1-dx(1))*(1-dx(2))*dx(3)+ &
    arr(i1(1),i1(2),i(3))  *dx(1)*dx(2)*(1-dx(3))+ &
    arr(i(1),i1(2),i(3)) *(1-dx(1))*dx(2)*(1-dx(3))+ &
    arr(i1(1),i(2),i(3)) *dx(1)*(1-dx(2))*(1-dx(3))+ &
    arr(i(1),i(2),i(3))*(1-dx(1))*(1-dx(2))*(1-dx(3))
 end function

 function ficorrect(r) result(y)
  real :: y,r
  y=erfc(r/2)
 end function

 function forcecorrect(r) result(y)
  real :: y,r
  y=erfc(r/2)+r/sqrt(PI)*exp(-r**2/4)
 end function
 
 real function dmeshQ()
  dmeshQ=dmesh
 end function

 real function softQ()
  softQ=rsoft*dmesh
 end function

 real function rcutQ()
  rcutQ=rcut*rsoft*dmesh
 end function

  
  subroutine Error(string,i)
  character(*) :: string
  integer, optional :: i

  print*,' pmgrav Error detected:'

  if(present(i)) then
   print*,string,i
  else
   print*,string
  endif

  stop
 end subroutine

end module 



subroutine testpm
 use pmgravMod
 real mass(1),pos(1,3),bmin(3),bmax(3),ppos(3),pot,pacc(3)
 integer i
 mass(1)=1
 pos=0.
 bmin=-1
 bmax=1

 call pmgravInit(256,bmin,bmax)
 call pmgrav(1,mass,pos)

ppos=0.
 do i=0,1000
  ppos=i/1000.
  pot=0.
  pacc=0.
  call pmgravaccpot(ppos,ppot=pot,pacc=pacc)
  write(*,*) sqrt(sum((ppos)**2)),sqrt(sum(pacc**2))
 enddo

end

module fixedhalomod
 implicit none

private
public :: initfixedhalo,endfixedhalo,fixedhaloacc,fixedhalopot,fixedhalotidalfield
public :: fixedhalopos, fixedhalomass

  integer, parameter :: iounit=19 
  real,parameter :: pi=3.14159265358979

  real :: fixedhalopos(3),fixedhalomass

  integer :: nhalo
  real, allocatable :: radhalo(:),fourpirho(:),pothalo(:),mhalo(:)
  
 contains

subroutine initfixedhalo(pos,halofile)
 character(len=*) :: halofile
 real :: pos(3)
 integer :: i,ioerror
  
 if(allocated(radhalo)) then
  print*,' ** warning: fixedhalomod already initialized **'
  return
 endif 

 fixedhalopos=pos
 
 open(iounit,FILE=halofile, STATUS='OLD',iostat=ioerror)
 if(ioerror.NE.0) call Error(' stop -- error opening halofile: '//halofile)
 
 read(iounit,*) nhalo
 if(nhalo.LE.10.OR.nhalo.GT.10000000) call Error('nhalo of file: '//halofile)

 allocate(radhalo(nhalo),fourpirho(nhalo),mhalo(nhalo), &
         pothalo(nhalo))
 do i=1,nhalo
   read(iounit,*,iostat=ioerror) radhalo(i),fourpirho(i),mhalo(i),pothalo(i)
   if(ioerror.NE.0) call Error(' error reading halofile: '//halofile)
   if(i.GE.2) then
      if(radhalo(i).LE.radhalo(i-1)) &
         call Error(' ordering in halofile: '//halofile,i)
      if(mhalo(i).LT.mhalo(i-1)) mhalo(i)=mhalo(i-1)   
   endif
 enddo
 close(iounit)

 fixedhalomass=mhalo(nhalo)
 pothalo(1:nhalo)=pothalo(1:nhalo)-(fixedhalomass/radhalo(nhalo)+pothalo(nhalo))
 fourpirho=4*pi*radhalo**2*fourpirho 	
         
end subroutine

function fixedhalopot(pos) result(pot)
 real pos(3),pot,r,r2
 r2=sum((pos-fixedhalopos)**2)
 r=sqrt(r2)
 if(r.GE.radhalo(nhalo)) then
  pot=-fixedhalomass/r
 else
   if(r.LE.radhalo(2)) then
      pot=pothalo(2)-mhalo(2)/2/radhalo(2)* &
            (1-r2/radhalo(2)**2)
   else
      pot=linearlookup(nhalo,radhalo,pothalo,r) 
   endif
 endif
end function

function fixedhaloacc(pos) result(acc)
 real pos(3),acc(3),r,r2,m

 r2=sum((pos-fixedhalopos)**2)
 r=sqrt(r2)
 if(r.GE.radhalo(nhalo)) then
   acc=-(pos-fixedhalopos)*fixedhalomass/r2/r
 else
   if(r.LT.radhalo(2)) then
      r=radhalo(2)
      r2=r**2
   endif
   m=hermitelookup(nhalo,radhalo,mhalo,fourpirho,r)   
   acc=-(pos-fixedhalopos)*m/r2/r
 endif
end function

function fixedhalotidalfield(pos) result(tide)
 real pos(3),tide(6),r,r2,m,dm,dr3i,dr5i,dx,dy,dz

 dx=pos(1)-fixedhalopos(1)
 dy=pos(2)-fixedhalopos(2)
 dz=pos(3)-fixedhalopos(3)
 r2=dx**2+dy**2+dz**2
 r=sqrt(r2)
 if(r.GE.radhalo(nhalo)) then
   dr3i=fixedhalomass/(r2*r)
   dr5i=3*fixedhalomass/(r2*r2*r)
 else  
   if(r.LT.radhalo(2)) then
      dr3i=mhalo(2)/radhalo(2)**3
      dr5i=0
   else
      call hermitelookup_deriv(nhalo,radhalo,mhalo,fourpirho,r,m,dm)
      dr3i=m/(r2*r)
      dr5i=(3*m-dm*r)/(r2*r2*r)
   endif
 endif
 tide(1)=(-dr3i+dx**2*dr5i)
 tide(4)=(-dr3i+dy**2*dr5i)
 tide(6)=(-dr3i+dz**2*dr5i)
 tide(2)=(dx*dy*dr5i)
 tide(3)=(dx*dz*dr5i)
 tide(5)=(dy*dz*dr5i)
end function

subroutine endfixedhalo

 deallocate(radhalo,fourpirho,mhalo,pothalo)

end subroutine

! -------------------utility functions below

 function findbin(n,ylist,y) result (bin)
  integer :: n,bin
  real :: ylist(n),y,s

  if(ylist(1).LT.ylist(n)) then
   s=1
  else
   s=-1
  endif  
  
 bin=findbin_const(n,ylist,y)
 if( (bin.LE.1.AND.s*ylist(1).GE.s*y).OR. &
      (bin.GE.n+1.AND.s*ylist(n).LE.s*y).OR. &
      (s*ylist(bin-1).LE.s*y.AND.s*ylist(bin).GE.s*y)) return
 bin=findbin_bisect(n,ylist,y)
 if( (bin.LE.1.AND.s*ylist(1).GE.s*y).OR. &
      (bin.GE.n+1.AND.s*ylist(n).LE.s*y).OR. &
      (s*ylist(bin-1).LE.s*y.AND.s*ylist(bin).GE.s*y)) return
 call Error('findbin failure') 

 end function

 function findbin_const(n,ylist,y) result (bin)
  integer :: n,bin
  real :: ylist(n),y,s,dr

  if(ylist(1).LT.ylist(n)) then
   s=1
  else
   s=-1
  endif  
  
  if(s*y.LE.s*ylist(1)) then
   bin=0
   return
  endif
  if(s*y.GE.s*ylist(n)) then
   bin=n+1  
   return
  endif

  dr=(ylist(n)-ylist(1))/(n-1)
  bin=INT((y-ylist(1))/dr)+2 ! 2 because: top index+fortran start at 1

 end function
 
 function findbin_bisect(n,ylist,y) result(bin)
  integer :: n,bin,up,low
  real :: ylist(n),y,s
  
  if(ylist(1).LT.ylist(n)) then
   s=1
  else
   s=-1
  endif  
  
  if(s*y.LE.s*ylist(1)) then
   bin=0
   return
  endif
  if(s*y.GE.s*ylist(n)) then
   bin=n+1  
   return
  endif
  up=n
  low=1
  do while((up-low).GT.1)
   bin=(low+up)/2
   if(s*y.LT.s*ylist(bin)) then
    up=bin
   else
    low=bin
   endif   
  enddo 
  bin=up
  end function

 function interpolatelinear(bin,n,xlist,ylist,x) result(y)
  integer :: n,bin,up,low
  real :: xlist(n),ylist(n),x,y,u,s
  if(bin.LE.1) then
   y=ylist(1)
   return
  endif 
  if(bin.GT.n) then
   y=ylist(n)
   return
  endif 
  if(xlist(bin).EQ.xlist(bin-1)) then
   y=(ylist(bin-1)+ylist(bin))/2
   return
  endif
  u=(x-xlist(bin-1))/(xlist(bin)-xlist(bin-1))
  y=(1-u)*ylist(bin-1)+u*ylist(bin)  
  return
 end function

 subroutine interpolatecubic(bin,n,xlist,ylist,yderiv,x,y,d)
  integer :: bin,n
  real :: xlist(n),ylist(n),yderiv(n),x,y,d
  real :: u,dy,dx,y1,yd1,yd2  
  if(bin.LE.1) then
   y=ylist(1)
   d=0.
   return
  endif 
  if(bin.GT.n) then
   y=ylist(n)
   d=0.
   return
  endif 
  dx=xlist(bin)-xlist(bin-1)
  dy=ylist(bin)-ylist(bin-1)
  if(dx.EQ.0) then
   y=(ylist(bin-1)+ylist(bin))/2
   d=(yderiv(bin-1)+yderiv(bin))/2
   return
  endif
  y1=ylist(bin-1)
  yd2=yderiv(bin)
  yd1=yderiv(bin-1)
  u=(x-xlist(bin-1))/(xlist(bin)-xlist(bin-1))
  y=u**3*(-2*dy+dx*(yd1+yd2))+u**2*(3*dy-dx*(2*yd1+yd2))+dx*yd1*u+y1
  d=(3*u**2*(-2*dy+dx*(yd1+yd2))+2*u*(3*dy-dx*(2*yd1+yd2))+dx*yd1)/ &
      (xlist(bin)-xlist(bin-1))
 end subroutine

 function hermitelookup(n,xlist,ylist,yderiv,x) result(y)
  integer :: n,bin
  real :: x,y,xlist(n),ylist(n),yderiv(n),d
  bin=findbin(n,xlist,x)
  call interpolatecubic(bin,n,xlist,ylist,yderiv,x,y,d)
 end function

 subroutine hermitelookup_deriv(n,xlist,ylist,yderiv,x,y,d)
  integer :: n,bin
  real :: x,y,xlist(n),ylist(n),yderiv(n),d
  bin=findbin(n,xlist,x)
  call interpolatecubic(bin,n,xlist,ylist,yderiv,x,y,d)
 end subroutine

 function linearlookup(n,xlist,ylist,x) result(y)
  integer :: n,bin
  real :: x,y,xlist(n),ylist(n)
  bin=findbin(n,xlist,x)
  y=interpolatelinear(bin,n,xlist,ylist,x)
 end function

subroutine Error(string,value)
 character(len=*) :: string
 integer, optional :: value
 
 print*,'--fixedHalo Mod Error--'
 print*,string
 if(present(value)) print*,value
 stop

end subroutine  

end module

subroutine accpothalo(ppos,pacc,pphi,option)
 use fixedhalomod
 include 'globals.h'
 character*4 :: option
 real :: ppos(3),pacc(3),pphi
 if(option.NE.'pot ') pacc=pacc+fixedhaloacc(ppos)
 if(option.NE.'acc ') pphi=pphi+fixedhalopot(ppos)
end subroutine

subroutine halotidalfield(ppos,ptide)
  use fixedhalomod
 real :: ppos(3),ptide(6)
 ptide=ptide+fixedhalotidalfield(ppos)
end subroutine

subroutine testhalo
 use fixedhalomod
 real pos(3),pot,acc(3),tide(6),dens,r
 integer i
 
 call initfixedhalo((/0.,0.,0./),"/home/inti/code/stars/data/hk_96_2.halo")

10 read*,pos
pot=fixedhalopot(pos)
acc=fixedhaloacc(pos)
tide=fixedhalotidalfield(pos)
dens=-(tide(1)+tide(4)+tide(6))/4/3.14159265358979
 r=sqrt(sum(pos**2))
 write(*,'(6g16.8)')  r,pot,acc,dens

 call endfixedhalo
end subroutine

module extractMod

 implicit none
 private
 public :: initextract,extractdensity,endextract

 integer, parameter :: dim=3
 real :: vertex(dim+1,dim)
 integer :: n(0:dim)
 real, allocatable, save :: pic(:,:,:)

 contains

subroutine initextract
 integer :: i,j

 n(0:dim)=0
 vertex(1:dim+1,1:dim)=0
 do i=1,dim
  print*,'# punten dim ',i; read*,n(i)
  if(n(i).LE.1) exit
 enddo  

 do i=1,dim
  n(i)=max(n(i),1)
 enddo 
 
 allocate(pic(n(1),n(2),n(3)))
 
 if(n(1).EQ.0) then
   print*,' extractdens heeft niks te doen!'
   return
 endif  
 
 do i=1,dim+1
  if(n(i-1).ge.2.OR.i.EQ.1) then 
    print*,'punt',i,'coordinaten?'
    read*,(vertex(i,j),j=1,dim)
    if(i.gt.1) vertex(i,1:dim)=vertex(i,1:dim)-vertex(1,1:dim)
  endif
 enddo
 
end subroutine

subroutine extractdensity(weights)
 
 real :: x(dim),t(dim),hsearch,dens,ddensdh,hn,weights(*),meana
 integer i,j,k,tot,nn,index(dim)
 character,dimension(dim) :: axes='xyz'

 hsearch=0.
 t(1:dim)=0  
 tot=1;   
 do i=1,dim
 tot=tot*n(i)
 enddo 
 
  
 do i=0,tot-1
  k=i
  x(1:dim)=vertex(1,1:dim)
  do j=1,dim
   if(n(j).EQ.1) then
    index(j:dim)=1
    exit
   endif
   t(j)=MOD(k,n(j))/REAL(n(j)-1)
   index(j)=MOD(k,n(j))+1
   x(1:dim)=x(1:dim)+t(j)*vertex(j+1,1:dim)
   k=k/n(j)   
  enddo
  nn=0
  hn=0
  call hsmdenspos(x(1:3),hsearch,dens,ddensdh,nn,hn)
  call gatter3(nn,x(1:3),hsearch,dens,ddensdh,meana,weights)
  pic(index(1),index(2),index(3))=meana
!  print*,'extractdensity:',(x(j),j=1,dim),gatscatdensity(x(1:3))
 enddo

end subroutine extractdensity

subroutine endextract(filename)
  character, optional :: filename*80
  character :: file*80
  integer :: naxes(3)
 
  if(present(filename)) then
   file=filename
  else
   print*,' uit filenaam?'
   read*, file
  endif
 
  naxes(1)=n(1)
  naxes(2)=n(2)
  naxes(3)=n(3)
  call writefits(file,3,naxes)
 
  deallocate(pic)
  
end subroutine 

 subroutine writefits(filename,naxis,naxes)
      integer status,unit,blocksize,bitpix,naxis,naxes(3)
      integer i,j,k,group,fpixel,nelements
      character filename*80
      logical simple,extend

      status=0

      call deletefile(filename,status)
      call ftgiou(unit,status)

      blocksize=1
      call ftinit(unit,filename,blocksize,status)

      simple=.true.
      bitpix=-64
      extend=.true.

      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)

      group=1
      fpixel=1
      nelements=1
      do i=1,naxis
       nelements=naxes(i)*nelements
      enddo
      call ftpprd(unit,group,fpixel,nelements,pic,status)

      call ftclos(unit, status)
      call ftfiou(unit, status)
      
      if (status .gt. 0)call printerror(status)
      end subroutine
          
      subroutine printerror(status)

      integer status
      character errtext*30,errmessage*80

      if (status .le. 0)return
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      enddo
      end subroutine
      
      
      subroutine deletefile(filename,status)
      integer status,unit,blocksize
      character*(*) filename

      if (status .gt. 0)return

      call ftgiou(unit,status)

      call ftopen(unit,filename,1,blocksize,status)

      if (status .eq. 0)then
          call ftdelt(unit,status)
      else if (status .eq. 103)then
          status=0
          call ftcmsg
      else
          status=0
          call ftcmsg
          call ftdelt(unit,status)
      end if

      call ftfiou(unit, status)
      end subroutine



end module

program extract
 use extractMod
 include 'globals.h'
 character*24 filenaam
 integer i,mapnr,nfeedback
 real,allocatable :: weights(:)
 call initmem(nbodsmax,nsphmax,ncells)
 
 call set_parameters(0)

 print*,'filenaam?'
 read*,filenaam

 call readbods(filenaam)

 call heattabel
        
 call initpars

 if(periodic) call initbc

 call initnewstar

 if(usepm) then
  if(verbosity.GT.0) print*,' ...initPM...'
  call initpm
 endif

 call postprocessread

10  print*,' map of? (0=rho, 1=HI, 2=H_2, 3=xe, 4= A, 5= A+Asn)'
    read*,mapnr

 nfeedback=0
 if(mapnr.EQ.5) then
  do i=nbodies-nstar+1,nbodies
   if(snentropy(i).GT.0) then
    nfeedback=nfeedback+1
    bodlist(nfeedback)=i
   endif
  enddo 
 endif     
 
 allocate(weights(nsph+nfeedback))

 weights(1:nsph)=mass(1:nsph)

 if(mapnr.EQ.1) then
  do i=1,nsph
   weights(i)=mass(i)*MAX(0.,(1-h2frac(i)-elecfrac(i)))
  enddo
 endif
 
 if(mapnr.EQ.2) then
  do i=1,nsph
   weights(i)=mass(i)*h2frac(i)
  enddo
 endif
 
 if(mapnr.EQ.3) then
  do i=1,nsph
   weights(i)=mass(i)*elecfrac(i)
  enddo
 endif

 if(mapnr.EQ.4.OR.mapnr.EQ.5) then
  do i=1,nsph
   weights(i)=mass(i)*entropy(i)
  enddo
  if(mapnr.EQ.5) then
   do i=1,nfeedback
    weights(i+nsph)=snentropy(bodlist(i))
    mass(i+nsph)=0.
    pos(i+nsph,1)=pos(bodlist(i),1)
    pos(i+nsph,2)=pos(bodlist(i),2)
    pos(i+nsph,3)=pos(bodlist(i),3)
   enddo
   nsph=nsph+nfeedback
  endif
 endif
 
 call makesphtree

 call initextract

 call extractdensity(weights)

 call endextract

 deallocate(weights)

 if(mapnr.EQ.5) nsph=nsph-nfeedback

 print*,'again? (0=yes)'
 read*, mapnr
 if(mapnr.EQ.0) goto 10

end program

module makemapMod
 implicit none
 private
 public:: InitMap, project,EndMap,EraseMap
 public:: nx,ny,pic,opdepth,extinction

 real,save :: xsize,ysize
 integer,save :: nx,ny
 integer,save :: maptype
 real,save :: dx,zmin,camdis
 real,save,dimension(3) :: lookat,xax,yax,zax,direction,from

 real, allocatable,save :: opdepth(:,:),pic(:,:)
 
 real, parameter :: sqrt2i=0.70710678118654752440
 real,parameter :: sqrt2=1.4142135623730950488
 real,parameter :: maxx=sqrt2
 real,parameter :: Pi=3.141592654

 integer,save :: projection, extinction

 integer,parameter :: Nstarmap=1000
 real :: mi(0:Nstarmap)

 type pparticle_type
  integer :: magic_number
  real :: pos(2)
  real :: size
  real :: mass
  real :: opac
 end type

 contains

 subroutine InitMap(imsize,width,focus,pointing,upvector,proj,ext,zm)
  integer, optional :: imsize(2),proj,ext
  real, optional :: width,focus(3),pointing(3),upvector(3),zm
  real :: up(3)
  integer :: test

  call InitStarMap
         
  if(present(proj)) then
   projection=proj
  else
   print*,' projection? (parallel=0, perspective=1)'
   read*, projection
  endif

  if(present(ext)) then
   extinction=ext
  else
   print*,'extinction (0=no,1=yes)?'
   read*,extinction
  endif

  zmin=-1.e30
  if(projection.ge.1) then
   if(present(zm)) then
    zmin=zm
   else
    print*,' zmin?'
    read*,zmin
   endif
  endif 
  
  if(present(imsize)) then
   nx=imsize(1)
   ny=imsize(2)
  else
   print*,' image pixel size (WxH)?'
   read*,nx,ny
  endif
  
  if(present(width)) then
   xsize=width
  else
   if(projection.eq.0) print*,' image width?'
   if(projection.eq.1) print*,' image angle?'    
   read*,xsize
  endif
  
  if(present(focus)) then
   lookat=focus
  else
   print*,' look at?'
   read*, lookat
  endif
  
  if(present(pointing)) then
   direction=pointing
  else
   if(projection.eq.0) print*,' direction?'
   if(projection.eq.1) print*,' from?'    
   read*,direction
  endif
  
  if(present(upvector)) then
   up=upvector
  else 
   print*,' upvector'
   read*,up
  endif
  
  allocate(pic(nx,ny),STAT=test)  
  if(test.NE.0) call Error(1)
   pic=0.
  
  allocate(opdepth(nx,ny),STAT=test)  
  if(test.NE.0) call Error(1)
   opdepth=1.
   
  if(projection.eq.0) from=lookat-direction  
  if(projection.eq.1) then
   from=direction
   direction=lookat-from
  endif
  camdis=norm(direction)
  if(projection.eq.1) xsize=2*camdis*tan(xsize/2./180.*Pi)
  call normalize(direction)
  zax=direction
  call outer(xax,direction,up)
  call normalize(xax)
  call outer(yax,xax,direction)
  call normalize(yax)

  dx=xsize/(nx-1)
  ysize=dx*(ny-1)
 end subroutine

subroutine EraseMap()

 pic=0.
 opdepth=1.

end subroutine

 subroutine EndMap()
 
  deallocate(pic,opdepth)

 end subroutine

 subroutine Error(i)
  integer i
  
  print*,' error making map',i
  stop
 end subroutine

 subroutine project(n,pos,sizes,mass,opac,pindex)
  integer,intent(in) :: n  ! arrsize necessary because pos() stored wrong way?
  real,intent(in) :: pos(:,:),sizes(:),mass(:)
  real,intent(in),optional :: opac(:)
  integer, intent(in), optional :: pindex(:)
  real ::ppos(3),psize,pmass,popac,d2
  real, allocatable :: scratch(:,:),zdist(:)
  integer, allocatable :: order(:)
  integer i,j,test,xmin,xmax,ymin,ymax
  integer mythread,totalthread,low(2),up(2)
!  integer mythread,totalthread,low,up
!$  integer omp_get_thread_num,omp_get_num_threads     
  integer :: magic_number   ! used to get consistent 'random' numbers 


 if((extinction.EQ.1).AND.(.not.present(opac))) then
  call error(99)
 endif 

 allocate(zdist(n),order(n),stat=test)
 if(test.ne.0) call Error(5)

 if(extinction.EQ.1) then
  do i=1,n
   call camcoor(pos(i,1:3),ppos)
   zdist(i)=ppos(3)
  enddo
  call mrgrnk(n,zdist,order)
 else
  do i=1,n
   order(i)=i
  enddo
 endif

!$omp parallel private(scratch,i,j,up,low,test,mythread,totalthread,ppos, &
!$omp pmass,popac,psize,xmin,xmax,ymin,ymax,magic_number)   
 allocate(scratch(min(nx,ny),min(nx,ny)),STAT=test)
 if(test.ne.0) call Error(5)
 
 mythread=0
 totalthread=1
!$ mythread=omp_get_thread_num()
!$ totalthread=omp_get_num_threads()
! low=(mythread*nx)/totalthread+1
! up=((mythread+1)*nx)/totalthread
 call verdeel(mythread,totalthread,nx,ny,low,up) 
 do j=1,n
  i=order(j)
  magic_number=i
  if(present(pindex)) magic_number=pindex(i)
  call camcoor(pos(i,1:3),ppos)
  pmass=0
  popac=0
  if(ppos(3).ge.zmin) then
   pmass=mass(i)
   psize=sizes(i)
   if(present(opac)) popac=opac(i)/dx**2
   if(projection.eq.1) then
    d2=sum(ppos**2)   
    psize=psize*camdis/ppos(3)
    ppos(1)=ppos(1)*camdis/ppos(3)
    ppos(2)=ppos(2)*camdis/ppos(3)  
    pmass=pmass*camdis**2/d2
    popac=popac*camdis**2/d2
   endif
   xmin=FLOOR((ppos(1)-maxx*psize+xsize/2.)/dx)+1
   xmax=CEILING((ppos(1)+maxx*psize+xsize/2.)/dx)+1
   ymin=FLOOR((ppos(2)-maxx*psize+ysize/2.)/dx)+1
   ymax=CEILING((ppos(2)+maxx*psize+ysize/2.)/dx)+1
   if(xmin.GT.up(1).OR.xmax.LT.low(1).OR. &
      ymin.GT.up(2).OR.ymax.LT.low(2)) then
!   if(xmin.GT.up.OR.xmax.LT.low.OR. &
!      ymin.GT.ny.OR.ymax.LT.1) then
      pmass=0   
      popac=0
   endif   
  endif
  if(extinction.EQ.1) then
   if(pmass.GT.0.OR.popac.gt.0) call projectopacity(low,up,pic,opdepth, &
                                  scratch,ppos,psize,pmass,popac,magic_number)
  else 
   if(pmass.gt.0) call projectparticle(low,up,pic,scratch,ppos,psize,pmass)
  endif
 enddo

 deallocate(scratch) 
!$omp end parallel 
 deallocate(zdist,order)
 
 end subroutine

 subroutine camcoor(ipos,opos)
  real, intent(in) :: ipos(3)
  real, intent(out) :: opos(3)
  
  opos(1)=dot_product(xax,ipos-from)
  opos(2)=dot_product(yax,ipos-from)
  opos(3)=dot_product(zax,ipos-from)

 end subroutine camcoor

 subroutine projectparticle(low,up,img,temp,pos,hsmooth,mass)
  real :: pos(3),hsmooth,mass,offset(2),img(:,:),temp(:,:)
  integer low(2),up(2),i,j,size
!  integer low,up,i,j,size
    
  size=CEILING(2*maxx*hsmooth/dx)+2
  if(2*maxx*hsmooth.LE.sqrt2*dx) size=3
  
  if(size.le.nx.AND.size.le.ny) then

   call positionp(i,j,offset,pos,hsmooth)

   call makepimage(temp,offset,size,hsmooth)
  
   call addpimage(low,up,img,i,j,size,temp,mass)
   
  endif

 end subroutine

 subroutine projectopacity(low,up,img,opdepth,temp,pos,hsmooth,mass,opac,magic_number)
   real :: pos(3),hsmooth,mass,offset(2),img(:,:),temp(:,:),opdepth(:,:),opac
  integer low(2),up(2),i,j,size
!  integer low,up,i,j,size
  integer :: magic_number 


  size=CEILING(2*maxx*hsmooth/dx)+2
  if(2*maxx*hsmooth.LE.sqrt2*dx) size=3
!  if(2*maxx*hsmooth/dx.LT.1.5) opac=opac*(2*maxx*hsmooth/dx/1.5)**2
    
  if(size.le.nx.AND.size.le.ny) then

   call positionp(i,j,offset,pos,hsmooth)

   if(opac.EQ.0) then
    call makesimage(temp,offset,size,hsmooth,magic_number)
   else   
    call makepimage(temp,offset,size,hsmooth)
   endif
   
   call addpopacimage(low,up,img,temp,opdepth,i,j,size,mass,opac)
   
  endif
   
 end subroutine

 subroutine addpimage(low,up,img,i,j,size,pimage,mass)
  integer low(2),up(2),i,j,size,n1,n2,m1,m2
!  integer low,up,i,j,size,n1,n2,m1,m2
  real mass,pimage(:,:),img(:,:)
  
 n1=max(1,low(1)-i); n2=min(size,up(1)-i)
 m1=max(1,low(2)-j); m2=min(size,up(2)-j)
! n1=max(1,low-i); n2=min(size,up-i)
! m1=max(1,1-j); m2=min(size,ny-j)
 img(i+n1:i+n2,j+m1:j+m2)=img(i+n1:i+n2,j+m1:j+m2)+mass*pimage(n1:n2,m1:m2)
  
 end subroutine

 subroutine addpopacimage(low,up,img,pimage,tau,i,j,size,mass,opac)
  integer low(2),up(2),i,j,size,n1,n2,m1,m2
!  integer low,up,i,j,size,n1,n2,m1,m2
  real mass,opac,pimage(:,:),img(:,:),tau(:,:)
  
 n1=max(1,low(1)-i); n2=min(size,up(1)-i)
 m1=max(1,low(2)-j); m2=min(size,up(2)-j)
! n1=max(1,low-i); n2=min(size,up-i)
! m1=max(1,1-j); m2=min(size,ny-j)

! if(opac.gt.0) tau(i+n1:i+n2,j+m1:j+m2)=tau(i+n1:i+n2,j+m1:j+m2)*exp(-opac/2*pimage(n1:n2,m1:m2))
! if(opac.gt.0) tau(i+n1:i+n2,j+m1:j+m2)=tau(i+n1:i+n2,j+m1:j+m2)*exp(-opac/2*pimage(n1:n2,m1:m2))

  if(mass.gt.0.and.opac.gt.0) then
!   tau(i+n1:i+n2,j+m1:j+m2)=tau(i+n1:i+n2,j+m1:j+m2)*(1.-min(1.,opac/2*pimage(n1:n2,m1:m2)))
   img(i+n1:i+n2,j+m1:j+m2)=img(i+n1:i+n2,j+m1:j+m2)+mass*pimage(n1:n2,m1:m2)*tau(i+n1:i+n2,j+m1:j+m2)
   tau(i+n1:i+n2,j+m1:j+m2)=tau(i+n1:i+n2,j+m1:j+m2)*(1.-min(1.,opac*pimage(n1:n2,m1:m2)))
   return
  endif
  if(mass.gt.0) img(i+n1:i+n2,j+m1:j+m2)=img(i+n1:i+n2,j+m1:j+m2)+mass*pimage(n1:n2,m1:m2)*tau(i+n1:i+n2,j+m1:j+m2)
  if(opac.gt.0) tau(i+n1:i+n2,j+m1:j+m2)=tau(i+n1:i+n2,j+m1:j+m2)*(1.-min(1.,opac*pimage(n1:n2,m1:m2)))
  
 end subroutine


 subroutine makepimage(pimage,offset,size,hsmooth)
  integer :: size
  real :: offset(2),hsmooth,pimage(:,:)
  real :: r,di,dj,dens,norm,hinv
  real :: xx,yy,fx(3),fy(3)
  integer :: i,j
  
  if(size.eq.3) then
!~    i=2;j=2
!~    if(offset(1)+maxx*hsmooth.LT.dx/2) i=1
!~    if(offset(2)+maxx*hsmooth.LT.dx/2) j=1
!~    if(offset(1)+maxx*hsmooth.GT.3*dx/2.) i=3
!~    if(offset(2)+maxx*hsmooth.GT.3*dx/2.) j=3
!~    pimage(1:3,1:3)=0
!~    pimage(i,j)=1
   xx=(offset(1)+maxx*hsmooth)/dx
   yy=(offset(2)+maxx*hsmooth)/dx   
   fx(1)=max(0.,min(1.,1-xx))
   fx(2)=max(0.,min(1.,1-abs(xx-1)))
   fx(3)=max(0.,min(1.,xx-1))
   fy(1)=max(0.,min(1.,1-yy))
   fy(2)=max(0.,min(1.,1-abs(yy-1)))
   fy(3)=max(0.,min(1.,yy-1))
   do i=1,3
     do j=1,3
       pimage(i,j)=fx(i)*fy(j)
     enddo
   enddo
   return
  endif 

  norm=0.
  hinv=1/hsmooth
  do j=1,size
   dj=(-maxx*hsmooth-offset(2)+(j-1)*dx)**2
   do i=1,size
      di=-maxx*hsmooth-offset(1)+(i-1)*dx    
      r=SQRT(di**2+dj)*hinv
      dens=spline(r)
      norm=norm+dens
      pimage(i,j)=dens
   enddo
  enddo  
  if(norm.EQ.0)  call Error(6)
  pimage(1:size,1:size)=pimage(1:size,1:size)/norm

 end subroutine

 subroutine positionp(i,j,offset,pos,hsmooth)
  integer :: i,j
  real :: offset(2),pos(3),hsmooth
  real x,y
  x=pos(1) ; y=pos(2)
    
  i=FLOOR((x-maxx*hsmooth+xsize/2.)/dx)!-1
  j=FLOOR((y-maxx*hsmooth+ysize/2.)/dx)!-1
  offset(1)=(x-maxx*hsmooth+xsize/2.)-(i)*dx !(i+1)
  offset(2)=(y-maxx*hsmooth+ysize/2.)-(j)*dx !(j+1)
 end subroutine

subroutine InitStarMap
 real :: dr,df,du,m(0:Nstarmap)
 integer :: n,i,j
 
 n=Nstarmap
 dr=sqrt(2.)/n
 df=1./n
 
 m(0)=0
 do i=1,n
  m(i)=m(i-1)+.5*dr*(dr*(i-1)*spline(dr*(i-1))+dr*i*spline(dr*i))
 enddo

 mi(0)=0.
 mi(n)=dr*n
 do i=1,n-1
  j=0
  do while(m(j)/m(n).lt.df*i)
   j=j+1
  enddo
  du=(df*i*m(n)-m(j-1))/(m(j)-m(j-1))
  mi(i)=(1-du)*dr*(j-1)+du*dr*j
 enddo 

end subroutine

subroutine makesimage(pimage,offset,size,hsmooth,magic_number)
  integer :: size
  real :: offset(2),hsmooth,pimage(:,:)
  integer :: k,i,j,ix,iy,im
  real :: rr,x(2),dr,mir,bright,norm,pRND
  real :: xx,yy,fx(3),fy(3)
  integer, parameter :: ndepth=4
  real, parameter :: brightfac=1.5
  integer magic_number

  if(size.eq.3) then
!~    i=2;j=2   
!~    if(offset(1)+maxx*hsmooth.LT.dx/2) i=1
!~    if(offset(2)+maxx*hsmooth.LT.dx/2) j=1
!~    if(offset(1)+maxx*hsmooth.GT.3*dx/2.) i=3
!~    if(offset(2)+maxx*hsmooth.GT.3*dx/2.) j=3
!~    pimage(1:3,1:3)=0
!~    pimage(i,j)=1
   xx=(offset(1)+maxx*hsmooth)/dx
   yy=(offset(2)+maxx*hsmooth)/dx   
   fx(1)=max(0.,min(1.,1-xx))
   fx(2)=max(0.,min(1.,1-abs(xx-1)))
   fx(3)=max(0.,min(1.,xx-1))
   fy(1)=max(0.,min(1.,1-yy))
   fy(2)=max(0.,min(1.,1-abs(yy-1)))
   fy(3)=max(0.,min(1.,yy-1))
   do i=1,3
     do j=1,3
       pimage(i,j)=fx(i)*fy(j)
     enddo
   enddo
   return
  endif 

  im=0
  norm=0.
  pimage(1:size,1:size)=0.
  do k=0,ndepth
   bright=1./brightfac**k
   do i=1,2**k
    rr=2
    do while(rr.gt.1)
      x(1)=pRND(magic_number+2*im)
      x(2)=pRND(3*magic_number+2*im+1)
      x=x*2-1
      rr=sum(x**2)
      im=im+1
    enddo
    j=rr*Nstarmap
    dr=rr*Nstarmap-j
    mir=(1-dr)*mi(j)+dr*mi(j+1)
    x=hsmooth*x*mir/sqrt(rr)
    x=x+offset+maxx*hsmooth
    ix=NINT(x(1)/dx)+1
    iy=NINT(x(2)/dx)+1
    if(ix.lt.1.or.ix.gt.size.or.iy.lt.1.or.iy.gt.size) then
!$omp critical
      print*,'project out of range'
      print*, x,ix,iy
      stop
!$omp end critical      
    endif 
    pimage(ix,iy)=pimage(ix,iy)+bright
    norm=norm+bright
   enddo
  enddo
  if(norm.le.0) then
   print*,norm
   stop
  endif  
  pimage(1:size,1:size)=pimage(1:size,1:size)/norm
end subroutine




 function spline(r) result(w)
  real :: r,w
  w=0
!  if(r.GT.2) return
  if(r.GT.sqrt2) return
  w=1-3/2.*r**2+sqrt2i*r**3

!  if(r.LT.1) then
!   w=1-3/2.*r**2+3/4.*r**3
!  else
!   w=1/4.*(2-r)**3
!  endif
!   w=w*10/(7*Pi)
 end function
 
 real function norm(n)
  real n(3)
   norm=SQRT(sum(n**2))
 end function

 subroutine normalize(n)
  real n(3),v
   v=norm(n)
   n(1)=n(1)/v
   n(2)=n(2)/v
   n(3)=n(3)/v
 end subroutine

 subroutine outer(o,v,w)
  real v(3),w(3),o(3)
  o(1)=v(2)*w(3)-w(2)*v(3)
  o(2)=v(3)*w(1)-w(3)*v(1)
  o(3)=v(1)*w(2)-w(1)*v(2)
 end subroutine


subroutine verdeel(i,n,nx,ny,low,up)
 integer:: n,deler1,deler2,nx,ny,i,ix,iy
 integer :: low(2),up(2)
 
 deler1=n**(0.5)
 do while(mod(n,deler1).NE.0.AND.deler1.GT.1)
  deler1=deler1-1
 enddo
 deler2=n/deler1

  iy=mod(i,deler1)
  ix=i/deler1

  low(1)=1+(nx*ix)/deler2
  up(1)=(nx*(ix+1))/deler2
  low(2)=1+(ny*iy)/deler1
  up(2)=(ny*(iy+1))/deler1

end subroutine


end module

! weights: returns normalized weights through tempvect for position spos 

subroutine weights(n,spos,secondsmooth)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: spos
 real,intent(in) :: secondsmooth
 integer :: i,p,iwsm
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm
 
 tmass=0.
 if(n.EQ.0) return
  
 do i=1,n
  p=bodlist(i)
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  hsminv=1./max(hsmooth(p),secondsmooth)
  wnorm=piinv*hsminv*hsminv*hsminv
  distnorm=hsminv**2*deldr2i
  dr2p=dr2*distnorm
  iwsm=INT(dr2p)
  if(ninterp.LT.iwsm) iwsm=ninterp
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  tempvect(i)=wnorm*wsm
  tmass=tmass+mass(p)*tempvect(i)
 enddo
 
 if(tmass.eq.0) call terror(' weights error ')
 
 do i=1,n
  tempvect(i)=tempvect(i)/tmass
 enddo
   
end subroutine weights


!  gatter: returns density through tempvect for position spos

function gatter(n,spos,secondsmooth)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: spos
 real,intent(in) :: secondsmooth
 integer :: i,p,iwsm
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm,gatter
 
 tmass=0.
 if(n.EQ.0) return
    
 do i=1,n
  p=bodlist(i)
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  hsminv=1./max(hsmooth(p),secondsmooth)
  wnorm=piinv*hsminv*hsminv*hsminv
  distnorm=hsminv**2*deldr2i
  dr2p=dr2*distnorm
  iwsm=INT(dr2p)
  if(ninterp.LT.iwsm) iwsm=ninterp
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  tempvect(i)=wnorm*wsm
  tmass=tmass+mass(p)*tempvect(i)
 enddo
 if(tmass.eq.0) call terror(' weights error ')
 gatter=tmass
   
end function gatter


function gatterdensity(position)
 include 'globals.h'
 real,dimension(3),intent(in) :: position
 real :: gatterdensity
 real :: gatter
 integer :: inear
 inear=0;
 call comsearch(root,0.,0.,position,inear,bodlist)
 if(inear.LE.0) print*,' gatterdens inear<1'
 gatterdensity=gatter(inear,position,0.)
 if(gatterdensity.LE.0) print*,' gatterdensity:',inear, gatterdensity,position
end function gatterdensity



function gatscatdensity(position)
 include 'globals.h'
 real,dimension(3),intent(in) :: position
 real :: gatscatdensity
 real :: gatscat,hsearch,sethsmooth
 integer :: inear
 hsearch=sethsmooth(position)
 inear=0;
 call comsearch(root,2*hsearch,0.,position,inear,bodlist)
 if(inear.LT.0) print*,' gatscatdens inear<nsmooth!'
 gatscatdensity=gatscat(inear,position,hsearch)
 if(gatscatdensity.LE.0) print*,' gatscatdensity:',inear, gatscatdensity,position
end function gatscatdensity

function gatscat(n,spos,secondsmooth)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: spos
 real,intent(in) :: secondsmooth
 integer :: i,p,iwsm,iwsm1
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm,gatscat
 real :: wnorm1,dr2i,wsm1,wmass,wmass1,drw1
 
 
 tmass=0.
 gatscat=0.
 if(n.EQ.0) return
    
 hsminv=1./secondsmooth
 wnorm=piinv*hsminv*hsminv*hsminv
 distnorm=hsminv*hsminv*deldr2i
    
 do i=1,n
  p=bodlist(i)
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  dr2p=dr2*distnorm
  iwsm=INT(dr2p)
  if(ninterp.LT.iwsm) iwsm=ninterp
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  wmass=wnorm*wsm
  dr2i=dr2*deldr2i/(hsmooth(p)*hsmooth(p))
  iwsm1=INT(dr2i)
  if(ninterp.LT.iwsm1) iwsm1=ninterp
  drw1=dr2i-iwsm1
  wsm1=(1.-drw1)*wsmooth(iwsm1)+drw1*wsmooth(1+iwsm1)
  wmass1=piinv/(hsmooth(p)*hsmooth(p)*hsmooth(p))*wsm1
  tmass=tmass+.5*mass(p)*(wmass+wmass1)
 enddo
 if(tmass.le.0) call terror(' weights error ')
 gatscat=tmass
   
end function gatscat


subroutine denscomp
include 'globals.h'
integer p
real x(3),gatterdensity
do p=1,nsph
x(1)=pos(p,1);x(2)=pos(p,2);x(3)=pos(p,3)
print*,'denscomp',rho(p),gatterdensity(x)
enddo
end subroutine denscomp


 
subroutine gatterweight(n,spos,hsearch,dens,ddensdh,weights)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: spos
 real,intent(in) :: hsearch,weights(*)
 real,intent(inout) :: dens, ddensdh
 integer :: i,p,iwsm
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm,gatter
 real :: dwmass,dwsm,dwmnbi,dwnorm
 dens=0.
 ddensdh=0.    
  hsminv=1./hsearch
  wnorm=piinv*hsminv*hsminv*hsminv
  dwnorm=piinv*hsminv**2*hsminv**2*hsminv
  distnorm=hsminv**2*deldr2i 
 do i=1,n
  p=bodlist(i)
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  dr2p=dr2*distnorm
  iwsm=INT(dr2p)
  if(ninterp.LT.iwsm) iwsm=ninterp
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  tempvect(i)=wnorm*wsm
  dens=dens+weights(p)*tempvect(i)
  ddensdh=ddensdh-3*hsminv*weights(p)*tempvect(i)
  dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
  dwmass=dwnorm*dwsm
  dwmnbi=weights(p)*dwmass
  ddensdh=ddensdh-dr2*hsminv*dwmnbi  
 enddo   
    
end subroutine gatterweight


subroutine gatter2(n,spos,hsearch,dens,ddensdh)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: spos
 real,intent(in) :: hsearch
 real,intent(inout) :: dens, ddensdh
 integer :: i,p,iwsm
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm,gatter
 real :: dwmass,dwsm,dwmnbi,dwnorm
 dens=0.
 ddensdh=0.    
  hsminv=1./hsearch
  wnorm=piinv*hsminv*hsminv*hsminv
  dwnorm=piinv*hsminv**2*hsminv**2*hsminv
  distnorm=hsminv**2*deldr2i 
 do i=1,n
  tempvect(i)=0.
  p=bodlist(i)
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  dr2p=dr2*distnorm
  if(ninterp.GT.dr2p) then
  iwsm=INT(dr2p)
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  tempvect(i)=wnorm*wsm
  dens=dens+mass(p)*tempvect(i)
  ddensdh=ddensdh-3*hsminv*mass(p)*tempvect(i)
  dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
  dwmass=dwnorm*dwsm
  dwmnbi=mass(p)*dwmass
  ddensdh=ddensdh-dr2*hsminv*dwmnbi  
  endif
 enddo   

end subroutine gatter2

subroutine gatter3(n,spos,hsearch,dens,ddensdh,meana,ain)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: spos
 real,intent(in) :: hsearch, ain(*)
 real,intent(inout) :: dens, ddensdh,meana
 integer :: i,p,iwsm
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm,gatter
 real :: dwmass,dwsm,dwmnbi,dwnorm
 dens=0.
 ddensdh=0.
 meana=0.    
  hsminv=1./hsearch
  wnorm=piinv*hsminv*hsminv*hsminv
  dwnorm=piinv*hsminv**2*hsminv**2*hsminv
  distnorm=hsminv**2*deldr2i 
 do i=1,n
  tempvect(i)=0.
  p=bodlist(i)
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  dr2p=dr2*distnorm
  if(ninterp.GT.dr2p) then
  iwsm=INT(dr2p)
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  tempvect(i)=wnorm*wsm
  dens=dens+mass(p)*tempvect(i)
  meana=meana+ain(p)*tempvect(i)
  ddensdh=ddensdh-3*hsminv*mass(p)*tempvect(i)
  dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
  dwmass=dwnorm*dwsm
  dwmnbi=mass(p)*dwmass
  ddensdh=ddensdh-dr2*hsminv*dwmnbi  
  endif
 enddo   
end subroutine gatter3


subroutine hfuncpos(spos,h,dens,ddensdh,fi,dfi,nneigh,hneigh)
 include 'globals.h'
  integer p,nneigh,j
  real fi,dfi,hneigh,h,spos(3),dens,ddensdh
  if(nneigh.EQ.0.OR.h.GT.hneigh.OR.h.LT.hneigh/2) then
   nneigh=0
   hneigh=h
   call search(root,2*h,spos,nneigh,bodlist)
  endif
  call gatter2(nneigh,spos,h,dens,ddensdh)
   fi=4*pi/3*h**3*(dens+rhomin)-massres
   dfi=4*pi*h**2*(dens+rhomin)+4*pi/3*h**3*ddensdh
  return
end

subroutine hnewtonpos(spos,h,success,nneigh,hneigh)
include 'globals.h'
integer p,success,nmax,nneigh,i
real hsmnw,hmin,hmax,prec,hneigh,fi,dfi,h,dens,ddensdh
real spos(3)
parameter(nmax=10,prec=0.001) 
 success=1
 hmin=.5*h;hmax=2*h 
 hsmnw=h
 i=0
10 if(hsmnw.LT.hmax.AND.hsmnw.GT.hmin.AND.i.LT.nmax) then
  i=i+1
  call hfuncpos(spos,hsmnw,dens,ddensdh,fi,dfi,nneigh,hneigh)
  if(dfi.NE.0) then 
   hsmnw=hsmnw-fi/dfi
  else
   hsmnw=0
  endif
  if(ABS(fi).LT.ABS(hsmnw*prec*dfi)) then
   h=hsmnw
   return
  endif
  goto 10
 else
  success=0
 endif 
end 


subroutine brackethpos(spos,hmin,hmax,success,nneigh,hneigh)
 include 'globals.h'
 integer p,success,nneigh,ntry,j
 real hmin,hmax,hneigh,spos(3),fac,f1,f2,df,sethsmooth
 real dum1,dum2
 parameter(fac=2.,ntry=20)
 external sethsmooth
 success=1
 hmax=fac*sethsmooth(spos)
 hmin=hmax/fac**2
 nneigh=0
 hneigh=0
 call hfuncpos(spos,hmax,dum1,dum2,f2,df,nneigh,hneigh)
 call hfuncpos(spos,hmin,dum1,dum2,f1,df,nneigh,hneigh) 
 do j=1,ntry
  if(f1*f2.LT.0) return
  if(abs(f1).lt.abs(f2)) then
   hmin=hmin/fac
   call hfuncpos(spos,hmin,dum1,dum2,f1,df,nneigh,hneigh)
  else
   hmax=hmax*fac
   call hfuncpos(spos,hmax,dum1,dum2,f2,df,nneigh,hneigh)
  endif
 enddo 
success=0
return
end 

subroutine hsafepos(spos,hguess,hmin,hmax,nneigh,hneigh)
include 'globals.h'
integer p,maxit,j,nneigh
real hmin,hmax,prec,hneigh,hguess,dum1,dum2
real df,dx,dxold,f,h,fh,fl,temp,xl,xh,spos(3)
parameter(maxit=25,prec=0.001)
 
nneigh=0
hneigh=0
call hfuncpos(spos,hmax,dum1,dum2,fh,df,nneigh,hneigh)
call hfuncpos(spos,hmin,dum1,dum2,fl,df,nneigh,hneigh)
 
 if(fl.eq.0) then
  hguess=hmin
  return
 endif
    if(fh.eq.0) then
   hguess=hmax
   return
 endif 
 if(hmin.GE.hmax.OR.fl.GE.fh.OR.fl*fh.GT.0) call terror('hsafepos error')
 xl=hmin
 xh=hmax 
 
 hguess=.5*(xl+xh)
 dxold=(xh-xl)
 dx=dxold
 call hfuncpos(spos,hguess,dum1,dum2,f,df,nneigh,hneigh)
 do j=1,maxit
  if(((hguess-xh)*df-f)*((hguess-xl)*df-f).GT.0.OR. &
&  abs(2*f).GT.ABS(dxold*df)) then
    dxold=dx
    dx=0.5*(xh-xl)
    hguess=xl+dx
    if(xl.EQ.hguess)return
  else
    dxold=dx
    dx=f/df
    temp=hguess
    hguess=hguess-dx
    if(temp.EQ.hguess)return
  endif
  if(abs(dx).LT.prec*hmax) return
  call hfuncpos(spos,hguess,dum1,dum2,f,df,nneigh,hneigh) 
  if(f.lt.0) then
   xl=hguess    
  else
   xh=hguess
  endif  
 enddo
 return 
end 

   subroutine hsmdenspos(spos,h,dens,ddensdh,nneigh,hneigh)
   include 'globals.h'
   integer p,i,j,success,nneigh
   real hsmn,hsmorg,fi,dfi,hmin,hmax,hneigh
   real dens,ddensdh,h,spos(3),getlocalscale
   i=0;j=0
   if(h.LE.0) h=getlocalscale(spos)
   hsmn=h
   nneigh=0
   hneigh=0
   call hnewtonpos(spos,hsmn,success,nneigh,hneigh)
   if(success.EQ.0) then 
   call brackethpos(spos,hmin,hmax,success,nneigh,hneigh) 
if(success.EQ.0) then
!$omp critical
call terror(' hsmdenspos error')
!$omp end critical
    endif
    call hsafepos(spos,hsmn,hmin,hmax,nneigh,hneigh)
   endif
   h=hsmn
   call hfuncpos(spos,h,dens,ddensdh,fi,dfi,nneigh,hneigh)
   end

  subroutine hsmpos(spos,h,nneigh,hneigh)
   include 'globals.h'
   integer p,i,success,nneigh
   real hsmn,fi,dfi,hmin,hmax,hneigh
   real dens,ddensdh,h,spos(3)
i=0
if(h.LE.0) h=consthsm
hsmn=h
nneigh=0
hneigh=0
   call hnewtonpos(spos,hsmn,success,nneigh,hneigh)
if(success.EQ.0) then
 call brackethpos(spos,hmin,hmax,success,nneigh,hneigh)
 call hsafepos(spos,hsmn,hmin,hmax,nneigh,hneigh)
endif
h=hsmn
end

subroutine denspos(spos,h,dens,ddensdh,newroot,newres)
  include 'globals.h'
  real spos(3),h,dens,ddensdh,newres,tmp2,hneigh,dum2,dum3
  integer newroot,tmp,nneigh
  
  tmp=root
  tmp2=massres
  root=newroot
  massres=newres
  call hsmpos(spos,h,nneigh,hneigh)
  call hfuncpos(spos,h,dens,ddensdh,dum2,dum3,nneigh,hneigh)
  root=tmp
  massres=tmp2
 end subroutine denspos

function setlocallength(x,newroot)
 include 'globals.h'
 real,dimension(3),intent(in) :: x
 integer,intent(in) :: newroot
 integer :: tmp,tmp2
 real :: sethsmooth,setlocallength
 
 tmp=root
 root=newroot
 setlocallength=sethsmooth(x)
 root=tmp
 return
 end function setlocallength

subroutine fuvfuncpos(spos,h,dens,ddensdh,nneigh,hneigh)
include 'globals.h'
integer p,nneigh,j
real fi,dfi,hneigh,h,spos(3),dens,ddensdh
if(nneigh.EQ.0.OR.h.GT.hneigh.OR.h.LT.hneigh/2) then
 nneigh=0
 hneigh=h
 call search(root,2*h,spos,nneigh,bodlist)
endif
call gatterweight(nneigh,spos,h,dens,ddensdh,starfuv)
return
end

 subroutine fuvpos(spos,h,dens,ddensdh,newroot,newres)
  include 'globals.h'
  real spos(3),h,dens,ddensdh,newres,tmp2,hneigh
  integer newroot,tmp,nneigh
  
  tmp=root
  tmp2=massres
  root=newroot
  massres=newres
  call hsmpos(spos,h,nneigh,hneigh)
  call fuvfuncpos(spos,h,dens,ddensdh,nneigh,hneigh)
  root=tmp
  massres=tmp2
 end subroutine fuvpos
  
 subroutine scattereps(n,spos)
 include 'globals.h' 
 integer,intent(in) :: n
 real,dimension(3),intent(in) :: spos
 integer :: i,p,iwsm
 real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm,gatter
 tmass=0.
 if(n.EQ.0) return
    
 do i=1,n
  p=bodlist(i)
  dx=spos(1)-pos(p,1)
  dy=spos(2)-pos(p,2)
  dz=spos(3)-pos(p,3)
  if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
  if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
  if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
  if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
  if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
  if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
  dr2=dx*dx+dy*dy+dz*dz
  hsminv=1./epsgrav(p)
  wnorm=piinv*hsminv*hsminv*hsminv
  distnorm=hsminv**2*deldr2i
  dr2p=dr2*distnorm
  iwsm=INT(dr2p)
  if(ninterp.LT.iwsm) iwsm=ninterp
  drw=dr2p-iwsm
  wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
  tempvect(i)=wnorm*wsm
  tmass=tmass+mass(p)*tempvect(i)
 enddo
 gatter=tmass
   
end subroutine

 
 subroutine emissdenspos(spos,h,dens,ddensdh,emiss,newroot,newres)
  use CoolingMod
  use ElementsMod
  include 'globals.h'
  real spos(3),h,dens,ddensdh,newres,tmp2,hneigh,dum2,dum3,emiss,t
  integer newroot,tmp,nneigh,i,p
  
  tmp=root
  tmp2=massres
  root=newroot
  massres=newres
  call hsmpos(spos,h,nneigh,hneigh)
  call hfuncpos(spos,h,dens,ddensdh,dum2,dum3,nneigh,hneigh)
  emiss=0
  t=0
  do i=1,nneigh
  p=bodlist(i)
   t=t+tempvect(i)*mass(p)*ethermal(p)
  enddo
   t=t/dens
   if(t.lt.20000) then
   if(t.gt.10000) t=10000
   emiss=abundanceQ(3)*elementCool(0.1,t,3)*dens**2*cool_par 
   endif
  root=tmp
  massres=tmp2
 end subroutine emissdenspos


function sethsmooth(position)
include 'globals.h'
real,dimension(3),intent(in) :: position
real :: hsearch,getlocalscale,hs
real :: hmin,hmax,sethsmooth
integer :: inear,i

 i=0
 hsearch=getlocalscale(position)
 hmin=0.;hmax=hsearch/2.;inear=0
 do while(inear.LE.nsmooth)
  i=i+1
  inear=0
  call search(root,2*hmax,position,inear,bodlist)
  hmax=hmax*1.3
 enddo
 hsearch=hmax/1.3
1 continue
 inear=0
 i=i+1
 call search(root,2*hsearch,position,inear,bodlist)
 if(inear.LT.(1-nsmtol)*nsmooth.OR.inear.GT.(1+nsmtol)*nsmooth) then
  if(inear.LT.nsmooth) then
   hmin=hsearch
   hsearch=0.5*(hsearch+hmax)
  endif
  if(inear.GT.nsmooth) then
   hmax=hsearch
   hsearch=0.5*(hsearch+hmin)
  endif
  goto 1
 endif
 sethsmooth=hsearch
 return
end function sethsmooth

program read_snapshot

   include 'globals.h'
   character*200 :: filename
   character*200 :: outfilename
   integer :: np,i,ioer
   real :: pmass,x(3),v(3)
   real :: mscale,vscale,tscale,lscale
   real :: epsg,epsdm,epsstar,ether
   call initmem(nbodsmax,nsphmax,ncells)

!   unitm_in_msun=1.e9
!   unitl_in_kpc=1.
!   timescale=1.488e19*unitl_in_kpc*sqrt(unitl_in_kpc/unitm_in_msun)
!   lengthscale=3.086e21*unitl_in_kpc
!   velscale=lengthscale/timescale

   print*,'simple file conversion'
   print*,'filename?'
   read*,filename
!   print*,'mscale (in msun)?'
!   read*,mscale
!   mscale=mscale/unitm_in_msun
!   print*,'vscale (in km/s)?'
!   read*,vscale
!   vscale=1.e5*vscale/velscale
!   print*,'tscale (in Myr)?'
!   read*,tscale
!   tscale=tscale/timescale*year*1.e6
!   print*,'m,v,t factor:',mscale,vscale,tscale
!   lscale=1
   
   print *,'opening...  '//trim(filename)

   open (1, file=trim(filename), form='unformatted')
   read (1,iostat=ioer) np,nsph,nstar
   if(ioer.NE.0) then 
    rewind(1)
    read (1,iostat=ioer) np
    nsph=0
    nstar=0
   endif
   print*, 'nbodies:',np,nsph,nstar
   nbodies=np
!   nsph=0
!   nstar=0
   totptag=nbodies
   tnow=0.   
   massres=0.

   outputfile=trim(filename)
   firstsnap=0
   nsnap=0
   uentropy=.FALSE.
   
   output=0
   output(1:3)=1
   
   do i=1,nbodies  
    read(1) pmass,x,v
    mass(i)=pmass
    pos(i,1:3)=x
    vel(i,1:3)=v
   enddo
  
   pmass=0;x=0;v=0
   do i=1,nbodies  
    pmass=pmass+mass(i)
    x=x+mass(i)*pos(i,1:3)    
    v=v+mass(i)*vel(i,1:3)    
   enddo
   x=x/pmass
   v=v/pmass
   
   do i=1,nbodies
    pos(i,1:3)=pos(i,1:3)-x
    vel(i,1:3)=vel(i,1:3)-v
   enddo

   print*,'ethermal? (0 for T= 10^4 K)'
   read*, ether
   if(ether.LE.0) ether=1.e4/4.86e5
   output(11)=0   
   if(nsph.gt.0) then
    output(11)=1
    ethermal(1:nsph) = ether
   endif
   
   print*,'fill tform (age=12.e9 yr)'
   output(5)=1
   tform(1:nbodies)=0.
   call random_number(tform(nbodies-nstar+1:nbodies))
   tform(nbodies-nstar+1:nbodies)=-tform(nbodies-nstar+1:nbodies)*800

   print*,'provide epsgrav? (0=no, 1=yes)'
   read*,output(4)
   if(output(4).EQ.1) then
    print*,'eps_gas, eps_DM, eps_stars?'
    read*,epsg,epsdm,epsstar
    epsgrav(1:nsph)=epsg
    epsgrav(nsph+1:nbodies-nstar)=epsdm
    epsgrav(nbodies-nstar+1:nbodies)=epsstar
   endif
   outfilename=trim(filename)//'.new'
   call outbods(outfilename)
end program

program test
 use ElementsMod 
 use H2CoolMod
 use CoolingMod
 use IonMod
 character(len=200) :: indatadir
 real :: temp,n,h2,le,lp,cr,rtemp,xe,h2f
 
 call InitElements
 indatadir="/home/pelupes/fish/stars/data/"
 call InitIon(1.e9,1.)
 call InitH2(indatadir)
 call InitCooling(indatadir)
!10 read*, temp,n
! if(temp.eq.0) stop
! h2=H2CoolFunc(temp)
! lp=CoolFunc(1.,temp)
! write(*,5),temp, n, h2,lp
!goto 10 
 
 do i=1,100
  temp=10**(1+7*(i-1.)/99.)
  n=1.
  cr=18
  h2f=1.
  call ion(temp,rtemp,xe,n,cr)
  le=xe*xeCool(rtemp)
  lp=max(0.,(1-xe))*HCool(rtemp)
  h2=H2Cool(rtemp,n)
  write(*,5),rtemp,xe,le,lp,h2
 enddo

5 format( e12.4,' ',e12.4,' ',e12.4,' ',e12.4,' ',e12.4)
 end program test

subroutine starevolv
  use StarsMod
  include 'globals.h'
     
  integer p
  real efuvnew,starage,timefac,fluxfac
      
  if(cosmo) call terror('no cosmo starevolv (yet)')
 
  timefac=timescale/year
  fluxfac=heatconst*unitm_in_msun*10**flxscale
 
  do p=nbodies-nstar+1,nbodies-nbh
    starage=(tnow-tform(p))*timefac
    efuvnew=fluxfac*dFUV(starage)
    starfuv(p)=efuvnew*mass(p)
    if(starfuv(p).LT.0.) starfuv(p)=0.0
  enddo
 
  do p=nbodies-nbh+1,nbodies
    starfuv(p)=0.
  enddo
   
end subroutine


subroutine initnewstar
  use StarsMod
  use ElementsMod
  include 'globals.h'

  if(.not.radiate) return
  call InitElements(metallicity)
  if(verbosity.GT.0)print*,' ...InitStars...'
  call InitStars(datadir,zQ())
  
end subroutine


subroutine newstar
include 'globals.h'	 
  real mjeans,tcsound2,ranfb,newstarmass,dvx,dvy,dvz
  logical formstar,force
  integer nform,nstable,p,i,ib,nforced,ioerror
  character*4 option         
  integer, allocatable :: forced(:)
  real fthresh,minmass
  parameter(fthresh=0.5)

  minmass=removgas*8.*massres/nsmooth

  allocate(forced(nsph))
   newstarmass=sfeff*8.*massres/nsmooth  

! 3 modes:
!  gerritsen: sf mass fraction of gas mass, constant delay 
!  nieuw: sfmass constant, delay with time inversely prop. to gas mass
! ( in order to keep physical star formation rate independent of particle mass)
!  molecular: sf mass fraction of gas mass, only if enough h2frac!
	  
  nform=0 
  nstable=0
  nforced=0
              
  if(sfmode.EQ.'gerritsen') then
    do p=1,nsph
      if(rho(p).EQ.0) cycle
      force=.false.
      tcsound2=csound(p)**2
      mjeans=rho(p)*pi/6.*(tcsound2*pi/rho(p))**1.5     
      if(mjeans.GT.masscrit) then
        tcollaps(p)=tnow        
        nstable=nstable+1
      endif
      formstar=(tnow-tcollaps(p))*SQRT(4*pi*rho(p)).GT.tcollfac
      if(rho(p).GT.rhomax.AND.mass(p).GT.0) then
        formstar=.TRUE.
        force=.TRUE.
      endif
      formstar=formstar.AND.(tnow-tform(p)).GT.tsnbeg.AND.mass(p).GT.0    
      if(formstar) then
        nform=nform+1
        bodlist(nform)=p       
        forced(nform)=0
        if(force) forced(nform)=1        
      endif
    enddo
  endif

  if(sfmode.EQ.'nieuw') then
    do p=1,nsph
      if(rho(p).EQ.0) cycle
      force=.false.
      tcsound2=csound(p)**2
      mjeans=rho(p)*pi/6.*(tcsound2*pi/rho(p))**1.5   
      if(mjeans.GT.masscrit) then
        tcollaps(p)=tnow       
        nstable=nstable+1
      endif
      formstar=mjeans.LE.masscrit.AND.  &
        exp(-(tnow-tstarform)*SQRT(4*pi*rho(p))* &
        mass(p)*sfeff/(tcollfac*newstarmass)).LT.ranfb(rnseed)
      if(rho(p).GT.rhomax.AND.mass(p).GT.0) then
        formstar=.TRUE.
        force=.TRUE.
      endif
      formstar=formstar.AND.(tnow-tform(p)).GT.tsnbeg.AND.mass(p).GT.0    
      if(formstar) then
        nform=nform+1
        bodlist(nform)=p       
        forced(nform)=0
        if(force) forced(nform)=1        
      endif
    enddo
  endif

  if(sfmode.EQ.'molecular') then
    do p=1,nsph
      if(rho(p).EQ.0) cycle
      force=.false.
      tcsound2=csound(p)**2
      mjeans=rho(p)*pi/6.*(tcsound2*pi/rho(p))**1.5   
      if(mjeans.GT.masscrit) then
        tcollaps(p)=tnow       
        nstable=nstable+1
      endif
      formstar=mjeans.LE.masscrit.AND.h2frac(p).GT.sfeff+fthresh.AND.  &
        exp(-(tnow-tstarform)*SQRT(4*pi*rho(p))/tcollfac).LT.ranfb(rnseed)
      if(rho(p).GT.rhomax.AND.mass(p).GT.0) then
        formstar=.TRUE.
        force=.TRUE.
      endif
      formstar=formstar.AND.(tnow-tform(p)).GT.tsnbeg.AND.mass(p).GT.0    
      if(formstar) then
        nform=nform+1
        bodlist(nform)=p       
        forced(nform)=0
        if(force) forced(nform)=1        
      endif
    enddo
  endif

  if(sfmode.EQ.'molecular2') then
    do p=1,nsph          
      if(rho(p).EQ.0) cycle
      force=.false.
      tcsound2=csound(p)**2
      mjeans=rho(p)*pi/6.*(tcsound2*pi/rho(p))**1.5	  
      if(mjeans.GT.masscrit) then
        tcollaps(p)=tnow	  
        nstable=nstable+1
      endif
! note that the condition on sfeff is a numerical req. and not 
! part of physical requirement (in which case I think it should
! be part of resetting clock)
      formstar=h2frac(p).GT.sfeff.AND. &   
        (tnow-tcollaps(p))*SQRT(4*pi*rho(p)).GT.tcollfac
      if(rho(p).GT.rhomax.AND.mass(p).GT.0) then
        formstar=.TRUE.
        force=.TRUE.
      endif
      formstar=formstar.AND.(tnow-tform(p)).GT.tsnbeg.AND.mass(p).GT.0	   
      if(formstar) then
        nform=nform+1
        bodlist(nform)=p	  
        forced(nform)=0
        if(force) forced(nform)=1	    
      endif
    enddo
  endif
	 
  if(nbodies+nform.GT.nbodsmax) CALL terror('too many stars')

! shift bh to end
  if(nform.GT.0) then
    pordercount=pordercount+1
    do i=nbodies+nform,nbodies+nform-nbh+1,-1
      p=i-nform
      mass(i)=mass(p)
      pos(i,1)=pos(p,1)
      pos(i,2)=pos(p,2)
      pos(i,3)=pos(p,3)
      vel(i,1)=vel(p,1)
      vel(i,2)=vel(p,2)
      vel(i,3)=vel(p,3)
      acc(i,1)=acc(p,1)
      acc(i,2)=acc(p,2)
      acc(i,3)=acc(p,3)
      acc(i,4)=acc(p,4)
      phi(i)=phi(p)
      phiext(i)=phiext(p)
      epsgrav(i)=epsgrav(p)
      itimestp(i)=itimestp(p)
      otimestp(i)=otimestp(p)
      tform(i)=tform(p)
      starfuv(i)=starfuv(p)
      tfeedb(i)=tfeedb(p)
      tvel(i)=tvel(p)
      snentropy(i)=snentropy(p)
      hsmooth(i)=hsmooth(p)
      nbexist(i)=nbexist(p)
    enddo

    open(unit=sfrfilenr,file=TRIM(outputfile)//'.sfh', &
           status='unknown',POSITION='APPEND',IOSTAT=ioerror)

    do i=1,nform
      p=nbodies+i-nbh
      ib=bodlist(i)
      tform(p)=tnow
      mass(p)=newstarmass
      if(sfmode.EQ.'gerritsen'.OR.sfmode.EQ.'molecular') &
        mass(p)=sfeff*mass(ib)
      if(sfmode.EQ.'molecular2') mass(p)=h2frac(ib)*mass(ib)
      if(mass(ib)-mass(p).lt.minmass.OR.forced(i).EQ.1) &
        mass(p)=mass(ib)
      pos(p,1)=pos(ib,1)
      pos(p,2)=pos(ib,2)
      pos(p,3)=pos(ib,3)
      vel(p,1)=vel(ib,1)
      vel(p,2)=vel(ib,2)
      vel(p,3)=vel(ib,3)
      acc(p,1)=acc(ib,1)
      acc(p,2)=acc(ib,2)
      acc(p,3)=acc(ib,3)
      acc(p,4)=acc(ib,4)
      phi(p)=phi(ib)
      phiext(p)=phiext(ib)
      tfeedb(p)=-2
      itimestp(p)=itimestp(ib)
      otimestp(p)=otimestp(ib)
      tvel(p)=tvel(ib)
      epsgrav(p)=eps
      if(adaptive_eps.OR.eps.EQ.0) epsgrav(p)=epsgrav(ib)       
!           epsgrav(p)=epsgrav(ib)
! check
      snentropy(p)=0.
      hsmooth(p)=hsmooth(ib)
      nbexist(p)=totptag+i

      if(ioerror.EQ.0) then
        write(sfrfilenr,*) ib,p,forced(i)
        write(sfrfilenr,*) tnow,tcollaps(ib)
        write(sfrfilenr,*) pos(p,1),pos(p,2),pos(p,3)
        write(sfrfilenr,*) vel(p,1),vel(p,2),vel(p,3)
        write(sfrfilenr,*) rho(ib)
        write(sfrfilenr,*) temperat(ib)          
        write(sfrfilenr,*) elecfrac(ib)
        write(sfrfilenr,*) fuvheat(ib)
        write(sfrfilenr,*) h2frac(ib)
        write(sfrfilenr,*) mass(p),mass(ib)
      endif
      tform(ib)=tnow
      tcollaps(ib)=tnow
      mass(ib)=MAX(mass(ib)-mass(p),0.)       
      if(sfmode.EQ.'molecular'.AND.sfeff.LT.1.) then
        h2frac(ib)=max((h2frac(ib)-sfeff)/(1.-sfeff),0.) 
      endif
      if(sfmode.EQ.'molecular2'.AND.sfeff.LT.1.) then
        h2frac(ib)=max((h2frac(ib)-sfeff)/(1.-sfeff),0.) 
      endif
      if(forced(i).EQ.1) nforced=nforced+1
    
      if(mass(ib)+mass(p).NE.0) then
        dvx=csound(ib)*(2*ranfb(rnseed)-1)
        dvy=csound(ib)*(2*ranfb(rnseed)-1)
        dvz=csound(ib)*(2*ranfb(rnseed)-1)
        vel(p,1)=vel(p,1)+dvx*mass(ib)/(mass(ib)+mass(p))
        vel(ib,1)=vel(ib,1)-dvx*mass(p)/(mass(ib)+mass(p))
        vel(p,2)=vel(p,2)+dvy*mass(ib)/(mass(ib)+mass(p))
        vel(ib,2)=vel(ib,2)-dvy*mass(p)/(mass(ib)+mass(p))
        vel(p,3)=vel(p,3)+dvz*mass(ib)/(mass(ib)+mass(p))
        vel(ib,3)=vel(ib,3)-dvz*mass(p)/(mass(ib)+mass(p))
      endif
      if(mass(p).LE.0) call terror('danger starmass')
    enddo

    if(ioerror.EQ.0) close(sfrfilenr)
  endif

  if(verbosity.GT.0) print*,'<starform> unstable, forming,forced:', &
    nsph-nstable,nform,nforced

  nstar=nstar+nform
  nbodies=nbodies+nform
  totptag=totptag+nform
  tstarform=tnow
  deallocate(forced)
      
end subroutine

function courant_timestep(p) result(dt)
! (eq 2.37/2.38 hk)
 include 'globals.h'
 integer :: p
 real :: dt
 dt=dtime
 if(p.GT.nsph) return
 dt=(hsmooth(p)*courant)/ &
   (csound(p)+1.2*(alpha*csound(p)+beta*mumaxdvh(p))+ABS(hsmdivv(p)))
! gadget visc
! dt=courant*hsmooth(p)/(mumaxdvh(p)+ABS(hsmdivv(p)))
 if(dt.le.0) then
   print*,p,nbexist(p),dt,hsmooth(p),rho(p),csound(p),mumaxdvh(p),hsmdivv(p),mass(p)
   call terror('timestep error: courant')	  
 endif	 
end function

function sqrtacc_timestep(p) result(dt)
 include 'globals.h'
 integer :: p
 real :: dt
 dt=dtime
 if(aacc(p).LE.0) return
 if(adaptive_eps) then
   dt=tstepcrit*sqrt(epsgrav(p)/aacc(p))
 else
   dt=tstepcrit*sqrt(MIN(epsgrav(p),eps)/aacc(p))		
 endif
 if(dt.le.0.) then
   print*,dt,epsgrav(p),aacc(p),eps
   call terror('timestep error: sqrttstp')	  
 endif	 
end function

function acc_timestep(p) result(dt)
 include 'globals.h'
 integer :: p
 real :: dt
 dt=dtime
 if(aacc(p).LE.0) return
 dt=tstpcr2/aacc(p)
 if(dt.le.0.) then
   print*,dt,epsgrav(p),aacc(p)
   call terror('timestep error: acc_tstp')	  
 endif	 
end function

function freeform_timestep(p) result(dt)
 include 'globals.h'
 integer :: p
 real :: dt,abvel
 dt=dtime
 abvel=sqrt(vel(p,1)**2+vel(p,2)**2+vel(p,3)**2)
 if(aacc(p).LE.0.OR.abvel.LE.0) return
 dt=(abvel/freev)**freevexp*(aacc(p)/freea)**freeaexp
 if(dt.le.0.) then
   print*,dt,abvel,aacc(p)
   call terror('timestep error: freetstp')	  
 endif	 
end function

subroutine promote_bins(minppbin,npactive,templist,bodlist)
 integer :: npactive,minppbin,templist(npactive),bodlist(npactive)
 integer :: i,p,startbod,intt,ninbin
 character(len=70) mess
 
 if(minppbin.LE.1) return
 i=0
 p=1
 startbod=0
 do while(p.LE.npactive)
   if(MOD(p-1,minppbin).EQ.0) then
      intt=templist(bodlist(p))
      ninbin=0
      startbod=p
   else
      if(intt.LT.templist(bodlist(p))) then
	print*,intt,templist(bodlist(p))
     	call terror(' timestep inconsistency')
      endif
      if(intt.GT.templist(bodlist(p))) i=i+1
      templist(bodlist(p))=intt
   endif
   ninbin=ninbin+1
   p=p+1
 enddo
 if(ninbin.LE.minppbin/2.AND.startbod.NE.0) then
   if(startbod.EQ.1) call terror(' timestep shuffle error')
   templist(bodlist(startbod:npactive))=templist(bodlist(startbod-1))
 endif
 write(mess,'("<timestep> checked, promoted:", i9,i9)') npactive,i 
 call report(1, mess)
end subroutine 

function log2(i) ! integer log base 2 rounded down
 integer log2,i
 if(i.LE.0) return
 log2=30
 do while(IAND(2**log2,i).EQ.0)
  log2=log2-1
 enddo
end function 

subroutine refresh_itimestp
 include 'globals.h'
 integer :: p,pbin,npcheck
 real :: dt
 real :: courant_timestep,sqrtacc_timestep,acc_timestep,freeform_timestep
 integer :: log2

 npcheck=0
 do p=1,nbodies
   if(itimestp(p).GT.active_bin) then
      npcheck=npcheck+1

      dt=dtime
      if(usesph)   dt=MIN(dt,courant_timestep(p))
      if(sqrttstp)  dt=MIN(dt,sqrtacc_timestep(p))
      if(acc_tstp)  dt=MIN(dt,acc_timestep(p))
      if(freetstp) dt=MIN(dt,freeform_timestep(p))
      
      if(dt.GE.dtime) then
        tempvect(npcheck)=dtime
	templist(npcheck)=1
      else
        tempvect(npcheck)=dt
	if(dtime/tempvect(npcheck).GT.2**30) &
                   call terror('timestep way too small') 
	templist(npcheck)=INT(dtime/tempvect(npcheck))+1
      endif
   endif
 enddo 

 call mrgrnk(npcheck,tempvect,bodlist)
 
 if(npcheck.GE.nsmooth+1) then 
   if(templist(bodlist(nsmooth+1)).GT.max_tbin) & 
                 call terror(' timestep too small')
 endif
 
 if(minppbin.GT.1) then
  call promote_bins(minppbin,npcheck,templist,bodlist) 
 else
  if(verbosity.GT.0) print*,'<timestep> checked:',npcheck
 endif
 
 npcheck=0
 do p=1,nbodies
   if(itimestp(p).GT.active_bin) then
      npcheck=npcheck+1
      pbin=active_bin+1   
      do while(2**(pbin-1).LT.templist(npcheck).AND.2**(pbin-1).LT.max_tbin)
        pbin=pbin+1
      enddo
      itimestp(p)=max(itimestp(p)-1,pbin)
   endif   
 enddo         

end subroutine

subroutine timestep(itime)
 include 'globals.h'
 integer :: itime
 integer :: i,p,pbin,largest_bin
 real :: dt
 integer :: maxbin
 real :: courant_timestep,sqrtacc_timestep,acc_timestep,freeform_timestep
 integer :: log2
 
 maxbin=log2(2*max_tbin)

 call refresh_itimestp()

 largest_bin=maxval(itimestp(1:nbodies))
 
 itime=itime+2**(maxbin-largest_bin)

 active_bin=largest_bin
 do while(IAND(itime,2**(maxbin-active_bin)).EQ.0)
  active_bin=active_bin-1
 enddo

 tsteppos=dtime/2**largest_bin

 npactive=0
 nsphact=0

 if(active_bin.EQ.0) then
   if(itime.NE.2**maxbin) then    
      print*,itime,maxbin,2**maxbin
      call terror('itime inconsistent')
   endif
  else
   do p=1,nbodies
    if(itimestp(p).EQ.active_bin) then
      npactive=npactive+1
      if(p.LE.nsph.and.usesph) nsphact=nsphact+1
      pactive(npactive)=p
    endif
   enddo
 endif

 if(verbosity.GT.0) &
   print*, '<timestep> smallest, current,npactive:', largest_bin,active_bin,npactive

 if(active_bin.EQ.0.AND.verbosity.GT.0) print*, '<timestep> endstep'

 if(npactive.GT.0) then 
   call corrpos(otimestp,'sync')
   call corrpos(itimestp,'desync')
   otimestp(pactive(1:npactive))=itimestp(pactive(1:npactive))
 endif
 
end subroutine

! tempr has to be fixed?
subroutine postprocessread
  include 'globals.h'
  real,allocatable :: tempr(:)

! setup initial conditions for simulation according to input
 
  if(verbosity.GT.0) print*,' ...transforming input...'

  if(nsph.EQ.0) usesph=.FALSE.
 
! move tempvect to tempr to be certain
  if(nsph.GT.0.AND.usesph) then
    allocate(tempr(nsph))
    tempr(1:nsph)=tempvect(1:nsph)
  endif
 
  if(sortpart) then
    if(verbosity.GT.0) print*,'...sorting...'
    call mortonsort
! fix order of tempr
    if(allocated(tempr)) call sort_additional_real(nsph,tempr)
  endif  
 
  if(input(1).EQ.0) call terror(' input error: need masses')

  if(input(42).EQ.0) then
    call nbexistinit
  endif

  if(nsph.GT.0) then
    if(massres.le.0.) then
!  massres=sum(mass(1:nsph))/8./nsph*nsmooth
!  massres=MINVAL(mass(1:nsph))/8.*nsmooth
      massres=MAXVAL(mass(1:nsph))/8.*nsmooth
    endif
  endif

  if(input(2).EQ.0) call terror(' input error: need positions')

  if(input(3).EQ.0) call terror(' input error: need velocities')

  call activateparts
 
  if(usesph.AND.nsph.GT.0) then
    if(verbosity.GT.0) print*,'...init sph...'
    veltpos(1:nsph,1:ndim)=vel(1:nsph,1:ndim) ! cosmofac veltpos is pec. vel.
    call makesphtree
    if(input(13).EQ.0) then
      hsmooth(1:nsph)=0. 
    endif
    if(hupdatemethod.NE.'mass')then
      call terror('TBD mass update')
!   call inithsm ! reimplement
!   if(input(13).EQ.0.OR.sphinit) then
!    CALL omp_neighbor('correct') 
!   endif
!   if(input(10).EQ.0.OR.sphinit) then
!    CALL initdens ! inclding symm and no divv
!   endif    
!  if(input(24).EQ.0) call veldisp
    else
      if(input(10).EQ.0.OR.input(13).EQ.0.OR.input(21).EQ.0.OR. &
       input(23).EQ.0.OR.sphinit) then
        call densnhsmooth
      endif
    endif 
  endif
 
  if(input(4).EQ.0.OR.any(epsgrav(1:nbodies).EQ.0)) then
    if((.NOT.usesph).OR.input(4).EQ.0.OR.any(epsgrav(nsph+1:nbodies).EQ.0)) call initeps ! stars + collisionless
    if(usesph.and.nsph.gt.0) then
      if(eps_is_h) then  
        if(input(13).EQ.0.OR.any(hsmooth(1:nsph).EQ.0)) then 
          call seteps('sph ')  ! not so good in fact .....
        else
          epsgrav(1:nsph)=hsmooth(1:nsph)
        endif
        if(mingaseps) epsgrav(1:nsph)=max(epsgas,epsgrav(1:nsph))
      else
        call initepsgas
      endif
    endif
  endif
  if(input(4).EQ.1.AND.eps.EQ.0) eps=sum(epsgrav(1:nbodies))/nbodies
  
  if(input(5).EQ.0) then
    tform(1:nsph)=tnow
    tform(nsph+1:nbodies)=tnow-2*tbubble
  endif

  tvel(1:nbodies)=tnow

  if(verbosity.GT.0) print*,'...init grav...'
  call zeroacc
  call zeropot
  acc(1:nbodies,4)=0.
  call gravity('both')
  if(.not.directsum.and.gdgop) then
    call zeroacc
    call zeropot
    call gravity('both')
  endif
 
  if(input(34).EQ.0.AND.(radiate.OR.starform)) call starevolv

  if(input(35).EQ.0) snentropy(nbodies-nstar+1:nbodies)=0

  if(usesph.AND.nsph.GT.0) then
    if(input(14).EQ.0.AND.radiate) then
      call zerofuv
      call fuvflux
    endif
    call makesphtree

! quick fix: (no longer necessary)
!    call tree_reduction(root,incells,'sph ') 
 
    if(input(20).NE.0) csound(1:nsph)=sqrt(gamma*csound(1:nsph)/rho(1:nsph))

    if( input(19).NE.0 .OR. input(20).NE.0 .OR. &
       input(11).NE.0 .OR. input(12).NE.0 ) then
      if(uentropy) then
        if(input(12).EQ.0) then
          if(input(11).NE.0) then
            entropy(1:nsph)=gamma1*tempr(1:nsph)/rho(1:nsph)**gamma1
          else
            entropy(1:nsph)=csound(1:nsph)**2/gamma/rho(1:nsph)**gamma1
          endif   
        endif
        if(input(11).NE.0.OR.input(12).NE.0) &
         csound(1:nsph)=sqrt(gamma*rho(1:nsph)**gamma1*entropy(1:nsph)) !cosmof3
      else
        if(.not.isotherm) then
          if(input(11).EQ.0) then
            if(input(12).NE.0) then
              ethermal(1:nsph)=tempr(1:nsph)/gamma1*rho(1:nsph)**gamma1
            else
              ethermal(1:nsph)=csound(1:nsph)**2/gamma/gamma1
            endif
          endif
        if(input(11).NE.0.OR.input(12).NE.0) &
         csound(1:nsph)=sqrt(gamma*gamma1*ethermal(1:nsph))
        else
          if(input(19).EQ.0.AND.input(20).EQ.0) then
            if(input(11).NE.0) then
              csound(1:nsph)=sqrt(ethermal(1:nsph))
            else
              csound(1:nsph)=sqrt(tempr(1:nsph))
            endif   
          else
	    ethermal(1:nsph)=csound(1:nsph)**2
	  endif
        endif 
      endif
    else
      call terror('no u,A,P or Csound for gas')
    endif
   
    ethold(1:nsph)=ethermal(1:nsph) 
   
    if(smoothinput) then
      call terror('checksmoothall')
      call smoothall
    endif

    dethdt(1:nsph)=0
    derad(1:nsph)=0

!  IF(smoothinput.OR.(hupdatemethod.NE.'mass'.AND.(input(21).EQ.0.OR. &
!       input(23).EQ.0))) CALL initdivv ! check why initvet does not change vel
! if ok can be integrated with density

    if(input(22).EQ.0) mumaxdvh(1:nsph)=0.
  
    if((input(17).EQ.0.OR.input(18).EQ.0).AND.radiate) call temperature
    call ethdotinit
   
    if(input(15).EQ.0.OR.feedback.NE.'solh') esnthdt(1:nsph)=0 !check
    if(input(16).EQ.0) tcollaps(1:nsph)=tnow   ! should be improved(tnow-.5*tff)!
!  if(input(24).EQ.0) call veldisp checkcheck

    if(input(25).EQ.0.AND.radiate) then
      h2frac(1:nsph)=0.
      h2time=tnow-1.e8/timescale*year
      call molecules
    else
      h2time=tnow
    endif

! hsmooth for stars+bh is not read..
    hsmooth(nbodies-nstar+1:nbodies)=0

    if(nbh.GT.0) then
      tform(nbodies-nbh+1:nbodies)=tnow-2*tbubble
      call blackholes
    endif

    if(nbh+nstar.GT.0) CALL mech_feedback
    
  endif

  if(input(43).EQ.0) then
    itimestp(1:nbodies)=1
    call refresh_itimestp
  endif
   
!  if(sortpart) call mortonsort

  if(allocated(tempr)) deallocate(tempr)
  
end subroutine

subroutine basicinput(filenaam)
  include 'globals.h'
  character*200 filenaam
  integer i,mapnr,nfeedback
  real,allocatable :: weights(:)
 
!  call set_parameters(0)

  print*,'filenaam?'
  read(*,'(a)') filenaam
 
  call readbods(filenaam)
  
!  call heattabel
         
!  call initpars

!  if(periodic) call initbc

!  call initnewstar

!  if(usepm) then
!    if(verbosity.GT.0) print*,' ...initPM...'
!    call initpm
!  endif

!  call postprocessread

end subroutine

program snapreader
  include 'globals.h'
  integer p
  character*200 filenaam
 
  call initmem(nbodsmax,nsphmax,ncells)
  call basicinput(filenaam)

! insert code after this

  open(unit=1,file=trim(filenaam)//'.simple',form='unformatted')
  write(1) nbodies,nsph,nstar
  do p=1,nbodies
    write(1), mass(p),pos(p,1:3),vel(p,1:3)
  enddo
  close(1) 
end program

subroutine corrpos(ctimestp,rc)
  include 'globals.h'
  character*7 rc
  integer :: i,p,k,ctimestp(*)
  real dt2,rcsign,acceff,dt

  if(rc(1:4).NE.'sync'.AND.rc(1:6).NE.'desync') &
    call terror('unknown sync option in corrpos')
  if(rc(1:4).EQ.'sync') then
    if(syncflag.EQ.0) return
    syncflag=0
    rcsign=-1.
    if(verbosity.GT.0) print*,'<corrpos> sync'
  endif
  if(rc(1:6).EQ.'desync') then	
    if(syncflag.EQ.1) return
    syncflag=1
    rcsign=1.
    if(verbosity.GT.0) print*,'<corrpos> desync'
  endif

  ppropcount=ppropcount+1

  if(.not.periodic) then
    do k=1,ndim
      do i=1,npactive
        p=pactive(i)
        dt2=(dtime/2**(ctimestp(p)-1))**2
        pos(p,k)=pos(p,k)+rcsign*acc(p,k)*dt2/8.
      enddo
    enddo
  else            
    do k=1,ndim
      do i=1,npactive
        p=pactive(i)
        dt2=(dtime/2**(ctimestp(p)-1))**2
        pos(p,k)=pos(p,k)+rcsign*acc(p,k)*dt2/8.
        if(pos(p,k).GE.hboxsize) pos(p,k)=pos(p,k)-pboxsize
        if(pos(p,k).LT.-hboxsize) pos(p,k)=pos(p,k)+pboxsize
      enddo
    enddo
  endif
end subroutine

subroutine steppos
  include 'globals.h'
  integer i,ib,p,k,nkeep
  real acceff,distance,csdtime

  ppropcount=ppropcount+1

  if(.not.periodic) then

    do k=1,ndim
      do p=1,nbodies
        pos(p,k)=pos(p,k)+vel(p,k)*tsteppos
      enddo
    enddo
  else
    do k=1,ndim
      do p=1,nbodies
        pos(p,k)=pos(p,k)+vel(p,k)*tsteppos
        if(pos(p,k).GE.hboxsize) pos(p,k)=pos(p,k)-pboxsize
        if(pos(p,k).LT.-hboxsize) pos(p,k)=pos(p,k)+pboxsize
      enddo
    enddo  
  endif

  tpos=tpos+tsteppos
  tnow=tpos
end subroutine

subroutine stepvel
  include 'globals.h'
  integer p,k,i
  real acceff,vfac1now,vfac2now,dt,go,maxacc

! adhoc acc limiter
  k=0
  if(usesph) then
    do i=1,nsphact
      p=pactive(i)
      acceff=sqrt(sum(acc(p,1:3)**2))
      maxacc=tstepcrit**2*hsmooth(p)*(2**(itimestp(p)-1)/dtime)**2
      if(acceff.GT.maxacc) then
        k=k+1
        acc(p,1:3)=acc(p,1:3)/acceff*maxacc
      endif	
    enddo
  endif
  if(k.GT.0.AND.(verbosity.GT.0).OR.k.GT.0.001*nsph) &
    print*,' > acc limiter',tnow,k
!

  do k=1,ndim
    do i=1,npactive
      p=pactive(i)
      vel(p,k)=vel(p,k)+acc(p,k)*dtime/2**(itimestp(p)-1)
    enddo
  enddo  
  do i=1,npactive
    p=pactive(i)
    tvel(p)=tvel(p)+dtime/2**(itimestp(p)-1)
    if(ABS(tvel(p)-tnow).gt.dtime/2**(itimestp(p)-1)) then
      print*,p,tvel(p),tnow,itimestp(p),npactive
      call terror(' stepvel error: tvel mismatch') 
    endif
  enddo
end subroutine

subroutine zeroacc
  include 'globals.h'
  acc(pactive(1:npactive),1:3)=0.
end subroutine

subroutine zeropot
  include 'globals.h'
  phi(pactive(1:npactive))=0.
  phiext(pactive(1:npactive))=0.
  if(npactive.EQ.nbodies) esofttot=0.0
end subroutine

subroutine vextrap
  include 'globals.h'
  integer p,k
  do k=1,ndim
    do p=1,nsph
      veltpos(p,k)=vel(p,k)+acc(p,k)*(tnow-tvel(p))
    enddo
  enddo  
end subroutine

subroutine allethdot
  include 'globals.h'

  if(.NOT.consph) then
    call terror(' non conservative TBD')
!    if(sph_visc.EQ.'sphv') call omp_ethdotcv(pc)
!    if(sph_visc.EQ.'bulk') call omp_ethdotbv(pc)
!    if(sph_visc.EQ.'sph ') call omp_ethdot(pc)
  else
!    if(sph_visc.EQ.'sph ') call omp_ethdotco(pc)
    if(sph_visc.EQ.'bulk') call terror(' allethdot error')
    if(sph_visc.EQ.'sphv') call terror(' allethdot error')
  endif

end subroutine

subroutine allentdot
  include 'globals.h'

  if(sph_visc.EQ.'sph ') call omp_entdot
  if(sph_visc.EQ.'bulk') call terror(' allentdot error')
  if(sph_visc.EQ.'sphv') call terror(' allentdot error')	

end subroutine
 	 	 
subroutine allaccsph
  include 'globals.h'

  if(.NOT.consph) then
    call terror(' non conservative TBD')
!    if(sph_visc.EQ.'sphv') call omp_accsphcv
!    if(sph_visc.EQ.'bulk') call omp_accsphbv
!    if(sph_visc.EQ.'sph ') call omp_accsph
  else
    if(sph_visc.EQ.'sph ') call omp_accsphco
    if(sph_visc.EQ.'bulk') call terror(' allaccsph error')
    if(sph_visc.EQ.'sphv') call terror(' allaccsph error')
  endif

end subroutine

subroutine alldentacc
  include 'globals.h'

  if(.NOT.consph) then
    call terror(' non conservative TBD')
!    if(sph_visc.EQ.'sphv') call omp_accsphcv
!    if(sph_visc.EQ.'bulk') call omp_accsphbv
!    if(sph_visc.EQ.'sph ') call omp_accsph
  else
    if(sph_visc.EQ.'sph ') call omp_entdotaccsphco
    if(sph_visc.EQ.'bulk') call terror(' allaccsph error')
    if(sph_visc.EQ.'sphv') call terror(' allaccsph error')
  endif
 	 	 
end subroutine

subroutine alldethacc
  include 'globals.h'
  if(.NOT.consph) then
    call terror(' dethacc TBD ')
!    if(sph_visc.EQ.'sphv') call omp_accsphcv
!    if(sph_visc.EQ.'bulk') call omp_accsphbv
!    if(sph_visc.EQ.'sph ') call omp_accsph
  else
    if(sph_visc.EQ.'sph ') call omp_ethdotaccsphco
    if(sph_visc.EQ.'bulk') call terror(' allaccsph error')
    if(sph_visc.EQ.'sphv') call terror(' allaccsph error')
  endif	 

end subroutine

subroutine stepsph
  include 'globals.h'
  integer i,j,npnear,p

  call makesphtree

  if(hupdatemethod.NE.'mass') then
    call terror('TBD: hupdate=mass')
!    call omp_stepnear !change to hsmcal
!    call omp_density  !easychange 
!    call veldisp ! lesseasy
  else
    call densnhsmooth
  endif

! call update_reduction !!!!!! not so urgent
! quick fix: (not parallelized)
  call tree_reduction(root,incells,'sph ') 

  if(nbh.GT.0) call blackholes
  if(nstar+nbh.GT.0) call mech_feedback
        
  if(nsphact.EQ.0) return

  if(.NOT.isotherm) then 
    if(.NOT.uentropy) then
      call allethdot
      call exstep2(1)
      call alldethacc
      call exstep2(2)
    else
      call allentdot   ! entdot is 2x faster than accsph 
      call exstep2(1)
      call alldentacc !  call allentdot
      call exstep2(2)
    endif
      call exstep2(3)
  else
    call alldethacc
  endif

end subroutine

subroutine step
  include 'globals.h'
  integer itime
  

  itime=0
  do while(itime.LT.2*max_tbin)
  
    call setrnd()

    if(starform.and.nsph.gt.0) then 
      if(verbosity.GT.0) print*,'<stepsys> starform...'
      call newstar
    endif

    if(nbh.gt.0) then
      if(verbosity.GT.0) print*,'<stepsys> bh mergers...'
      call bhmergers
    endif

    if(verbosity.GT.0) print*,'<stepsys> partremoval1...'
    call partremoval

    if(verbosity.GT.0) print*,'<stepsys> timestep..'
    call timestep(itime)

    if(verbosity.GT.0) print*,'<stepsys> steppos..'
    call steppos
    
! note that particles are not removed in clean, just set to zero mass
! - we have moved this from before partremoval. all routines should be
! 'zero-mass-safe'
    if(verbosity.GT.0) print*,'<stepsys> clean...'
    call clean

!    if(verbosity.GT.0) print*,'<stepsys> cosmo...'

!TBD    if(usesph.and.radiate) call cosmicray

    if(usesph) then
      if(verbosity.GT.0) print*,'<stepsys> extrapolate..'
      call vextrap
      call extrapethrho
    endif
    
    if(npactive.gt.0) then
      if(verbosity.GT.0) print*,'<stepsys> gravity..'
      call zeroacc
      call gravity('acc ')
    endif 

    if((starform.or.radiate)) then
      if(verbosity.GT.0) print*,'<stepsys> starevolv..'
      call starevolv
    endif
    
    if(usesph.and.nsphact.gt.0.and.radiate) then
      if(verbosity.GT.0) print*,'<stepsys> fuvflux..'
      call zerofuv
      call fuvflux
    endif
 
    if(usesph.and.radiate) then
      if(verbosity.GT.0) print*,'<stepsys> molecules...'
      call molecules
    endif
  
    if(usesph) then
      if(verbosity.GT.0) print*,'<stepsys> stepsph..'
      call stepsph
    endif 

    if(npactive.GT.0) then
      if(verbosity.GT.0) print*,'<stepsys> stepvel..'
!    if(sphfiltr.and.usesph.and.nsphact.gt.0) call vfilter tbd
      call stepvel
    endif
    
  enddo

  if(verbosity.GT.0) print*,'<stepsys> partremoval2...'
  call partremoval

  if(verbosity.GT.0) print*,'<stepsys> nbodies,nsph,nstar:',nbodies,nsph,nstar     
  
  if(sortpart) then
    if(verbosity.GT.0) print*,'<stepsys> sorting...'
    if(sortpart) call mortonsort
  endif
  
end subroutine

subroutine stepsystem(n)
  include 'globals.h'
  integer n
! for AMUSE
! reset the record of the removed ids
    nremovals = 0
! ---
  call step
  print*,'<stepsystem> step completed:',n
  call outstate(n)

end subroutine

C this file contains the input/output routines
C ol -style
C***********************************************************************
C
C
                          SUBROUTINE defaultparams
C
C
C=======================================================================
 
	INCLUDE 'globals.h'

        INTEGER i,kk

         datadir='./datadir/'
         inputfile='input'
	 outputfile='output'
	 firstsnap=0
         nsteps=0
         stepout=5
         steplog=5
         dtime=1.
         bh_tol=0.5
         eps=1.
         adaptive_eps=.FALSE.
         targetnn=32
         nn_tol=0.1
         usequad=.FALSE.
         directsum=.FALSE.
!         sboundary=boundary

         max_tbin=4096
         minppbin=1

         usesph=.TRUE.
         sphinit=.TRUE.
         uentropy=.TRUE.
         isotherm=.FALSE.
         sph_visc='sph '
         epsgas=0.005
         gamma=1.66667
         alpha=0.5
         beta=1.
         epssph=0.01
         courant=0.3
         eps_is_h=.TRUE.
         consthsm=0.2
         nsmooth=64
         nsmtol=0.1

         symmetry='hk'

         radiate=.FALSE.
         graineff=0.05
	 crionrate=3.6
         heat_par1=0.0
         heat_par2=0.0
         cool_par=1.
         unitl_in_kpc=1.0
         unitm_in_msun=1.e9

         halofile='none'
         fixthalo=.FALSE.

         selfgrav=.TRUE.
         starform=.FALSE.

         cosmo=.FALSE.
         comove=.FALSE.
         pboxsize=300.

         optdepth=0.
         tcollfac=1.
         masscrit=1.e5
         removgas=0.25
         sfeff=0.25
	 tbubble=3.e7
         sne_eff=0.
         tsnbeg=3.e6
         feedback='fuv '
         verbosity=0
        
         hupdatemethod='mass'
         smoothinput=.FALSE.
         consph=.TRUE.
	 sfmode='gerritsen'
         rhomax=100
	 sqrttstp=.FALSE.
	 acc_tstp=.TRUE.
	 tstepcrit=1.
	 tstpcr2=0.25
	 freetstp=.FALSE.
	 freev=0.5
	 freea=.35
	 freevexp=0.
	 freeaexp=-1.
	 gdgop=.TRUE.
	 gdgtol=0.01

         output=0
         output(1:3)=1

         RETURN
        END



C***********************************************************************
C
C
                          SUBROUTINE inparams
C
C
C=======================================================================
 
	INCLUDE 'globals.h'

        CHARACTER*9 sboundary,boundary
        CHARACTER *1 pcomment
        INTEGER i,ioerror,kk
        LOGICAL bdummy

        if(.not.periodic) boundary='vacuum'
        if(periodic) boundary='periodic'

        print*,' ...reading run info...'
        OPEN(UNIT=upars,FILE=parsfile,STATUS='OLD',IOSTAT=ioerror)
        IF(ioerror.NE.0) THEN
	 PRINT*,' cannot read parameters from file: ',parsfile
         PRINT*,' using defaults'

	 CALL defaultparams
	
	 RETURN
	 	 
	ENDIF

        READ(upars,'(a)') pcomment
        READ(upars,'(a)') pcomment
        READ(upars,'(a)') datadir
	datadir=adjustl(datadir)
        i=index(datadir,' ')
        if(i.ne.0) datadir=datadir(1:i)

        READ(upars,'(a)') inputfile
	READ(upars,'(a)') outputfile
	READ(upars,*) firstsnap
        READ(upars,*) nsteps
        READ(upars,*) stepout
        READ(upars,*) steplog
        READ(upars,*) dtime
        READ(upars,*) bh_tol
        READ(upars,*) eps
        READ(upars,*) adaptive_eps
        READ(upars,*) targetnn
        READ(upars,*) nn_tol
        READ(upars,*) usequad
        READ(upars,*) directsum
        READ(upars,'(a)') sboundary
	IF(sboundary.NE.boundary) 
     &	  print*,'warning: compiled with: boundary=',boundary

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*) max_tbin
        READ(upars,*) minppbin

        READ(upars,'(a)') pcomment

        READ(upars,*) usesph
        READ(upars,*) sphinit
        READ(upars,*) uentropy
        READ(upars,*) isotherm
        READ(upars,'(a)') sph_visc
        READ(upars,*) epsgas
        READ(upars,*) gamma
        READ(upars,*) alpha
        READ(upars,*) beta
        READ(upars,*) epssph
        READ(upars,*) courant
        READ(upars,*) 
        READ(upars,*) eps_is_h
        READ(upars,*) consthsm
        READ(upars,*) nsmooth
        READ(upars,*) nsmtol

        READ(upars,'(a)') symmetry
        READ(upars,*) 
        READ(upars,*)  
        READ(upars,*)  

        READ(upars,'(a)') pcomment

        READ(upars,*) radiate
        READ(upars,*) graineff
	READ(upars,*) crionrate
        READ(upars,*) heat_par1
        READ(upars,*) heat_par2
        READ(upars,*) cool_par
        READ(upars,*) 
        READ(upars,*)  ! mh/kboltz
        READ(upars,*) unitl_in_kpc
        READ(upars,*) unitm_in_msun
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*)
        READ(upars,*)
        READ(upars,*)

        READ(upars,'(a)') pcomment

        READ(upars,'(a)') halofile
	halofile=adjustl(halofile)
        i=index(halofile,' ')
        if(i.ne.0) halofile=halofile(1:i)

        READ(upars,*) fixthalo
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*)
        READ(upars,*)
        READ(upars,*)
        READ(upars,*)
        READ(upars,*)
        READ(upars,*)

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*)

        READ(upars,'(a)') pcomment

        READ(upars,*) selfgrav
        READ(upars,*) starform
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*)

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) cosmo
        READ(upars,*) comove
        READ(upars,*) 
        READ(upars,*) pboxsize
        READ(upars,*) 

        READ(upars,'(a)') pcomment
        READ(upars,*) optdepth
        READ(upars,*) tcollfac
        READ(upars,*) masscrit
        READ(upars,*) removgas
        READ(upars,*) sfeff
        READ(upars,*) 
	READ(upars,*) tbubble
        READ(upars,*) sne_eff
        READ(upars,*)
        READ(upars,*)
        READ(upars,*) tsnbeg
        READ(upars,*) feedback
        READ(upars,*) bdummy
        if(bdummy) verbosity=99
        
	READ(upars,'(a)') pcomment
        READ(upars,'(a)') hupdatemethod
        READ(upars,*)  smoothinput
        READ(upars,*) consph
	READ(upars,'(a)') sfmode
        READ(upars,'(a)') 
        READ(upars,*) rhomax
	READ(upars,*) 
	READ(upars,*) sqrttstp
	READ(upars,*) acc_tstp
	READ(upars,*) tstepcrit
	READ(upars,*) tstpcr2
	READ(upars,*) freetstp
	READ(upars,*) freev
	READ(upars,*) freea
	READ(upars,*) freevexp
	READ(upars,*) freeaexp
	READ(upars,*) gdgop
	READ(upars,*) gdgtol

        READ(upars,'(a)') pcomment

        output=0
	kk=0
	DO  i=1,64
	 IF(kk+1.EQ.i) THEN
          READ(upars,*) kk,pcomment, output(kk)
	 ENDIF
	ENDDO
		
        CLOSE(UNIT=upars)

        IF(bdummy) THEN
	 print*,'  > detailed info: loud =.TRUE.'   
	ELSE
	 print*,'  > sparse info: loud=.FALSE.' 
        ENDIF
	
	RETURN
        END
	

C***********************************************************************
C
C
                          SUBROUTINE someparams
C
C
C=======================================================================
 
	INCLUDE 'globals.h'

        CHARACTER*9 sboundary,boundary
        CHARACTER *1 pcomment,pdummy
        INTEGER i,ioerror,kk,idummy
	REAL rdummy
        LOGICAL bdummy

        if(.not.periodic) boundary='vacuum'
        if(periodic) boundary='periodic'

        print*,' ...scanning run info...'
        OPEN(UNIT=upars,FILE=parsfile,STATUS='OLD',IOSTAT=ioerror)
        IF(ioerror.NE.0) THEN
	 PRINT*,' cannot read parameters from file: ',parsfile
	 PRINT*,' thus no changes'
	 RETURN	 	 
	ENDIF

        READ(upars,'(a)') pcomment
        READ(upars,'(a)') pcomment
        READ(upars,'(a)') datadir
        READ(upars,'(a)') pdummy !inputfile
	READ(upars,'(a)') outputfile
	READ(upars,*) idummy !firstsnap
        READ(upars,*) nsteps
        READ(upars,*) stepout
        READ(upars,*) steplog
        READ(upars,*) rdummy !dtime
        READ(upars,*) rdummy !bh_tol
        READ(upars,*) rdummy !eps
        READ(upars,*) bdummy !adaptive_eps
        READ(upars,*) idummy !targetnn
        READ(upars,*) rdummy !nn_tol
        READ(upars,*) bdummy !usequad
        READ(upars,*) bdummy !directsum
        READ(upars,'(a)') pdummy !sboundary

        READ(upars,'(a)') pcomment

        READ(upars,*)
        READ(upars,*) max_tbin
        READ(upars,*) minppbin

        CLOSE(UNIT=upars)
        PRINT*,'...So far so good...'
	RETURN
        
        READ(upars,'(a)') pcomment

        READ(upars,*) usesph
        READ(upars,*) sphinit
        READ(upars,*) uentropy
        READ(upars,*) isotherm
        READ(upars,'(a)') sph_visc
        READ(upars,*) epsgas
        READ(upars,*) gamma
        READ(upars,*) alpha
        READ(upars,*) beta
        READ(upars,*) epssph
        READ(upars,*) courant
        READ(upars,*) 
        READ(upars,*) eps_is_h
        READ(upars,*) consthsm
        READ(upars,*) nsmooth
        READ(upars,*) nsmtol

        READ(upars,'(a)') symmetry
        READ(upars,*)
        READ(upars,*) 
        READ(upars,*) 

        READ(upars,'(a)') pcomment

        READ(upars,*) radiate
        READ(upars,*) graineff
	READ(upars,*) crionrate
        READ(upars,*) heat_par1
        READ(upars,*) heat_par2
        READ(upars,*) cool_par
        READ(upars,*) 
        READ(upars,*)
        READ(upars,*) unitl_in_kpc
        READ(upars,*) unitm_in_msun
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*)
        READ(upars,*)

        READ(upars,'(a)') pcomment

        READ(upars,'(a)') halofile
	halofile=adjustl(halofile)
        i=index(halofile,' ')
        if(i.ne.0) halofile=halofile(1:i)

        READ(upars,*) fixthalo
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) 

        READ(upars,'(a)') pcomment

        READ(upars,*) selfgrav
        READ(upars,*) starform
        READ(upars,*) 
        READ(upars,*)
        READ(upars,*)

        READ(upars,'(a)') pcomment

        READ(upars,*) 
        READ(upars,*) 
        READ(upars,*) cosmo
        READ(upars,*) comove
        READ(upars,*) 
        READ(upars,*) pboxsize
        READ(upars,*)

        READ(upars,'(a)') pcomment
        READ(upars,*) optdepth
        READ(upars,*) tcollfac
        READ(upars,*) masscrit
        READ(upars,*) removgas
        READ(upars,*) sfeff
        READ(upars,*) 
	READ(upars,*) tbubble
        READ(upars,*) sne_eff
        READ(upars,*)
        READ(upars,*)
        READ(upars,*) tsnbeg
        READ(upars,*) feedback
        READ(upars,*) bdummy
        if(bdummy) verbosity=99
        
	READ(upars,'(a)') pcomment
        READ(upars,'(a)') hupdatemethod
        READ(upars,*)  smoothinput
        READ(upars,*) consph
	READ(upars,'(a)') sfmode
        READ(upars,'(a)') 
        READ(upars,*) rhomax
	READ(upars,*) 
	READ(upars,*) sqrttstp
	READ(upars,*) acc_tstp
	READ(upars,*) tstepcrit
	READ(upars,*) tstpcr2
	READ(upars,*) freetstp
	READ(upars,*) freev
	READ(upars,*) freea
	READ(upars,*) freevexp
	READ(upars,*) freeaexp
	READ(upars,*) gdgop
	READ(upars,*) gdgtol

        READ(upars,'(a)') pcomment

        output=0
	kk=0
	DO  i=1,64
	 IF(kk+1.EQ.i) THEN
          READ(upars,*) kk,pcomment, output(kk)
	 ENDIF
	ENDDO
		
        IF(bdummy) THEN
	 print*,'  > detailed info: loud =.TRUE.'   
	ELSE
	 print*,'  > sparse info: loud=.FALSE.' 
        ENDIF
	
	RETURN
        END

program read_snapshot

   include 'globals.h'
   integer :: NFILES        

   character*200 fileroot,filename
   character*6 nostring

!    this is an array of the possible data fields that can appear in an
!    output/restart snapshot.
  integer, parameter :: ntagl = 24

  ! names for the integer part of the header
  integer*4, parameter :: Nint_header_entries = 7
  character(ntagl), parameter :: i_header_variable_names(Nint_header_entries) = &
       (/ "NparSnap                ", &    ! 1
          "NparFile                ", &    ! 2
          "NumFiles                ", &    ! 3
          "NsphNeighbors           ", &    ! 4
          "RayBoundaryConditions   ", &    ! 5
          "OnTheSpot               ", &    ! 6
          "TotalRaysTraced         " /)    ! 7

  ! names for the real part of the header
  integer*4, parameter :: Nreal_header_entries = 18
  character(ntagl), parameter :: r_header_variable_names(Nreal_header_entries) = &
       (/ "Time                    ", &  ! 1
          "IsoMass                 ", &  ! 2
          "IsoTemperature          ", &  ! 3
          "ScaleFactor             ", &  ! 4
          "BoxLowX                 ", &  ! 5
          "BoxLowY                 ", &  ! 6
          "BoxLowZ                 ", &  ! 7
          "BoxHighX                ", &  ! 8
          "BoxHighY                ", &  ! 9
          "BoxHighZ                ", &  ! 10
          "CodeLenINcm             ", &  ! 11
          "CodeLumINergs_per_s     ", &  ! 12
          "CodeTimeINs             ", &  ! 13
          "OmegaMatter             ", &  ! 14
          "OmegaBaryon             ", &  ! 15
          "OmegaLambda             ", &  ! 16
          "LittleHubble            ", &  ! 17
          "RecombRayTolerance      " /)  ! 18


  ! names of the possible snapshot data fields
  integer*4, parameter :: ndatablocks = 30
  character(ntagl), parameter :: data_field_names(ndatablocks) = &  
       (/ "id                      ",&  ! 1
          "xpos                    ",&  ! 2
          "ypos                    ",&  ! 3
          "zpos                    ",&  ! 4
          "xvel                    ",&  ! 5
          "yvel                    ",&  ! 6
          "zvel                    ",&  ! 7
          "hsml                    ",&  ! 8
          "rho                     ",&  ! 9
          "mass                    ",&  ! 10
          "temperature             ",&  ! 11
          "xHII                    ",&  ! 12
          "xHeII                   ",&  ! 13
          "xHeIII                  ",&  ! 14
          "xHIIrc                  ",&  ! 15
          "xHeIIrc                 ",&  ! 16
          "xHeIIIrc                ",&  ! 17
          "lasthit                 ",&  ! 18
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               ",&
          "undefined               " /)

  type integer_header_entry
     character(ntagl) :: name
     integer*8 :: var
  end type integer_header_entry

  type real_header_entry
     character(ntagl) :: name
     real*8 :: var
  end type real_header_entry

  type particle_header_type
     type(integer_header_entry) :: int(Nint_header_entries)
     type(real_header_entry) :: real(Nreal_header_entries)
     integer*4 :: DataPresent(ndatablocks)
  end type particle_header_type

   real(kind=4),save :: rblock(nsphmax)
   integer(kind=4),save :: iblock(nsphmax)
   integer(kind=8),save :: iblock2(nsphmax)
   type(particle_header_type) :: phead
   real :: codemass,codevel,mscale,vscale,tscale,lscale
   integer no,k,i
      character(ntagl) :: DataFieldLabel

   call initmem(nbodsmax,nsphmax,ncells)

   unitm_in_msun=1.e9
   unitl_in_kpc=1.
   timescale=1.488e19*unitl_in_kpc*sqrt(unitl_in_kpc/unitm_in_msun)
   lengthscale=3.086e21*unitl_in_kpc
   velscale=lengthscale/timescale

   print*,'gabe file conversion'
   print*,'fileroot?'
   read*,fileroot
   
   filename=trim(fileroot)//'.unf'

   k=len_trim(fileroot)
   read(fileroot(k-2:k),*) no
   print *,'opening...  '//trim(filename)
   print*,' detected No.', no

! now, read in the header
   open (1, file=filename, form='unformatted')
   read(1) DataFieldLabel, phead

   print*,DataFieldLabel
   do i = 1,Nint_header_entries
    if (phead%int(i)%name /= i_header_variable_names(i)) then
      print*,phead%int(i)%name,i_header_variable_names(i)
      write(*,*) "integer part of snapshot header corrupted"
      stop
    end if
   end do

   do i = 1,Nreal_header_entries
    if (phead%real(i)%name /= r_header_variable_names(i)) then
      write(*,*) "real part of header corrupted"
      stop
    end if
   end do

        do i = 1,3
           if (phead%real(4+i)%var > phead%real(7+i)%var) then
              write(*,*) "Box Low > Box High ... exiting"
              stop
            end if
         end do


   codemass=phead%real(12)%var * phead%real(13)%var**3 / phead%real(11)%var**2
   codevel=phead%real(11)%var/phead%real(13)%var

   if(phead%int(3)%var.NE.1) then
    print*,'numfiles>1 not yet..'
    stop
   endif 
   
    print*,' assumed that all is gas'
   if(phead%int(1)%var.GT.nsphmax) then
    print*,'max number of particle exceed'
    stop
   endif 
   nsph=phead%int(1)%var
   nbodies=nsph

   if(phead%DataPresent(1).EQ.1) then 
    read(1) DataFieldLabel, iblock2(1:nsph)
   endif 
   
   if(phead%DataPresent(2).EQ.1) then
    read(1) DataFieldLabel, rblock(1:nsph) 
    pos(1:nsph,1)=rblock(1:nsph)
   endif 
   if(phead%DataPresent(3).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph)
    pos(1:nsph,2)=rblock(1:nsph)    
   endif
   if(phead%DataPresent(4).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph)
    pos(1:nsph,3)=rblock(1:nsph)
   endif 
  
   if(phead%DataPresent(5).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph);vel(1:nsph,1)=rblock(1:nsph)
   endif
   if(phead%DataPresent(6).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); vel(1:nsph,2)=rblock(1:nsph)
   endif
   if(phead%DataPresent(7).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); vel(1:nsph,3)=rblock(1:nsph)
   endif
   if(phead%DataPresent(8).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); hsmooth(1:nsph)=rblock(1:nsph)
   endif
   if(phead%DataPresent(9).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); rho(1:nsph)=rblock(1:nsph)
   endif
   if(phead%DataPresent(10).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); mass(1:nsph)=rblock(1:nsph)
   endif
   if(phead%DataPresent(11).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); temperat(1:nsph)=rblock(1:nsph)
   endif
   if(phead%DataPresent(12).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); elecfrac(1:nsph)=rblock(1:nsph)
   endif
   if(phead%DataPresent(13).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); elecfrac(1:nsph)=elecfrac(1:nsph)+0.1*rblock(1:nsph)
   endif
   if(phead%DataPresent(14).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph); elecfrac(1:nsph)=elecfrac(1:nsph)+0.1*2*rblock(1:nsph)
   endif
   if(phead%DataPresent(15).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph)
   endif
   if(phead%DataPresent(16).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph)
   endif
   if(phead%DataPresent(17).EQ.1) then 
    read(1) DataFieldLabel,rblock(1:nsph)
   endif
   if(phead%DataPresent(18).EQ.1) then 
    read(1) DataFieldLabel,iblock2(1:nsph)
   endif


   close(1)
   print *,'Done with reading.'

   mass(1:nsph)=mass(1:nsph)/unitm_in_msun/solarmass*codemass
   pos(1:nsph,1:3)=pos(1:nsph,1:3)/unitl_in_kpc*phead%real(11)%var/kpc
   hsmooth(1:nsph)=hsmooth(1:nsph)/unitl_in_kpc*phead%real(11)%var/kpc
   vel(1:nsph,1:3)=vel(1:nsph,1:3)/velscale*codevel
   
   totptag=nbodies
   tnow=0
!   tnow=phead%time/timescale*phead%CodeTime_s
   massres=0.

   if(phead%DataPresent(11).NE.1) then 
    temperat(1:nsph)=8000
   endif


   firstsnap=0
   uentropy=.FALSE.
   output=0
   output(1:3)=1
   output(13)=1
   output(17:18)=1
   
   write(nostring,'(I6.6)') no   
   call outbods(trim(fileroot(1:k-4)//'.'//nostring))
end program

program read_snapshot
 use sphray_io_mod
   include 'globals.h'
   integer :: NFILES        
   type(sphray_snap_type) :: s

   character*200 fileroot,filename
   character*6 nostring

   real :: codemass,codevel,mscale,vscale,tscale,lscale
   integer no,k,i
   call initmem(nbodsmax,nsphmax,ncells)

   unitm_in_msun=1.e9
   unitl_in_kpc=1.
   timescale=1.488e19*unitl_in_kpc*sqrt(unitl_in_kpc/unitm_in_msun)
   lengthscale=3.086e21*unitl_in_kpc
   velscale=lengthscale/timescale

   print*,'gabe file conversion'
   print*,'filename?'
   read*,fileroot
   
   filename=trim(fileroot)

   k=index(filename,'.')
   if(k.le.5.or.k.ge.200) then 
    print*,'filename not of expected xxx_nnn.y form'
    stop
   endif
   print*,fileroot(k-3:k-1)

   read(fileroot(k-2:k),*) no
   print *,'opening...  '//trim(filename)
   print*,' detected No.', no


   call read_sphray_snapshot(s,filename)

   print *,'Done with reading.'

   codemass=s%CGSlum * s%CGStime**3/ s%CGSlen**2
   codevel=s%CGSlen/s%CGStime

   print*,'derived codemass, codevel:',codemass,codevel

   if(s%Nfiles.NE.1) then
    print*,'numfiles>1 not yet..'
    stop
   endif 
   
    print*,' assumed that all is gas'
   if(s%NparSnap.GT.nsphmax) then
    print*,'max number of particle exceed'
    stop
   endif 
   nsph=s%NparSnap
   nbodies=nsph

   if(s%Datapresent(1))  nbexist(1:nsph)=s%id(1:nsph)
   if(s%Datapresent(2))  pos(1:nsph,1)=s%pos(1:nsph,1)
   if(s%Datapresent(2))  pos(1:nsph,2)=s%pos(1:nsph,2)
   if(s%Datapresent(2))  pos(1:nsph,3)=s%pos(1:nsph,3)
   if(s%Datapresent(5))  vel(1:nsph,1)=s%vel(1:nsph,1)
   if(s%Datapresent(5))  vel(1:nsph,2)=s%vel(1:nsph,2)
   if(s%Datapresent(5))  vel(1:nsph,3)=s%vel(1:nsph,3)
   if(s%Datapresent(8))  hsmooth(1:nsph)=s%hsml(1:nsph) /2
   if(s%Datapresent(9))  rho(1:nsph)=s%rho(1:nsph)
   if(s%Datapresent(10))  mass(1:nsph)=s%mass(1:nsph)
   if(s%Datapresent(11))  temperat(1:nsph)=s%T(1:nsph)
   if(s%Datapresent(12))  elecfrac(1:nsph)=s%xHII(1:nsph)
   if(s%Datapresent(13))  elecfrac(1:nsph)=elecfrac(1:nsph)+0.1*s%xHeII(1:nsph)
   if(s%Datapresent(14))  elecfrac(1:nsph)=elecfrac(1:nsph)+0.1*2*s%xHeIII(1:nsph)
      
   mass(1:nsph)=mass(1:nsph)/unitm_in_msun/solarmass*codemass
   pos(1:nsph,1:3)=pos(1:nsph,1:3)/unitl_in_kpc*s%CGSlen/kpc
   hsmooth(1:nsph)=hsmooth(1:nsph)/unitl_in_kpc*s%CGSlen/kpc
   vel(1:nsph,1:3)=vel(1:nsph,1:3)/velscale*codevel
   
   totptag=nbodies
   tnow=0
!   tnow=s%Time/timescale*s%CGStime
   massres=0.

   firstsnap=0
   uentropy=.FALSE.
   output=0
   output(1:3)=1
   output(13)=1
   output(17:18)=1
   
   write(nostring,'(I6.6)') no   
   call outbods(trim(fileroot(1:k-5)//'.'//nostring))
end program

! preempt rho=0 case ******

subroutine minigatter(n,ppos,hsearch,dens,ddensdh)
  include 'globals.h' 
  integer,intent(in) :: n
  real,intent(in) :: hsearch,ppos(3)
  real,intent(inout) :: dens, ddensdh
  integer :: i,p,iwsm
  real :: wnorm,distnorm,hsminv,dr2p,dr2,drw,wsm
  real :: dwsm,dwmnbi,dwnorm,dx,dy,dz
  dens=0.
  ddensdh=0.    
  hsminv=1./hsearch
  wnorm=piinv*hsminv*hsminv*hsminv
  dwnorm=piinv*hsminv**2*hsminv**2*hsminv
  distnorm=hsminv**2*deldr2i      
  do i=1,n
    p=srlist(i)
    dx=ppos(1)-pos(p,1)
    dy=ppos(2)-pos(p,2)
    dz=ppos(3)-pos(p,3)
    if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
    if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
    if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
    if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
    if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
    if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
    dr2=dx*dx+dy*dy+dz*dz
    dr2p=dr2*distnorm
    if(ninterp.GT.dr2p) then
      iwsm=INT(dr2p)
      drw=dr2p-iwsm
      wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
      dens=dens+wnorm*wsm
      ddensdh=ddensdh-3*hsminv*wnorm*wsm
      dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
      dwmnbi=dwnorm*dwsm
      ddensdh=ddensdh-dr2*hsminv*dwmnbi  
    endif
  enddo   
end subroutine

subroutine hsmfunc(ppos,h,fi,dfi)
  include 'globals.h'
  integer nneigh
  real fi,dfi,h,ppos(3),dens,ddensdh
  call cond_srch(ppos,h,root,nneigh,srlist)
  call minigatter(nneigh,ppos,h,dens,ddensdh)
  fi=4*pi/3*h**3*(dens+rhomin/(massres*8./nsmooth))-nsmooth/8.
  dfi=4*pi*h**2*(dens+rhomin/(massres*8./nsmooth))+4*pi/3*h**3*ddensdh
end

subroutine newtonhsm(ppos,h,success,i)
  include 'globals.h'
  integer success,nmax,nneigh,i
  real hsmnw,hmin,hmax,prec,fi,dfi,h,ppos(3)
  parameter(nmax=10,prec=0.001) 
  success=1
  hmin=.5*h;hmax=2*h 
  hsmnw=h
  i=0
10 if(hsmnw.LT.hmax.AND.hsmnw.GT.hmin.AND.i.LT.nmax) then
      i=i+1
      call hsmfunc(ppos,hsmnw,fi,dfi)
      if(dfi.NE.0) then 
        hsmnw=hsmnw-fi/dfi
      else
        hsmnw=0
      endif 
      if(ABS(fi).LT.ABS(hsmnw*prec*dfi)) then
        h=hsmnw
        return
      endif
      goto 10
   else
      success=0
   endif
end subroutine

subroutine brackethsm(ppos,hmin,hmax,success)
  include 'globals.h'
  integer p,success,ntry,j
  real hmin,hmax,ppos(3),fac,f1,f2,df,getlocalscale
  real dum1,dum2
  parameter(fac=1.5,ntry=40)
  external getlocalscale
  success=1
  hmax=fac*getlocalscale(ppos)
  hmin=hmax/fac
  call hsmfunc(ppos,hmax,f2,df)
  call hsmfunc(ppos,hmin,f1,df)    
  do j=1,ntry
    if(f1*f2.LT.0) return
    if(abs(f1).lt.abs(f2)) then
      hmin=hmin/fac
      call hsmfunc(ppos,hmin,f1,df)
    else
      hmax=hmax*fac
      call hsmfunc(ppos,hmax,f2,df)
    endif
  enddo 
  success=0
end subroutine

subroutine safehsm(ppos,hguess,hmin,hmax)
  include 'globals.h'
  integer p,maxit,j
  real hmin,hmax,prec,hguess,dum1,dum2
  real df,dx,dxold,f,h,fh,fl,temp,xl,xh,ppos(3)
  parameter(maxit=25,prec=0.001)
  
  call hsmfunc(ppos,hmax,fh,df)
  call hsmfunc(ppos,hmin,fl,df)
  
  if(fl.eq.0) then
    hguess=hmin
    return
  endif 
  if(fh.eq.0) then
    hguess=hmax
    return
  endif
  if(hmin.GE.hmax.OR.fl.GE.fh.OR.fl*fh.GT.0) call terror('hsafepos error')
  xl=hmin
  xh=hmax  
  
  hguess=.5*(xl+xh)
  dxold=(xh-xl)
  dx=dxold
  call hsmfunc(ppos,hguess,f,df)
  do j=1,maxit
    if(((hguess-xh)*df-f)*((hguess-xl)*df-f).GT.0.OR. &
          abs(2*f).GT.ABS(dxold*df)) then
      dxold=dx
      dx=0.5*(xh-xl)
      hguess=xl+dx
      if(xl.EQ.hguess)return
    else
      dxold=dx
      dx=f/df
      temp=hguess
      hguess=hguess-dx
      if(temp.EQ.hguess)return
    endif
    if(abs(dx).LT.prec*hmax) return
    call hsmfunc(ppos,hguess,f,df)      
    if(f.lt.0) then
      xl=hguess 
    else
      xh=hguess
    endif  
  enddo
end subroutine

subroutine gethsm(ppos,h,i,j)
  include 'globals.h'
  integer i,j,success
  real hsmn,fi,dfi,hmin,hmax
  real h,ppos(3),getlocalscale
  i=0;j=0
  if(h.LE.0) h=1.75*getlocalscale(ppos)
  hsmn=h
  call newtonhsm(ppos,hsmn,success,i)
  if(success.EQ.0) then    
    j=1
    call brackethsm(ppos,hmin,hmax,success) 
    if(success.EQ.0.OR.hmin.LE.0.OR.hmax.LE.0) then
!$omp critical
      print*,getlocalscale(ppos)
      print*, ppos
      print*,rsize,root
      print*,bottom(root,1:3)
      print*,success,hmin,hmax
      call terror(' hsmpos error 1')
!$omp end critical
    endif
    call safehsm(ppos,hsmn,hmin,hmax)
    if(.NOT.(hsmn.GE.hmin.AND.hsmn.LE.hmax)) then
!$omp critical
      print*,hmin,hsmn,hmax
      call terror(' hsmpos error 2')
!$omp end critical
    endif  
  endif
  h=hsmn
end subroutine

subroutine pdensity(p,n)
  include 'globals.h'
  integer n,p
  real h,ppos(3),pvel(3),lrho,ldrhodh,lhdivv,lhcurlv,lvdisp
  h=hsmooth(p)
  ppos=pos(p,1:3)
  pvel=veltpos(p,1:3)
  call skinnydensity(n,h,ppos,pvel,lrho,ldrhodh,lhdivv,lhcurlv,lvdisp)
  rho(p)=lrho
  drhodh(p)=ldrhodh
  hsmdivv(p)=lhdivv
  hsmcurlv(p)=lhcurlv
  vdisp(p)=lvdisp
end

subroutine skinnydensity(n,h,ppos,pvel,lrho,ldrhodh,lhdivv,lhcurlv,lvdisp)
  include 'globals.h'
  integer i,iwsm,n,p
  real hsminv,wnorm,distnorm,dr2p,drw,wsm,wmass,dr2, &
       wmass1,dwnorm,vdotdr,dwsm,dwmass,dx,dy,dz, &
       dvx,dvy,dvz,dwmnbi,curlvx,curlvy,curlvz,mv(3),mv2
  real h,ppos(3),pvel(3),lrho,ldrhodh,lhdivv,lhcurlv,lvdisp
  lrho=0.
  ldrhodh=0.
  lhdivv=0.
  lhcurlv=0.
  lvdisp=0.
  curlvx=0.;curlvy=0.;curlvz=0.
  mv=0.;mv2=0.
  hsminv=1./h
  wnorm=piinv*hsminv*hsminv*hsminv
  dwnorm=piinv*hsminv**2*hsminv**2*hsminv
  distnorm=hsminv**2*deldr2i
  do i=1,n
    p=srlist(i)
    dx=ppos(1)-pos(p,1)
    dy=ppos(2)-pos(p,2)
    dz=ppos(3)-pos(p,3)   
    if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
    if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
    if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
    if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
    if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
    if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
    dr2=dx*dx+dy*dy+dz*dz
    dr2p=dr2*distnorm
    if(ninterp.GE.dr2p) then
      iwsm=INT(dr2p)   
      drw=dr2p-iwsm
      wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
      wmass=wnorm*wsm
      lrho=lrho+mass(p)*wmass
      ldrhodh=ldrhodh-3*hsminv*mass(p)*wmass

      mv(1)=mv(1)+veltpos(p,1)*mass(p)*wmass
      mv(2)=mv(2)+veltpos(p,2)*mass(p)*wmass
      mv(3)=mv(3)+veltpos(p,3)*mass(p)*wmass
      mv2=mv2+(veltpos(p,1)**2+veltpos(p,2)**2+ &
        veltpos(p,3)**2)*mass(p)*wmass

      dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
      dwmass=dwnorm*dwsm
      dwmnbi=mass(p)*dwmass
      dvx=pvel(1)-veltpos(p,1)
      dvy=pvel(2)-veltpos(p,2)
      dvz=pvel(3)-veltpos(p,3)
      vdotdr=dvx*dx+dvy*dy+dvz*dz     
      lhdivv=lhdivv-dwmnbi*vdotdr
      ldrhodh=ldrhodh-dr2*hsminv*dwmnbi

      curlvx=curlvx+dwmnbi*(dz*dvy-dy*dvz)
      curlvy=curlvy+dwmnbi*(dx*dvz-dz*dvx)
      curlvz=curlvz+dwmnbi*(dy*dvx-dx*dvy)
    endif
  enddo   
  if(lrho.GT.0) then
    lhdivv=h*lhdivv/lrho
    lhdivv=lhdivv/(1+h*ldrhodh/3/(rhomin+lrho)) ! f_i correction 
    lhcurlv=h*SQRT(curlvx**2+curlvy**2+curlvz**2)/lrho
   
    mv=mv/lrho
    mv2=mv2/lrho
  endif
   
  lvdisp=MAX(0.,(mv2-mv(1)**2-mv(2)**2-mv(3)**2))
  lvdisp=SQRT(lvdisp)
end subroutine

subroutine phsm(p,i,j)
  include 'globals.h'
  real hneigh,h,ppos(3)
  integer p,i,j,nneigh
  ppos=pos(p,1:3)
  h=hsmooth(p)
  call gethsm(ppos,h,i,j)
  hsmooth(p)=h
end subroutine

subroutine densnhsmooth
  include 'globals.h'
  integer p,i,j,k,imax,jtot,nneigh,kmin,kmax
  integer omp_get_max_threads,nchunk,chunk,maxthread
  integer, parameter :: nbuf=32
  integer :: ib,buf(nbuf),todo(nbuf),ntodo,totalsearches
  real :: time1,time2,mintime,maxtime,tottime,utime1,utime2
  real oldrho, drhosum
  integer niter

  if(nsphact.EQ.0) return
  imax=0
  jtot=0
  nnmin=nbodies;nnmax=0;nntot=0
  mintime=1.e10; maxtime=0.; tottime=0
  drhosum=0

  maxthread=1
  nchunk=1
  niter=0
!$  maxthread=omp_get_max_threads()
!$  nchunk=MAX(MIN(10*maxthread,nsphact/nbuf),maxthread)
  totalsearches=0
!$omp parallel shared(nchunk) &
!$omp private(i,j,p,k,nneigh,kmin,kmax, buf,todo,ntodo,ib,chunk,oldrho) &
!$omp reduction( max : imax,nnmax,maxtime) &
!$omp reduction(+ : jtot,nntot,tottime,totalsearches,drhosum,niter) &
!$omp reduction( min : nnmin,mintime) 
  call wall_time(time1)
  ncalls=0;nsearches=0
!$omp do schedule(guided,1) 
  do chunk=1,nchunk
    kmin=int(nsphact*float(chunk-1)/nchunk)+1
    kmax=int(nsphact*float(chunk)/nchunk)
    buf=0
    reuseflag=1
    searchreuse=0
    do k=kmin,kmax
      call presearch(k,kmax,nbuf,buf,ntodo,todo)
      do ib=1,ntodo
        niter=niter+1
        p=todo(ib)
        call phsm(p,i,j)  
        call pcond_srch(root,p,nneigh,srlist)
        oldrho=rho(p)
        call pdensity(p,nneigh)
        if(oldrho.NE.0) drhosum=drhosum+abs(rho(p)-oldrho)/oldrho
        nnmin=MIN(nnmin,nneigh)
        nnmax=MAX(nnmax,nneigh)
        nntot=nntot+nneigh
        imax=MAX(i,imax)
        jtot=jtot+j 
        if(eps_is_h) then
          if(mingaseps) then 
            epsgrav(p)=max(epsgas,hsmooth(p))
          else
            epsgrav(p)=hsmooth(p)
          endif  
        endif
      enddo
    enddo
  enddo
!$omp enddo nowait
  call wall_time(time2)
  mintime=MIN(mintime,time2-time1)
  maxtime=MAX(maxtime,time2-time1)
  tottime=tottime+time2-time1
  totalsearches=totalsearches+nsearches
!$omp end parallel 
  nnavg=nntot/nsphact
  if(verbosity.GT.0) print*,'<densnhsmooth> parts,searches:', nsphact,totalsearches 
  if(verbosity.GT.0) print*,'<densnhsmooth> mn,av,mx:',nnmin,nnavg,nnmax
  if(verbosity.GT.0) then
    write(*,'(" <densnhsmooth> time:", 3f8.2)') maxtime,mintime,tottime
    print*,'<densnhsmooth> max iter, fails:',imax,jtot
  endif
  if(verbosity.GT.0.AND.drhosum/npactive.GT.0.01) &
      print*,' *** drho warning *** ',drhosum/npactive, npactive
  if(niter.NE.nsphact) then
    print*, niter,nsphact
    print*, nchunk,maxthread
    print*, minval(hsmooth(1:nsph)),maxval(hsmooth(1:nsph)), drhosum
    print*, minval(hsmooth(pactive(1:nsphact))),maxval(hsmooth(pactive(1:nsphact)))
    call terror("inconsistent densnhsmooth iter count")
  endif
end subroutine

subroutine gatterdens(n,spos,hsearch,dens,ddensdh)
  include 'globals.h' 
  integer,intent(in) :: n
  real,dimension(3),intent(in) :: spos
  real,intent(in) :: hsearch
  real,intent(inout) :: dens, ddensdh
  integer :: i,p,iwsm
  real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm
  real :: dwmass,dwsm,dwmnbi,dwnorm,wmass
  dens=0.
  ddensdh=0.    
  hsminv=1./hsearch
  wnorm=piinv*hsminv*hsminv*hsminv
  dwnorm=piinv*hsminv**2*hsminv**2*hsminv
  distnorm=hsminv**2*deldr2i      
  do i=1,n
    p=srlist(i)
    dx=spos(1)-pos(p,1)
    dy=spos(2)-pos(p,2)
    dz=spos(3)-pos(p,3)
    if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
    if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
    if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
    if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
    if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
    if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
    dr2=dx*dx+dy*dy+dz*dz
    dr2p=dr2*distnorm
    if(ninterp.GT.dr2p) then
      iwsm=INT(dr2p)
      drw=dr2p-iwsm
      wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
      wmass=wnorm*wsm
      dens=dens+mass(p)*wmass
      ddensdh=ddensdh-3*hsminv*mass(p)*wmass
      dwsm=(1.-drw)*dwsmooth(iwsm)+drw*dwsmooth(1+iwsm)
      dwmass=dwnorm*dwsm
      dwmnbi=mass(p)*dwmass
      ddensdh=ddensdh-dr2*hsminv*dwmnbi  
    endif
  enddo   
end subroutine 

subroutine gatter_hydro_state(n,spos,svel,hsearch,dens,rhov,rhov2,rhoe)
  include 'globals.h' 
  integer,intent(in) :: n
  real,dimension(3),intent(in) :: spos, svel
  real,intent(in) :: hsearch
  real,intent(inout) :: dens,rhov(3),rhoe,rhov2
  integer :: i,p,iwsm
  real :: dx,dy,dz,wnorm,distnorm,hsminv,dr2p,drw,tmass,dr2,wsm
  real :: dwmass,dwsm,dwmnbi,dwnorm,wmass
  dens=0.
  rhov=0.
  rhoe=0.
  rhov2=0.
  hsminv=1./hsearch
  wnorm=piinv*hsminv*hsminv*hsminv
  distnorm=hsminv**2*deldr2i      
  do i=1,n
    p=srlist(i)
    dx=spos(1)-pos(p,1)
    dy=spos(2)-pos(p,2)
    dz=spos(3)-pos(p,3)
    if(dx.GE.hboxsize.AND.periodic) dx=dx-pboxsize
    if(dx.LT.-hboxsize.AND.periodic) dx=dx+pboxsize
    if(dy.GE.hboxsize.AND.periodic) dy=dy-pboxsize
    if(dy.LT.-hboxsize.AND.periodic) dy=dy+pboxsize
    if(dz.GE.hboxsize.AND.periodic) dz=dz-pboxsize
    if(dz.LT.-hboxsize.AND.periodic) dz=dz+pboxsize
    dr2=dx*dx+dy*dy+dz*dz
    dr2p=dr2*distnorm
    if(ninterp.GT.dr2p) then
      iwsm=INT(dr2p)
      drw=dr2p-iwsm
      wsm=(1.-drw)*wsmooth(iwsm)+drw*wsmooth(1+iwsm)
      wmass=wnorm*wsm
      dens=dens+mass(p)*wmass
      rhov=rhov+mass(p)*(vel(p,1:3)-svel(1:3))*wmass
      rhov2=rhov2+mass(p)*sum((vel(p,1:3)-svel(1:3))**2)*wmass
      rhoe=rhoe+mass(p)*ethermal(p)*wmass
    endif
  enddo   
end subroutine 

subroutine hsmdenspos2(ppos,h,dens,ddensdh,nneigh)
  include 'globals.h'
  integer nneigh,i,j
  real dens,ddensdh,h,ppos(3)
  call gethsm(ppos,h,i,j)
  call cond_srch(ppos,h,root,nneigh,srlist)
  call gatterdens(nneigh,ppos,h,dens,ddensdh)
end subroutine

module viewer

use opengl_gl
use opengl_glu
use opengl_glut

implicit none
 private
 save
 public :: initViewer                               ! initialize viewer
 public :: NormalKey, Idlefunc,MouseClick, &        ! public to allow application
           MouseClickMotion,NormalKeyUp,menu_handler             !  to  'take over'
 public :: freeflightQ, leftbuttonQ, rightbuttonQ,slewQ,outputtext
 public :: request_refresh,refresh
 public :: spot,cam, viewangle,ratio
 public :: set_rfitheta, pointCamera                                            
                                                     
integer, parameter :: MouseMovementScale=200
real(kind=gldouble), parameter :: curveScale=0.02
real(kind=gldouble), parameter :: freeFlightSpeed=0.0005
integer, parameter :: MouseMirror=1
real(kind=gldouble), parameter :: M_PI=3.14159265358979323846_gldouble
real(kind=gldouble),dimension(3), parameter :: zero=(/0.,0.,0./)
real, parameter :: minSpotDistance=.001
integer(kind=glcint), parameter :: RESET = 10, QUIT = 11, FFLIGHT=12, SLEWCAM=13
real(kind=gldouble) :: scaleFactor=1.
real(kind=gldouble), dimension(3) :: cam,spot,upvector=(/0.,0.,1./),up,ri,dummy
real, dimension(2) :: mousexyzero
integer :: npart, leftbutton=1,rightbutton=1
real(kind=gldouble) :: viewangle=45.,ratio,angle
real(kind=gldouble):: nearplane=0.01,farplane=10000.
real(kind=gldouble) :: mx,my
real(kind=gldouble) :: fi=0.,theta=0.,r=1.
real(kind=gldouble),dimension(3) :: da=(/0.,0.03, 0.1/) 
logical :: slew=.FALSE.
logical :: free_flight=.FALSE.
logical :: refresh=.TRUE.

 contains

! state query functions
logical function freeflightQ();freeflightQ=free_flight;end function
integer function leftbuttonQ();leftbuttonQ=leftbutton;end function leftbuttonQ
integer function rightbuttonQ();rightbuttonQ=rightbutton;end function rightbuttonQ
logical function slewQ();slewQ=slew;end function slewQ

subroutine request_refresh()
  refresh=.TRUE.
end subroutine

subroutine set_rfitheta(newspot,newcam)
  real(kind=gldouble), dimension(3), intent(in) :: newspot,newcam
  real(kind=gldouble) :: x,y,z
  
  x=newcam(1)-newspot(1)
  y=newcam(2)-newspot(2)
  z=newcam(3)-newspot(3)
  r=(x**2+y**2+z**2)**0.5
  theta=asin(z/r)
  fi=atan2(x,y)
  spot=newspot
  cam=newcam
  call request_refresh()
  
end subroutine


subroutine rotate(moving,fixed,r,fi,theta)
  real(kind=gldouble), dimension(3), intent(inout) :: moving
  real(kind=gldouble), dimension(3), intent(in) :: fixed
  real(kind=gldouble),intent(in) :: r, fi, theta
 
 moving(1)=fixed(1)+r*sin(fi)*cos(theta)
 moving(2)=fixed(2)+r*cos(fi)*cos(theta)
 moving(3)=fixed(3)+r*sin(theta)
end subroutine rotate

subroutine translate(one,two,trans)
  real(kind=gldouble), dimension(3), intent(inout) :: one,two
  real(kind=gldouble), dimension(3), intent(in) :: trans
 
 one(1)=one(1)+trans(1);two(1)=two(1)+trans(1)
 one(2)=one(2)+trans(2);two(2)=two(2)+trans(2)
 one(3)=one(3)+trans(3);two(3)=two(3)+trans(3)

end subroutine translate

function distance2( o, t)
  real(kind=gldouble), dimension(3), intent(in) :: o,t
  real(kind=gldouble) :: distance2
 distance2=(o(1)-t(1))**2+(o(2)-t(2))**2+(o(3)-t(3))**2
 return 

end function distance2

subroutine pointCamera()

 call glMatrixMode(GL_PROJECTION)
 call glLoadIdentity()
 call gluPerspective(viewangle, ratio, nearplane, farplane)
 call glMatrixMode(GL_MODELVIEW)
 call glLoadIdentity()
 call gluLookAt( cam(1), cam(2), cam(3), &
                 spot(1), spot(2), spot(3), &
		 upvector(1), upvector(2), upvector(3))

end subroutine pointCamera


subroutine ReshapeWindow( width, height)
  integer(kind=glint), intent(inout) :: width,height
 
 if(height.LT.1) height=1
 ratio=width/real(height)
 call glViewPort(0,0,width,height)
 call pointCamera()
 
end subroutine ReshapeWindow


subroutine MouseClick(button, state, x, y)
  integer(kind=glcint),intent(in out) :: button,state,x,y 
   
 if(button.EQ.GLUT_LEFT_BUTTON) then
  if(state.EQ.GLUT_DOWN) leftbutton=0
  if(state.EQ.GLUT_UP) leftbutton=1
 mousexyzero(1)=x;mousexyzero(2)=y
 mx=0.;my=0.
 endif
 if(button.EQ.GLUT_RIGHT_BUTTON) then
  if(state.EQ.GLUT_DOWN) rightbutton=0
  if(state.EQ.GLUT_UP) rightbutton=1
 mousexyzero(1)=x;mousexyzero(2)=y
 endif
end subroutine MouseClick

subroutine MouseClickMotion(x,y)
  integer(kind=glcint),intent(in out) :: x,y 
  real(kind=gldouble) :: rscl
  real(kind=gldouble),dimension(3) :: trans=(/0.,0.,0./)
 if((.NOT.(leftbutton.EQ.0)).AND.(.NOT.(rightbutton.EQ.0))) return

 if((.NOT.(leftbutton.EQ.0)).AND.(rightbutton.EQ.0)) then
  if(.NOT.slew) then
   r=r*2**((y-mousexyzero(2))/MouseMovementScale)
   if(r.LT.minSpotDistance) r=minSpotDistance
   if(r.gt.1000*scaleFactor) r=1000*scaleFactor
   call rotate(cam, spot,r,fi,theta)
  endif
  if(slew) then
   call rotate(trans,zero, &
         scaleFactor*((y-mousexyzero(2))/MouseMovementScale/2),fi,theta)
   call translate(cam,spot,trans)
  endif  
 endif

 if((leftbutton.EQ.0).AND.(.NOT.(rightbutton.EQ.0))) then
  if(free_flight) then
   mx=mx+(x-mousexyzero(1))/MouseMovementScale
   my=my+(y-mousexyzero(2))/MouseMovementScale
   if(abs(mx).LT.0.02) mx=0.
   if(abs(my).LT.0.02) my=0.  
  endif
  if(.NOT.free_flight) then
   fi=fi+(x-mousexyzero(1))/MouseMovementScale
   theta=theta+(y-mousexyzero(2))/MouseMovementScale
   if(theta.GT.M_PI/2.) theta=M_PI/2.-0.001
   if(theta.LT.-M_PI/2.) theta=-M_PI/2.+0.001
   if(slew) then
    call rotate(spot, cam,r,fi+M_PI,-theta)
   else
    call rotate(cam, spot,r,fi,theta)
   endif
  endif
 endif
 
 if((leftbutton.EQ.0).AND.(rightbutton.EQ.0)) then
  viewangle=viewangle*(1+(y-mousexyzero(2))/MouseMovementScale)
  if(viewangle.LT.1) viewangle=1
  if(viewangle.GT.120) viewangle=120
 endif
 mousexyzero(1)=x;mousexyzero(2)=y;
 call pointCamera
 call glutPostRedisplay
 
end subroutine MouseClickMotion

! key=32 : space
subroutine NormalKey( key, x, y)
  integer(kind=glcint),intent(in out) :: key
  integer(kind=glcint),intent(in out) :: x,y
 mx=0.;my=0.
 if(key.EQ.102) then ! 'f' for freeflight
  free_flight=.NOT.free_flight 
  slew=free_flight
  call glutTimerFunc(20, frame, 0)
 endif
 if(key.EQ.115) then ! s for slew camera
  slew=.NOT.slew
 endif
 if(key.EQ.114) then ! r for reset camera
  call reset_to_init()
 endif
 if(key.eq.113) call glutLeaveMainLoop() ! q to quit
 if(key.eq.99) then
  print*,'----- view parameters -----'
  write(*,'("spot: ",3f8.2)') spot  
  write(*,'("cam: ",3f8.2)') cam
  write(*,'("dir: ",3f8.2)') spot-cam  
 endif
end subroutine NormalKey

subroutine NormalKeyUp( key, x, y)
  integer(kind=glint),intent(in out) :: key
  integer(kind=glcint),intent(in out) :: x,y
 mx=0.;my=0.
! if(key.EQ.32) free_flight=0 
end subroutine NormalKeyUp

subroutine Idlefunc()
  real(kind=gldouble),dimension(3) :: trans=(/0.,0.,0./)

end subroutine Idlefunc

recursive subroutine frame(dummy)
  real(kind=gldouble),dimension(3) :: trans=(/0.,0.,0./)
integer(kind=glint), intent(in out) :: dummy
 if(free_flight) then
  call rotate(trans,zero,-freeFlightSpeed*scaleFactor,fi,theta)
  call translate(cam,spot,trans)
 if(leftbutton.EQ.0) then
  fi=fi+mx*curveScale
  theta=theta+my*curveScale
  if(theta.GT.M_PI/2.) theta=M_PI/2.-0.001
  if(theta.LT.-M_PI/2.) theta=-M_PI/2.+0.001
  call rotate(spot,cam,r,fi+M_PI,-theta)
 endif 
  call pointCamera
 endif
 if(free_flight) then
   call glutPostRedisplay
   call glutTimerFunc(20, frame, 0)
 endif  
end subroutine frame

subroutine MouseMoves( x, y)
  integer(glint) :: x,y
 
 if(free_flight) then
  mx=mx+(x-mousexyzero(1))/MouseMovementScale
  my=my+(y-mousexyzero(2))/MouseMovementScale
  if(abs(mx).LT.0.02) mx=0.
  if(abs(my).LT.0.02) my=0.
 endif
end subroutine MouseMoves

subroutine menu_handler(value)
  integer(kind=glcint), intent(in out) :: value
 select case(value)
 case(SLEWCAM)
   slew=.NOT.slew
 case(FFLIGHT)
   free_flight=.not.free_flight  
   slew=free_flight
   call glutTimerFunc(20, frame, 0)
 case(RESET)
   call reset_to_init
 case(QUIT)
   call glutLeaveMainLoop()
 end select
 return
end subroutine menu_handler

subroutine reset_to_init
 slew=.FALSE.
 r=scaleFactor!;fi=0.;theta=0.
 spot(1)=0.;spot(2)=0. ;spot(3)=0.
 viewangle=45.
 call rotate( cam,spot,r,fi,theta);
 call pointCamera
 call glutPostRedisplay 
end subroutine reset_to_init

function initViewer(starScale) result(menuid)
  real,intent(in) :: starScale
  integer(kind=glcint) :: menuid
 
 
 if(starScale.GT.0) scaleFactor=starScale

 
 menuid = glutCreateMenu(menu_handler)
 call glutAddMenuEntry("toggle camera slew [s]",SLEWCAM)
 call glutAddMenuEntry("toggle free flight [f]",FFLIGHT)
 call glutAddMenuEntry("reset to initial view [r]",RESET)
 call glutAddMenuEntry("quit [q]",QUIT)

 call glutReshapeFunc( ReshapeWindow)
 call glutMousefunc( MouseClick)
 call glutMotionFunc( MouseClickMotion)
 call glutIgnoreKeyRepeat(1)
 call glutKeyboardFunc( NormalKey )
 call glutKeyboardUpFunc( NormalKeyUp)
! call glutIdleFunc( Idlefunc )
! call glutTimerFunc(20, frame, 0)

 call reset_to_init
end function initViewer

subroutine outputtext(x,y,s)
  real(kind=gldouble) :: x,y
  character :: s*(*)
  character :: c
  integer :: i,lenc
  
  call glrasterpos2d(x,y)
  lenc = len(s)
  do i=1,lenc
    c = s(i:i)
    call glutbitmapcharacter(GLUT_BITMAP_HELVETICA_18, &
          ichar(c))
  end do
end subroutine outputtext


end module viewer

module snap_viewer
 
  use opengl_gl
  use opengl_glut
  use opengl_glu
 save
 private
 public :: initnbody,display,attachmenu,createsubmenus,IdleFunc2,NormalKey2,da,viewer_refresh,check_for_refresh
 
  integer, parameter :: NMAX=2000000
  integer, parameter :: GAS=1,STAR=2,HALO=3,AXES=4,BOX=5,CAMSPOT=6
  integer :: ntot,ngas,nstars  
  real(kind=gldouble) :: boxsize,kpcboxsize,snaptime
  real(kind=glfloat),dimension(3) :: da=(/0.,0., 1./) 
  real(kind=glfloat),dimension(3) :: no=(/1.,0., 0./) 
!  real(kind=glfloat),dimension(3) :: da=(/.15,.075, .026/) 
!  real(kind=glfloat),dimension(3) :: no=(/1.,0., .0/) 
  real(kind=glfloat) :: pointsize_gas=3.,pointsize_stars=1.5,pointsize_halo=2. 
 
  logical :: show_gas=.TRUE.,show_stars=.TRUE.,SHOW_halo=.FALSE.
  logical :: show_axes=.TRUE.,show_box=.TRUE.,show_spot=.TRUE.,show_data=.TRUE.
  logical :: update_flag=.TRUE.
  integer :: show_temp=0
  logical :: show_age=.FALSE.

  integer :: ok=0
  integer :: step
  real :: tfac
    
 contains

subroutine show_menu(optie)
  integer(kind=glint), intent(inout) :: optie
  
 select case (optie)
 case(1)
  show_stars=.NOT.show_stars
 case(2)
  show_gas=.NOT.show_gas
 case(3)
  show_halo=.NOT.show_halo
 case(4)
  call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,no)
!  call glPointParameterfvEXT(GL_DISTANCE_ATTENUATION_EXT,no)
 case(5) 
  call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,da)
!  call glPointParameterfvEXT(GL_DISTANCE_ATTENUATION_EXT,da)
 case(6)
  show_data=.NOT.show_data
 case(7)
  show_axes=.NOT.show_axes 
 case(8)
  show_box=.NOT.show_box 
 case(9)
  show_spot=.NOT.show_spot 
 case default
 end select

 call glutPostRedisplay
 
end subroutine show_menu

subroutine prop_menu(optie)
  integer(kind=glcint), intent(inout)::optie

 select case (optie)
 case(1)
  show_temp=0
  show_age=.FALSE.
 case(2)
  if(show_temp.eq.1) then 
   show_temp=0
  else
   show_temp=1
  endif
 case(3)
  show_age=.NOT.show_age
 case(4)
  if(show_temp.eq.2) then
   show_temp=0
  else 
   show_temp=2
   endif
 case(5)
  if(show_temp.eq.3) then 
   show_temp=0
  else
   show_temp=3
  endif
 case(6)
  if(show_temp.eq.4) then 
   show_temp=0
  else
   show_temp=4
  endif
 case(7)
  if(show_temp.eq.5) then 
   show_temp=0
  else
   show_temp=5
  endif
 case(8)
  pointsize_gas=pointsize_gas*1.5
 case(9)
  pointsize_gas=pointsize_gas/1.5
 case(10)
  pointsize_stars=pointsize_stars*1.5
 case(11)
  pointsize_stars=pointsize_stars/1.5
 case(12)
  pointsize_halo=pointsize_halo*1.5
 case(13)
  pointsize_halo=pointsize_halo/1.5


 case default
end select
 call prerender
 call glutPostRedisplay
end subroutine prop_menu

subroutine createsubmenus(i,j,k)
  integer(glcint),intent(inout) :: i,j,k

 i=glutCreateMenu(update_menu)
 call glutaddmenuentry('refresh view', 1)
 call glutaddmenuentry('automatic updates', 2)
 call glutaddmenuentry('no update', 3)
  
 j=glutCreateMenu(show_menu)
 call glutaddmenuentry('toggle stars', 1)
 call glutaddmenuentry('toggle gas', 2)
 call glutaddmenuentry('toggle halo', 3)
 call glutaddmenuentry('normal points', 4)
 call glutaddmenuentry('EXT points', 5)
 call glutaddmenuentry('toggle data', 6)
 call glutaddmenuentry('toggle axes', 7)
 call glutaddmenuentry('toggle box', 8)
 call glutaddmenuentry('toggle spot', 9)
 

 k=glutCreateMenu(prop_menu)
 call glutaddmenuentry('plain',1)
 call glutaddmenuentry('toggle temperature', 2)
 call glutaddmenuentry('toggle fuvheat', 4)
 call glutaddmenuentry('toggle luminosity', 3)
 call glutaddmenuentry('toggle unstable', 5)
 call glutaddmenuentry('toggle ionization', 6)
 call glutaddmenuentry('toggle hsmooth', 7)
 call glutaddmenuentry('increase gas size', 8)
 call glutaddmenuentry('decrease gas size', 9)
 call glutaddmenuentry('increase star size', 10)
 call glutaddmenuentry('decrease star size', 11)
 call glutaddmenuentry('increase dark size', 12)
 call glutaddmenuentry('decrease dark size', 13)
 call glutaddmenuentry('(all trigger refresh)', 99) 
 

end subroutine createsubmenus

subroutine attachmenu(i,j,k)
 integer(glcint),intent(in) :: i,j,k
 call glutaddsubmenu('refresh options', i)
 call glutaddsubmenu('view options', j)
 call glutaddsubmenu('show properties',k)

end subroutine attachmenu

function starscale() result(box)

	include 'globals.h'
  real(kind=gldouble) :: maxcor=0,maxcorg=0,maxcors=0,box
! schaal:
	maxcor=maxval(abs(pos(1:nbodies,1:3)))	
	if(maxcor.le.0) maxcor=1.
        if(nsph.gt.0) then
	maxcorg=maxval(abs(pos(1:nsph,1:3)))	
	endif
	if(maxcorg.le.0) maxcorg=maxcor	
        if(nstar.gt.0) then
	maxcors=maxval(abs(pos(nbodies-nstar+1:nbodies,1:3)))	
	endif
	if(maxcors.le.0) maxcors=maxcor	
	maxcor=(maxcor*maxcorg*maxcors)**.33333
	box=2*maxcor
	return
end function starscale


function initnbody()
  use ElementsMod
  use starsMod
  include 'globals.h'
  real :: initnbody

 boxsize=starscale()
 kpcboxsize=boxsize*unitl_in_kpc
 initnbody=1.5*boxsize

 call selectparticles
 call prerender

end function initnbody

subroutine viewer_refresh()
!  use ElementsMod
!  use starsMod
  use viewer
!  include 'globals.h'
!  real :: initnbody

! boxsize=starscale()
! kpcboxsize=boxsize*unitl_in_kpc
! initnbody=1.5*boxsize

 call request_refresh
 
end subroutine

recursive subroutine check_for_refresh(dummy)
  use viewer
  integer(kind=glint), intent(in out) :: dummy
  if(refresh.OR.update_flag) then
    refresh=.FALSE.
    call selectparticles
    call prerender
    call pointCamera
    call glutPostRedisplay
  endif
  call glutTimerFunc(100,check_for_refresh,0)
end subroutine

subroutine selectparticles
  include 'globals.h'
  integer :: p,i
  real :: temp
 ntot=nbodies
 ngas=nsph
 nstars=nstar
 snaptime=tnow*timescale/year/1.e6
 step=nbodies/NMAX+1
 tfac=meanmwt*mhboltz*(gamma-1.)
 ok=1
end subroutine

subroutine prerender

 if(ok.NE.1) return
 call gaslist
 call starlist
 call darklist
 call drawaxes
end subroutine prerender

subroutine update_menu(optie)
integer(glcint),intent(inout) ::optie
logical ::flag
integer(glint) :: dummy

select case(optie)

case(1)
  call viewer_refresh
case(2)
  update_flag=.TRUE.
case(3)
  update_flag=.FALSE.
case default 

end select

end subroutine update_menu

subroutine NormalKey2( key, x, y)
 use viewer
  integer(kind=glcint),intent(in out) :: key
  integer(kind=glcint),intent(in out) :: x,y

 call Normalkey( key,x,y)
end subroutine NormalKey2

subroutine display
 call glClearColor(0.02_glfloat,0.02_glfloat,0.02_glfloat, 0.0_glfloat)
 call glClear(ior(GL_COLOR_BUFFER_BIT,GL_DEPTH_BUFFER_BIT))

  call glDepthFunc(GL_LESS)
  call glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
  if(show_axes) call glCallList(AXES)
  if(show_box) call glCallList(BOX)
  if(show_spot) then
    call drawspot
    call glLineWidth(2.25_glfloat)
    call glCallList(CAMSPOT)
    call glLineWidth(1.25_glfloat)
  endif

  call glDepthMask(.False.)
!  call glDepthFunc(GL_ALWAYS)
  call glBlendFunc(GL_SRC_ALPHA,GL_ONE)
  if( show_stars) call renderstars
  if( show_halo) call renderhalo
  if( show_gas) call rendergas
  call glDepthMask(.True.)

  call glDepthFunc(GL_LESS)
  call glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA)
  call drawtext
 call glutSwapBuffers();
end subroutine display

subroutine IdleFunc2

end subroutine Idlefunc2


subroutine gaslist
 include 'globals.h'
 integer i
 real(kind=glfloat) :: xt,yt,zt,red,green,blue,alpha_c,temp
 real(kind=glfloat) :: lhmin,lhmax

 if(show_temp.EQ.5)	then
   lhmin=log(minval(hsmooth(1:nsph))) 
   lhmax=log(maxval(hsmooth(1:nsph)))
 endif

 call glNewList(GAS,GL_COMPILE)
 call glPointSize( pointsize_gas)
 call glBegin(GL_POINTS)
 call glColor4f(1._glfloat, .8_glfloat, .8_glfloat,.6_glfloat)

 do i=1,nsph,step
        xt=pos(i,1)
	yt=pos(i,2)
	zt=pos(i,3)
	
	if(show_temp.EQ.1) then
	
	  temp=(log10(temperat(i))-1.)/8.
	  red=-0.125+2*temp
	  blue=MAX(1-8/3.*temp,-3./8.+temp)+0.2
	  green=-1.+3*temp+0.2
          alpha_c=.6
!	  alpha_c=.2+.5*temp
	  call glColor4f(red, green, blue,alpha_c)
	
	end if
	
	if(show_temp.eq.2) then
	
	  temp=log(fuvheat(i))-log(7.)
	  red=.5+temp/4
	  blue=Max(0.6,1.+temp/4)
	  green=.5+temp/4
	  alpha_c=.8
	
	  call glColor4f(red, green, blue,alpha_c)
	
	end if

	if(show_temp.eq.3) then
          red=0.4;green=0.4;blue=0.4;alpha_c=0.6
	 if(rho(i)*pi/6.*((gamma*gamma1*temperat(i)/tfac)*pi/rho(i))**1.5.LE.masscrit)then
	   red=0.;green=1.;blue=0.
	 endif 
	 call glColor4f(red, green, blue,alpha_c)
	endif

	if(show_temp.eq.4) then
	
	  temp=elecfrac(i)
	  if(temp.GT.1) temp=1.
	  temp=3+log10(temp)
	  if(temp.LE.0) temp=0.
	  temp=temp/3.
	  red=temp
	  green=1.-temp
	  blue=0.
	  alpha_c=.6
	  
	  call glColor4f(red, green, blue,alpha_c)
	
	end if

	if(show_temp.EQ.5) then
	
	  green=(log(hsmooth(i))-lhmin)/(lhmax-lhmin)
	  blue=0.
	  red=1-green
    alpha_c=.7-.7*green
	  call glColor4f(red, green, blue,alpha_c)
	
	end if



        call glVertex3f(xt,yt,zt)



 enddo

 call glEnd()
 call glEndList()


end subroutine gaslist

subroutine starlist
 use starsMod
 include 'globals.h'
  integer i,nbands
  real(kind=glfloat) :: xt,yt,zt,red,green,blue,alpha_c,temp
  real :: age,band(1:20)
 nbands=nbandsQ()

 call glNewList(STAR,GL_COMPILE)
 call glPointSize( pointsize_stars)
 call glColor4f(1._glfloat, 1._glfloat, .8_glfloat,.75_glfloat)
 call glBegin(GL_POINTS)

 do i=nbodies-nstar+1,nbodies,step
 
  xt=pos(i,1)
  yt=pos(i,2)
  zt=pos(i,3)
  if(show_age) then
   age=(tnow-tform(i))*timescale/year
   band=mbands(age)/mbands(0.)
   red=0.9+alog10(band(5))/3
   green=0.9+alog10(band(2))/3
   blue=0.9+alog10(band(1))/3
   alpha_c=0.5+green/2
   call glColor4f(red, green, blue,alpha_c)
 !  call glPointSize( (1._glfloat+3._glfloat*temp))
  end if
		
  call glVertex3f(xt,yt,zt)
 
 enddo
 call glEnd()
 call glEndList()


end subroutine starlist

subroutine darklist
 include 'globals.h'
  integer i
  real(kind=glfloat) :: xt,yt,zt,red,green,blue,alpha_c,temp

 call glNewList(HALO,GL_COMPILE)
 call glPointSize( pointsize_halo)

 call glColor4f(.75_glfloat, .75_glfloat, .75_glfloat,.7_glfloat)
 call glBegin(GL_POINTS)

 do i=nsph+1,nbodies-nstar
  xt=pos(i,1)
  yt=pos(i,2)
  zt=pos(i,3)
  call glVertex3f(xt,yt,zt)
 enddo
 call glEnd()
 call glEndList()
end subroutine darklist


subroutine rendergas
 call glCallList(GAS)
end subroutine rendergas

subroutine renderstars
 call glCallList(STAR)
end subroutine renderstars

subroutine renderhalo
  call glCallList(HALO)
end subroutine renderhalo

subroutine drawaxes

 call glNewList(BOX,GL_COMPILE)
! Draw axes so we know the orientation
 call glPushMatrix
 call glScaled(boxsize/3,boxsize/3,boxsize/3)
 call glColor4f(.3_glfloat,.3_glfloat,1._glfloat,1._glfloat);
 call glutWireCube(3._gldouble);
 call glPopMatrix
 call glEndList

 call glNewList(AXES,GL_COMPILE)
 call glPushMatrix
 call glScaled(boxsize/3,boxsize/3,boxsize/3)
 call glColor4f(.2_glfloat, 1._glfloat, .2_glfloat,.8_glfloat)
 call glBegin(GL_LINES)
 call glVertex3f(-2.0_glfloat,0.0_glfloat,0.0_glfloat)
 call glVertex3f(2.0_glfloat,0.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,-2.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,2.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,0.0_glfloat,-2.0_glfloat)
 call glVertex3f(0.0_glfloat,0.0_glfloat,2.0_glfloat)

! Draw crude x, y and z to label the axes

 call glVertex3f(2.1_glfloat,-0.1_glfloat,0.1_glfloat) ! X
 call glVertex3f(2.1_glfloat,0.1_glfloat,-0.1_glfloat)
 call glVertex3f(2.1_glfloat,-0.1_glfloat,-0.1_glfloat)
 call glVertex3f(2.1_glfloat,0.1_glfloat,0.1_glfloat)
 call glVertex3f(0.1_glfloat,2.1_glfloat,0.1_glfloat) ! Y
 call glVertex3f(0.0_glfloat,2.1_glfloat,0.0_glfloat)
 call glVertex3f(-0.1_glfloat,2.1_glfloat,0.1_glfloat)
 call glVertex3f(0.1_glfloat,2.1_glfloat,-0.1_glfloat)
 call glVertex3f(-0.1_glfloat,0.1_glfloat,2.1_glfloat) ! Z
 call glVertex3f(0.1_glfloat,0.1_glfloat,2.1_glfloat)
 call glVertex3f(0.1_glfloat,0.1_glfloat,2.1_glfloat)
 call glVertex3f(-0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glVertex3f(-0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glVertex3f(0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glEnd

 call glPopMatrix

 call glEndList

end subroutine drawaxes

subroutine drawspot
 use viewer

 call glNewList(CAMSPOT,GL_COMPILE)
 call glPushMatrix
! call glScaled(boxsize/3,boxsize/3,boxsize/3)
 call glColor4f(1._glfloat, .2_glfloat, .2_glfloat,1._glfloat)
 call glBegin(GL_LINES)
 call glVertex3d(spot(1)-.02_glfloat,spot(2),spot(3))
 call glVertex3d(spot(1)+.02_glfloat,spot(2),spot(3))
 call glVertex3d(spot(1),spot(2)-.02_glfloat,spot(3))
 call glVertex3d(spot(1),spot(2)+.02_glfloat,spot(3))
 call glVertex3d(spot(1),spot(2),spot(3)-.02_glfloat)
 call glVertex3d(spot(1),spot(2),spot(3)+.02_glfloat)
 call glEnd

 call glPopMatrix

 call glEndList

end subroutine drawspot


subroutine drawtext
 use viewer
  character*8 rs
  character*36 rs2
  integer(kind=glint) :: viewport(4)
  real(kind=gldouble) :: xp1,xp2,yp1,yp2
  
  if(.not.show_data) return
  call glGetIntegerv(GL_VIEWPORT,viewport) 
  call glmatrixmode(GL_PROJECTION)
  call glPushMatrix
  call glLoadIdentity
  xp1=viewport(1)
  yp1=viewport(2)
  xp2=viewport(3)
  yp2=viewport(4)
  call glortho(xp1,xp2,yp1,yp2,-1._gldouble,1._gldouble)
  call glmatrixmode(GL_MODELVIEW)
  call glPushMatrix
  call glLoadIdentity
  call glColor4f(0._glfloat,.6_glfloat,1.0_glfloat,0.8_glfloat)
  if(yp2-yp1.gt.120) then
   if(xp2-xp1.gt.480) then
    write(rs,'(f8.2)') snaptime
    call outputtext(xp1+3._gldouble,yp1+3._gldouble,'time (Myr):'//rs)
    write(rs,'(f8.2)') boxsize
    call outputtext(xp2-100._gldouble,yp1+3._gldouble,'box:'//rs)
   endif

   if(xp2-xp1.gt.480) then
    write(rs2,'(3f8.3)') spot  
    call outputtext(xp2-250._gldouble,yp2-20._gldouble,"spot:")
    call outputtext(xp2-210._gldouble,yp2-20._gldouble,rs2)
    write(rs2,'(3f8.3)') cam
    call outputtext(xp2-250._gldouble,yp2-40._gldouble,"cam:")
    call outputtext(xp2-210._gldouble,yp2-40._gldouble,rs2)
    write(rs2,'(3f8.3)') spot-cam  
    call outputtext(xp2-250._gldouble,yp2-60._gldouble,"dir:")
    call outputtext(xp2-210._gldouble,yp2-60._gldouble,rs2)

    call itos(ntot-ngas-nstars,8,rs)
    call outputtext(xp1+3._gldouble,yp2-20._gldouble,'halo:')
    if(.not.show_halo) call glColor4f(0.4_glfloat,0.4_glfloat,0.4_glfloat,0.5_glfloat)
    call outputtext(xp1+70._gldouble,yp2-20._gldouble,rs)
    call glColor4f(0._glfloat,.6_glfloat,1.0_glfloat,0.8_glfloat)

    call itos(ngas,8,rs)
    call outputtext(xp1+3._gldouble,yp2-40._gldouble,'gas:')
    if(.not.show_gas) call glColor4f(0.4_glfloat,0.4_glfloat,0.4_glfloat,0.5_glfloat)
    call outputtext(xp1+70._gldouble,yp2-40._gldouble,rs)
    call glColor4f(0._glfloat,.6_glfloat,1.0_glfloat,0.8_glfloat)

    call itos(nstars,8,rs)
    call outputtext(xp1+3._gldouble,yp2-60._gldouble,'stars:')
    if(.not.show_stars) call glColor4f(0.4_glfloat,.4_glfloat,.4_glfloat,0.5_glfloat)
    call outputtext(xp1+70._gldouble,yp2-60._gldouble,rs)
   endif
  endif
  call glPopMatrix
  call glmatrixmode(GL_PROJECTION)
  call glPopMatrix
  call glmatrixmode(GL_MODELVIEW)
end subroutine drawtext

end module snap_viewer


subroutine viewbodies
 use viewer
 use opengl_gl
 use opengl_glut
 use opengl_glu
 use snap_viewer
 implicit none
  real :: rsize
  integer(glcint) :: i,j,k
  integer(glcint) :: win,menu
 
 call glutInit
 call glutInitWindowPosition(100,100)
 call glutInitWindowSize(700,400)
 call glutInitDisplayMode(ior(GLUT_DEPTH,ior(GLUT_RGBA,GLUT_DOUBLE)))
 
 win=glutCreateWindow("Fi viewer")
 call createsubmenus(i,j,k)
 
 rsize=initnbody()
 da(3)=1./rsize**2*16.
 da(2)=da(3)*rsize/2.

 menu=initViewer(rsize) 
! NB
 call glutKeyboardFunc( NormalKey2 )
 call glutTimerFunc(100, check_for_refresh,0 )
! NB (in initnbody?)
 call glutAttachMenu(GLUT_MIDDLE_BUTTON)
 call attachmenu(i,j,k)
 call glutDisplayFunc( display)

 call glEnable(GL_DEPTH_TEST)
 call glEnable(GL_BLEND)
 call glBlendFunc(GL_SRC_ALPHA,GL_ONE)
 call glEnable(GL_POINT_SMOOTH)
 call glEnable(GL_LINE_SMOOTH)
 call glHint(GL_LINE_SMOOTH_HINT, GL_NICEST)
 call glHint(GL_POINT_SMOOTH_HINT, GL_NICEST)
 call glLineWidth(1.25_glfloat)
 call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,da)
 call glPointParameterfARB(GL_POINT_SIZE_MIN_ARB, 2._glfloat) 
 call glPointParameterfARB(GL_POINT_FADE_THRESHOLD_SIZE_ARB, 0._glfloat) 
! call glPointParameterfvEXT(GL_DISTANCE_ATTENUATION_EXT,da)
! call glPointParameterfEXT(GL_POINT_SIZE_MIN_EXT, 2._glfloat) 
! call glPointParameterfEXT(GL_POINT_FADE_THRESHOLD_SIZE_EX, 0._glfloat) 

 call glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE,GLUT_ACTION_GLUTMAINLOOP_RETURNS)
 call glutMainLoop()

end subroutine

subroutine pt_setup
	
end subroutine pt_setup

subroutine trigger_viewer_refresh
 use snap_viewer
 
 call viewer_refresh

end subroutine 

function get_image_target(x,y,z) result(ret)
  use viewer
  real :: x,y,z
  integer :: ret
  x=spot(1);y=spot(2);z=spot(3)
  ret=0
end function

function set_image_target(x,y,z) result(ret)
  use viewer
  real :: x,y,z, newspot(3),newcam(3)
  integer :: ret
  newspot(1)=x;
  newspot(2)=y;
  newspot(3)=z
  newcam=cam
  call set_rfitheta(newspot,newcam)
  ret=0
end function

function get_viewpoint(x,y,z) result(ret)
  use viewer
  real :: x,y,z
  integer :: ret
  x=cam(1);y=cam(2);z=cam(3)
  ret=0
end function

function set_viewpoint(x,y,z) result(ret)
  use viewer
  real :: x,y,z
  real :: newspot(3),newcam(3)
  integer :: ret
  newcam(1)=x
  newcam(2)=y
  newcam(3)=z
  newspot=spot
  call set_rfitheta(newspot,newcam)
  ret=0
end function

function get_upvector(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  x=0;y=0;z=1
  ret=0
end function

function set_upvector(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  ret=-2
end function

function get_image_angle(x) result(ret)
  use viewer
  real :: x
  integer :: ret
  x=viewangle
  ret=0
end function

function set_image_angle(x) result(ret)
  use viewer
  real :: x
  integer :: ret
  viewangle=x
  ret=0
end function

function get_image_ratio(x) result(ret)
  use viewer
  real :: x
  integer :: ret
  x=ratio
  ret=0
end function

subroutine basicinput
 include 'globals.h'
 character*24 filenaam
 integer i,mapnr,nfeedback
 real,allocatable :: weights(:)
 
 call set_parameters(0)

 print*,'filenaam?'
 read*,filenaam

 call readbods(filenaam)

 call heattabel
        
 call initpars

 if(periodic) call initbc

 call initnewstar

 if(usepm) then
  if(verbosity.GT.0) print*,' ...initPM...'
  call initpm
 endif

 call postprocessread

end subroutine

program snapreader
 use StarsMod
 use ionMod
 include 'globals.h'
 integer i,p
 real timefac,starage
 real ttemp,temp,xelec,xhii,xheii,xheiii,nh

 call initmem(nbodsmax,nsphmax,ncells)
 call basicinput

      print*,densconst,crionrate

! insert code after this
 timefac=timescale/year
 open(unit=1,file='sources.gabe',status='unknown')
 do p=nbodies-nstar+1,nbodies 
  starage=(tnow-tform(p))*timefac
  if(starage.LT.3.e7) write(1,'( 4g16.6 )') pos(p,1:3), Nlya(starage)*unitm_in_msun*mass(p)
 enddo
 close(1)

 ttemp=10000
 temp=10000
 nh=1.
 call Ionh(ttemp,temp,xelec,xhii,xheii,xheiii,nh,crionrate)
 print*,temp,xelec,xhii,xheii,xheiii

end program

module ElementsMod
 implicit none
 private
 public :: elementnrQ,abundancesQ,weightsQ,fractionsQ,wfractionsQ,zQ ,&
           meanmwtQ,nelementsQ,elementnamesQ,wfractionQ,InitElements, &
           solarzQ,fractionQ,abundanceQ
 
  integer, parameter :: nelements=8
  character(len=4),dimension(nelements),parameter :: elementnames = &
             (/"H   ","He  ","C   ","N   ","O   ","Ne  ","Si  ","Fe  "/) 
  integer, parameter :: H=1,He=2,metals(6)=(/ 3,4,5,6,7,8 /)
  
  real :: abundances(nelements)=(/0., 0., 0., 0., 0., 0., 0., 0. /)

!  real, parameter :: abundances(nelements)= &
!                      (/ 1.,.09,3.75e-5,8.7e-6,4.4e-5,2.6e-6,3.2e-6,3.2e-6 /)
!  real, parameter :: abundances(nelements)= &
!                      (/ 1.,.1,3.75e-4,8.7e-5,4.4e-4,2.6e-5,3.2e-5,3.2e-5 /)

  real, parameter :: weights(nelements) = &
                      (/ 1.0079,4.0026,12.011,14.007,15.999,20.18,28.086,55.845/)
  real, save :: fractions(nelements)=0., wfractions(nelements)=0., meanmwt=0.
 
  real, parameter :: solarz=0.01545
 
contains
 
  function elementnrQ(string) result(x)
   character(len=4), intent(in) :: string
   integer :: i,x
   x=0
   do i=1,nelements
    if(elementnames(i).EQ.string) x=i
   enddo
  end function
  
  subroutine InitElements(metallicity)
   character(len=*), optional :: metallicity
   
   if(any(abundances.NE.0)) return
   
   if(present(metallicity)) then
    select case (metallicity)
    case('2.5-solar')
      abundances=(/ 1.,.085,8.28e-4,2.1e-4,1.67e-3,3.e-4,8.88e-5,8.e-5 /)
    case('solar')
      abundances=(/ 1.,.085,3.31e-4,8.3e-5,6.76e-4,1.2e-4,3.55e-5,3.2e-5 /)
    case('0.2-solar')
      abundances=(/ 1.,.085,6.62e-5,1.66e-5,1.33e-4,2.4e-5,7.1e-6,6.4e-6 /)
    case('0.1-solar')
      abundances=(/ 1.,.085,3.31e-5,8.3e-6,6.76e-5,1.2e-5,3.55e-6,3.2e-6 /)
    case('0.02-solar')
      abundances=(/ 1.,.085,6.62e-6,1.66e-6,1.33e-5,2.4e-6,7.1e-7,6.4e-7 /)
    case('0.01-solar')
      abundances=(/ 1.,.065,3.31e-6,8.3e-7,6.76e-6,1.2e-6,3.55e-7,3.2e-7 /)
    case('FeSi-depl')
      abundances=(/ 1.,.085,3.31e-4,8.3e-5,6.76e-4,1.2e-4,1.18e-6,1.07e-6 /)    
    case('C-depl')    
      abundances=(/ 1.,.085,1.1e-5,8.3e-5,6.76e-4,1.2e-4,3.55e-5,3.2e-5 /)
    case default
      print*,'unknown metallicity (compilation error)'         
      stop
    end select
   else
    abundances=(/ 1.,.085,3.31e-4,8.3e-5,6.76e-4,1.2e-4,3.55e-5,3.2e-5 /)
   endif
      
   fractions=abundances/sum(abundances)
   meanmwt=sum(fractions*weights)
   wfractions=weights*abundances/sum(weights*abundances) 
  end subroutine   

  function abundancesQ() result(x)
   real :: x(nelements)
   x=abundances
  end function 
  function abundanceQ(i) result(x)
   integer :: i
   real :: x
   x=abundances(i)
  end function 
  function weightsQ() result(x)
   real :: x(nelements)
   x=weights
  end function 
  function fractionsQ() result(x)
   real :: x(nelements)
   x=fractions
  end function 
  function wfractionsQ() result(x)
   real :: x(nelements)
   x=wfractions
  end function 
  function meanmwtQ() result(x)
   real :: x
   x=meanmwt
  end function 
  function nelementsQ() result(x)
   integer :: x
   x=nelements
  end function 
  subroutine elementnamesQ(x)
   character(len=4),dimension(nelements) :: x
   x=elementnames
  end subroutine  
  function wfractionQ(n) result(x)
   integer :: n
   real :: x
   x=wfractions(n)
  end function
  function fractionQ(n) result(x)
   integer :: n
   real :: x
   x=fractions(n)
  end function
  function zQ() result(x)
   real :: x
   x=sum(wfractions(metals))
  end function
  function solarzQ() result(x)
   real :: x
   x=solarz
  end function

end module ElementsMod


!program test
! use ElementsMod
! real weights(8)
! call InitElements

! print*,meanmwt/fractions(1),wfractions(1)

! weights=wfractionsQ()
 
! print*,weights
! print*,weights(1),weights(2),sum(weights(3:8))
! print*, zQ()
!end program 

MODULE MuseHelpers
 use StoppingConditions
    integer, private, save :: nstep

CONTAINS

subroutine muse_start
  include 'globals.h'
  real*8 rtime, dum
  logical, save :: firstcall=.TRUE.
!$  integer :: omp_get_max_threads

  dum = rtime()
  
  if(firstcall) then
    firstcall=.FALSE.
    print*,' --- FI Amuse interface ---'
    call initmem(nbodsmax,nsphmax,ncells)
!$  print*,' omp threads:',omp_get_max_threads()
  endif

  call set_parameters_to_defaults
  
  nstep = 0

end subroutine

subroutine muse_init
 include 'globals.h'
 real tbegin
 common /amusecom/ tbegin
 
! call startout

 call muse_set_time(tbegin)
 
 call check_parameters

 call heattabel

 call initpars
	
 call inithalo

 if(periodic.and.selfgrav) call initbc

 call initnewstar

end subroutine

subroutine muse_finalize_init
 include 'globals.h'
 real*8 dum1,dum2,dum3

 if(usepm) then
	 if(verbosity.GT.0) print*,' ...initPM...'
	 call initpm 
 endif
 
 call postprocessread
	
 !call initpos
 
 call activateparts
 
 otimestp(pactive(1:npactive))=itimestp(pactive(1:npactive))
	     
 call inittimestep
                		
 !call outstate(0)
 !call muse_energies(1,dum1,dum2,dum3)
 
  ! the postprocessread call will result in potential energies, but
  ! these do not account for the smoothing lengths
  ! doing the next two call is needed but will change the initial 
  ! energy book-keeping (probably for the better but needs
  ! some thought before activated!):
  !call zeropot
  !call gravity('pot ')
 call diagnostics()

end subroutine

function amuse_synchronize_model() result(ret)
  include 'globals.h'
  integer ret
  real*8 dum1,dum2,dum3
! muse_energies does coorpos if called (1,..)
  call muse_energies(1,dum1,dum2,dum3)
  ret=0
end function

function muse_reinitialize() result(ret)
  include 'globals.h'
  integer ret
  real*8 dum1,dum2,dum3
  
  if(syncflag.NE.0) then
    ret=-1
    return
  endif  
  call partremoval
!  if(sortpart) call mortonsort
!  call initstep
!  call zeroacc
!  call zeropot
!  acc(1:nbodies,4)=0.
!  call gravity('both')
!  call makesphtree
!  call densnhsmooth
! call tree_reduction(root,incells,'sph ')
!  if(uentropy) then
!    csound(1:nsph)=sqrt(gamma*rho(1:nsph)**gamma1*entropy(1:nsph)) !cosmof3
!  else
!    csound(1:nsph)=sqrt(gamma*gamma1*ethermal(1:nsph))
!  endif
!  if(input(34).EQ.0) call starevolv
!  tvel(1:nbodies)=tnow
  rho(1:nsph)=0
  call postprocessread

  !call initpos
  call activateparts
 
  otimestp(pactive(1:npactive))=itimestp(pactive(1:npactive))
	     
  
  call inittimestep
  
  call muse_energies(1,dum1,dum2,dum3)
  
  if(verbosity.GT.0) print*,' **warning: check results reinit**' 
  ret=0
end function

subroutine muse_reset(time)
 include 'globals.h'
 real time
 integer dum,dumm(2)
 real tbegin
 common /amusecom/ tbegin

 nbodies=0
 nsph=0
 nstar=0
 totptag=0
 nbh=0
 
 tnow=0
 tbegin=0
 mtot=0
 ektot=0
 eptot=0
 snheat=0
 eradiate=0
 esofttot=0
 enerror=0
 estar=0
 efuvheat=0
 eradcool=0
 tpos=tnow
 teth=tnow
 trad=tnow
 if(meanmwt.LE.0) meanmwt=1.
 if(fhydrogn.LE.0) fhydrogn=1.
 massres=0
 tstarform=tnow
 tsnfeedback=tnow
 tbh=tnow
 eps=0. 

 syncflag=0
 treestatecount=-1
 sphtreecount=-1
 ppropcount=0
 pordercount=0
 dum=0 
 !must set dum to zero before calling muse_find_particle, 
 !not all fortran versions will reset
 !the parameters to zero
 dum=muse_find_particle(dum, -1,-1,dumm)

 input=0
 input(1:4)=1  ! mass+pos+vel+eps
 input(5)=1    ! tform
 input(42)=1   ! nbexist

 input(19)=1   ! csound 
 input(13)=0   ! hsmooth
 
end subroutine


subroutine muse_end
 include 'globals.h'


end subroutine

subroutine muse_set_time(time)
 include 'globals.h'
 real :: time
 
 tnow=time
 tpos=tnow
 teth=tnow
 trad=tnow
 tstarform=tnow
 tsnfeedback=tnow
 tbh=tnow
   
end subroutine


subroutine muse_set_begin_time(time)
 include 'globals.h'
 real :: time
 real tbegin
 common /amusecom/ tbegin
 tbegin = time
end subroutine

function muse_get_begin_time()
 include 'globals.h'
 real tbegin
 common /amusecom/ tbegin
 real :: muse_get_begin_time
 muse_get_begin_time = tbegin
end function

subroutine muse_add_particle_sph(id,m,x,y,z,vx,vy,vz,e,u,npart)
 include 'globals.h'
 integer :: npart
 integer :: id(npart)
 real :: m(npart),x(npart),y(npart),z(npart), &
  vx(npart),vy(npart),vz(npart),e(npart),u(npart)
 integer addspace_gas
 integer p

 p=addspace_gas(npart)

 mass(p:p+npart-1)=m(1:npart)
 pos(p:p+npart-1,1)=x(1:npart)
 pos(p:p+npart-1,2)=y(1:npart)
 pos(p:p+npart-1,3)=z(1:npart)
 vel(p:p+npart-1,1)=vx(1:npart)
 vel(p:p+npart-1,2)=vy(1:npart)
 vel(p:p+npart-1,3)=vz(1:npart)
 epsgrav(p:p+npart-1)=e(1:npart)
 hsmooth(p:p+npart-1)=e(1:npart)
! ethermal(p:p+npart-1)=u(1:npart)
! ethold(p:p+npart-1)=u(1:npart)
 if(.NOT.isotherm) then
   csound(p:p+npart-1)=sqrt(gamma*gamma1*u(1:npart))
 else
   csound(p:p+npart-1)=sqrt(u(1:npart))   
 endif
 nbexist(p:p+npart-1)=id(1:npart)

end subroutine

subroutine muse_add_particle_star(id,m,x,y,z,vx,vy,vz,e,tf,npart)
 include 'globals.h'
 integer :: npart
 integer :: id(npart)
 real :: m(npart),x(npart),y(npart),z(npart), &
  vx(npart),vy(npart),vz(npart),e(npart),tf(npart)
 integer addspace_star
 integer p

 p=addspace_star(npart)

 mass(p:p+npart-1)=m(1:npart)
 pos(p:p+npart-1,1)=x(1:npart)
 pos(p:p+npart-1,2)=y(1:npart)
 pos(p:p+npart-1,3)=z(1:npart)
 vel(p:p+npart-1,1)=vx(1:npart)
 vel(p:p+npart-1,2)=vy(1:npart)
 vel(p:p+npart-1,3)=vz(1:npart)
 epsgrav(p:p+npart-1)=e(1:npart)
 tform(p:p+npart-1)=tf(1:npart)
 nbexist(p:p+npart-1)=id(1:npart)
end subroutine


subroutine muse_add_particle_dm(id,m,x,y,z,vx,vy,vz,e,npart)
 include 'globals.h'
 integer :: npart
 integer :: id(npart)
 real :: m(npart),x(npart),y(npart),z(npart), &
  vx(npart),vy(npart),vz(npart),e(npart)
 integer addspace_dm
 integer p

 p=addspace_dm(npart)

 mass(p:p+npart-1)=m(1:npart)
 pos(p:p+npart-1,1)=x(1:npart)
 pos(p:p+npart-1,2)=y(1:npart)
 pos(p:p+npart-1,3)=z(1:npart)
 vel(p:p+npart-1,1)=vx(1:npart)
 vel(p:p+npart-1,2)=vy(1:npart)
 vel(p:p+npart-1,3)=vz(1:npart)
 epsgrav(p:p+npart-1)=e(1:npart)
 nbexist(p:p+npart-1)=id(1:npart)

end subroutine

function muse_get_nbodies() result(n)
 include 'globals.h'
 integer :: n
 n=nbodies
end function 

function muse_get_nsph() result(n)
 include 'globals.h'
 integer :: n
 n=nsph
end function

function muse_get_nstar() result(n)
 include 'globals.h'
 integer :: n
 n=nstar
end function

function muse_get_ndm() result(n)
 include 'globals.h'
 integer :: n
 n=nbodies-nsph-nstar
end function

function muse_get_time_step() result(dt)
 include 'globals.h'
 real :: dt
 dt=dtime
end function

subroutine muse_stepsys(tend,sync)
 include 'globals.h'
 
 real :: tend
 integer :: p
 integer :: sync
 integer :: is_number_of_steps_detection_enabled
 integer :: is_timeout_detection_enabled
 integer :: is_out_of_box_detection_enabled
 integer :: is_density_limit_detection_enabled
 integer :: is_internal_energy_limit_detection_enabled
 
 integer :: max_number_of_steps=0
 real :: timeout
 real :: stop_boxsize
 real :: minimum_density_parameter, maximum_density_parameter
 real :: minimum_internal_energy_parameter, maximum_internal_energy_parameter
 
 integer :: clock_init, clock_current, count_rate, count_max
 integer :: number_of_steps_innerloop
 real :: minu,maxu
 integer :: stopping_index, error
 integer,save :: n=0
 
 number_of_steps_innerloop = 0

 error = reset_stopping_conditions()
 error = is_stopping_condition_enabled(NUMBER_OF_STEPS_DETECTION, is_number_of_steps_detection_enabled)
 error = is_stopping_condition_enabled(TIMEOUT_DETECTION, is_timeout_detection_enabled)
 error = is_stopping_condition_enabled(OUT_OF_BOX_DETECTION, is_out_of_box_detection_enabled)
 error = is_stopping_condition_enabled(DENSITY_LIMIT_DETECTION, is_density_limit_detection_enabled)
 error = is_stopping_condition_enabled(INTERNAL_ENERGY_LIMIT_DETECTION, is_internal_energy_limit_detection_enabled)
 error = get_stopping_condition_number_of_steps_parameter(max_number_of_steps)
 error = get_stopping_condition_timeout_parameter(timeout)
 error = get_stopping_condition_out_of_box_parameter(stop_boxsize)
 error = get_stopping_condition_minimum_density_parameter(minimum_density_parameter);
 error = get_stopping_condition_maximum_density_parameter(maximum_density_parameter);
 error = get_stopping_condition_minimum_internal_energy_parameter(minimum_internal_energy_parameter);
 error = get_stopping_condition_maximum_internal_energy_parameter(maximum_internal_energy_parameter);
 call SYSTEM_CLOCK(clock_init, count_rate, count_max)

!keep a record of the removed ids
 nremovals = 0
!---
 call activateparts
 call corrpos(itimestp,'desync')

 do while(tnow<tend-dtime/2)
   call step
   if (is_number_of_steps_detection_enabled.GT.0) then
      number_of_steps_innerloop = number_of_steps_innerloop +1
      if (number_of_steps_innerloop.GT.max_number_of_steps) then
         stopping_index = next_index_for_stopping_condition()
         error = set_stopping_condition_info(stopping_index, NUMBER_OF_STEPS_DETECTION)
      endif
   endif
   if (is_timeout_detection_enabled.GT.0) then
      call SYSTEM_CLOCK(clock_current, count_rate, count_max)
      if ((clock_current-clock_init).GT.timeout) then
         stopping_index = next_index_for_stopping_condition()
         error = set_stopping_condition_info(stopping_index, TIMEOUT_DETECTION)
      endif
   endif
   if (is_out_of_box_detection_enabled.GT.0) then
      do p=1,nbodies
         if(sum(pos(p,1:3)**2).GE.stop_boxsize**2) then
            stopping_index = next_index_for_stopping_condition()
            if (stopping_index.GE.0) then
               error = set_stopping_condition_info(stopping_index, OUT_OF_BOX_DETECTION)
               error = set_stopping_condition_particle_index(stopping_index, 0, nbexist(p))
            endif
         endif
      enddo
   endif
   if (is_density_limit_detection_enabled.GT.0) then
      do p=1,nsph
         if ((rho(p).GT.maximum_density_parameter).OR.(rho(p).LT.minimum_density_parameter)) then
            stopping_index = next_index_for_stopping_condition()
            if (stopping_index.GE.0) then
               error = set_stopping_condition_info(stopping_index, DENSITY_LIMIT_DETECTION)
               error = set_stopping_condition_particle_index(stopping_index, 0, nbexist(p))
            endif
         endif
      enddo
   endif
   if (is_internal_energy_limit_detection_enabled.GT.0) then
      do p=1,nsph
        if(uentropy) then
          minu=minimum_internal_energy_parameter*gamma1/rho(p)**gamma1
          maxu=maximum_internal_energy_parameter*gamma1/rho(p)**gamma1
        else
          minu=minimum_internal_energy_parameter
          maxu=maximum_internal_energy_parameter
        endif
        if ((ethermal(p).GT.maxu).OR.(ethermal(p).LT.minu)) then
          stopping_index = next_index_for_stopping_condition()
          if (stopping_index.GE.0) then
               error = set_stopping_condition_info(stopping_index, INTERNAL_ENERGY_LIMIT_DETECTION)
               error = set_stopping_condition_particle_index(stopping_index, 0, nbexist(p))
          endif
        endif
      enddo
   endif

   if (is_any_condition_set().GT.0) exit
   n=n+1
 enddo
! call outstate(n)
 if(sync.EQ.1) then 
   call activateparts
   call corrpos(itimestp,'sync')
 endif  
end subroutine

subroutine muse_get_gravity(epsin,x,y,z,ax,ay,az,n)
  include 'globals.h'
 integer :: n,i
 real :: epsin(n),x(n),y(n),z(n) 
 real :: ax(n),ay(n),az(n)
 real :: ppos(3),peps, pacc(3),pphi

 if(treestatecount.NE.ppropcount+pordercount) call maketree 
!$omp parallel do private(i,peps,ppos,pacc,pphi) shared(epsin,x,y,z,ax,ay,az,n)
 do i=1,n
  peps=epsin(i)
  ppos(1)=x(i);ppos(2)=y(i);ppos(3)=z(i)  
  call evaluate_gravity(peps,ppos,pphi,pacc,'acc ')
  ax(i)=pacc(1);ay(i)=pacc(2);az(i)=pacc(3)
 enddo
end subroutine

subroutine muse_get_tidalfield(epsin,x,y,z,tide,n)
  include 'globals.h'
 integer :: n,i
 real :: epsin(n),x(n),y(n),z(n) 
 real :: tide(6,n)
 real :: ppos(3),peps, ptide(6)

 if(treestatecount.NE.ppropcount+pordercount) call maketree 
!$omp parallel do private(i,peps,ppos,ptide) shared(epsin,x,y,z,tide,n)
 do i=1,n
  peps=epsin(i)
  ppos(1)=x(i);ppos(2)=y(i);ppos(3)=z(i)  
  call evaluate_tidalfield(peps,ppos,ptide)
  tide(1:6,i)=ptide(1:6)
 enddo
end subroutine


subroutine muse_get_pot(epsin,x,y,z,pot,n)
  include 'globals.h'
 integer :: n,i
 real :: epsin(n),x(n),y(n),z(n) 
 real :: pot(n)
 real :: ppos(3),peps, pacc(3),pphi

 if(treestatecount.NE.ppropcount+pordercount) call maketree 
!$omp parallel do private(i,peps,ppos,pacc,pphi) shared(epsin,x,y,z,pot,n)
 do i=1,n
  peps=epsin(i)
  ppos(1)=x(i);ppos(2)=y(i);ppos(3)=z(i)  
  call evaluate_gravity(peps,ppos,pphi,pacc,'pot ')
  pot(i)=pphi
 enddo
end subroutine

subroutine muse_get_hydro_state(x,y,z,vx,vy,vz, &
                                  rh_out,rhvx_out,rhvy_out,rhvz_out,rhe_out,n)
  include 'globals.h'
  integer :: n,i,nneigh
  real :: x(n),y(n),z(n),vx(n),vy(n),vz(n), &
    rh_out(n),rhvx_out(n),rhvy_out(n),rhvz_out(n),rhe_out(n) 
  real :: ppos(3),pvel(3),rh,rhv(3),rhe,rhv2,h,dum,ethtoent
  logical :: vdisp_included

  vdisp_included=.NOT.isotherm
  if(sphtreecount.NE.ppropcount+pordercount) call makesphtree
!$omp parallel private(i,ppos,pvel,rh,rhv,rhe,rhv2,h,dum,ethtoent,nneigh) &
!$omp shared(x,y,z,vx,vy,vz,rh_out,rhvx_out,rhvy_out,rhvz_out,rhe_out,n,vdisp_included)
  h=0
  reuseflag=1
  searchreuse=0
!$omp do  
  do i=1,n
    ppos(1)=x(i);ppos(2)=y(i);ppos(3)=z(i)  
    pvel(1)=vx(i);pvel(2)=vy(i);pvel(3)=vz(i)  
    call hsmdenspos2(ppos,h,rh,dum,nneigh)
    call gatter_hydro_state(nneigh,ppos,pvel,h,rh,rhv,rhv2,rhe)
    if(uentropy) then
      ethtoent=gamma1/rh**gamma1
    else
      ethtoent=1
    endif
    rh_out(i)=rh
    rhvx_out(i)=rhv(1)
    rhvy_out(i)=rhv(2)
    rhvz_out(i)=rhv(3)
    rhe=rhe/ethtoent
    if(vdisp_included) then
      rhe_out(i)=rhe+0.5*rhv2
    else
      rhe_out(i)=0.
      if(rh.GT.0) rhe_out(i)=rhe+0.5*sum(rhv**2)/rh
    endif
  enddo
!$omp end parallel
  
end subroutine


subroutine muse_set_nstar(ns)
 include 'globals.h'
 integer ns
 nstar=ns
end subroutine

subroutine muse_set_nsph(ns)
 include 'globals.h'
 integer ns
 nsph=ns
end subroutine

subroutine muse_energies(mode,ek,ep,eth)
 include 'globals.h'
 real :: ek,ep,eth
 integer :: mode
 
 if(mode.NE.0) then
  call activateparts
  call corrpos(itimestp,'sync')
  call zeropot
  call gravity('pot ')
  call diagnostics
 endif
 
 ek=ektot
 ep=eptot
 eth=ethtot
end subroutine

function muse_get_time() result(t)
 include 'globals.h'
 real :: t
 t=tnow
end function

function muse_get_dynamical_time_scale() result(dt)
 include 'globals.h'
 real dt
 dt=(-0.5*mtot*mtot/eptot) / sqrt(2*ektot/mtot)
end function
 
function muse_find_particle(count,id,n,ids) result(p)
  use hashMod
  integer :: id,n,p,ids(*)
  integer :: count
  integer, save :: statecount=-1
  
  p=-1
  
  if(statecount.NE.count) then
    if(n.GT.0) call initHash(n/2+1,n,ids) 
    statecount=count
  endif  
   
  if(n.GT.0) p=find(id,ids)
   
end function


subroutine muse_get_state(id,m,x,y,z,vx,vy,vz,e)
  include 'globals.h'
  integer :: id,dum
  real*8 :: m,x,y,z,vx,vy,vz,e
  dum=amuse_get_state(id,m,x,y,z,vx,vy,vz,e)
end subroutine
 
function amuse_get_state(id,m,x,y,z,vx,vy,vz,e) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: m,x,y,z,vx,vy,vz,e

  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(nbexist(p).NE.id) call terror("id error 2")
  m=mass(p)
  x=pos(p,1)
  y=pos(p,2)
  z=pos(p,3)
  vx=vel(p,1)
  vy=vel(p,2)
  vz=vel(p,3)
  e=epsgrav(p)
  ret=0 
end function

function amuse_get_state_sph(id,m,x,y,z,vx,vy,vz,e,u) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: m,x,y,z,vx,vy,vz,e,u

  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(p.GT.nsph) then
    ret=1
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  m=mass(p)
  x=pos(p,1)
  y=pos(p,2)
  z=pos(p,3)
  vx=vel(p,1)
  vy=vel(p,2)
  vz=vel(p,3)
  e=epsgrav(p)
  if(uentropy) then
    u=entropy(p)/gamma1*rho(p)**gamma1
  else
    u=ethermal(p)
  endif
  ret=0 
end function

function amuse_get_state_star(id,m,x,y,z,vx,vy,vz,e,tf) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: m,x,y,z,vx,vy,vz,e,tf

  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(p.LT.nbodies-nstar+1) then
    ret=1
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  m=mass(p)
  x=pos(p,1)
  y=pos(p,2)
  z=pos(p,3)
  vx=vel(p,1)
  vy=vel(p,2)
  vz=vel(p,3)
  e=epsgrav(p)
  tf=tform(p)
  ret=0 
end function

function amuse_set_state(id,m,x,y,z,vx,vy,vz,e) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: m,x,y,z,vx,vy,vz,e

  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(nbexist(p).NE.id) call terror("id error 2")
  mass(p)=m
  pos(p,1)=x
  pos(p,2)=y
  pos(p,3)=z
  vel(p,1)=vx
  vel(p,2)=vy
  vel(p,3)=vz
  epsgrav(p)=e
  ret=0 
end function

function amuse_set_state_sph(id,m,x,y,z,vx,vy,vz,e,u) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: m,x,y,z,vx,vy,vz,e,u

  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(p.GT.nsph) then
    ret=-2
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  mass(p)=m
  pos(p,1)=x
  pos(p,2)=y
  pos(p,3)=z
  vel(p,1)=vx
  vel(p,2)=vy
  vel(p,3)=vz
  epsgrav(p)=e
  if(uentropy) then
    entropy(p)=u*gamma1/rho(p)**gamma1
    entold(p)=entropy(p)
    csound(p)=sqrt(gamma*gamma1*u)
  else
    if(.NOT.isotherm) then
      csound(p)=sqrt(gamma*gamma1*u)
    else
      csound(p)=sqrt(u)   
    endif
    ethermal(p)=u
    ethold(p)=u
  endif
  ret=0 
end function

function amuse_set_state_star(id,m,x,y,z,vx,vy,vz,e,tf) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: m,x,y,z,vx,vy,vz,e,tf

  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(p.LT.nbodies-nstar+1) then
    ret=-2
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  mass(p)=m
  pos(p,1)=x
  pos(p,2)=y
  pos(p,3)=z
  vel(p,1)=vx
  vel(p,2)=vy
  vel(p,3)=vz
  epsgrav(p)=e
  tform(p)=tf
  ret=0 
end function

function amuse_get_mass(id,m) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: m
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(nbexist(p).NE.id) call terror("id error 2")
  m=mass(p)
  ret=0 
end function
function amuse_get_epsgrav(id,e) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: e
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(nbexist(p).NE.id) call terror("id error 2")
  e=epsgrav(p)
  ret=0 
end function
function amuse_get_hsmooth(id,h) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: h
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(nbexist(p).NE.id) call terror("id error 2")
  h=hsmooth(p)
  ret=0 
end function
function amuse_get_density(id, density) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: density
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(nbexist(p).NE.id) call terror("id error 2")
  density=rho(p)
  ret=0 
end function

function amuse_get_pressure(id, pressure) result(ret)
   include 'globals.h'
   integer :: id, ret, p
   real*8 :: pressure
   p = muse_find_particle(pordercount, id, nbodies, nbexist)
   if(p.EQ.0) then
      ret = -1
      return
   endif 
   if(nbexist(p).NE.id) call terror("id error 2")
   
   if(uentropy) then
      pressure = entropy(p) * rho(p)**gamma
   else
      pressure = gamma1 * rho(p) * ethermal(p)
   endif
   ret = 0 
end function

function amuse_get_position(id,x,y,z) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: x,y,z
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(nbexist(p).NE.id) call terror("id error 2")
  x=pos(p,1)
  y=pos(p,2)
  z=pos(p,3)
  ret=0 
end function

function amuse_get_potential(id, phi_) result(ret)
  include 'globals.h'
  real*8 :: phi_
  integer :: id,ret,p

  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    print*, id,nbodies
    print*
    print*,nbexist(1:nbodies)
    stop
    ret=-1
    return
  endif 
  if(nbexist(p).NE.id) call terror("id error 2")
  phi_ = phi(p)
  ret=0
end function

function amuse_get_velocity(id,vx,vy,vz) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: vx,vy,vz
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(nbexist(p).NE.id) call terror("id error 2")
  vx=vel(p,1)
  vy=vel(p,2)
  vz=vel(p,3)
  ret=0 
end function
function amuse_get_internal_energy(id,u) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: u
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(p.GT.nsph) then
    ret=1
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  if(uentropy) then
    u=entropy(p)/gamma1*rho(p)**gamma1
  else
    u=ethermal(p)
  endif
  ret=0 
end function
function amuse_get_dinternal_energy_dt(id,u) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: u
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(p.GT.nsph) then
    ret=1
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  if(uentropy) then
    u=-csound(p)**2*hsmdivv(p)/(gamma*hsmooth(p))+dentdt(p)/gamma1*rho(p)**gamma1
  else
    u=dethdt(p)
  endif
  ret=0 
end function
function amuse_get_star_tform(id,tf) result(ret)
  include 'globals.h'
  integer :: id,ret,p
  real*8 :: tf
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif 
  if(p.LT.nbodies-nstar+1) then
    ret=1
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  tf=tform(p)
  ret=0 
end function

function amuse_set_mass(id,m) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: m
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(nbexist(p).NE.id) call terror("id error 2")
  mass(p)=m
  ret=0 
end function
function amuse_set_epsgrav(id,e) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: e
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(nbexist(p).NE.id) call terror("id error 2")
  epsgrav(p)=e
  ret=0 
end function
function amuse_set_hsmooth(id,h) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: h
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(nbexist(p).NE.id) call terror("id error 2")
  hsmooth(p)=h
  ret=0 
end function
function amuse_set_position(id,x,y,z) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: x,y,z
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(nbexist(p).NE.id) call terror("id error 2")
  pos(p,1)=x
  pos(p,2)=y
  pos(p,3)=z
  ret=0 
end function
function amuse_set_velocity(id,vx,vy,vz) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: vx,vy,vz
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(nbexist(p).NE.id) call terror("id error 2")
  vel(p,1)=vx
  vel(p,2)=vy
  vel(p,3)=vz
  ret=0 
end function
function amuse_set_internal_energy(id,u) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: u
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(p.GT.nsph) then
    ret=-2
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  if(.not.(u.GT.0.AND.u.LT.HUGE(u))) then
    ret=-3
    return
  endif
  if(uentropy) then
    entropy(p)=u*gamma1/rho(p)**gamma1
    entold(p)=entropy(p)
    csound(p)=sqrt(gamma*gamma1*u)
  else
    if(.NOT.isotherm) then
      csound(p)=sqrt(gamma*gamma1*u)
    else
      csound(p)=sqrt(u)   
    endif
    ethermal(p)=u
    ethold(p)=u
  endif
  ret=0 
end function
function amuse_set_star_tform(id,tf) result(ret)
  include 'globals.h'
  integer :: id,p,ret
  real*8 :: tf
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(p.LT.nbodies-nstar+1) then
    ret=-2
    return
  endif  
  if(nbexist(p).NE.id) call terror("id error 2")
  tform(p)=tf
  ret=0 
end function


function muse_remove_particle(id) result(ret)
  include 'globals.h'
  integer :: id,p,ret

  if(syncflag.NE.0) then
    ret=-2
    return
  endif  
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(nbexist(p).NE.id) call terror("id error 2")
  mass(p)=0.
  ret=0   
end function

function muse_index_of_first_particle(id) result(ret)
  include 'globals.h'
  integer id,ret
  if(nbodies.LT.1) then
    ret=-1
    return
  endif
  id=nbexist(1)
  ret=0
end function

function muse_index_of_next_particle(id,id1) result(ret)
  include 'globals.h'
  integer id,id1,p,ret
  if(nbodies.LT.1) then
    ret=-1
    return
  endif
  p=muse_find_particle(pordercount,id,nbodies,nbexist)
  if(p.EQ.0) then
    ret=-1
    return
  endif
  if(p.EQ.nbodies) then
    ret=1
    id1=id
    return
  endif    
  id1=nbexist(p+1)
  ret=0
end function

function new_id()
  include 'globals.h'
  integer new_id
  totptag=totptag+1
  new_id=totptag
end function

! parameter setters & getters

! logical
subroutine amuse_set_usesph(x)
  include 'globals.h'
  logical,intent(in) :: x
  usesph=x
end subroutine
subroutine amuse_get_usesph(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=usesph
end subroutine

subroutine amuse_set_radiate(x)
  include 'globals.h'
  logical,intent(in) :: x
  radiate=x
end subroutine
subroutine amuse_get_radiate(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=radiate
end subroutine

subroutine amuse_set_starform(x)
  include 'globals.h'
  logical,intent(in) :: x
  starform=x
end subroutine
subroutine amuse_get_starform(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=starform
end subroutine

subroutine amuse_set_cosmo(x)
  include 'globals.h'
  logical,intent(in) :: x
  cosmo=x
end subroutine
subroutine amuse_get_cosmo(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=cosmo
end subroutine

subroutine amuse_set_sqrttstp(x)
  include 'globals.h'
  logical,intent(in) :: x
  sqrttstp=x
end subroutine
subroutine amuse_get_sqrttstp(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=sqrttstp
end subroutine

subroutine amuse_set_acc_tstp(x)
  include 'globals.h'
  logical,intent(in) :: x
  acc_tstp=x
end subroutine
subroutine amuse_get_acc_tstp(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=acc_tstp
end subroutine

subroutine amuse_set_freetstp(x)
  include 'globals.h'
  logical,intent(in) :: x
  freetstp=x
end subroutine
subroutine amuse_get_freetstp(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=freetstp
end subroutine

subroutine amuse_set_usequad(x)
  include 'globals.h'
  logical,intent(in) :: x
  usequad=x
end subroutine
subroutine amuse_get_usequad(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=usequad
end subroutine

subroutine amuse_set_directsum(x)
  include 'globals.h'
  logical,intent(in) :: x
  directsum=x
end subroutine
subroutine amuse_get_directsum(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=directsum
end subroutine

subroutine amuse_set_selfgrav(x)
  include 'globals.h'
  logical,intent(in) :: x
  selfgrav=x
end subroutine
subroutine amuse_get_selfgrav(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=selfgrav
end subroutine

subroutine amuse_set_fixthalo(x)
  include 'globals.h'
  logical,intent(in) :: x
  fixthalo=x
end subroutine
subroutine amuse_get_fixthalo(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=fixthalo
end subroutine

subroutine amuse_set_adaptive_eps(x)
  include 'globals.h'
  logical,intent(in) :: x
  adaptive_eps=x
end subroutine
subroutine amuse_get_adaptive_eps(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=adaptive_eps
end subroutine

subroutine amuse_set_gdgop(x)
  include 'globals.h'
  logical,intent(in) :: x
  gdgop=x
end subroutine
subroutine amuse_get_gdgop(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=gdgop
end subroutine

subroutine amuse_set_smoothinput(x)
  include 'globals.h'
  logical,intent(in) :: x
  smoothinput=x
end subroutine
subroutine amuse_get_smoothinput(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=smoothinput
end subroutine

subroutine amuse_set_consph(x)
  include 'globals.h'
  logical,intent(in) :: x
  consph=x
end subroutine
subroutine amuse_get_consph(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=consph
end subroutine

subroutine amuse_set_sphinit(x)
  include 'globals.h'
  logical,intent(in) :: x
  sphinit=x
end subroutine
subroutine amuse_get_sphinit(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=sphinit
end subroutine

subroutine amuse_set_uentropy(x)
  include 'globals.h'
  logical,intent(in) :: x
  uentropy=x
end subroutine
subroutine amuse_get_uentropy(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=uentropy
end subroutine

subroutine amuse_set_isotherm(x)
  include 'globals.h'
  logical,intent(in) :: x
  isotherm=x
end subroutine
subroutine amuse_get_isotherm(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=isotherm
end subroutine

subroutine amuse_set_eps_is_h(x)
  include 'globals.h'
  logical,intent(in) :: x
  eps_is_h=x
end subroutine
subroutine amuse_get_eps_is_h(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=eps_is_h
end subroutine

subroutine amuse_set_balsara(x)
  include 'globals.h'
  logical,intent(in) :: x
  balsara=x
end subroutine
subroutine amuse_get_balsara(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=balsara
end subroutine

subroutine amuse_set_mingaseps(x)
  include 'globals.h'
  logical,intent(in) :: x
  mingaseps=x
end subroutine
subroutine amuse_get_mingaseps(x)
  include 'globals.h'
  logical, intent(out) :: x
  x=mingaseps
end subroutine



! integer

subroutine amuse_set_firstsnap(x)
  include 'globals.h'
  integer, intent(in) :: x
  firstsnap=x
end subroutine
subroutine amuse_get_firstsnap(x)
  include 'globals.h'
  integer, intent(out) :: x
  x=firstsnap
end subroutine

subroutine amuse_set_stepout(x)
  include 'globals.h'
  integer, intent(in) :: x
  stepout=x
end subroutine
subroutine amuse_get_stepout(x)
  include 'globals.h'
  integer, intent(out) :: x
  x=stepout
end subroutine

subroutine amuse_set_steplog(x)
  include 'globals.h'
  integer, intent(in) :: x
  steplog=x
end subroutine
subroutine amuse_get_steplog(x)
  include 'globals.h'
  integer, intent(out) :: x
  x=steplog
end subroutine

subroutine amuse_set_max_tbin(x)
  include 'globals.h'
  integer, intent(in) :: x
  max_tbin=x
end subroutine
subroutine amuse_get_max_tbin(x)
  include 'globals.h'
  integer, intent(out) :: x
  x=max_tbin
end subroutine

subroutine amuse_set_minppbin(x)
  include 'globals.h'
  integer, intent(in) :: x
  minppbin=x
end subroutine
subroutine amuse_get_minppbin(x)
  include 'globals.h'
  integer, intent(out) :: x
  x=minppbin
end subroutine

subroutine amuse_set_targetnn(x)
  include 'globals.h'
  integer, intent(in) :: x
  targetnn=x
end subroutine
subroutine amuse_get_targetnn(x)
  include 'globals.h'
  integer, intent(out) :: x
  x=targetnn
end subroutine

subroutine amuse_set_verbosity(x)
  include 'globals.h'
  integer, intent(in) :: x
  verbosity=x
end subroutine
subroutine amuse_get_verbosity(x)
  include 'globals.h'
  integer, intent(out) :: x
  x=verbosity
end subroutine

subroutine amuse_set_nsmooth(x)
  include 'globals.h'
  integer, intent(in) :: x
  nsmooth=x
end subroutine
subroutine amuse_get_nsmooth(x)
  include 'globals.h'
  integer, intent(out) :: x
  x=nsmooth
end subroutine


! reals

subroutine amuse_set_pboxsize(x)
  include 'globals.h'
  real*8, intent(in) :: x
  pboxsize=x
end subroutine
subroutine amuse_get_pboxsize(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=pboxsize
end subroutine

subroutine amuse_set_unitm_in_msun(x)
  include 'globals.h'
  real*8, intent(in) :: x
  unitm_in_msun=x
end subroutine
subroutine amuse_get_unitm_in_msun(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=unitm_in_msun
end subroutine

subroutine amuse_set_unitl_in_kpc(x)
  include 'globals.h'
  real*8, intent(in) :: x
  unitl_in_kpc=x
end subroutine
subroutine amuse_get_unitl_in_kpc(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=unitl_in_kpc
end subroutine

subroutine amuse_set_dtime(x)
  include 'globals.h'
  real*8, intent(in) :: x
  dtime=x
end subroutine
subroutine amuse_get_dtime(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=dtime
end subroutine

subroutine amuse_set_tstepcrit(x)
  include 'globals.h'
  real*8, intent(in) :: x
  tstepcrit=x
end subroutine
subroutine amuse_get_tstepcrit(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=tstepcrit
end subroutine

subroutine amuse_set_tstpcr2(x)
  include 'globals.h'
  real*8, intent(in) :: x
  tstpcr2=x
end subroutine
subroutine amuse_get_tstpcr2(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=tstpcr2
end subroutine

subroutine amuse_set_freev(x)
  include 'globals.h'
  real*8, intent(in) :: x
  freev=x
end subroutine
subroutine amuse_get_freev(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=freev
end subroutine

subroutine amuse_set_freea(x)
  include 'globals.h'
  real*8, intent(in) :: x
  freea=x
end subroutine
subroutine amuse_get_freea(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=freea
end subroutine

subroutine amuse_set_freevexp(x)
  include 'globals.h'
  real*8, intent(in) :: x
  freevexp=x
end subroutine
subroutine amuse_get_freevexp(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=freevexp
end subroutine

subroutine amuse_set_freeaexp(x)
  include 'globals.h'
  real*8, intent(in) :: x
  freeaexp=x
end subroutine
subroutine amuse_get_freeaexp(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=freeaexp
end subroutine

subroutine amuse_set_bh_tol(x)
  include 'globals.h'
  real*8, intent(in) :: x
  bh_tol=x
end subroutine
subroutine amuse_get_bh_tol(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=bh_tol
end subroutine

subroutine amuse_set_eps(x)
  include 'globals.h'
  real*8, intent(in) :: x
  eps=x
end subroutine
subroutine amuse_get_eps(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=eps
end subroutine

subroutine amuse_set_gdgtol(x)
  include 'globals.h'
  real*8, intent(in) :: x
  gdgtol=x
end subroutine
subroutine amuse_get_gdgtol(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=gdgtol
end subroutine

subroutine amuse_set_nn_tol(x)
  include 'globals.h'
  real*8, intent(in) :: x
  nn_tol=x
end subroutine
subroutine amuse_get_nn_tol(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=nn_tol
end subroutine

subroutine amuse_set_epsgas(x)
  include 'globals.h'
  real*8, intent(in) :: x
  epsgas=x
end subroutine
subroutine amuse_get_epsgas(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=epsgas
end subroutine

subroutine amuse_set_gamma(x)
  include 'globals.h'
  real*8, intent(in) :: x
  gamma=x
end subroutine
subroutine amuse_get_gamma(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=gamma
end subroutine

subroutine amuse_set_alpha(x)
  include 'globals.h'
  real*8, intent(in) :: x
  alpha=x
end subroutine
subroutine amuse_get_alpha(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=alpha
end subroutine

subroutine amuse_set_beta(x)
  include 'globals.h'
  real*8, intent(in) :: x
  beta=x
end subroutine
subroutine amuse_get_beta(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=beta
end subroutine

subroutine amuse_set_epssph(x)
  include 'globals.h'
  real*8, intent(in) :: x
  epssph=x
end subroutine
subroutine amuse_get_epssph(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=epssph
end subroutine

subroutine amuse_set_courant(x)
  include 'globals.h'
  real*8, intent(in) :: x
  courant=x
end subroutine
subroutine amuse_get_courant(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=courant
end subroutine

subroutine amuse_set_removgas(x)
  include 'globals.h'
  real*8, intent(in) :: x
  removgas=x
end subroutine
subroutine amuse_get_removgas(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=removgas
end subroutine

subroutine amuse_set_consthsm(x)
  include 'globals.h'
  real*8, intent(in) :: x
  consthsm=x
end subroutine
subroutine amuse_get_consthsm(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=consthsm
end subroutine

subroutine amuse_set_nsmtol(x)
  include 'globals.h'
  real*8, intent(in) :: x
  nsmtol=x
end subroutine
subroutine amuse_get_nsmtol(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=nsmtol
end subroutine

subroutine amuse_set_graineff(x)
  include 'globals.h'
  real*8, intent(in) :: x
  graineff=x
end subroutine
subroutine amuse_get_graineff(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=graineff
end subroutine

subroutine amuse_set_crionrate(x)
  include 'globals.h'
  real*8, intent(in) :: x
  crionrate=x
end subroutine
subroutine amuse_get_crionrate(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=crionrate
end subroutine

subroutine amuse_set_heat_par1(x)
  include 'globals.h'
  real*8, intent(in) :: x
  heat_par1=x
end subroutine
subroutine amuse_get_heat_par1(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=heat_par1
end subroutine

subroutine amuse_set_heat_par2(x)
  include 'globals.h'
  real*8, intent(in) :: x
  heat_par2=x
end subroutine
subroutine amuse_get_heat_par2(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=heat_par2
end subroutine

subroutine amuse_set_cool_par(x)
  include 'globals.h'
  real*8, intent(in) :: x
  cool_par=x
end subroutine
subroutine amuse_get_cool_par(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=cool_par
end subroutine

subroutine amuse_set_optdepth(x)
  include 'globals.h'
  real*8, intent(in) :: x
  optdepth=x
end subroutine
subroutine amuse_get_optdepth(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=optdepth
end subroutine

subroutine amuse_set_tcollfac(x)
  include 'globals.h'
  real*8, intent(in) :: x
  tcollfac=x
end subroutine
subroutine amuse_get_tcollfac(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=tcollfac
end subroutine

subroutine amuse_set_masscrit(x)
  include 'globals.h'
  real*8, intent(in) :: x
  masscrit=x
end subroutine
subroutine amuse_get_masscrit(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=masscrit
end subroutine

subroutine amuse_set_sfeff(x)
  include 'globals.h'
  real*8, intent(in) :: x
  sfeff=x
end subroutine
subroutine amuse_get_sfeff(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=sfeff
end subroutine

subroutine amuse_set_tbubble(x)
  include 'globals.h'
  real*8, intent(in) :: x
  tbubble=x
end subroutine
subroutine amuse_get_tbubble(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=tbubble
end subroutine

subroutine amuse_set_sne_eff(x)
  include 'globals.h'
  real*8, intent(in) :: x
  sne_eff=x
end subroutine
subroutine amuse_get_sne_eff(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=sne_eff
end subroutine

subroutine amuse_set_tsnbeg(x)
  include 'globals.h'
  real*8, intent(in) :: x
  tsnbeg=x
end subroutine
subroutine amuse_get_tsnbeg(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=tsnbeg
end subroutine

subroutine amuse_set_rhomax(x)
  include 'globals.h'
  real*8, intent(in) :: x
  rhomax=x
end subroutine
subroutine amuse_get_rhomax(x)
  include 'globals.h'
  real*8, intent(out) :: x
  x=rhomax
end subroutine


! character

subroutine amuse_set_halofile(x)
  include 'globals.h'
  character(len=30), intent(in) :: x
  halofile=x
end subroutine
subroutine amuse_get_halofile(x)
  include 'globals.h'
  character(len=30), intent(out) :: x
  x=halofile
end subroutine

subroutine amuse_set_feedback(x)
  include 'globals.h'
  character(len=4), intent(in) :: x
  feedback=x
end subroutine
subroutine amuse_get_feedback(x)
  include 'globals.h'
  character(len=4), intent(out) :: x
  x=feedback
end subroutine

subroutine amuse_set_sfmode(x)
  include 'globals.h'
  character(len=10), intent(in) :: x
  sfmode=x
end subroutine
subroutine amuse_get_sfmode(x)
  include 'globals.h'
  character(len=10), intent(out) :: x
  x=sfmode
end subroutine

subroutine amuse_set_hupdatemethod(x)
  include 'globals.h'
  character(len=4), intent(in) :: x
  hupdatemethod=x
end subroutine
subroutine amuse_get_hupdatemethod(x)
  include 'globals.h'
  character(len=4), intent(out) :: x
  x=hupdatemethod
end subroutine

subroutine amuse_set_sph_visc(x)
  include 'globals.h'
  character(len=4), intent(in) :: x
  sph_visc=x
end subroutine
subroutine amuse_get_sph_visc(x)
  include 'globals.h'
  character(len=4), intent(out) :: x
  x=sph_visc
end subroutine

subroutine amuse_set_fi_data_directory(x)
  include 'globals.h'
  character(len=200), intent(in) :: x
  datadir=x
end subroutine
subroutine amuse_get_fi_data_directory(x)
  include 'globals.h'
  character(len=200), intent(out) :: x
  x=datadir
end subroutine


function amuse_get_number_of_sph_particles_removed(x)
  include 'globals.h'
  integer :: amuse_get_number_of_sph_particles_removed
  integer, intent(out) :: x
  x=nremovals
  amuse_get_number_of_sph_particles_removed = 0
end function

function amuse_get_id_of_removed_sph_particle(x, id_of_removed_particle)
  include 'globals.h'
  integer :: amuse_get_id_of_removed_sph_particle
  integer, intent(in) :: x
  integer, intent(out) :: id_of_removed_particle
  if(x.GE.nremovals) then
    amuse_get_id_of_removed_sph_particle=-1
    return
  endif  
  amuse_get_id_of_removed_sph_particle = 0
  id_of_removed_particle=removedidssph(x+1)
end function


END MODULE MuseHelpers


! dummies:
! (only necessary to be able to compile using old muse style interface files)

subroutine call_external_acc(eps,x,y,z,ax,ay,az,n)
  integer n
  real :: eps(n), x(n),y(n),z(n)
  real :: ax(n),ay(n),az(n)

end subroutine

subroutine call_external_pot(eps,x,y,z,phi,n)
  integer n
  real :: eps(n), x(n),y(n),z(n)
  real :: phi(n)

end subroutine


subroutine external_gravity(option)
 include 'globals.h'
 character*4 option
 integer, parameter :: bunchsize=1024
 real :: l_eps(bunchsize), l_pos(bunchsize,3), &
         l_phi(bunchsize), l_acc(bunchsize,3)
 integer i,ndone,todo

 ndone=0
 do while(ndone.LT.npactive)

    todo=MIN(bunchsize,npactive-ndone)

    l_eps(1:todo)=epsgrav(pactive(ndone+1:ndone+todo))
    l_pos(1:todo,1:3)=pos(pactive(ndone+1:ndone+todo),1:3)
    l_acc(1:todo,1:3)=0
    l_phi(1:todo)=0

    select case (option)
    case('acc ')
      call call_external_acc(l_eps(1), &
           l_pos(1,1),l_pos(1,2),l_pos(1,3), &
           l_acc(1,1),l_acc(1,2),l_acc(1,3), todo)
    case('pot ')
      call call_external_pot(l_eps(1), &
             l_pos(1,1),l_pos(1,2),l_pos(1,3), &
             l_phi(1), todo)
    case default
      call call_external_acc(l_eps(1), &
             l_pos(1,1),l_pos(1,2),l_pos(1,3), &
             l_acc(1,1),l_acc(1,2),l_acc(1,3), todo)
      call call_external_pot(l_eps(1), &
             l_pos(1,1),l_pos(1,2),l_pos(1,3), &
             l_phi(1), todo)
    end select

    acc(pactive(ndone+1:ndone+todo),1:3)= &
            acc(pactive(ndone+1:ndone+todo),1:3)+l_acc(1:todo,1:3)	   
    phi(pactive(ndone+1:ndone+todo))= &
            phi(pactive(ndone+1:ndone+todo))+l_phi(1:todo)	   

    ndone=ndone+todo

 enddo

end subroutine
